(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: Auto.mod,v $
# $Author: Sopra $      (Reini)
# $Date: 2001/01/14 10:46:13 $
# $Revision: 1.16 $
# Bemerkungen: letzte Aenderung 01.03.2001

*)
(***************c***************************************************************)
(******************************************************************************)


IMPLEMENTATION MODULE Auto; (* Version 2.0 *)


  FROM Datum  IMPORT            DisposeStag, DisposeDatum, DuplicateDatum,
  				DatumAlsString,
  				IsEqualJahr, IsEqualMonat, IsEqualTag,
  				LiesMonatInDatum, LiesMonatInStag,
  				LiesTagInDatum, LiesTagInStag,
  				MonatAlsCard, LetztesJahr,
  				PruefeObMonatsErster, PruefeObMonatJanuar,
  				SetzeTagInDatum, SetzeMonatInDatum,
  				LiesJahrInDatum, SmallerDatum,
  				IncDatum,
  				ErsteWocheInMonat, NaechsteWocheInMonat,
  				SetzeJahresanfang, SetzeJahresende;	


  IMPORT String, WholeStr;
  				
  FROM AutoIMPORTE IMPORT 	TDatum, TStag, TJahr,
  				TKond,
  				THK, TPersID,
  				TVtr, TVtrID,
  				TKst, TKstID,
  				TBu, TBuArt,
  				TString,
  				CreateBg,
  				BuStorniert,
  				DispBu, DispHK, DispKond, DispKst, DispVtr,
  				Druck,
  				ErsteBuZuKst, ErsteHK, ErsteVtrZuHK, EtatDerKst,
  				ErsteAktKst,
  				FirstValVtrZuHK, FirstValVtrZuHKinZeitraum,
  				FirstValVtrZuHKmitZeitpunkt, FirstVtrZuHKinZraum,
  				FirstVtrZuHKmitZeitpunkt,
  				HoleAktTKond, HoleAktWKond,
  				InsertBg,
  				KstID2String, LGueltigBisInVtr,
  				LHKID, LSTagDerWKond, LStdSinTKond, LJahrInKst,
  				LGueltigVonInVtr, LStdZahlInVtr, LKIDinKst,
  				LKstIDinVtr, LVtrIDinVtr, LHKIDinVtr, LBetragInBu,
  				NaechsteHK, NaechsteBuZuKst, NaechsteVtrZuHK,
  				NextValVtrZuHK, NextValVtrZuHKinZeitraum,
  				NextValVtrZuHKmitZeitpunkt, NextVtrZuHKmitZeitpunkt,
  				NextVtrZuHKinZraum, NaechsteAktKst,
  				SetKstIDinBu, SetKstLiquAm, SetVtrIDinBu,
  				SetBetragInBu, SetGebuchtAmInBu, SetBuchungsArtInBu,
  				VtrID2String;
  				


  				
(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

  PROCEDURE WGAnteilDerKst ( inVtr : TVtr; inStTagDat : TDatum; inWG : CARDINAL ) : CARDINAL;

  (* -- Berechnet den Anteil am WG der HK, den die Kst zu zahlen hat
     -- HK und Kst sind durch inVtr festgelegt, inStTagDat ist das
     -- Datum des Stichtags, d.h. falls das aktuelle Datum nicht der Stichtag ist,
     -- wird als Schaetzung der Stichtag der am aktuellen Datum gueltigen WG-Kondition
     -- erwartet *)


  VAR
	outVtr   : TVtr;     (* -- durchlaeuft alle zum Stichtag gueltigen
                                -- Vertraege der HK und wird zur Bestimmung der
     	       	    	      	-- Stdzahl benoetigt *)
	Stdzahl  : CARDINAL; (* -- Summe der Stundenzahl aller am Stichtag
     	       	    	        -- geltenden Vertraege der HK *)
	Anteil	 : CARDINAL;
	outResult: BOOLEAN;

  BEGIN

          (*  Stunden := Summe Stundenzahl aller am Stichtag geltenden
     	      Vertraege der Hilfskraft ;
          *)
	  Anteil    := 0;
          Stdzahl   := 0;
          outResult := FirstValVtrZuHKmitZeitpunkt ( LHKIDinVtr (inVtr),inStTagDat,
                                                     outVtr);

          IF outResult THEN

            REPEAT
              Stdzahl := Stdzahl + LStdZahlInVtr (outVtr);
            UNTIL NOT NextValVtrZuHKmitZeitpunkt ( LHKIDinVtr (inVtr),
                                                   inStTagDat, outVtr);

              Anteil := inWG * LStdZahlInVtr (inVtr) / Stdzahl;
	   END (* IF *);
	

	RETURN Anteil

  END WGAnteilDerKst;

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)


(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

  PROCEDURE AnzahlMonateImJahr (inHKID : TPersID; inDatum : TDatum) : CARDINAL;

      VAR MonateFeld : ARRAY [1..12] OF BOOLEAN; (* -- gibt an, ob die HK im jeweiligen
                                                  -- Monat gearbeitet hat *)
        AnzMonate  : CARDINAL;
	Index      : CARDINAL;  (* -- Index in MonateFeld       *)
	JAnfang    : TDatum;	(* -- 01.01.++++ : Jahresanfang *)
        JEnde      : TDatum;	(* -- 31.12.++++ : Jahresende   *)
	LaufDatum  : TDatum;    (* -- fuer Schleifendurchlauf   *)
        VtrEnde    : TDatum;
	outResult  : BOOLEAN;
	outVtr     : TVtr;

    BEGIN
	AnzMonate := 0;

        (*
	Monate := Anzahl Monate, die die Hilfskraft in Datum.Jahr beschaeftigt war,
		angefangene Monate werden voll gezaehlt; *)
	(* -- sorgt dafuer, dass JAnfang und JEnde das aktuelle Jahr enthalten *)

	JAnfang := DuplicateDatum (inDatum);
	JEnde   := DuplicateDatum (inDatum);
	SetzeJahresanfang (JAnfang);
        SetzeJahresende   (JEnde);

	(* -- jeden Vertrag der HK durchgehen, der ganz oder teilweise
           -- ins akt. Jahr fllt
           -- Achtung : gehrt ein Vertrag ber 2 Jahre, drfen nur die Tage,
           --           getestet werden, die zum aktuellen Jahr gehren *)

        outResult := FirstValVtrZuHKinZeitraum (inHKID, JAnfang, JEnde, outVtr);

	IF outResult THEN

	  REPEAT
            (* -- jeden Tag des Vertrags durchlaufen und zugehoerigen Monat bestimmen *)

            LaufDatum := LGueltigVonInVtr ( outVtr ) ;
            VtrEnde   := LGueltigBisInVtr ( outVtr ) ;

            WHILE NOT SmallerDatum (VtrEnde, LaufDatum) DO

              (* -- Monat des Datums bestimmen und in Monatsfeld markieren, falls Datum
                 -- im aktuellen Jahr liegt *)
              IF IsEqualJahr ( LiesJahrInDatum (LaufDatum), LiesJahrInDatum (inDatum) ) THEN
              	Index := MonatAlsCard ( LiesMonatInDatum (LaufDatum) );
              	MonateFeld [Index] := TRUE
	      END; (* IsEqualJahr *)
	
	      IncDatum (LaufDatum)

                (* -- VtrBez.FirstValidVtrZuHKinZeitraum (inPersID : TPersID;
                   --      inAnfang,inEnde :TDatum; VAR outVtr : TVtr) : BOOLEAN;
                   -- VtrBez.NextValidVtrZuHKinZeitraum  (inPersID : TPersID;
                   --      inAnfang,inEnde : TDatum; VAR inoutVtr : TVtr) : BOOLEAN;:
                   --      soll ersten/naechsten nicht stornierten, lfd oder nicht,
                   --      Vertrag der HK innerhalb des Jahres zurckgeben
        	   -- Vtr.LiesGueltigVoninVtr (inVtr: TVtr) : TDatum;
	           -- Vtr.LiesGueltigBisinVtr (inVtr : TVtr) : TDatum;
                   -- in allen Vertraegen jeden Tag duchlaufen und zugehoerigen Monat
	           -- ermitteln, Monat in
                   -- lokalem Feld markieren und Anzahl der Monate bestimmen :
        	   -- Datum.MonatAlsCardinal (inM : TMonat) : CARDINAL;
	           -- Datum.IncDatum(VAR inoutDatum : TDatum);
                 *)

            END (* WHILE *);
            DisposeDatum (LaufDatum);
            DisposeDatum (VtrEnde);

          UNTIL NOT NextValVtrZuHKinZeitraum (inHKID, JAnfang, JEnde, outVtr);

          DispVtr (outVtr);

          (* -- Anzahl der markierten Monate bestimmen *)
	  FOR Index := 1 TO 12 DO
            IF MonateFeld [Index] = TRUE THEN AnzMonate := AnzMonate + 1 END;
	  END (* FOR *);

	END (* IF outResult *);
        DisposeDatum (JAnfang);
	DisposeDatum (JEnde);

        RETURN AnzMonate

  END AnzahlMonateImJahr;

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)



(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

  PROCEDURE BerechneWGDerHK ( inHK : THK; inWK : TKond; inDatum : TDatum) : CARDINAL;
  (* inDatum ist der Stichtag in Datumsform *)
  VAR
	StdImBMonat  : CARDINAL;	(* -- Stunden im Bemessungsmonat *)
        outTK        : TKond;
	MonatsBetrag : CARDINAL;
	WeihnGeld    : CARDINAL;
	WAnfang      : TDatum;	(* -- Datum des Wochenanfangs *)
	WEnde        : TDatum;	(* -- Datum des Wochenausgangs *)
	outResult    : BOOLEAN;
	outVtr       : TVtr;

  BEGIN
          (* -- Geleistete Stunden im Bemessungsmonat ermitteln*)
	  StdImBMonat  := 0;
          WeihnGeld    := 0;
	  MonatsBetrag := 0;

          (* -- FOR alle Wochen W IN WK.Bemessungsmonat DO *)
          ErsteWocheInMonat (inDatum, WAnfang, WEnde);

	  REPEAT
	    outResult := FirstValVtrZuHKinZeitraum ( LHKID (inHK), WAnfang, WEnde, outVtr);
            REPEAT

	   (* -- fuer alle Vertraege der HK, die die Woche enthalten DO
              -- Bemerkung : Vertraege beinhalten laut Mario nur ganze Wochen
              -- daraus folgt : ein Vertrag enthaelt die Woche ganz oder gar nicht.
              -- D.h. an dieser Stelle ist schon sicher, dass die gefragte Woche
              -- im Vertragszeitraum ist, so dass die geleistete Stunden aktualisiert
              -- werden kann
           *)

                StdImBMonat := StdImBMonat + LStdZahlInVtr (outVtr)

            UNTIL NOT NextValVtrZuHKinZeitraum ( LHKID (inHK), WAnfang, WEnde, outVtr);
            IF outResult THEN DispVtr (outVtr) END;

          UNTIL NOT NaechsteWocheInMonat (inDatum, WAnfang, WEnde);

	  (* -- Ende geleistete Stunden im Bemessungsmonat ermitteln *)

          IF HoleAktTKond (inDatum, outTK) THEN
                (* -- Am Berechnungstag geltende Tarifkondition *)
		(* -- TK := Konden.HoleGueltigeTKond( inD: TDatum); *)
          	MonatsBetrag := LStdSinTKond (outTK) * StdImBMonat;
		
	  	DispKond (outTK);

          	WeihnGeld := MonatsBetrag * AnzahlMonateImJahr( LHKID (inHK), inDatum) / 12;
          END (* IF *);

          DisposeDatum (WAnfang);
          DisposeDatum (WEnde);

          RETURN WeihnGeld

  END BerechneWGDerHK;

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

  PROCEDURE WGeldBuchen (inHK : THK; inWK : TKond; inDatum : TDatum);
        (* -- inDatum enthaelt Stichtag *)
	(* -- Eingaben:	Hilfskraft H, Weihnachtsgeldkondition WK, Datum von D2.2.1)
	   -- Ausgaben:	Druckauftrag  an D2.8
	   -- Vorbedingungen: 	...
	   -- Nachbedingungen:	...   *)

    VAR AnzMonate    : CARDINAL;
	WeihnGeld    : CARDINAL;
	Stdzahl      : CARDINAL;
	Anteil	     : CARDINAL;
	WAnfang      : TDatum;	(* -- Datum des Wochenanfangs *)
	WEnde        : TDatum;	(* -- Datum des Wochenausgangs *)
	outResult    : BOOLEAN;
	outDruckErfolg : BOOLEAN;
	outVtr       : TVtr;
	outBu	     : TBu;
	outMsg	     : TString;
	druckString  : TString; (* -- Dieser String wird zum Ausdrucken verwendet *)
	lokString    : ARRAY [0..255] OF CHAR;


    BEGIN
	(* -- Monate := Anzahl Monate, die die Hilfskraft in Datum.Jahr
           -- beschaeftigt war,angefangene Monate werden voll gezaehlt;
     	   -- eine HK ist nur WG-berechtigt, falls sie im Jahr mehr als 5
     	   -- Monate beschaeftigt war
	*)

     	WeihnGeld := 0;
	AnzMonate := AnzahlMonateImJahr ( LHKID (inHK), inDatum );

	IF (AnzMonate > 5) THEN

          WeihnGeld := BerechneWGDerHK (inHK, inWK, inDatum);

          (*
            -- Stunden := Summe Stundenzahl aller am Stichtag geltenden
		     Vertraege der Hilfskraft ;
     	    -- Stunden wird nur zur Bestimmung des Anteils einer Kst am WG
     	    -- benoetigt und wird daher nur in WGAnteilDerKst benoetigt
          *)

          outResult := FirstValVtrZuHKmitZeitpunkt ( LHKID (inHK),inDatum, outVtr);

	  (* -- falls es einen gueltigen Vertrag mit dem Stichtag gibt, muss
     	     -- fuer diesen Vertrag berechnet werden, welchen Anteil die durch
             -- diesen Vertrag betroffene Kst am WG zu zahlen hat *)

          IF outResult THEN

            REPEAT
              Anteil := WGAnteilDerKst (outVtr, inDatum, WeihnGeld);
                       (* WeihnGeld * LStdZahlInVtr (outVtr) / Stdzahl; *)

                (*
		B := Buchung.create (V.KostenstellenID, V.VertragsID,
                                                  Anteil, Datum, "WG");
                Buchungen.add (B);
				   -- CreateBu(...), LiesVtrIDInVtr, LiesKstIDInVtr,
				   -- SetzeKstIDinBu, SetzeVtrIDInBu, SetzeBetragInBu,
                                   -- SetzeGebuchtAminBu, SetzeBuchungsArtInBu,
				   -- InsertBu
			
		Druckauftrag (V.VertragsID, V.KostenstellenID, Anteil, Datum, "WG")
				   -- Print(...)..., VtrIDAlsString, KstIDAlsString,
                                   -- DatumAlsString, CardAlsString
		*)

	        outBu := CreateBg();
		SetVtrIDinBu       (outBu, LVtrIDinVtr (outVtr) );
                SetKstIDinBu       (outBu, LKstIDinVtr (outVtr) );
	        SetGebuchtAmInBu   (outBu, inDatum);
	        SetBetragInBu      (outBu, Anteil);
	        SetBuchungsArtInBu (outBu, WG);
	
	        IF InsertBg (outBu, outMsg) THEN
	        	(* -- Druckausgabe *)
	        	(* -- outMsg wird in Druck wiederverwendet! *)
	        	druckString := String.Create();
	        	String.Schreibe (druckString, "Buchung : ");
	        	outDruckErfolg := Druck (druckString, outMsg);
	        	
	        	IF outDruckErfolg THEN
	        		outDruckErfolg := Druck ( VtrID2String ( LVtrIDinVtr (outVtr)), outMsg )
	        	END;
	        	
	        	IF outDruckErfolg THEN
	        		outDruckErfolg := Druck ( KstID2String ( LKstIDinVtr (outVtr)), outMsg )
	        	END;
	        	
	        	IF outDruckErfolg THEN
	        		outDruckErfolg := Druck ( DatumAlsString (inDatum), outMsg )
	        	END;
			
			IF outDruckErfolg THEN
				WholeStr.CardToStr( Anteil, lokString );
				String.Schreibe (druckString, lokString);
				outDruckErfolg := Druck (druckString, outMsg)
			END;
			
			IF outDruckErfolg THEN
				String.Schreibe (druckString, "Buchungsende");
				outDruckErfolg := Druck (druckString, outMsg)
			END;
			
			String.Dispose (druckString);
			
		END (* IF *);
		
		DispBu             (outBu);

             UNTIL NOT NextValVtrZuHKmitZeitpunkt ( LHKID (inHK), inDatum, outVtr);

           END (* outResult *)
	END (* IF AnzMonate *);
    END WGeldBuchen;

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)	

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

  PROCEDURE WGeldErmitteln (inDatum: TDatum);

  	    (* --Buchen der Weihnachtsgelder z. Stichtag; Prozess D2.2.1*)
  	    (* --> Prozess D 2.2.2 (Weihnachtsgeld buchen) --> D 2.5 (Druckprozess) *)
            (* -- PROZESS-SPEZIFIKATION betroffene Hilfskrfte ermitteln (D2.2.1)
	       -- Eingaben: 	Datum von Proze D2.1
	       -- Ausgaben:	Hilfskraft + Datum + Weihnachtsgeldkondition an Proze D2.2.2

	       -- Vorbedingungen: ...
	       -- Nachbedingungen:...    *)

  VAR	outWK      : TKond;       (* -- am inDatum geltende WG-Kond *)
        outStTag   : TStag;
        outResult  : BOOLEAN;
        outVtr     : TVtr;
        outHK	   : THK;

  BEGIN
    (* Ermittle die am inDatum gueltige Weihnachtsgeldkondition WK *)

    outResult := HoleAktWKond (inDatum, outWK);

    IF outResult THEN

      outStTag := LSTagDerWKond (outWK);

      IF (IsEqualTag   (LiesTagInStag   (outStTag), LiesTagInDatum   (inDatum)) AND
          IsEqualMonat (LiesMonatInStag (outStTag), LiesMonatInDatum (inDatum))) THEN
	(*
     	       -- IF (WK.Stichtag.Tag = Datum.Tag) and (WK.Stichtag.Monat = Datum.Monat)
     	       -- falls das uebergebene inDatum gleich dem Stichtag ist
               --    THEN
               --   FOR alle Hilfskrfte H DO *)

          outResult := ErsteHK (outHK);

          IF outResult THEN

            REPEAT
              (* -- FirstHK(VAR outHK : THK), NextHK( VAR inoutHK : THK *)
	      (* --IF es existiert ein Vertrag V mit (V.PersonenID = H.PersonenID) and
                       (WK.Stichtag IN [V.GltigVon, V.GltigBis]) THEN *)

                IF FirstValVtrZuHKmitZeitpunkt ( LHKID (outHK), inDatum, outVtr) THEN

		     (* -- LiesPersID,
		      -- IF
                      --   FirstValidVtrZuHKinZeitpunkt(inPersID: TPersID, inDatum: TDatum,
                      --                         VAR outVtr:TVtr):BOOLEAN;
	              -- THEN
		      --   wobei als inDatum hier inStichtag bergeben wird, da an dieser
                      --   Stelle inDatum den Stichtag enthaelt
 		       WGeldBuchen (H, WK, Datum)
               	       END
		       END
	               END
	               END *)

                  WGeldBuchen (outHK, outWK, inDatum);
                  DispVtr (outVtr)

                END (* IF FirstValVtr... *);
            UNTIL NOT NaechsteHK(outHK);
            DispHK (outHK)

          END (* outResult *);

      END (* IF IsEqual and IsEqual *);
      DispKond    (outWK);
      DisposeStag (outStTag);

    END (* IF outResult *);
  END WGeldErmitteln;

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)
	
  PROCEDURE LiquidierenKst (inKst : TKst; inDatum : TDatum);

	(* -- PROZESS-SPEZIFIKATION Kostenstelle liquidieren (D2.3.2)
	   -- Eingaben: 	Kostenstelle + Datum (von Proze D2.3.1)
	   -- Ausgaben:	Druckauftrag (an Proze D2.5)

	   -- Vorbedingungen: 	Kostenstelle nicht liquidiert
	   -- Nachbedingungen:	...  *)     	

    VAR
	Betrag 		: INTEGER;
	outBu  		: TBu;
	result 		: BOOLEAN;
	outDruckErfolg	: BOOLEAN;
	outMsg 		: TString;
	druckString	: TString;
	lokString	: ARRAY [0..255] OF CHAR;

    BEGIN
	(*Betrag := Kostenstelle.Kontingente * Kostenstelle.quivalent;*)
	(* -- BerechneEtatKst (inKstID: TKstID): Integer  *)

        Betrag := 0;
	Betrag := EtatDerKst ( LKIDinKst (inKst) );

	IF ErsteBuZuKst ( LKIDinKst (inKst), outBu) THEN

	(* FOR alle Buchungen B mit B.KostenstellenID = Kostenstelle.KostenstellenID DO*)
	(* -- FirstBuMitKstID, NextBuMitKstID *)

            REPEAT
		IF NOT BuStorniert (outBu) THEN
		
		    Betrag := Betrag - LBetragInBu (outBu);
			
		END; (*IF*)
            UNTIL NOT NaechsteBuZuKst ( LKIDinKst (inKst), outBu);

            DispBu (outBu);

	END; (* ErsteBuZuKst *)

	IF Betrag <> 0 THEN
	    outBu := CreateBg();
            SetKstIDinBu       (outBu, LKIDinKst (inKst) );
	    SetGebuchtAmInBu   (outBu, inDatum);
	    SetBetragInBu      (outBu, -Betrag);
	    SetBuchungsArtInBu (outBu, Abschluss);
                (* Felder zuweisen: (Kostenstelle.KostenstellenID,
                                     UNDEF, -Betrag, Datum, Abschluss);*)
	    result := InsertBg (outBu, outMsg);
	    DispBu   (outBu);
	END; (*IF*)

	SetKstLiquAm (inKst, inDatum);
	(* Kostenstelle.LiquidiertAm := Datum;*)
	(* automatische Druckaufbereitung (Kostenstelle, Betrag) *)

	druckString := String.Create ();
	String.Schreibe (druckString, "Kostenstelle (ID) liquidiert :");
	outDruckErfolg := Druck (druckString, outMsg);
	
	IF outDruckErfolg THEN
		outDruckErfolg := Druck ( KstID2String ( LKIDinKst (inKst) ), outMsg )
	END;
	
	IF outDruckErfolg THEN
		outDruckErfolg := Druck ( DatumAlsString (inDatum) , outMsg)
	END;
			
	IF outDruckErfolg THEN
		WholeStr.IntToStr( Betrag, lokString );
		String.Schreibe (druckString, lokString);
		outDruckErfolg := Druck (druckString, outMsg)
	END;
			
	IF outDruckErfolg THEN
		String.Schreibe (druckString, "Buchungsende");
		outDruckErfolg := Druck (druckString, outMsg)
	END;	
		
	String.Dispose (druckString);
	
    END LiquidierenKst;

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

  PROCEDURE Jahresabschluss (inDatum: TDatum);
  	   (* -- Abschlu d. Kostenstellen z. Jahres- bzw. Semesterende; Prozess D2.3.1*)
           (* --> Prozess D 2.3.2 (Lehrgebiet liquidieren) --> D 2.5 (Druckprozess)   *)

	   (* -- PROZESS-SPEZIFIKATION betroffene Kostenstellen ermitteln (D2.3.1)
	      -- Eingaben: 	Datum von Proze D2.1*)
	   (*	Ausgaben:	Kostenstelle + Datum -- an Proze D2.3.2

		Vorbedingungen: 	...
		Nachbedingungen:	...
           *)
  VAR
	outKst   : TKst;

  BEGIN
	(* -- falls Jahresanfang : 01.01.xxxx *)

	IF PruefeObMonatsErster(inDatum) AND PruefeObMonatJanuar (inDatum) THEN

           IF ErsteAktKst (outKst) THEN

              REPEAT

		IF IsEqualJahr (LJahrInKst (outKst),
                                LetztesJahr (LiesJahrInDatum (inDatum)) ) THEN
                    LiquidierenKst(outKst, inDatum);
		        (* FOR alle Kostenstellen K DO *)
			(* -- FirstLfdKst, NextLfdKst *)
			(*IF K.Jahr = Datum.Jahr - 1 THEN*)
			(* -- Ksten.LiesJahrInKst, Datum.LiesJahrInDatum,
                           -- LetztesJahrInDatum, IsEqualJahrInDatum *)
 			(*	Kostenstelle liquidieren (K, Datum)*)
			(*END IF*)
		        (*END FOR*)
                END (* IsEqual *)
              UNTIL NOT NaechsteAktKst (outKst);
              DispKst (outKst);

            END (* AktKst *);

	 END (*IF pruefe *);

  END Jahresabschluss;

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)



PROCEDURE NachziehenAutoBuen(inoutLAD : TDatum; inAktDat : TDatum);
	(*
	-- vb: inLAD< AktDatum - 1
	-- Rufe fr jeden Tag in der Differenz inAktDatum-inLAD die Procedures
	-- betroffeneHilfsKraefteErmitteln und betroffeneLehrgebieteErmitteln
	-- nb: automatischer Betrieb fr die Tage im Zeitinterval [inLAD,AktDatum]
	-- sind durchgefhrt
	-- Prozess D 2.1 Datumsverwaltung
	*)
       (*
       -- PROZESS-SPEZIFIKATION Datumsverwaltung (D2.1)
       -- Eingaben: 	Datum Uhr
       --        	Erlaubnis zum automatischen Betrieb vom Proze D1
       -- Ausgaben:	Datum ( an die Prozesse D2.2 - D2.4
       --         	Ende des automatischen Betriebs (an Proze D1

       -- Vorbedingungen: 	...
       -- Nachbedingungen:	...*)

  BEGIN
		 (* Vergleich des Systemdatums mit dem aktuellen Datum ;*)
		 (* WHILE Systemdatum < aktuelles Datum DO *)
      WHILE SmallerDatum (inoutLAD, inAktDat) DO
                       (* rufe die Prozesse 2.2 - 2.3 auf *)
          WGeldErmitteln (inoutLAD);
          Jahresabschluss(inoutLAD);
		       (* Systemdatum := Systemdatum + 1; *)
	  IncDatum (inoutLAD);
      END (*WHILE*);

  END NachziehenAutoBuen;



(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)
  	     	
END Auto.
