MODULE autotest;

IMPORT Auto;
IMPORT HKB;
IMPORT String;
IMPORT Stringliste;
IMPORT Datum;
IMPORT HKe;
IMPORT Ksten;
IMPORT Konden;
IMPORT Buen;
IMPORT Vtre;

FROM SysDat	IMPORT TVersion, VersionVonString, SetzeSystemDatumInSysDat,
                       LiesSystemDatumInSysDat;
FROM Adm	IMPORT InitSystemInAdm;

FROM InOut IMPORT WriteString, WriteLn, ReadString, WriteCard, ReadCard, WriteInt;


TYPE TString = String.TString;
     TStringliste = Stringliste.TStringliste;
     TDatum  = Datum.TDatum;
     THK     = HKe.THK;
     TPersID = HKe.TPersID;
     TKst    = Ksten.TKst;
     TKstID  = Ksten.TKstID;
     TKond   = Konden.TKond;
     TBu     = Buen.TBu;
     TVtr    = Vtre.TVtr;
     TVtrID  = Vtre.TVtrID;


(* -- es wird eine vorgegebene Versionsnummer verwendet
   -- VersNr = 1 : TVersion *)

VAR Befehl          	: CARDINAL;
    TestProcs       	: ARRAY[0..20] OF PROC;
    MaxProcNr       	: CARDINAL;

	outVersNr	: TVersion;
	outVStr		: TString;
	outMsg		: TString;
	outResult	: BOOLEAN;
	Auswahl		: CARDINAL;
	StrArray	: ARRAY [0..255] OF CHAR;
	SysDatum	: TDatum;



 PROCEDURE LiesDatum () : TDatum;
 VAR 	DatStr : TDatum;
     	eingabe: TString;
	Msg    : TString;
	res    : BOOLEAN;
 BEGIN
	StringEingeben ("Datum :", eingabe);
	res := Datum.DatumVonString (eingabe, DatStr, Msg);
	IF NOT res THEN String.Dispose (Msg) END;
	String.Dispose (eingabe);
	RETURN DatStr;
 END LiesDatum;


 PROCEDURE LiesHKID () : TPersID;
 VAR	outHKID	: TPersID;
	eingabe : TString;
 BEGIN
	StringEingeben ("HKID :",eingabe);
	outHKID := HKe.StringInPersID (eingabe);
	String.Dispose (eingabe);
	RETURN outHKID;
 END LiesHKID;


 PROCEDURE LiesKstID () : TKstID;
 VAR	outKstID	: TKstID;
	eingabe 	: TString;
 BEGIN
	StringEingeben ("KstID :",eingabe);
	outKstID := Ksten.StringInKstID (eingabe);
	String.Dispose (eingabe);
	RETURN outKstID;
 END LiesKstID;


 PROCEDURE LiesVtrID () : TVtrID;
 VAR	outVtrID	: TVtrID;
	eingabe 	: TString;
 BEGIN
	StringEingeben ("VtrID :",eingabe);
	outVtrID := Vtre.StringInVtrID (eingabe);
	String.Dispose (eingabe);
	RETURN outVtrID;
 END LiesVtrID;

	
 PROCEDURE Nachz();
 VAR LAD   : TDatum;

 BEGIN
      WriteString ("Letztes akt. Datum :");
      LAD := LiesDatum();

      Auto.NachziehenAutoBuen(LAD,
			LiesSystemDatumInSysDat());

      Datum.DisposeDatum (LAD);
 END Nachz;


 PROCEDURE AnzM();
 VAR 	HKID : TPersID;
     	inDat: TDatum;
     	out  : CARDINAL;

	result: BOOLEAN;
 BEGIN

	HKID := LiesHKID();
	inDat := LiesDatum();
	out := Auto.AnzahlMonateImJahr(HKID,inDat);
	HKe.DisposePersID (HKID);
	Datum.DisposeDatum (inDat);
	WriteString ("AnzahlMonate :");
	WriteCard (out, 10);
	WriteLn;
 END AnzM;


 PROCEDURE HKWGBer();
 VAR inDat: TDatum;
     out  : BOOLEAN;
     eingabe : TString;
	datum : TString;
	Msg	: TString;
	result	: BOOLEAN;
 BEGIN
	StringEingeben ("HKID :", eingabe);
	StringEingeben ("Datum:", datum);
	result := Datum.DatumVonString (datum, inDat, Msg);
     	out := Auto.HKWGBerechtigt(HKe.StringInPersID (eingabe), inDat);
	IF out THEN WriteString ("WGBerechtigt"); WriteLn
	ELSE
		WriteString ("nicht WGBerechtigt");
		WriteLn;
	END;
	String.Dispose (eingabe);
	String.Dispose (datum);
 END HKWGBer;


 PROCEDURE BerWG();
 VAR inHK       : THK;
     outHKID	: TPersID;
     inWK       : TKond;
     inStTagDat : TDatum;
	datum	: TString;
	Msg	: TString;
	out	: CARDINAL;
	eingabe	: TString;
	result	: BOOLEAN;
 BEGIN
	StringEingeben("HKID : ",eingabe);
	StringEingeben("Datum: ",datum);

	result := Datum.DatumVonString (datum, inStTagDat, Msg);
	IF NOT result THEN WriteString ("Fehler in Datumstring") END;
        outHKID := HKe.StringInPersID (eingabe);
	result := HKe.SearchHK( outHKID, inHK);
	IF NOT result THEN WriteString ("Fehler in HKID") END;
	result := Konden.HoleGueltigeWKond (inStTagDat, inWK);
	IF NOT result THEN WriteString ("Fehler in WKond") END;
	out := Auto.BerechneWGDerHK(inHK, inWK, inStTagDat);

	WriteString ("WG der HK :");
	WriteCard (out, 10);

	HKe.DisposeHK(inHK);
	HKe.DisposePersID (outHKID);
	Konden.DisposeKond (inWK);
	Datum.DisposeDatum (inStTagDat);
	String.Dispose (datum);
	String.Dispose (eingabe);
 END BerWG;


 PROCEDURE WGAnt();
 VAR Vtr    : TVtr;
     inStDat: TDatum;
     inWG   : CARDINAL;
	out : CARDINAL;
	WG  : CARDINAL;
	vStr: TString;
	datum: TString;
	Msg : TString;
	result : BOOLEAN;
 BEGIN
	StringEingeben ("VtrID :", vStr);
	StringEingeben ("Datum :", datum);
	WriteString ("WG = 10000 Pf");
	WriteLn;
	inWG := 10000;
	IF Vtre.SearchVtr (Vtre.StringInVtrID (vStr), Vtr) THEN
		WriteString ("Vtr gefunden")
	ELSE
		WriteString ("Vtr nicht gefunden")
	END;
	WriteLn;
	result := Datum.DatumVonString (datum, inStDat, Msg);
	out := Auto.WGAnteilDerKst(Vtr, inStDat, inWG);
	WriteString ("WG-Anteil :");
	WriteCard ( out, 10);
	WriteLn;
	String.Dispose (vStr);
	String.Dispose (datum);
	Vtre.DisposeVtr (Vtr);
	Datum.DisposeDatum (inStDat);
 END WGAnt;


 PROCEDURE NVtr();
 VAR Vtr    : TVtr;
     outMsg : TString;
	out : BOOLEAN;
	res : BOOLEAN;
 BEGIN
	(* -- NeuVertrag eingeben *)
	Vtr := Vtre.CreateVtr ();
	Vtre.SetzePersIDinVtr (Vtr, LiesHKID());
	Vtre.SetzeKstIDinVtr (Vtr, LiesKstID());
	WriteString ("GueltigVon  ");
	Vtre.SetzeGueltigVoninVtr (Vtr, LiesDatum());
	WriteString ("GueltigBis  ");
	Vtre.SetzeGueltigBisinVtr (Vtr, LiesDatum());
	WriteString ("Erstellt am  ");
	res := Vtre.SetzeErstellDatinVtr (Vtr, LiesDatum());
	WriteString ("Stundenzahl = 50");
	WriteLn;
	res := Vtre.SetzeStdzahlinVtr (Vtr, 50);
        WriteString ("vor NVtrBearbeiten");
	IF HKB.BearbeitenNeuVtr(Vtr, outMsg) THEN
		WriteString ("Neuvertrag erstellt!")
	ELSE
		StringAusgeben (outMsg);
		String.Dispose (outMsg);
	END;
	Vtre.DisposeVtr (Vtr);
 END NVtr;


 PROCEDURE VtrAendern();
 VAR 	Vtr     	: TVtr;
	outVtrID	: TVtrID;
     	Dat     	: TDatum;
	(*SysDatum	: TDatum;*)
     	Msg     	: TString;
	out 		: BOOLEAN;
	inStDat		: TDatum;
	result 		: BOOLEAN;
 BEGIN

        outVtrID := LiesVtrID();
	WriteString ("Neues Vertragsende  ");
	Dat := LiesDatum();
	(*WriteString ("System");
	SysDatum := LiesDatum();
	SetzeSystemDatumInSysDat (SysDatum);*)

	result := Vtre.SearchVtr (outVtrID, Vtr);
	IF result THEN WriteString ("Vtr gefunden") END;

	out := HKB.AendernVtr(Vtr, Dat, Msg);
	IF NOT out THEN StringAusgeben (Msg); String.Dispose(Msg)
	ELSE
        	WriteString ("OK");
		WriteLn;
	END;
	Vtre.DisposeVtrID (outVtrID);
	Vtre.DisposeVtr (Vtr);
	Datum.DisposeDatum (Dat);
	(*Datum.DisposeDatum (SysDatum);*)
 END VtrAendern;


 PROCEDURE VtrStorno();
 VAR 	Vtr     : TVtr;
     	Msg     : TString;
	out	: BOOLEAN;
 BEGIN
	out := Vtre.SearchVtr (LiesVtrID(), Vtr);
	IF out THEN WriteString("Vtr gefunden")
	ELSE
		WriteString ("Vtr nicht gefunden");
	END;
	WriteLn;
	IF HKB.StornierenVtr(Vtr, Msg) THEN
		WriteString ("Storno erfolgreich");
	ELSE
		StringAusgeben(Msg);
		String.Dispose (Msg);
	END;
	WriteLn;
	Vtre.DisposeVtr (Vtr);
 END VtrStorno;


 PROCEDURE RestEtat();
 VAR outKstID : TKstID;
	out : INTEGER;
 BEGIN
	outKstID := LiesKstID();
	out := HKB.BerRestEtatDerKst (outKstID);
	WriteString ("Restetat :");
	WriteInt (out, 10);
	WriteLn;
	Ksten.DisposeKstID (outKstID);
 END RestEtat;


 PROCEDURE AufnHK();
 VAR 	HK     	: THK;
     	Msg 	: TString;
	Name	: TString;
	out	: BOOLEAN;
 BEGIN
	HK := HKe.CreateHK();
        StringEingeben("Name der HK: ",Name);
	HKe.SetzeNameinHK (HK, Name);
	IF HKB.AufnehmenHK (HK, Msg) THEN
		WriteString ("HK aufgenommen");
	ELSE
		StringAusgeben(Msg);
		String.Dispose (Msg);
	END;
	WriteLn;
	HKe.DisposeHK (HK);
 END AufnHK;


 PROCEDURE AendernHK();
 VAR 	HK	: THK;
	outHKID	: TPersID;
     	Msg	: TString;
	name	: TString;
	out	: BOOLEAN;
 BEGIN
	outHKID := LiesHKID();
	IF HKe.SearchHK (outHKID, HK) THEN
		StringEingeben("neuer Name : ", name);
		HKe.SetzeNameinHK (HK, name);
		IF HKB.AendernHK(HK, Msg) THEN
			WriteString ("Aenderung erfolgreich");
		ELSE
			StringAusgeben(Msg);
			String.Dispose(Msg);
		END;
		WriteLn;
		HKe.DisposeHK (HK);
	ELSE
		WriteString ("HK nicht im Ordner gefunden");
	END;
	WriteLn;
	HKe.DisposePersID (outHKID);
 END AendernHK;


 PROCEDURE LoeHK();
 VAR	HK	: THK;
	HKID	: TPersID;
	Msg	: TString;
	res	: BOOLEAN;
 BEGIN
	HKID := LiesHKID();
	res := HKe.SearchHK (HKID, HK);
	IF res AND HKB.LoeschenHK(HK, Msg) THEN
		WriteString ("HK geloescht");
		HKe.DisposeHK (HK);
	ELSE
		StringAusgeben (Msg);
		String.Dispose (Msg);
	END;
	WriteLn;
	HKe.DisposePersID (HKID);
 END LoeHK;


 PROCEDURE KstenListeAllesAusgeben;
 VAR KstenListe : TStringliste;
     ueberschrift : TString;
 BEGIN

    WriteString("******** Operation: Ksten.GibAllesAlsStringlisteInKsten **********");
    WriteLn;

    KstenListe := Ksten.GibAllesAlsStringlisteInKsten();
    ueberschrift := String.Create();
    String.Schreibe (ueberschrift,
    "KstID Name                 Jahr Einr-Datum SperrDatum LiquiDatum Kontingente quivalente");
    StringAusgeben (ueberschrift);
    String.Dispose (ueberschrift);

    KompletteListeAusgeben (KstenListe);
    Stringliste.Dispose (KstenListe);
 END KstenListeAllesAusgeben;


 PROCEDURE VtreAllesListeAusgeben;
 VAR VtreListe : TStringliste;
     headline : TString;
 BEGIN

    WriteString("********* Operation: Vtre.GibAllesAlsStringlisteInVtr ***********");
    WriteLn;

    headline := String.Create();
    String.Schreibe (headline,
    "VtrID PerID KstID ErstellDat GueltigVon GueltigBis Storno     Stdzl Taetigkt   Begruendg ");
    StringAusgeben (headline);
    String.Dispose (headline);
    VtreListe := Vtre.GibAllesAlsStringlisteInVtr();
    KompletteListeAusgeben (VtreListe);
    Stringliste.Dispose (VtreListe);
 END VtreAllesListeAusgeben;


 PROCEDURE HKeAllesListeAusgeben;
 VAR HKeListe : TStringliste;
     headline : TString;
 BEGIN

    WriteString("********* Operation: HKe.GibAllesAlsStringlisteInVtr ***********");
    WriteLn;

    headline := String.Create();
    String.Schreibe (headline,
    "Datenfelder ");
    StringAusgeben (headline);
    String.Dispose (headline);
    HKeListe := HKe.GibHKeAlsStringlisteinHKe();
    KompletteListeAusgeben (HKeListe);
    Stringliste.Dispose (HKeListe);
 END HKeAllesListeAusgeben;


 PROCEDURE KompletteListeAusgeben (Testliste : TStringliste);
    VAR AktuellesElement : String.TString;
 BEGIN
    Stringliste.GoStart (Testliste);
    WHILE NOT Stringliste.OffEnd(Testliste) DO
       AktuellesElement := Stringliste.Current(Testliste);
       StringAusgeben (AktuellesElement);
       String.Dispose (AktuellesElement);
       Stringliste.StepNext(Testliste)
    END; (* WHILE *)
    WriteLn;
    WriteString("Aktuelle Position: OffEnd!");
    WriteLn;
 END KompletteListeAusgeben;




  PROCEDURE Auswahlmenue() : CARDINAL;
  VAR ItemNr : CARDINAL;

     PROCEDURE MenueItem(inItemText : ARRAY OF CHAR);
     BEGIN
       WriteCard (ItemNr, 2);
       WriteString (" --> ");
       WriteString (inItemText);
       WriteLn;
       INC (ItemNr)
    END MenueItem;

  BEGIN
    ItemNr := 0;
    MenueItem ("Programm beenden");
    MenueItem ("Auto.NachziehenAutoBuen");
    MenueItem ("Auto.AnzahlMonateImJahr");
    MenueItem ("Auto.HKWGBerechtigt");
    MenueItem ("Auto.BerechneWGDerHK");
    MenueItem ("Auto.WGAnteilDerKst");
    MenueItem ("HKB.BearbeitenNeuVtr");
    MenueItem ("HKB.AendernVtr");
    MenueItem ("HKB.StornierenVtr");
    MenueItem ("HKB.BerRestEtatDerKst");
    MenueItem ("HKB.AufnehmenHK");
    MenueItem ("HKB.AendernHK");
    MenueItem ("HKB.LoeschenHK");
    MenueItem ("Alle Ksten ausgeben");
    MenueItem ("Alle Vtre ausgeben");
    MenueItem ("Alle HKs ausgeben");


    RETURN IhreWahl()
  END Auswahlmenue;


  PROCEDURE InitTestProcs;
  VAR ProcNr : CARDINAL;

     PROCEDURE ProcEintragen(inOperation : PROC);
     BEGIN
       TestProcs [ProcNr] := inOperation;
       INC (ProcNr)
     END ProcEintragen;

  BEGIN
    ProcNr := 0;
    ProcEintragen (Programmende);
    ProcEintragen (Nachz);
    ProcEintragen (AnzM);
    ProcEintragen (HKWGBer);
    ProcEintragen (BerWG);
    ProcEintragen (WGAnt);
    ProcEintragen (NVtr);
    ProcEintragen (VtrAendern);
    ProcEintragen (VtrStorno);
    ProcEintragen (RestEtat);
    ProcEintragen (AufnHK);
    ProcEintragen (AendernHK);
    ProcEintragen (LoeHK);
    ProcEintragen (KstenListeAllesAusgeben);
    ProcEintragen (VtreAllesListeAusgeben);
    ProcEintragen (HKeAllesListeAusgeben);
    MaxProcNr := ProcNr;
  END InitTestProcs;

PROCEDURE BefehlAuswerten(inBefehl : CARDINAL);
BEGIN

    IF inBefehl < MaxProcNr THEN
      TestProcs [inBefehl];
    ELSE
      WriteString("Dies war eine falsche Eingabe.");
      WriteLn;
    END; (* IF *)
 END BefehlAuswerten;

PROCEDURE Programmende;
BEGIN
   WriteString("Programmende!");
   WriteLn
END Programmende;

PROCEDURE IhreWahl() : CARDINAL;
VAR outEingabe : CARDINAL;
BEGIN
   WriteString("Befehl Nr.: ");
   ReadCard(outEingabe);
   WriteLn;
   RETURN outEingabe
END IhreWahl;

PROCEDURE StringAusgeben (inStr : TString);
   VAR Test : ARRAY[1..50] OF CHAR;
BEGIN
   WriteString("[");
   String.Lies (inStr, Test);
   WriteString(Test);
   WriteString("]");
   WriteLn;
END StringAusgeben;

PROCEDURE StringEingeben (frage: ARRAY OF CHAR; VAR outStr : TString);
VAR Wert : ARRAY [0..50] OF CHAR;
BEGIN
   WriteString(frage);
   ReadString(Wert);
   outStr := String.Create();
   String.Schreibe (outStr, Wert);
   WriteLn;
END StringEingeben;




BEGIN
  InitTestProcs;
	(* -- Laden der Testdaten *)
	outResult := FALSE;
	WriteString("Autotest!");
	WriteLn;
	(* -- Systemdatum setzen *)
	WriteString ("System");
	SysDatum := LiesDatum();
	SetzeSystemDatumInSysDat (SysDatum);
	Datum.DisposeDatum (SysDatum);

	outVStr := String.Create();
	String.Schreibe (outVStr,"1");
	outResult := VersionVonString (outVStr, outVersNr, outMsg);
	
	IF outResult THEN
	       outResult := InitSystemInAdm (outVersNr, outMsg)
	END;
	
	IF outResult THEN
		WriteString("Version geladen!");
		WriteLn;
	ELSE
		String.Lies (outMsg, StrArray);
		WriteString (StrArray);
		WriteLn;
		String.Dispose (outMsg)
	END;
	
	String.Dispose (outVStr);

  REPEAT
      Befehl := Auswahlmenue();
      BefehlAuswerten (Befehl);
  UNTIL Befehl = 0;

END autotest.