(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: HatBuBez.mod,v $
# $Author: Sopra $
# $Date: 2001/03/10 09:47:50 $
# $Revision: 1.1.1.1 $
# Bemerkungen: 

IMPLEMENTATION MODULE HatBuBez   FM HatBuchungsBeziehung

Sigrid Preuss
*)
(******************************************************************************)
 
IMPLEMENTATION MODULE HatBuBez;

(* FM HatBuchungsBeziehung *)

(* IMPORTE *)
 
IMPORT Vtre;
IMPORT Buen;
FROM String IMPORT TString;

                     
(******************** An TS Buchungen TS_Buen durchgereichte Opeationen ******)  

PROCEDURE FirstBuZuVtr (inVtrID : TVtrID; VAR outBu : TBu) : BOOLEAN;
(*
Vb:	 ExistiertBuID(inoutBu) AND Search(inoutBu.BuID,x)
Die erste nicht stornierte Buchung B mit B.VtrID = inVtrID wird zurueckgegeben und auf diese positioniert
Sei OK der boolsche Rueckgabewert, dann gilt:
Nb:     Ordner nicht leer <=> outBu enthaelt die erste nicht stornierte
        Buchung B mit B.KstID = inKstID
*)

BEGIN
   RETURN Buen.FirstBuZuVtr (inVtrID, outBu);
END FirstBuZuVtr;


PROCEDURE  NextBuZuVtr  (inVtrID : TVtrID; inoutBu : TBu) : BOOLEAN;
(*
Vb:	 ExistiertBuID(inoutBu) AND Search(inoutBu.BuID,x)
Die naechste nicht stornierte Buchung B mit B.VtrID = inVtrID wird zurueckgegeben und auf diese positioniert
Sei OK der boolsche Rueckgabewert, dann gilt:
Nb:	OK <=> inoutBu enthaelt die naechste nicht stornierte Buchung
               mit B.VtrID = inVtrID AND pos_neu = pos_alt + 1
*)
BEGIN
   RETURN Buen.NextBuZuVtr  (inVtrID, inoutBu);
END NextBuZuVtr;



PROCEDURE FirstBuMitBuArtZuVtr (inVtrID : TVtrID; inBuArt : TBuArt;
                                VAR outBu : TBu) : BOOLEAN;
(*
Vb:	 ExistiertBuID(inoutBu) AND Search(inoutBu.BuID,x)
Die erste nicht stornierte Buchung B mit BuchungsArt inBuArt und
B.VtrID = inVtrID wird zurueckgegeben und auf diese positioniert
Sei OK der boolsche Rueckgabewert, dann gilt:
Nb:     Ordner nicht leer <=> outBu enthaelt die erste nicht stornierte
        Buchung B mit BuchungsArt = inBuArt und mit B.KstID = inKstID
*)

BEGIN
   RETURN Buen.FirstBuMitBuArtZuVtr (inVtrID, inBuArt, outBu);
END FirstBuMitBuArtZuVtr;



PROCEDURE  NextBuMitBuArtZuVtr  (inVtrID : TVtrID; inBuArt : TBuArt;
                                 inoutBu : TBu) : BOOLEAN;
(*
Vb:	 ExistiertBuID(inoutBu) AND Search(inoutBu.BuID,x)
Die naechste nicht stornierte Buchung B mit BuchungsArt = inBuArt
und B.VtrID = inVtrID wird zurueckgegeben und auf diese positioniert
Sei OK der boolsche Rueckgabewert, dann gilt:
Nb:	OK <=> inoutBu enthaelt die naechste nicht stornierte Buchung
               BuchungsArt = inBuArt und AND pos_neu = pos_alt + 1
*)

BEGIN
   RETURN Buen.NextBuMitBuArtZuVtr  (inVtrID, inBuArt, inoutBu);
END NextBuMitBuArtZuVtr;



PROCEDURE StorniereBuZuVtr (inVtrID : TVtrID ; VAR outMessage : TString
                           ) : BOOLEAN;
(*
VB: --
Storniert alle Buchungen der Buchungsart "Gehalt" zu dem Vertrag inVtr
Stornierungsdatum ist das aktuelle Systemdatum
Sei OK der boolesche Rueckgabeparameter, dann gilt:
Nb: OK <=> Alle Buchungen  der Buchungsart "Gehalt" zu dem Vertrag inVtr
           sind storniert
*)

BEGIN
   RETURN Buen.StorniereBuZuVtr(inVtrID, outMessage); 
END StorniereBuZuVtr;



END HatBuBez.  	


