
(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: Info.mod,v $
# $Author: Gabi
# $Date: 2001/03/14 10:36:30 $
# $Revision: 1
Bemerkungen:

 Informationsbetrieb wie in Produktskizze der Aufgabenstellung  Seite 13
ergibt sich als Abfallprodukt aus dem Datenteilsystem


z.B:
- Erstelle eine aktuelle Vertragsliste fr eine Hilfskraft
- Ermittle alle Vertrge einer Hilfskraft innerhalb eines vorgegebenen Zeitraums (z,B. Jahres) bzw. alle Vertrge einer Hilfskraft
- Ermittle alle Hilfskrfte, deren Vertrge bis zu einem bestimmten Zeitpunkt auslaufen
- Liefere alle Buchungen auf einer Kostenstelle innerhalb eines Zeitraumes
- Ermittle die insgesamt verfgbaren Haushaltsmittel auf einer oder mehrerer Kostenstellen des Lehrgebietes (in DM, Hilfskraf-Stunden oder als Anzahl damit finalzierbarer Hilfskrfte mit 19 h Beschftigungszeit pro Woche)

*****************************************************************************)

IMPLEMENTATION MODULE Info;

IMPORT Stringliste;
IMPORT String;
IMPORT Ksten;
IMPORT Buen;
IMPORT Konden;
IMPORT Vtre;
IMPORT HKe;
IMPORT HKB;

FROM WholeStr IMPORT IntToStr;

TYPE TStringliste = Stringliste.TStringliste;
     TString      = String.TString;

(************************************************************************************************)

PROCEDURE ZeigeAlleKsten(): TStringliste;
(* Schoenhammer, Herbert: Aufgebohrt, damit der RestEtat der Kostenstelle mit ausgegeben wird *)

(*
Gib die Kostenstellen die nicht liquidiert sind mit folgender Formatierung als Stringliste aus;
	   Formatierung: KstenID (5Zeichen); 1 Leerzeichen; Name (20Zeichen);
	   1 Leerzeichen; Jahr (4Zeichen);
	   1 Leerzeichen; Sperrdatum wenn vorhanden, sonst Leerzeichen (10Zeichen);
	   insgesamt also 42 Zeichen 	
*)
VAR KstenListe : TStringliste;
    aktString, kstid_str, etat_str, blank, komma_str, null_str, prefix : TString;
    kstid : Ksten.TKstID;
    restetat : INTEGER;
    arrayofchar : ARRAY [1..255] OF CHAR;
    laenge,i : CARDINAL;
CONST laenge_betrag = 12;
BEGIN

    KstenListe := Ksten.GibAllesAlsStringlisteInKsten();

    IF NOT Stringliste.IsEmpty (KstenListe) THEN

       kstid_str := String.Create();
       etat_str := String.Create();

       blank := String.Create();
       String.Schreibe (blank, " ");

       komma_str := String.Create ();
       String.Schreibe (komma_str, ",");

       null_str := String.Create ();
       String.Schreibe (null_str, "0");

       Stringliste.GoStart (KstenListe);

       WHILE NOT Stringliste.OffEnd (KstenListe) DO
          aktString := Stringliste.Current (KstenListe);
          String.Auslesen (aktString, 0, 5, kstid_str);
          kstid := Ksten.StringInKstID (kstid_str);

          String.Anhaengen (blank, aktString);

          restetat := HKB.BerRestEtatDerKst (kstid);
          IntToStr (restetat, arrayofchar);
          String.Schreibe (etat_str, arrayofchar);

          (* In Ausgabe auf laenge_betrag Zeichen formatieren *)
          laenge := String.Laenge(etat_str);

          (* Sollte RestEtat ein DM-Betrag sein, das folgende aktivieren *)
         IF laenge = 1 THEN
            String.Einfuegen (null_str, 0, etat_str);
            laenge := laenge + 1;
         END;

         IF laenge = 2 THEN
            String.Einfuegen (null_str, 0, etat_str);
            laenge := laenge + 1;
         END;

         String.Einfuegen (komma_str, laenge-2, etat_str);

         IF laenge < laenge_betrag THEN
            prefix := String.Create();
            FOR i := 1 TO (laenge_betrag - laenge - 1) DO
                String.Anhaengen (blank, prefix)
            END; (* FOR *)
            String.Anhaengen (prefix, aktString);
            String.Dispose (prefix);
            String.Anhaengen (etat_str, aktString);
         ELSE
            String.Schreibe (etat_str, "************");
            String.Anhaengen (etat_str, aktString);
         END;

         Stringliste.Update (KstenListe, aktString);
         Stringliste.StepNext (KstenListe);
         String.Dispose (aktString);
         Ksten.DisposeKstID(kstid);

       END; (* WHILE *)

       String.Dispose (kstid_str);
       String.Dispose (etat_str);
       String.Dispose (blank);
       String.Dispose (null_str);
       String.Dispose (komma_str);

    END; (* NOT Stringliste.IsEmpty ... *)

    RETURN KstenListe;

END ZeigeAlleKsten;
(************************************************************************************************)

PROCEDURE ZeigeAlleVtre(): TStringliste;
(*
Gib die Vertrge mit folgender Formatierung als Stringliste aus;
	       Formatierung: VtrID (5Zeichen); 1 Leerzeichen; PersID(5Zeichen) ;
             1 Leerzeichen; KstID (5Zeichen), 1 Leerzeichen;
             Erstellungsdatum (10Zeichen);
	       insgesamt also 28Zeichen
*)
BEGIN
	RETURN Vtre.GibAllesAlsStringlisteInVtr();
END ZeigeAlleVtre;
(************************************************************************************************)

PROCEDURE ZeigeAlleHK(): TStringliste;
(*
Gib die Hilfskraefte in sortierter Reihenfolge (nach Familienname) mit
   folgender Formatierung als Stringliste aus;
   Formatierung: PersId (5Zeichen), 1 Leerzeichen, Familienname(25Zeichen),
   1 Leerzeichen, Vorname (15Zeichen), 1 Leerzeichen, Wohnort (10Zeichen)
   insgesamt also 58Zeichen.
*)
BEGIN
	RETURN HKe.GibAllesAlsStringlisteinHKe();
END ZeigeAlleHK;
(************************************************************************************************)

PROCEDURE ZeigeAlleBuen(): TStringliste;
(*
Gib die Buchungen mit folgender Formatierung als Stringliste aus;
   Formatierung: BuenID (5Zeichen), 1 Leerzeichen, BuchungsArt (6Zeichen),
                 1 Leerzeichen, Buchungsbetrag (10Zeichen), 1 Leerzeichen,
                 Gebucht Am (TT.MM.JJJJ - 10Zeichen)
   insgesamt also 34 Zeichen
*)

BEGIN
	RETURN Buen.GibAllesAlsStringlisteinBuen();
END ZeigeAlleBuen;
(************************************************************************************************)

PROCEDURE ZeigeAlleTKond(): TStringliste;
(*
Gib die Tarif-Konditionen mit folgender Formatierung als Stringliste
          aus; Formatierung: GueltigVon (10Zeichen); 1 Leerzeichen;
          GueltigBis(10Zeichen); 1 Leerzeichen; Stundensatz(5Zeichen);
          insgesamt also 27 Zeichen
*)
BEGIN
 	RETURN Konden.GibTKondAlsStringlisteInKonden();
END ZeigeAlleTKond;
(************************************************************************************************)

PROCEDURE ZeigeAlleVKond(): TStringliste;
(*
Gib die Vertrags-Konditionen mit folgender Formatierung als
          Stringliste aus; Formatierung: GueltigVon (10Zeichen);
          1 Leerzeichen; GueltigBis(10Zeichen); 1 Leerzeichen;
          Beschftigungshchstdauer(5Zeichen); 1 Leerzeichen;
          Stundenobergrenze(5Zeichen); insgesamt also 33 Zeichen
*)
BEGIN
	RETURN Konden.GibVKondAlsStringlisteInKonden();
END ZeigeAlleVKond;
(************************************************************************************************)

PROCEDURE ZeigeAlleWKond(): TStringliste;
(*
Gib die Weihnachtsgeld-Konditionen mit folgender Formatierung als
          Stringliste aus; Formatierung: GueltigVon (10Zeichen); 1 Leerzeichen;
          GueltigBis(10Zeichen); 1 Leerzeichen; Bemessungsmonat(2Zeichen);
          1 Leerzeichen; Stichtag(2Zeichen); insgesamt also 27 Zeichen
*)
BEGIN
	RETURN Konden.GibWKondAlsStringlisteInKonden();
END ZeigeAlleWKond;
(************************************************************************************************)

END Info.
