#
# Aufruf make
# Dieses Makefile erstellt die Teilsysteme
# TS_Datum, TS_Buen, TS_HKe, TS_Konden, TS_Ksten, TS_Vtre
#

################################################################
#      Hauptprogramm hiks erstellen, Beilspiel fuer
#                                    Teilsystem Kostenstellen
################################################################

# vorerst eine Dummy-Datei hiks.mod anlegen
# hiks.o: hiks.mod vdat.o datum.o ksten.o konden.o
#	gpm -g hiks.mod

# vorerst eine Dummy-Datei hiks.mod anlegen
SysKstIMPORT.o: TS_Sys/SysKstIMPORT.mod vdat.o datum.o ksten.o konden.o \
                vtr.o buen.o belbez.o vtrbez.o hatbubez.o psb.o
	gpm -g TS_Sys/SysKstIMPORT.mod


################################################################
#      TS Virtuelles Dateisystem TS_VDat
################################################################

datum.o: TS_Datum/Datum.def TS_Datum/Datum.mod \
         TS_Datum/DatumIMPORTE.def TS_Datum/DatumIMPORTE.mod
	gpm -g TS_Datum/DatumIMPORTE.def
	gpm -g TS_Datum/DatumIMPORTE.mod
	gpm -g TS_Datum/Datum.def
	gpm -g TS_Datum/Datum.mod


################################################################
#      TS Datum TS_Datum
################################################################

vdat.o: datum.o TS_VDat/VDat.def TS_VDat/VDat.mod
	gpm -g TS_VDat/VDat.def
	gpm -g TS_VDat/VDat.mod


################################################################
#      TS Kostenstellen TS_Ksten
################################################################

ksten.o: TS_Ksten/ksten.def TS_Ksten/ksten.mod \
         TS_Ksten/kstenIMPORTE.def TS_Ksten/kstenIMPORTE.mod \
         datum.o vdat.o
	gpm -g TS_Ksten/kstenIMPORTE.def
	gpm -g TS_Ksten/kstenIMPORTE.mod
	gpm -g TS_Ksten/ksten.def
	gpm -g TS_Ksten/ksten.mod


################################################################
#      TS Konditionen TS_Konden
################################################################

konden.o: TS_Konden/konden.def TS_Konden/konden.mod \
          TS_Konden/kondenIMPORTE.def TS_Konden/kondenIMPORTE.mod \
         datum.o vdat.o
	gpm -g TS_Konden/kondenIMPORTE.def
	gpm -g TS_Konden/kondenIMPORTE.mod
	gpm -g TS_Konden/konden.def
	gpm -g TS_Konden/konden.mod

################################################################
#      TS Vertraege TS_Vtr
################################################################

vtr.o: TS_Vtre/vtre.def TS_Vtre/vtre.mod \
          TS_Vtre/vtreIMPORTE.def TS_Vtre/vtreIMPORTE.mod \
         datum.o vdat.o
	gpm -g TS_Vtre/vtreIMPORTE.def
	gpm -g TS_Vtre/vtreIMPORTE.mod
	gpm -g TS_Vtre/vtre.def
	gpm -g TS_Vtre/vtre.mod


################################################################
#      TS Hilfskraefte TS_HKe
################################################################

hke.o: TS_HKe/HKe.def TS_HKe/HKe.mod \
          TS_HKe/HKeIMPORTE.def TS_HKe/HKeIMPORTE.mod \
         datum.o vdat.o
	gpm -g TS_HKe/HKeIMPORTE.def
	gpm -g TS_HKe/HKeIMPORTE.mod
	gpm -g TS_HKe/HKe.def
	gpm -g TS_HKe/HKe.mod



################################################################
#      TS Buchungen TS_Buen
################################################################

hke.o: TS_Buen/Buen.def TS_Buen/Buen.mod \
          TS_Buen/BuenIMPORTE.def TS_Buen/BuenIMPORTE.mod \
         datum.o vdat.o
	gpm -g TS_Buen/BuenIMPORTE.def
	gpm -g TS_Buen/BuenIMPORTE.mod
	gpm -g TS_Buen/Buen.def
	gpm -g TS_Buen/Buen.mod



################################################################
#      FM BelastetBeziehung FM_BelBez
################################################################

belbez.o: FM_BelBez/BelBez.def FM_BelBez/BelBez.mod \
           ksten.o buen.o
	gpm -g FM_BelBez/BelBez.def
	gpm -g FM_BelBez/BelBez.mod


################################################################
#      FM VertragsBeziehungen FM_VtrBez
################################################################

vtrbez.o: FM_VtrBez/VtrBez.def FM_VtrBez/VtrBez.mod \
           ksten.o hke.o vtre.o datumfm.o datum.o
	gpm -g FM_VtrBez/VtrBez.def
	gpm -g FM_VtrBez/VtrBez.mod


################################################################
#      FM HatBuchungBeziehung FM_HatBuBez
################################################################

hatbubez.o: FM_HatBuBez/HatBuBez.def FM_HatBuBez/HatBuBez.mod \
            vtre.o buen.o
	gpm -g FM_HatBuBez/HatBuBez.def
	gpm -g FM_HatBuBez/HatBuBez.mod



################################################################
#      TS Personensachbearbeiter TS_PSB
################################################################

psb.o: TS_PSB/PSB.def TS_PSB/PSB.mod \
          TS_PSB/PSBIMPORTE.def TS_PSB/PSBIMPORTE.mod \
         datum.o vdat.o
	gpm -g TS_PSB/PSBIMPORTE.def
	gpm -g TS_PSB/PSBIMPORTE.mod
	gpm -g TS_PSB/PSB.def
	gpm -g TS_PSB/PSB.mod

