(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: AdmFM.mod,v $
# $Author: Sopra $
# $Date: 2001/03/10 14:10:08 $
# $Revision: 1.2 $
# Bemerkungen: Funktionen der Administratorfunktion.  hgw, 13.1.2001 19:15 
*)
(******************************************************************************)
 
IMPLEMENTATION MODULE AdmFM;

IMPORT 	AdmIMPORTE;
IMPORT 	String, WholeStr;
FROM 	ProgArgs IMPORT EnvironString;

TYPE 	TString = String.TString;
	TModus 	= AdmIMPORTE.TModus;
	THandle = AdmIMPORTE.THandle;

PROCEDURE BackupSystem( VAR outM: TString):BOOLEAN;

	(* Die Lokation der Dateien wird ber die Umgebungsvariable HIKS_DAT *)
	(* und HIKS.SYS festgelegt. *)

VAR 	V		: TVersion;
	M		: TModus;
	H		: THandle;
	success		: BOOLEAN;
	HiKS_Dat	: ARRAY [1..255] OF CHAR;
	qualiFileName	: TString;
	message		: TString;
        CharArray	: ARRAY [1..255] OF CHAR;  
BEGIN
        success:=FALSE;
	message:=NIL;
	EnvironString( "HIKS_DAT",HiKS_Dat );
	
	V:=AdmIMPORTE.LiesBackupVersion();
	M:=AdmIMPORTE.SetWrite();
	
	qualiFileName:=BauFileName(HiKS_Dat, "Konditionen", V);	
	IF AdmIMPORTE.Open(H,qualiFileName,M) THEN
		success:=AdmIMPORTE.SaveKonditionen(H,message);
		IF success THEN
			success:=AdmIMPORTE.Close(H);
		END (* IF *);
	ELSE
		success:=FALSE;
		outM:=String.Create();
		String.Schreibe(outM,
			"Fehler beim Speichern der Konditionen!");
        END (* IF *);
	String.Dispose(qualiFileName);

	qualiFileName:=BauFileName(HiKS_Dat, "Kostenstellen", V);	
	IF AdmIMPORTE.Open(H,qualiFileName,M) AND success THEN
		success:=AdmIMPORTE.SaveKostenstellen(H,message);
		IF success THEN
			success:=AdmIMPORTE.Close(H);
		END (* IF *);
	ELSE
		success:=FALSE;
		outM:=String.Create();
		String.Schreibe(outM,
			"Fehler beim Speichern der Kostenstellen!");
        END (* IF *);
	String.Dispose(qualiFileName);

	qualiFileName:=BauFileName(HiKS_Dat, "Buchungen", V);	
	IF AdmIMPORTE.Open(H,qualiFileName,M) THEN
		success:=AdmIMPORTE.SaveBuchungen(H,message);
		IF success THEN
			success:=AdmIMPORTE.Close(H);
		END (* IF *);
	ELSE
		success:=FALSE;
		outM:=String.Create();
		String.Schreibe(outM,"Fehler beim Speichern der Buchungen!");
        END (* IF *);
	String.Dispose(qualiFileName);

	qualiFileName:=BauFileName(HiKS_Dat, "Vertraege", V);	
	IF AdmIMPORTE.Open(H,qualiFileName,M) THEN
		success:=AdmIMPORTE.SaveVertraege(H,message);
		IF success THEN
			success:=AdmIMPORTE.Close(H);
		END (* IF *);
	ELSE
		success:=FALSE;
		outM:=String.Create();
		String.Schreibe(outM,"Fehler beim Speichern der Vertraege!");
        END (* IF *);
	String.Dispose(qualiFileName);

	qualiFileName:=BauFileName(HiKS_Dat, "Hilfskraefte", V);	
	IF AdmIMPORTE.Open(H,qualiFileName,M) THEN
		success:=AdmIMPORTE.SaveHilfskraefte(H,message);
		IF success THEN
			success:=AdmIMPORTE.Close(H);
		END (* IF *);
	ELSE
		success:=FALSE;
		outM:=String.Create();
		String.Schreibe(outM,
			"Fehler beim Speichern der Hilfskraefte!");
        END (* IF *);
	String.Dispose(qualiFileName);

        qualiFileName:=BauFileName(HiKS_Dat, "HIDVerwaltung", V);
        IF AdmIMPORTE.Open(H,qualiFileName,M) THEN
                success:=AdmIMPORTE.SaveHIDVerwaltung(H,message);
                IF success THEN
                        success:=AdmIMPORTE.Close(H);
                END (* IF *);
        ELSE
                success:=FALSE;
		outM:=String.Create();
                String.Schreibe(outM,
                        "Fehler beim Speichern der Hilfskraft- ID Verwaltung!");
        END (* IF *);
        String.Dispose(qualiFileName);  

	IF success THEN
		AdmIMPORTE.NeuesBackup();(* Inkrementiere Versionszaehler und *)
                                         (* Update der Backuptabelle *)
        	success:=WriteHiKSini(outM);
	END (* IF *);
	IF NOT success AND (message=NIL) THEN
		message:=String.Create();
		outM:=String.Create();
		String.Schreibe(message,
			"Beim Backup des Systems ist ein Fehler aufgetreten!");
	END;
	RETURN success;


END BackupSystem;

PROCEDURE RestoreSystem( V: TVersion ; VAR outM: TString):BOOLEAN;

	(* Die Lokation der Dateien wird ber die Umgebungsvariable HIKS_DAT *)
	(* festgelegt. *)
VAR 
	M		: TModus;
	success		: BOOLEAN;
	H		: THandle;
	HiKS_Dat	: ARRAY [1..255] OF CHAR;
	qualiFileName	: TString;
	message		: TString;
BEGIN
        
	success:=TRUE;
	message:=NIL;
	EnvironString( "HIKS_DAT",HiKS_Dat );
	M:=AdmIMPORTE.SetRead();

	qualiFileName:=BauFileName(HiKS_Dat, "HIDVerwaltung", V);	
	IF AdmIMPORTE.Open(H,qualiFileName,M) THEN
		success:=AdmIMPORTE.LoadHIDVerwaltung(H,message);
                IF success THEN
                        success:=AdmIMPORTE.Close(H);
                END (* IF *);    
	ELSE
		success:=FALSE;
		outM:=String.Create();
		String.Schreibe(outM,
			"Fehler beim Laden der Hilfskraft- ID Verwaltung!");
        END (* IF *);
	String.Dispose(qualiFileName);

	qualiFileName:=BauFileName(HiKS_Dat, "Konditionen", V);	
	IF AdmIMPORTE.Open(H,qualiFileName,M) AND success THEN
		success:=AdmIMPORTE.LoadKonditionen(H,message);
                IF success THEN
                        success:=AdmIMPORTE.Close(H);
                END (* IF *);    
	ELSE
		success:=FALSE;
		outM:=String.Create();
		String.Schreibe(outM,"Fehler beim Laden der Konditionen!");
        END (* IF *);
	String.Dispose(qualiFileName);


	qualiFileName:=BauFileName(HiKS_Dat, "Kostenstellen", V);	
	IF AdmIMPORTE.Open(H,qualiFileName,M) AND success THEN
		success:=AdmIMPORTE.LoadKostenstellen(H,message);
                IF success THEN
                        success:=AdmIMPORTE.Close(H);
                END (* IF *);    
	ELSE
		success:=FALSE;
		outM:=String.Create();
		String.Schreibe(outM,"Fehler beim Laden der Kostenstellen!");
        END (* IF *);
	String.Dispose(qualiFileName);

	qualiFileName:=BauFileName(HiKS_Dat, "Buchungen", V);	
	IF AdmIMPORTE.Open(H,qualiFileName,M) AND success THEN
		success:=AdmIMPORTE.LoadBuchungen(H,message);
                IF success THEN
                        success:=AdmIMPORTE.Close(H);
                END (* IF *);    
	ELSE
		success:=FALSE;
		outM:=String.Create();
		String.Schreibe(outM,"Fehler beim Laden der Buchungen!");
        END (* IF *);
	String.Dispose(qualiFileName);


	qualiFileName:=BauFileName(HiKS_Dat, "Vertraege", V);	
	IF AdmIMPORTE.Open(H,qualiFileName,M) AND success THEN
		success:=AdmIMPORTE.LoadVertraege(H,message);
                IF success THEN
                        success:=AdmIMPORTE.Close(H);
                END (* IF *);    
	ELSE
		success:=FALSE;
		outM:=String.Create();
		String.Schreibe(outM,"Fehler beim Laden der Vertraege!");
        END (* IF *);
	String.Dispose(qualiFileName);


	qualiFileName:=BauFileName(HiKS_Dat, "Hilfskraefte", V);	
	IF AdmIMPORTE.Open(H,qualiFileName,M) AND success THEN
		success:=AdmIMPORTE.LoadHilfskraefte(H,message);
                IF success THEN
                        success:=AdmIMPORTE.Close(H);
                END (* IF *);    
	ELSE
		success:=FALSE;
		outM:=String.Create();
		String.Schreibe(outM,"Fehler beim Laden der Hilfskraefte!");
        END (* IF *);
	String.Dispose(qualiFileName);


	RETURN success;

END RestoreSystem;



PROCEDURE InitSystem( inV: TVersion ; VAR outM: TString):BOOLEAN;
	(* Ruft nacheinander alle Creates fr die BehlterADOs in den Daten   *)
	(* TS auf und fllt diese durch Aufruf von RestoreSystemInAdm         *)
	(* falls InitSystem mit Version=0 aufgerufen wird, startet das System *)
	(* mit leeren Daten-Ordnern					      *)
VAR success	: BOOLEAN;

BEGIN
	(* Createoperationen werden in den Datenteisystemen ausgefuehrt! *)
(*	AdmIMPORTE.CreateKondenOrdner();*) 
(*	AdmIMPORTE.CreateKstenOrdner(); *)
(*	AdmIMPORTE.CreateVtreOrdner();  *)
(*	AdmIMPORTE.CreateHKeOrdner();   *)
(*	AdmIMPORTE.CreateBuenOrdner();  *)
(*	AdmIMPORTE.CreateIDVerwalt();   *)
	success:= AdmIMPORTE.DruckerInit(outM) ;
	(* Falls Version=0 wird nichtsgeladen *);
	IF success AND NOT AdmIMPORTE.IsZeroVersion(inV) THEN
		success:= RestoreSystem(inV,outM);
	END (* IF *);
	RETURN success;
END InitSystem;

PROCEDURE ReadHiKSini( VAR outM: TString):BOOLEAN;
	(* Ldt beim Start des Systems die Datei HiKS.ini und traegt den *)
	(* Inhalt in die Backuptabelle ein *)

VAR	M		: TModus;
	success		: BOOLEAN;
	H		: THandle;
	HiKS_Sys	: ARRAY [1..255] OF CHAR;
	qualiFileName	: TString;
	str		: TString;
BEGIN
        success:=TRUE;
	str:=String.Create();
        qualiFileName:=String.Create();
	EnvironString( "HIKS_SYS",HiKS_Sys );
	String.Schreibe(qualiFileName,HiKS_Sys);
	String.Schreibe(str,"/HiKS.ini");
	String.Anhaengen(str,qualiFileName);
	M:=AdmIMPORTE.SetRead();
	IF AdmIMPORTE.Open(H,qualiFileName,M) THEN
		IF NOT AdmIMPORTE.LoadBackupTable(H,outM) THEN
			success:=FALSE;
			outM:=String.Create();
			String.Schreibe(outM,
				"Fehler beim Lesen der HiKS.ini!");
		END (* IF *);
	        IF NOT AdmIMPORTE.Close(H)  THEN
                	success:=FALSE;
			outM:=String.Create();
                	String.Schreibe(outM,
				"Fehler beim Schliessen der HiKS.ini!");
		END (* IF *); 
	ELSE
		success:=FALSE;
		outM:=String.Create();
		String.Schreibe(outM,"Fehler beim ffnen der HiKS.ini!");
        END (* IF *);
	String.Dispose(str);
        
	RETURN success;
END ReadHiKSini;

PROCEDURE WriteHiKSini( VAR outM: TString):BOOLEAN;
	(* Schreibt den Inhalt der Bakuptabelle in die Datei HiKS.ini *)

VAR	M		: TModus;
	success		: BOOLEAN;
	H		: THandle;
	HiKS_Sys	: ARRAY [1..255] OF CHAR;
	qualiFileName	: TString;
	str		: TString;
BEGIN
        success:=TRUE;
	str:=String.Create();
	qualiFileName:=String.Create();
	EnvironString( "HIKS_SYS",HiKS_Sys );
	String.Schreibe(qualiFileName,HiKS_Sys);
	String.Schreibe(str,"/HiKS.ini");
	String.Anhaengen(str,qualiFileName);
	M:=AdmIMPORTE.SetWrite();
	IF AdmIMPORTE.Open(H,qualiFileName,M) THEN
		IF NOT AdmIMPORTE.SaveBackupTable(H,outM) THEN
			success:=FALSE;
			outM:=String.Create();
			String.Schreibe(outM,
				"Fehler beim Schreiben der HiKS.ini!");
		END (* IF *);
	ELSE
		success:=FALSE;
		outM:=String.Create();
		String.Schreibe(outM,"Fehler beim ffnen der HiKS.ini!");
        END (* IF *);
	IF NOT AdmIMPORTE.Close(H) THEN
                success:=FALSE;
		outM:=String.Create();
                String.Schreibe(outM,"Fehler beim Schliessen der HiKS.ini!");
        END (* IF *);     
	String.Dispose(str);
        
	RETURN success;
END WriteHiKSini;




PROCEDURE BauFileName(	inPfad: ARRAY OF CHAR;
			inName: ARRAY OF CHAR; 
			inV: TVersion): TString;
VAR 	str1,str2	: TString;
	strVersion	: TString;
	backslash	: TString;
BEGIN
	str1:=String.Create();
	str2:=String.Create();
	backslash:=String.Create();   
	String.Schreibe(backslash,"/");
        String.Schreibe(str1,inPfad);
	String.Anhaengen(backslash,str1); (* hier sollte geprueft werden,*)
					  (* ob str1 mit '/' endet ! *)
	String.Schreibe(str2,inName); 		
        String.Anhaengen(str2,str1);
	strVersion:=AdmIMPORTE.Version2String(inV);
	String.Anhaengen(strVersion,str1);
	String.Schreibe(str2,".dat");
	String.Anhaengen(str2,str1);
	String.Dispose(str2);
	String.Dispose(backslash);
	RETURN str1;
END BauFileName;       

END AdmFM.


