(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: Auto2.mod,v $
# $Author: Sopra $      (Reini)
# $Date: 2001/03/10 09:47:52 $
# $Revision: 1.1.1.1 $
# Bemerkungen:
*)
(******************************************************************************)
(******************************************************************************)


IMPLEMENTATION MODULE Auto; (* Version 2.0 *)
  IMPORT AutoIMPORTE;
  IMPORT Datum;


(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

  PROCEDURE WGAnteilDerKst (inVtr : TVtr; inStTagDat : TDatum; inWG : CARDINAL) : CARDINAL;
  (* -- Berechnet den Anteil am WG der HK, den die Kst zu zahlen hat
     -- HK und Kst sind durch inVtr festgelegt, inStTagDat ist das
     -- Datum des Stichtags - vom aktuellen Datum als Schtzung *)

  VAR
	outVtr   : TVtr;     (* zur Bestimmung der Stdzahl *)
	Stdzahl  : CARDINAL; (* *)
	Anteil	 : CARDINAL;
	outResult: BOOLEAN;

  BEGIN

          (*
          Stunden := Summe Stundenzahl aller am Stichtag geltenden Vertraege der Hilfskraft ;
          *)
	  Anteil    := 0;
          Stdzahl   := 0;
          outResult := FirstValVtrZuHKmitZeitpunkt ( LHKIDinVtr (inVtr),inStTagDat,\
                                                     outVtr);

          IF outResult THEN

            REPEAT
              Stdzahl := Stdzahl + LStdZahlInVtr (outVtr);
            UNTIL NOT NextValVtrZuHKmitZeitpunkt ( LHKIDinVtr (inVtr), \
                                                   inStTagDat, outVtr);

              Anteil := inWG * LStdZahlInVtr (inVtr) / Stdzahl;
	   END (* IF *);

	RETURN Anteil

  END WGAnteilDerKst;

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)


(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

  PROCEDURE WGeldErmitteln (inDatum: TDatum);

  	    (* --Buchen der Weihnachtsgelder z. Stichtag; Prozess D2.2.1*)
  	    (* --> Prozess D 2.2.2 (Weihnachtsgeld buchen) --> D 2.5 (Druckprozess) )*
            (* -- PROZESS-SPEZIFIKATION betroffene Hilfskrfte ermitteln (D2.2.1)
	       -- Eingaben: 	Datum von Proze D2.1
	       -- Ausgaben:	Hilfskraft + Datum + Weihnachtsgeldkondition an Proze D2.2.2

	       -- Vorbedingungen: ...
	       -- Nachbedingungen:...    *)

  VAR	outWK      : TKond;
        outStTag   : TStag;
        outResult  : BOOLEAN;
        outVtr     : TVtr;

  BEGIN
    (* Ermittle die am Datum gltige Weihnachtsgeldkondition WK *)

    outResult := HoleAktWKond (inDatum, outWK);

    IF outResult THEN

      outStTag := LSTagDerWKond (outWK);

      IF (IsEqualTag   (LiesTagStag   (outStTag), LiesTagInDatum   (inDatum)) AND
          IsEqualMonat (LiesMonatStag (outStTag), LiesMonatInDatum (inDatum))) THEN
	(* IF (WK.Stichtag.Tag = Datum.Tag) and (WK.Stichtag.Monat = Datum.Monat) *)
                   (* -- HoleGueltigeWKond( inD: TDatum, VAR outWKond):BOOLEAN;
		      -- Stichtag := LiesSTagInWKond( inKondition: TKond): TDatum )
                      -- (LiesMonatStag(Stichtag)=LiesMonatInDatum(Datum)) and
                      -- (LiesTagStag(Stichtag)=LiesTagInDatum(Datum)) *)

        (*   THEN
             FOR alle Hilfskrfte H DO *)

          outResult := ErsteHK (outHK);

          IF outResult THEN

            REPEAT
              (* -- FirstHK(VAR outHK : THK), NextHK( VAR inoutHK : THK *)
	      (* --IF es existiert ein Vertrag V mit (V.PersonenID = H.PersonenID) and
                       (WK.Stichtag IN [V.GltigVon, V.GltigBis]) THEN *)

                IF FirstValVtrZuHKmitZeitpunkt ( LHKID (outHK), inDatum, outVtr) THEN

		     (* -- LiesPersID,
		      -- IF
                      --   FirstValidVtrZuHKinZeitpunkt(inPersID: TPersID, inDatum: TDatum,
                      --                         VAR outVtr:TVtr):BOOLEAN;
	              -- THEN
		      --   wobei als inDatum hier inStichtag bergeben wird, da an dieser
                      --   Stelle inDatum den Stichtag enthaelt
 		       WGeldBuchen (H, WK, Datum)
               	       END
		       END
	               END
	               END *)

                  WGeldBuchen (outHK, outWK, inDatum);
                  DisposeVtr (outVtr)

                END (* IF FirstValVtr... *);
            UNTIL NOT NaechsteHK(outHK);
            DispHK (outHK)

          END (* outResult *);

      END (* IF IsEqual and IsEqual *);
      DispKond    (outWK);
      DisposeStag (outStTag);

    END (* IF outResult *);

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

  PROCEDURE WGeldBuchen (inHK, inWK, inDatum)
        (* -- inDatum enthaelt Stichtag *)
	(* -- Eingaben:	Hilfskraft H, Weihnachtsgeldkondition WK, Datum (*von D2.2.1)
	   -- Ausgaben:	Druckauftrag (* an D2.8
	   -- Vorbedingungen: 	...
	   -- Nachbedingungen:	...   *)

    VAR AnzMonate    : CARDINAL;
	WeihnGeld    : CARDINAL;
	Stdzahl      : CARDINAL;
	Anteil	     : CARDINAL;
	WAnfang      : TDatum;	(* -- Datum des Wochenanfangs *)
	WEnde        : TDatum;	(* -- Datum des Wochenausgangs *)
	outResult    : BOOLEAN;
	outVtr       : TVtr;
	outBu	     : TBu;


    BEGIN
	(* -- Monate := Anzahl Monate, die die Hilfskraft in Datum.Jahr
           -- beschaeftigt war,angefangene Monate werden voll gezaehlt;
	*)

	AnzMonate := AnzahlMonateImJahr ( LHKID (inHK) );

	IF (AnzMonate > 5) THEN

          WeihnGeld := BerechneWGDerHK (inHK, inWK, inDatum);

          (*
          Stunden := Summe Stundenzahl aller am Stichtag geltenden
		     Vertraege der Hilfskraft ;
          *)
          Stdzahl   := 0;
          outResult := FirstValVtrZuHKmitZeitpunkt ( LHKID (inHK),inDatum, outVtr);

	  (* -- falls es einen gueltigen Vertrag mit dem Stichtag gibt *)
          IF outResult THEN
            (*  -- wird wohl nicht mehr gebraucht, bleibt bis zur Ueberpruefung
            REPEAT
              Stdzahl := Stdzahl + LStdZahlInVtr (outVtr);
            UNTIL NOT NextValVtrZuHKmitZeitpunkt ( LHKID (inHK), inDatum, outVtr);

	    outResult := FirstValVtrZuHKmitZeitpunkt ( LHKID (inHK),inDatum, outVtr);
            *)
            REPEAT
              Anteil := WGAnteilDerKst (outVtr, inDatum, WeihnGeld);
                       (* WeihnGeld * LStdZahlInVtr (outVtr) / Stdzahl; *)

                (*
		B := Buchung.create (V.KostenstellenID, V.VertragsID,
                                                  Anteil, Datum, "WG");
                Buchungen.add (B);
				   -- CreateBu(...), LiesVtrIDInVtr, LiesKstIDInVtr,
				   -- SetzeKstIDinBu, SetzeVtrIDInBu, SetzeBetragInBu,
                                   -- SetzeGebuchtAminBu, SetzeBuchungsArtInBu,
				   -- InsertBu
			
		Druckauftrag (V.VertragsID, V.KostenstellenID, Anteil, Datum, "WG")
				   -- Print(...)..., VtrIDAlsString, KstIDAlsString,
                                   -- DatumAlsString, CardAlsString
		*)

	        outBu := CreateBg();
		SetVtrIDinBu       (outBu, LVtrIDinVtr (outVtr) );
                SetKstIDinBu       (outBu, LKstIDinVtr (outVtr) );
	        SetGebuchtAmInBu   (outBu, inDatum);
	        SetBetragInBu      (outBu, Anteil);
	        SetBuchungsArtInBu (outBu, "WG");
	        InsertBg           (outBu);
	        DispBu             (outBu);

		Druck ("Hier drucken!");

             UNTIL NOT NextValVtrZuHKmitZeitpunkt ( LHKID (inHK), inDatum, outVtr);

           END (* outResult *)
	END (* IF AnzMonate *);
    END (* WGeldBuchen*);

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)	

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

  PROCEDURE Jahresabschluss (inDatum: TDatum);
  	   (* -- Abschlu d. Kostenstellen z. Jahres- bzw. Semesterende; Prozess D2.3.1*)
           (* --> Prozess D 2.3.2 (Lehrgebiet liquidieren) --> D 2.5 (Druckprozess)

	   (* -- PROZESS-SPEZIFIKATION betroffene Kostenstellen ermitteln (D2.3.1)
	      -- Eingaben: 	Datum (*von Proze D2.1*)
	   (*	Ausgaben:	Kostenstelle + Datum -- an Proze D2.3.2

		Vorbedingungen: 	...
		Nachbedingungen:	...
           *)
  VAR
	outKst   : TKst;

  BEGIN
	(* -- falls Jahresanfang : 01.01.xxxx *)

	IF PruefeObMonatsErster(inDatum) AND PruefeObMonatJanuar (inDatum) THEN

           IF ErsteLfdKst (outKst) THEN

              REPEAT

		IF IsEqualJahr (LJahrInKst (outKst),
                                LetzteJahr (LiesJahrInDatum (inDatum)) ) THEN
                    LiquidierenKst(outKst, inDatum);
		        (* FOR alle Kostenstellen K DO *)
			(* -- FirstLfdKst, NextLfdKst *)
			(*IF K.Jahr = Datum.Jahr - 1 THEN*)
			(* -- Ksten.LiesJahrInKst, Datum.LiesJahrInDatum,
                           -- LetztesJahrInDatum, IsEqualJahrInDatum *)
 			(*	Kostenstelle liquidieren (K, Datum)*)
			(*END IF*)
		        (*END FOR*)
                END (* IsEqual *)
              UNTIL NOT NaechsteLfdKst (outKst);
              DisposeKst (outKst);

            END (* LfdKst *);

	 END (*IF pruefe *);

  END (* Jahresabschluss *);

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)
	
  PROCEDURE LiquidierenKst (inKst : TKst, inDatum : TDatum);

	(* -- PROZESS-SPEZIFIKATION Kostenstelle liquidieren (D2.3.2)
	   -- Eingaben: 	Kostenstelle + Datum (*von Proze D2.3.1)
	   -- Ausgaben:	Druckauftrag (*an Proze D2.5)

	   -- Vorbedingungen: 	Kostenstelle nicht liquidiert
	   -- Nachbedingungen:	...  *)     	

    VAR
	Betrag : INTEGER;
	outBu  : TBu;

    BEGIN
	(*Betrag := Kostenstelle.Kontingente * Kostenstelle.quivalent;*)
	(* -- BerechneEtatKst (inKstID: TKstID): Integer  *)

        Betrag := 0;
	Betrag := EtatDerKst (inKst);

	IF ErsteBuZuKst ( LKIDinKst (inKst), outBu) THEN

	(* FOR alle Buchungen B mit B.KostenstellenID = Kostenstelle.KostenstellenID DO*)
	(* -- FirstBuMitKstID, NextBuMitKstID *)

            REPEAT
		IF NOT BuStorniert (outBu) THEN
		
		    Betrag := Betrag - LBetragInBu (outBu);
			
		END; (*IF*)
            UNTIL NOT NaechsteBuZuKst ( LKIDinKst (inKst), outBu);

            DispBu (outBu);

	END; (* ErsteBuZuKst *)

	IF Betrag <> 0 THEN
	    outBu := CreateBg();
            SetKstIDInBu       (outBu, LKIDinKst (inKst) );
	    SetGebuchtAmInBu   (outBu, inDatum);
	    SetBetragInBu      (outBu, -Betrag);
	    SetBuchungsArtInBu (outBu, "Abschluss");
                (* Felder zuweisen: (Kostenstelle.KostenstellenID,
                                     UNDEF, -Betrag, Datum, Abschluss);*)
	    InsertBg (Bu);
	    DispBu   (outBu);
	END; (*IF*)

	SetKstLiquAm (inDatum, inKst);
	(* Kostenstelle.LiquidiertAm := Datum;*)
	(* automatische Druckaufbereitung (Kostenstelle, Betrag) *)

	Druck ("Hier drucken !")
    END (* LiquidierenKst *);

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)




(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

  PROCEDURE AnzahlMonateImJahr (inHKID : TPersID) : CARDINAL;

      VAR MonateFeld : ARRAY [1..12] OF BOOLEAN; (* -- gibt an, ob die HK im jeweiligen
                                                  -- Monat gearbeitet hat *)
        AnzMonate  : CARDINAL;
	Index      : CARDINAL;  (* -- Index in MonateFeld       *)
	JAnfang    : TDatum;	(* -- 01.01.++++ : Jahresanfang *)
        JEnde      : TDatum;	(* -- 31.12.++++ : Jahresende   *)
	LaufDatum  : TDatum;    (* -- fuer Schleifendurchlauf   *)
        VtrEnde    : TDatum;
	outResult  : BOOLEAN;
	outVtr     : TVtr;

    BEGIN
	AnzMonate := 0;

        (*
	Monate := Anzahl Monate, die die Hilfskraft in Datum.Jahr beschaeftigt war,
		angefangene Monate werden voll gezaehlt; *)
	(* -- sorgt dafuer, dass JAnfang und JEnde das aktuelle Jahr enthalten *)

	JAnfang := DuplicateDatum (inDatum);
	JEnde   := DuplicateDatum (inDatum);
	SetzeTagInDatum   (JAnfang, 1);
	SetzeMonatInDatum (JAnfang, 1);
        SetzeTagInDatum   (JEnde,  12);
	SetzeMonatInDatum (JEnde,  31);

	(* -- jeden Vertrag der HK durchgehen, der ganz oder teilweise
           -- ins akt. Jahr fllt *)

        outResult := FirstValVtrZuHKinZeitraum (inHKID, JAnfang, JEnde, outVtr);

	IF outResult THEN

	  REPEAT
            (* -- jeden Tag des Vertrags durchlaufen und zugehoerigen Monat bestimmen *)

            LaufDatum := DuplicateDatum ( LGueltigVonInVtr(outVtr) );
            VtrEnde   := DuplicateDatum ( LGueltigBisInVtr(outVtr) );

            WHILE NOT SmallerDatum (VtrEnde, LaufDatum) DO
              (* -- Monat des Datums bestimmen und in Monatsfeld markieren *)
              Index := MonatAlsCARD ( LiesMonatInDatum (LaufDatum) );
              Monatefeld [Index] := TRUE;
	      IncDatum (LaufDatum);

                (* -- VtrBez.FirstValidVtrZuHKinZeitraum (inPersID : TPersID;
                   --      inAnfang,inEnde :TDatum; VAR outVtr : TVtr) : BOOLEAN;
                   -- VtrBez.NextValidVtrZuHKinZeitraum  (inPersID : TPersID;
                   --      inAnfang,inEnde : TDatum; VAR inoutVtr : TVtr) : BOOLEAN;:
                   --      soll ersten/naechsten nicht stornierten, lfd oder nicht,
                   --      Vertrag der HK innerhalb des Jahres zurckgeben
        	   -- Vtr.LiesGueltigVoninVtr (inVtr: TVtr) : TDatum;
	           -- Vtr.LiesGueltigBisinVtr (inVtr : TVtr) : TDatum;
                   -- in allen Vertraegen jeden Tag duchlaufen und zugehoerigen Monat
	           -- ermitteln, Monat in
                   -- lokalem Feld markieren und Anzahl der Monate bestimmen :
        	   -- Datum.MonatAlsCardinal (inM : TMonat) : CARDINAL;
	           -- Datum.IncDatum(VAR inoutDatum : TDatum);
                 *)

            END (* WHILE *);
            DisposeDatum (LaufDatum);
            DisposeDatum (VtrEnde);

          UNTIL NOT NextValVtrZuHKinZeitraum (inHKID, JAnfang, JEnde, outVtr);

          DisposeVtr (outVtr);

          (* -- Anzahl der markierten Monate bestimmen *)
	  FOR Index := 1 TO 12 DO
            IF MonateFeld [Index] = TRUE THEN AnzMonate := AnzMonate + 1
	  END (* FOR *);

	END (* IF outResult *);
        DisposeDatum (JAnfang);
	DisposeDatum (JEnde);

        RETURN AnzMonate

  END (* AnzahlMonateImJahr *);

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)


(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

  PROCEDURE BerechneWGDerHK ( inHK : THK; inWK : TKond; inStTagDat : TDatum);
  VAR
	StdImBMonat  : CARDINAL;	(* -- Stunden im Bemessungsmonat *)
        outTK        : TKond;
	MonatsBetrag : CARDINAL;
	WeihnGeld    : CARDINAL;
	WAnfang      : TDatum;	(* -- Datum des Wochenanfangs *)
	WEnde        : TDatum;	(* -- Datum des Wochenausgangs *)
	outResult    : BOOLEAN;
	outVtr       : TVtr;

  BEGIN
          (* -- Geleistete Stunden im Bemessungsmonat ermitteln*)
	  StdImBMonat  := 0;
          WeihnGeld    := 0;
	  MonatsBetrag := 0;

          (* -- FOR alle Wochen W IN WK.Bemessungsmonat DO *)
          ErsteWocheInMonat (inDatum, WAnfang, WEnde);

	  REPEAT
	    outResult := FirstValVtrZuHKInZeitraum ( LHKID (inHK), WAnfang, WEnde, outVtr);
            REPEAT

	   (* -- fuer alle Vertraege der HK, die die Woche enthalten DO
              -- Bemerkung : Vertraege beinhalten laut Mario nur ganze Wochen
              -- daraus folgt : ein Vertrag enthaelt die Woche ganz oder gar nicht.
              -- D.h. an dieser Stelle ist schon sicher, dass die gefragte Woche
              -- im Vertragszeitraum ist, so dass die geleistete Stunden aktualisiert
              -- werden kann
           *)

                StdImBMonat := StdImBMonat + LStdZahlInVtr (outVtr)

            UNTIL NOT NextValVtrZuHKInZeitraum ( LHKID (inHK), WAnfang, WEnde, outVtr);
            IF outResult THEN DisposeVtr (outVtr)END;

          UNTIL NOT NaechsteWocheInMonat (inDatum, WAnfang, WEnde);

	  (* -- Ende geleistete Stunden im Bemessungsmonat ermitteln *)

          outTK := HoleAktTKond (inDatum);
                (* -- Am Berechnungstag geltende Tarifkondition *)
		(* -- TK := Konden.HoleGueltigeTKond( inD: TDatum); *)
          MonatsBetrag := LStdSinTKond (outTK) * StdImBMonat;
		
	  DispKond (outTK);

          WeihnGeld := MonatsBetrag * AnzMonate / 12;

          DisposeDatum (WAnfang);
          DisposeDatum (WEnde);

          RETURN WeihnGeld

  END (* BerechneWGDerHK *);

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

PROCEDURE NachziehenAutoBuen(VAR inoutLAD:TDatum, inAktDat:TDatum);
	(*
	-- vb: inLAD< AktDatum - 1
	-- Rufe fr jeden Tag in der Differenz inAktDatum-inLAD die Procedures
	-- betroffeneHilfsKraefteErmitteln und betroffeneLehrgebieteErmitteln
	-- nb: automatischer Betrieb fr die Tage im Zeitinterval [inLAD,AktDatum]
	-- sind durchgefhrt
	-- Prozess D 2.1 Datumsverwaltung
	*)
       (*
       -- PROZESS-SPEZIFIKATION Datumsverwaltung (D2.1)
       -- Eingaben: 	Datum Uhr
       --        	Erlaubnis zum automatischen Betrieb(*vom Proze D1
       -- Ausgaben:	Datum (* an die Prozesse D2.2 - D2.4
       --         	Ende des automatischen Betriebs (*an Proze D1

       -- Vorbedingungen: 	...
       -- Nachbedingungen:	...*)

  BEGIN
		 (* Vergleich des Systemdatums mit dem aktuellen Datum ;*)
		 (* WHILE Systemdatum < aktuelles Datum DO *)
      WHILE SmallerDatum (inoutLAD, aktDatum) DO
                       (* rufe die Prozesse 2.2 - 2.3 auf *)
          WGeldErmitteln (inoutLAD);
          Jahresabschluss(inoutLAD);
		       (* Systemdatum := Systemdatum + 1; *)
	  IncDatum (inoutLAD);
      END (*WHILE*);

  END (* NachziehenAutoBuen *) ;

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)
  	     	
END Auto;  	


