(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: Buen.mod,v $
# $Author: lurk $
# $Date: 2001/03/11 09:31:10 $
# $Revision: 1.5 $
Bemerkungen:

IMPLEMENTATION MODULE Buen   TS-Export-Schnittstelle Buchungen

Sigrid Preuss

*)
(******************************************************************************)
 
IMPLEMENTATION MODULE Buen;


(* TS Buchungen *)


(* --------------------------------------------------------------------
   -- Enthaltene Komponenten:
   --      ADT  Bu
   --      ADT  Instantiierungsmodul BuListe
   --      ADT  BuOrdnerSchablone
   --      ADT  BuOrdner
   --      ADT  BuenPersistent
   --------------------------------------------------------------------
*)



FROM Datum        IMPORT TDatum;
FROM String       IMPORT TString;
FROM Stringliste  IMPORT TStringliste;



IMPORT Bu, BuOrdner, BuenPersistent, BuenIMPORTE;

CONST LaengeBuIDNR = 5;

TYPE    TBu    = Bu.TBu;


(* --------------------------------------------------------------------
   -- Durchreichen bzw. Umbenennen der Operationen von
   --   Modul  BuenIMPORTE
   --------------------------------------------------------------------
*)



PROCEDURE       DisposeBuID (VAR inoutBuID:TBuID);
BEGIN
  BuenIMPORTE.DisposeBuID(inoutBuID);
END DisposeBuID;

PROCEDURE       DuplicateBuID (inBuID:TBuID):TBuID;
BEGIN
  RETURN BuenIMPORTE.DuplicateBuID(inBuID);
END DuplicateBuID;

PROCEDURE       IsEqualBuID (inBuID1,inBuID2:TBuID):BOOLEAN;
BEGIN
  RETURN BuenIMPORTE.IsEqualBuID(inBuID1, inBuID2);
END IsEqualBuID;

PROCEDURE       EqualizeBuID (inoutZielBuID:TBuID;
                                inQuelleBuID:TBuID);
BEGIN
  BuenIMPORTE.EqualizeBuID(inoutZielBuID, inQuelleBuID);
END EqualizeBuID;

PROCEDURE       SameBuID (inBuID1:TBuID;inBuID2:TBuID):BOOLEAN;
BEGIN
  RETURN BuenIMPORTE.SameBuID(inBuID1, inBuID2);
END SameBuID;

PROCEDURE       SmallerBuID (inBuID1:TBuID;inBuID2:TBuID):BOOLEAN;
BEGIN
  RETURN BuenIMPORTE.SmallerBuID(inBuID1, inBuID2);
END SmallerBuID;

PROCEDURE       PruefeBuID (inString : TString; VAR outMessage : TString
                           ) : BOOLEAN;
  BEGIN
  RETURN BuenIMPORTE.PruefeBuID(inString, outMessage);
END PruefeBuID;

PROCEDURE       BuIDAlsString (inBuID       : TBuID) : TString;
BEGIN
  RETURN BuenIMPORTE.BuIDAlsString(inBuID, LaengeBuIDNR);
END BuIDAlsString;

PROCEDURE       StringInBuID (inString : TString) : TBuID;
BEGIN
  RETURN BuenIMPORTE.StringInBuID(inString);
END StringInBuID;





(* --------------------------------------------------------------------
   -- Durchreichen bzw. Umbenennen der Operationen von
   --   ADT-Modul  Bu
   --------------------------------------------------------------------
*)


(* Basis-Operationen *)

PROCEDURE	CreateBu ():TBu;
BEGIN
  RETURN Bu.Create();
END CreateBu;

PROCEDURE	DisposeBu (VAR inoutBu : TBu);
BEGIN
  Bu.Dispose(inoutBu);
END DisposeBu;

PROCEDURE	DuplicateBu (inBu : TBu) : TBu;
BEGIN
  RETURN Bu.Duplicate(inBu);
END DuplicateBu;

PROCEDURE	IsEqualBu (inBu1, inBu2 : TBu) : BOOLEAN;
BEGIN
  RETURN Bu.IsEqual(inBu1,inBu2);
END IsEqualBu;

PROCEDURE	EqualizeBu (inoutZielBu : TBu; inQuellBu : TBu);
BEGIN
  Bu.Equalize(inoutZielBu,inQuellBu);
END EqualizeBu;


(* BuID-Operationen *)

PROCEDURE	LiesBuIDBu (inBu : TBu) : TBuID;
BEGIN
  RETURN Bu.LiesBuID(inBu);
END LiesBuIDBu;

PROCEDURE	ExistiertBuIDBu (inBu : TBu) : BOOLEAN;
BEGIN
  RETURN Bu.ExistiertBuID(inBu);
END ExistiertBuIDBu;



(* KstID-Operationen *)

PROCEDURE	LiesKstIDinBu (inBu : TBu) : TKstID;
BEGIN
  RETURN Bu.LiesKstID(inBu);
END LiesKstIDinBu;

PROCEDURE	SetzeKstIDinBu (inoutBu : TBu; inKstID : TKstID);
BEGIN
  Bu.SetzeKstID(inoutBu, inKstID);
END SetzeKstIDinBu;

PROCEDURE	ExistiertKstIDinBu (inBu : TBu) : BOOLEAN;
BEGIN
  RETURN Bu.ExistiertKstID(inBu);
END ExistiertKstIDinBu;



(* VtrID-Operationen *)

PROCEDURE	LiesVtrIDinBu (inBu : TBu) : TVtrID;
BEGIN
  RETURN Bu.LiesVtrID(inBu);
END LiesVtrIDinBu;

PROCEDURE	SetzeVtrIDinBu (inoutBu : TBu; inVtrID : TVtrID);
BEGIN
  Bu.SetzeVtrID(inoutBu, inVtrID);
END SetzeVtrIDinBu;

PROCEDURE	ExistiertVtrIDinBu (inBu : TBu) : BOOLEAN;
BEGIN
  RETURN Bu.ExistiertVtrID(inBu);
END ExistiertVtrIDinBu;



(* Attribut-Operationen *)

PROCEDURE	LiesBetraginBu (inBu : TBu) : INTEGER;
BEGIN
  RETURN Bu.LiesBetrag(inBu);
END LiesBetraginBu;

PROCEDURE	SetzeBetraginBu (inoutBu : TBu; inBetrag : INTEGER);
BEGIN
  Bu.SetzeBetrag(inoutBu, inBetrag);
END SetzeBetraginBu;



PROCEDURE	LiesGebuchtAminBu (inBu : TBu) : TDatum;
BEGIN
  RETURN Bu.LiesGebuchtAm(inBu);
END LiesGebuchtAminBu;

PROCEDURE	SetzeGebuchtAminBu (inoutBu : TBu; inGebuchtAm : TDatum);
BEGIN
  Bu.SetzeGebuchtAm(inoutBu, inGebuchtAm);
END SetzeGebuchtAminBu;


PROCEDURE	LiesStorniertAminBu (inBu : TBu) : TDatum;
BEGIN
  RETURN Bu.LiesStorniertAm(inBu);
END LiesStorniertAminBu;


PROCEDURE	SetzeStorniertAminBu (inoutBu : TBu; inStorniertAm : TDatum);
BEGIN
  Bu.SetzeStorniertAm(inoutBu, inStorniertAm);
END SetzeStorniertAminBu;


PROCEDURE	IstStorniertinBu (inBu:TBu) : BOOLEAN;
BEGIN
  RETURN Bu.IstStorniert(inBu);
END IstStorniertinBu;


PROCEDURE	LiesBuchungsArtinBu (inBu : TBu) : TBuArt;
BEGIN
  RETURN Bu.LiesBuchungsArt(inBu);
END LiesBuchungsArtinBu;


PROCEDURE	SetzeBuchungsArtinBu (inoutBu : TBu; inBuchungsArt : TBuArt);
BEGIN
  Bu.SetzeBuchungsArt(inoutBu, inBuchungsArt);
END SetzeBuchungsArtinBu;


(* --------------------------------------------------------------------
   -- Durchreichen bzw. Umbenennen der Operationen von
   --   ADT-Modul  BuOrdner
   --------------------------------------------------------------------
*)



PROCEDURE	InsertBu(inoutBu : TBu;  VAR outMessage : TString) : BOOLEAN;
BEGIN
  RETURN BuOrdner.Insert(inoutBu, outMessage);
END InsertBu;


PROCEDURE	SearchBu(inBuID:TBuID; VAR outBu:TBu) : BOOLEAN;
BEGIN
  RETURN BuOrdner.Search(inBuID, outBu);
END SearchBu;


PROCEDURE	UpdateBu(inoutBu : TBu; outMessage : TString) : BOOLEAN;
BEGIN
  RETURN BuOrdner.Update(inoutBu, outMessage);
END UpdateBu;


PROCEDURE BerGebGelderDerKst(inKSTID: TKstID) : INTEGER;
BEGIN
  RETURN BuOrdner.BerGebGelderDerKst(inKSTID);
END BerGebGelderDerKst;
 

PROCEDURE	StorniereBuZuVtr(inVtrID : TVtrID;
                                 VAR outMessage : TString) : BOOLEAN;
BEGIN
  RETURN BuOrdner.StorniereBuZuVtr(inVtrID, outMessage);
END StorniereBuZuVtr;

 

(* -------------------------------------------------------------------------- *)
(* Iteratoren ueber nicht stornierte Buchungen                                *)
(* -------------------------------------------------------------------------- *)


PROCEDURE	FirstBu (VAR outBu : TBu) : BOOLEAN;
BEGIN
  RETURN BuOrdner.First(outBu);
END FirstBu;

PROCEDURE	NextBu(inoutBu:TBu) : BOOLEAN;
BEGIN
  RETURN BuOrdner.Next(inoutBu);
END NextBu;

PROCEDURE FirstBuZuKst (inKstID : TKstID; VAR outBu : TBu) : BOOLEAN;
BEGIN
  RETURN BuOrdner.FirstBuZuKst(inKstID, outBu);
END FirstBuZuKst;
 
 
PROCEDURE NextBuZuKst  (inKstID : TKstID; inoutBu : TBu) : BOOLEAN;
BEGIN
  RETURN BuOrdner.NextBuZuKst(inKstID, inoutBu);
END NextBuZuKst;
 

PROCEDURE FirstBuZuVtr (inVtrID : TVtrID; VAR outBu : TBu) : BOOLEAN;
BEGIN
  RETURN BuOrdner.FirstBuZuVtr(inVtrID, outBu);
END FirstBuZuVtr;

PROCEDURE  NextBuZuVtr  (inVtrID : TVtrID; inoutBu : TBu) : BOOLEAN;
BEGIN
  RETURN BuOrdner.NextBuZuVtr(inVtrID, inoutBu);
END NextBuZuVtr;

 
PROCEDURE FirstBuMitBuArtZuVtr (inVtrID : TVtrID; inBuArt : TBuArt;
                         VAR outBu : TBu) : BOOLEAN;
BEGIN
  RETURN BuOrdner.FirstBuMitBuArtZuVtr(inVtrID, inBuArt, outBu);
END FirstBuMitBuArtZuVtr;

PROCEDURE  NextBuMitBuArtZuVtr  (inVtrID : TVtrID; inBuArt : TBuArt;
                         inoutBu : TBu) : BOOLEAN;
BEGIN
  RETURN BuOrdner.NextBuMitBuArtZuVtr(inVtrID, inBuArt, inoutBu);
END NextBuMitBuArtZuVtr;


(* -------------------------------------------------------------------------- *)
(* Iterator ueber alle Buchungen (einschl. der stornierten)                   *)
(* -------------------------------------------------------------------------- *)



PROCEDURE	FirstBuUndStorno (VAR outBu : TBu) : BOOLEAN;
BEGIN
  RETURN BuOrdner.FirstBuUndStorno(outBu);
END FirstBuUndStorno;

PROCEDURE	NextBuUndStorno (inoutBu:TBu) : BOOLEAN;
BEGIN
  RETURN BuOrdner.NextBuUndStorno(inoutBu);
END NextBuUndStorno;



(*************************** StringOperationen ***************************)
 
 
PROCEDURE GibBuenAlsStringlisteinBuen () : TStringliste;
                              
BEGIN
  RETURN BuOrdner.GibBuenAlsStringliste();
END GibBuenAlsStringlisteinBuen;
 
PROCEDURE        GibAllesAlsStringlisteinBuen () : TStringliste;
BEGIN
  RETURN BuOrdner.GibAllesAlsStringliste();
END GibAllesAlsStringlisteinBuen;


(***************************** DateiOperationen ***************************)


PROCEDURE        LoadinBuen(inHandle : THandle;
                           VAR outMessage : TString) : BOOLEAN;
BEGIN
  RETURN BuenPersistent.Load(inHandle, outMessage);
END LoadinBuen;

PROCEDURE        SaveinBuen(inHandle : THandle;
                           VAR outMessage : TString) : BOOLEAN;
BEGIN
  RETURN BuenPersistent.Save(inHandle, outMessage);
END SaveinBuen;


END Buen.
