(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: BuenIMPORTE.mod,v $
# $Author: lurk $
# $Date: 2001/03/10 16:03:10 $
# $Revision: 1.2 $
Bemerkungen:

IMPLEMENTATION MODULE BuenIMPORTE   TS-Import-Schnittstelle Buchungen

Sigrid Preuss

*)
(******************************************************************************)
 
IMPLEMENTATION MODULE BuenIMPORTE;

(* TS Buchungen *)

FROM Datum  IMPORT TDatum;
FROM String IMPORT TString;

IMPORT SysDat;
IMPORT VDat;
IMPORT HIDVerwaltung;
IMPORT Ksten;
IMPORT Vtre;


(* --------------------------------------------------------------------------
   -- Durchreichen der importierten Operationen
   -- Teilsystem HIDVerwaltung
   --------------------------------------------------------------------------
*)


PROCEDURE	DisposeBuID (VAR inoutBuID : TBuID);
BEGIN
  HIDVerwaltung.DisposeHID(inoutBuID);
END DisposeBuID;

PROCEDURE	DuplicateBuID (inBuID : TBuID)  : TBuID;
BEGIN
  RETURN HIDVerwaltung.DuplicateHID(inBuID);
END DuplicateBuID;

PROCEDURE	IsEqualBuID (inBuID1,inBuID2 : TBuID) : BOOLEAN;
BEGIN
  RETURN HIDVerwaltung.IsEqualHID(inBuID1, inBuID2);
END IsEqualBuID;

PROCEDURE	EqualizeBuID (inoutZielBuID : TBuID;
                                inQuelleBuID : TBuID);
BEGIN
  HIDVerwaltung.EqualizeHID(inoutZielBuID, inQuelleBuID);
END EqualizeBuID;

PROCEDURE	SameBuID (inBuID1 : TBuID ;
                            inBuID2 : TBuID) : BOOLEAN;
BEGIN
  RETURN HIDVerwaltung.SameSeqNrHID(inBuID1, inBuID2);
END SameBuID;

PROCEDURE	SmallerBuID (inBuID1 : TBuID;
                               inBuID2 : TBuID) : BOOLEAN;
BEGIN
  RETURN HIDVerwaltung.SmallerSeqNrHID(inBuID1, inBuID2);
END SmallerBuID;

PROCEDURE	HoleNeueBuID () : TBuID;
BEGIN
  RETURN HIDVerwaltung.HoleNeueID();
END HoleNeueBuID;

PROCEDURE	UeberlasseAlteBuID (inBuID : TBuID);
BEGIN
  HIDVerwaltung.UeberlasseAlteID(inBuID);
END UeberlasseAlteBuID;



PROCEDURE       PruefeBuID (inString : TString; VAR outMessage : TString
                             ) : BOOLEAN;
BEGIN
  RETURN HIDVerwaltung.PruefeHID(inString, outMessage);
END PruefeBuID;


PROCEDURE       BuIDAlsString (inBuID   : TBuID;
                                 inIDLaenge : CARDINAL) : TString;
BEGIN
  RETURN HIDVerwaltung.HID2Str4SL(inBuID, inIDLaenge);
END BuIDAlsString;


PROCEDURE      StringInBuID (inString : TString) : TBuID;
BEGIN
  RETURN HIDVerwaltung.Str2HID(inString);
END StringInBuID;



(* --------------------------------------------------------------------------
   -- Durchreichen der importierten Operationen
   -- Teilsystem Kostenstellen
   --------------------------------------------------------------------------
*)

PROCEDURE DisposeKstID(VAR inoutKstID : TKstID);
BEGIN
  Ksten.DisposeKstID(inoutKstID);
END DisposeKstID;

PROCEDURE DuplicateKstID(inKstID : TKstID):TKstID;
BEGIN
  RETURN Ksten.DuplicateKstID(inKstID);
END DuplicateKstID;

PROCEDURE IsEqualKstID(inKstID1, inKstID2: TKstID):BOOLEAN;
BEGIN
  RETURN Ksten.IsEqualKstID(inKstID1, inKstID2);
END IsEqualKstID;

PROCEDURE EqualizeKstID(inKstID1, inKstID2: TKstID);
BEGIN
  Ksten.EqualizeKstID(inKstID1, inKstID2);
END EqualizeKstID;


PROCEDURE       PruefeKstID (inString : TString; VAR outMessage : TString
                             ) : BOOLEAN;
BEGIN
  RETURN Ksten.PruefeKstID(inString, outMessage);
END PruefeKstID;


(*
PROCEDURE       KstIDAlsString (inKstID   : TKstID;
                                inIDLaenge : CARDINAL) : TString;
*)
PROCEDURE       KstIDAlsString (inKstID   : TKstID) : TString;
BEGIN
  RETURN Ksten.KstIDAlsString(inKstID);
END KstIDAlsString;


PROCEDURE      StringInKstID (inString : TString) : TKstID;
BEGIN
  RETURN Ksten.StringInKstID(inString);
END StringInKstID;



(* --------------------------------------------------------------------------
   -- Durchreichen der importierten Operationen
   -- Teilsystem Vertraege
   --------------------------------------------------------------------------
*)

PROCEDURE DisposeVtrID(VAR inoutVtrID : TVtrID);
BEGIN
  Vtre.DisposeVtrID(inoutVtrID);
END DisposeVtrID;

PROCEDURE DuplicateVtrID(inVtrID : TVtrID):TVtrID;
BEGIN
  RETURN Vtre.DuplicateVtrID(inVtrID);
END DuplicateVtrID;

PROCEDURE IsEqualVtrID(inVtrID1, inVtrID2: TVtrID):BOOLEAN;
BEGIN
  RETURN Vtre.IsEqualVtrID(inVtrID1, inVtrID2);
END IsEqualVtrID;

PROCEDURE EqualizeVtrID(inVtrID1, inVtrID2: TVtrID);
BEGIN
  Vtre.EqualizeVtrID(inVtrID1, inVtrID2);
END EqualizeVtrID;


PROCEDURE       PruefeVtrID (inString : TString; VAR outMessage : TString
                             ) : BOOLEAN;
BEGIN
  RETURN Vtre.PruefeVtrID(inString, outMessage);
END PruefeVtrID;


(*
PROCEDURE       VtrIDAlsString (inVtrID   : TVtrID;
                                inIDLaenge : CARDINAL) : TString;
*)
PROCEDURE       VtrIDAlsString (inVtrID   : TVtrID) : TString;
BEGIN
  RETURN Vtre.VtrIDAlsString(inVtrID);
END VtrIDAlsString;


PROCEDURE      StringInVtrID (inString : TString) : TVtrID;
BEGIN
  RETURN Vtre.StringInVtrID(inString);
END StringInVtrID;



(* --------------------------------------------------------------------------
   -- Durchreichen der importierten Operationen
   -- Teilsystem VDat (Virtuelles Dateisystem)
   --------------------------------------------------------------------------
*)


PROCEDURE WriteLineInVDat (inHandle : THandle; inString : TString;
                           VAR outMessage :TString) :BOOLEAN;
BEGIN
  RETURN VDat.WriteLineInVDat(inHandle, inString, outMessage);
END WriteLineInVDat;

PROCEDURE ReadLineInVDat (inHandle : THandle; VAR outString : TString;
                          VAR outMessage :TString) :BOOLEAN;
BEGIN
  RETURN VDat.ReadLineInVDat(inHandle, outString, outMessage);
END ReadLineInVDat;

PROCEDURE EofInVDat (inHandle : THandle) : BOOLEAN;
BEGIN
  RETURN VDat.EofInVDat(inHandle);
END EofInVDat;



(* --------------------------------------------------------------------------
   -- Durchreichen der importierten Operationen
   -- Teilsystem SysDat
   --------------------------------------------------------------------------
*)

PROCEDURE LiesSystemDatumInSysDat() : TDatum;
BEGIN
  RETURN SysDat.LiesSystemDatumInSysDat();
END LiesSystemDatumInSysDat;

END BuenIMPORTE.
