(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: Datum.mod,v $
# $Author: Sopra $
# $Date: 2001/03/13 18:13:34 $
# $Revision: 1.4 $
# Bemerkungen:

*)
(******************************************************************************)


IMPLEMENTATION MODULE Datum;

(* TS Datum *)
(* Die Woche geht von Montag(1) bis Sonntag(7)  *)  

(* DatenTeilSystem zum Erzeugen, Lschen von Datum ADOs. *)
(* Operatoren auf Datums ADOs *)


(* IMPORTE *)
IMPORT String; 
IMPORT DatumIMPORTE;
IMPORT Date, Tag, Monat, Jahr, STag;

TYPE 	TDatum	= Date.TDatum; 
	TStag	= STag.TStag;
	TTag	= Tag.TTag;
	TMonat	= Monat.TMonat;
	TJahr	= Jahr.TJahr;


(**************************** Datentyp TTag = Tag *****************************)
PROCEDURE CreateTag():TTag;
             (* Liefert und initialisiert ein leeres, neues ADO
                vom Typ TJahr
                wird u.a. benoetigt in Kst.CreateKst() *)
BEGIN
	RETURN Tag.CreateTag();
END CreateTag;

PROCEDURE DisposeTag (VAR inoutTag : TTag);
BEGIN
        Tag.DisposeTag(inoutTag);
END DisposeTag;

PROCEDURE TagAlsCard (inTag : TTag ) : CARDINAL;
(*
Vb: --
Gibt die Tageszahl 1..31 des Monats als CARDINAL zurck.

Nb: --
*)
BEGIN
	RETURN Tag.TagAlsCard(inTag);
END TagAlsCard;

PROCEDURE IsEqualTag (inTag1, inTag2:TTag) : BOOLEAN;
(*
Vb: (1<=inTag1<=31) AND (1<=inTag2<=31)
Prueft ob inTag1 = inTag2
NB: (True <=> inTag1 = inTag2)
*)   
BEGIN
	RETURN Tag.IsEqualTag(inTag1, inTag2);
END IsEqualTag; 

(*************************** Datentyp TMonat = Monat **************************)

PROCEDURE CreateMonat():TMonat;
BEGIN
	RETURN Monat.CreateMonat();
END CreateMonat;

PROCEDURE DisposeMonat (VAR inoutMonat : TMonat);
BEGIN
	Monat.DisposeMonat(inoutMonat); 
END DisposeMonat;

PROCEDURE IsEqualMonat (inMonat1, inMonat2:TMonat) : BOOLEAN;
(*
Vb: (1<=inMonat1<=12) AND (1<=inMonat2<=12)
Prueft ob inMonat1 = inMonat2
NB: (True <=> inMonat1 = inMonat2)
*)
BEGIN
	RETURN Monat.IsEqualMonat (inMonat1, inMonat2);
END IsEqualMonat;

PROCEDURE DuplicateMonat (inMonat : TMonat) : TMonat;
              (* Erzeugt ein neues ADO vom Typ TMonat mit
                 Zustandsgleichheit zu inMonat
              wird benoetigt in Kst.LiesJahrinKst (..);   *)
BEGIN
	RETURN Monat.DuplicateMonat(inMonat);
END DuplicateMonat;

PROCEDURE EqualizeMonat (VAR inoutZielMonat, inMonat : TMonat);  
BEGIN
	 Monat.EqualizeMonat(inoutZielMonat, inMonat); 
END  EqualizeMonat;

PROCEDURE MonatAlsCard (inMonat : TMonat ) : CARDINAL;
(*
Vb: --
Gibt die Monatszahl 1..12 des Monats als CARDINAL zurck.
Nb: --
*)
BEGIN
	RETURN Monat.MonatAlsCard (inMonat);
END MonatAlsCard;  

(*************************** Datentyp TJahr = Jahr ****************************)

PROCEDURE CreateJahr():TJahr;
BEGIN
	RETURN Jahr.CreateJahr();
END CreateJahr;

PROCEDURE DisposeJahr (VAR inoutJahr : TJahr);
             (* entfernt das ADO Jahr aus dem System
              wird benoetigt in Kst.DisposeKst (...);*)
BEGIN
	Jahr.DisposeJahr(inoutJahr);
END DisposeJahr; 

PROCEDURE SmallerJahr (inSmallerJahr, inGreaterJahr : TJahr) : BOOLEAN;
            (* vergleicht zwei Jahreszahlen vom Typ TJahr und
               liefert TRUE, wenn inSmallerJahr < inGreaterJahr
            wird benoetigt in Vtr.BeginntNotImLfdJahr*)
BEGIN
	RETURN Jahr.SmallerJahr (inSmallerJahr, inGreaterJahr);
END SmallerJahr; 

PROCEDURE EqualizeJahr (VAR inoutZielJahr, inJahr : TJahr);
             (* Gleicht den Zustand/ die Attribute des ZielJahres
                an das inJahr an
             wird benoetigt in Kst.EqualizeKst (...);
                               Kst.SetzeJahrinKst (..);*)
BEGIN
	Jahr.EqualizeJahr (inoutZielJahr, inJahr);
END EqualizeJahr; 

PROCEDURE DuplicateJahr (inJahr : TJahr) : TJahr;
              (* Erzeugt ein neues ADO vom Typ TJahr mit
                 Zustandsgleichheit zu inJahr
              wird benoetigt in Kst.LiesJahrinKst (..);   *)
BEGIN
	RETURN Jahr.DuplicateJahr (inJahr );
END DuplicateJahr; 

PROCEDURE JahrAlsCard (inJahr: TJahr) : CARDINAL;
(*
Vb: --
Gibt die Jahreszahl als CARDINAL zurck.
Nb: --
*)
BEGIN
	RETURN Jahr.JahrAlsCard (inJahr);
END JahrAlsCard; 

PROCEDURE SetzeJahr (VAR inoutJahr: TJahr; inV: CARDINAL);
(*
Vb: --
Setze die Jahreszahl inoutJahr  auf inV zurueck. Falls inV ausserhalb des Werte
bereiches wird nichts zugewiesen
Nb: --
*)   
BEGIN
	Jahr.SetzeJahr(inoutJahr,inV);
END SetzeJahr;

PROCEDURE LetztesJahr (inJahr : TJahr) : TJahr;
(*
Vb: inJahr >= 1901
Liefert die um 1 dekrementierte Jahreszahl von inJahr zurueck.
Nb: --
*)
BEGIN
	RETURN Jahr.LetztesJahr (inJahr );
END LetztesJahr; 

PROCEDURE IsEqualJahr (inJahr1, inJahr2:TJahr) : BOOLEAN;
(*
Vb: (injahr1 >=1900) AND (inJahr2 >= 1900)
Prueft ob injahr1 = inJahr2
NB: (True <=> inJahr1 = inJahr2)
*) 
BEGIN
	RETURN Jahr.IsEqualJahr (inJahr1, inJahr2);
END IsEqualJahr; 

(**************************** Datentyp TStag = Stichtag ***********************)

PROCEDURE CreateStag ():TStag;
(* 
Vb:		keine	 
Erzeugt ein neues ADO D vom Typ TStag 
Liefert IstStagEternity=TRUE zurck falls UNDEF
Nb:	ADO D existiert       
*)
BEGIN
	RETURN STag.CreateStag();
END CreateStag;

PROCEDURE DisposeStag (VAR inoutD:TStag);
(*  
Vb: keine 
ADO D wird aus dem System entfernt 
Nb:	ADO D existiert nicht mehr 
*) 
BEGIN
	STag.DisposeStag(inoutD);
END DisposeStag;

PROCEDURE DuplicateStag ( inD:TStag):TStag;
(* 
Vb:	keine 
Erzeugt das Rckgabe ADO und gleicht die Werte der Attribute an; 
Nb:	IsEqual(D, RckgabeD) and not (D=RckgabeD) 
*) 
BEGIN
	RETURN STag.DuplicateStag(inD);
END DuplicateStag;
          
PROCEDURE IsEqualStag (inD1,inD2: TStag ):BOOLEAN;
(*
Vb:		keine 
berprft die beiden Konditionen auf Wertegleichheit der aller Attribute 
Nb:	keine  
*)
BEGIN
	RETURN STag.IsEqualStag(inD1,inD2);
END IsEqualStag;

PROCEDURE EqualizeStag (VAR inoutZielD:TStag ; inQuellD:TStag); 
(*
Vb:	keine 
gleicht die Werte der Attribute von ZielD an die von QuellD an, wobei die Identitt der ADO's nicht verndert wird 
Nb:	IsEqual(QuellD,ZielD) and not (QuellD=ZielD)
*)
BEGIN
	STag.EqualizeStag(inoutZielD, inQuellD);
END EqualizeStag;


PROCEDURE LiesTagInStag ( inStag :TStag):TTag; 
(*
Vb:		keine 
Liefert den Tag des ADO  Stag
Nb:	keine 
*)
BEGIN
	RETURN STag.LiesTagInStag(inStag);
END LiesTagInStag;

PROCEDURE SetzeTagInStag (VAR inoutStag:TStag; inTag:TTag); 
(*
Vb: Tag in [1..31] 
Setzt den Tag im ADO Stag
Nb:	GetTag(Dneu)=Tag 
*)
BEGIN
	STag.SetzeTagInStag(inoutStag,inTag);
END SetzeTagInStag;

PROCEDURE LiesMonatInStag (inStag:TStag):TMonat; 
(*
Vb:		keine 
Liefert den Monat des ADO  Stag
Nb:	keine 
*)
BEGIN
	RETURN STag.LiesMonatInStag(inStag);
END LiesMonatInStag;

PROCEDURE SetzeMonatInStag (VAR inoutStag:TStag; inMonat:TMonat); 
(*
Vb:		keine 
Setze Monat [1..12] des ADO Stag
Nb:	keine 
*)
BEGIN
	STag.SetzeMonatInStag(inoutStag,inMonat);
END SetzeMonatInStag;

PROCEDURE SmallerStag ( inKleinerStag, inGroesserStag : TStag):BOOLEAN;
(*
Vb:     keine
TRUE falls inKleinerStag < inGroesserStag
Nb:     keine
*)                                                                              
BEGIN
	RETURN STag.SmallerStag(inKleinerStag, inGroesserStag);
END SmallerStag; 

PROCEDURE PruefeStag (inStag: TStag) : BOOLEAN;
(*
Vb: --
Prft, ob es sich bei dem Stichtag inStag um ein gueltiges Datum handelt.
z.B. wird bei inStag = 31.02. ein false geliefert. 
Da ein Stichtag 29.02. nur alle vier Jahre auftreten wrde, ist ein Stichtag 29.02. ebenfalls verboten
nb: (false <=> inStag ungueltig) sonst true
*)
BEGIN
	RETURN STag.PruefeStag(inStag);
END PruefeStag;

PROCEDURE SetzeStagEternity (VAR inoutStag:TStag);
(*
Vb:             keine
Setze inoutStag auf UNDEF
Nb:     keine
*)
BEGIN
	STag.SetzeStagEternity (inoutStag);
END SetzeStagEternity ;

PROCEDURE IstStagEternity (inStag:TStag):BOOLEAN;
(*
Vb:             keine
TRUE, falls inoutStag = UNDEF
Nb:     keine
*)
BEGIN
	RETURN STag.IstStagEternity (inStag);
END IstStagEternity ;

(************************** Datentyp TDatum ******************************)

PROCEDURE CreateDatum ():TDatum;
(* 
Vb:		keine	 
Erzeugt ein neues ADO D vom Typ TDatum 
Nb:	ADO D existiert AND setze 31.12.9999 als Defaultwert      
*)
BEGIN
	RETURN 	Date.CreateDatum();
END CreateDatum;


PROCEDURE DisposeDatum (VAR inoutD:TDatum);
(*  
Vb: keine 
ADO D wird aus dem System entfernt 
Nb:	ADO D existiert nicht mehr 
*) 
BEGIN
	Date.DisposeDatum(inoutD);
END DisposeDatum;


PROCEDURE DuplicateDatum (VAR inD:TDatum):TDatum;
(* 
Vb:	keine 
Erzeugt das Rckgabe ADO und gleicht die Werte der Attribute an; 
Nb:	IsEqual(D, RckgabeD) and not (D=RckgabeD) 
*) 
BEGIN
	RETURN Date.DuplicateDatum(inD);
END DuplicateDatum;
          
PROCEDURE IsEqualDatum (inD1,inD2: TDatum ):BOOLEAN;
(*
Vb:		keine 
berprft die beiden Konditionen auf Wertegleichheit der aller Attribute 
Nb:	keine  
*)
BEGIN
	RETURN Date.IsEqualDatum(inD1,inD2);
END IsEqualDatum;

PROCEDURE EqualizeDatum (VAR inoutZielD:TDatum ; inQuellD:TDatum); 
(*
Vb:	keine 
gleicht die Werte der Attribute von ZielD an die von QuellD an, wobei die Identitt der ADO's nicht verndert wird 
Nb:	IsEqual(QuellD,ZielD) and not (QuellD=ZielD)
*)
BEGIN
	Date.EqualizeDatum(inoutZielD, inQuellD);
END EqualizeDatum;

PROCEDURE PruefeDatum (inDatum : TDatum) : BOOLEAN;
(*
Vb: --
Prft die Konsistenz (Gueltigkeit des bergebenen Datums.
So ist der 31.02. fr jedes Jahr verboten. Schaltjahre usw. sollten bercksichtigt sein.
nb: (false <=> inDatum ungueltig) sonst true
*)
BEGIN
	RETURN Date.PruefeDatum(inDatum);
END PruefeDatum;

PROCEDURE PruefeObMonatsErster (inDatum : TDatum) : BOOLEAN;
(*
Vb: --
Prueft, ob es sich bei dem Datum inDatum um den Monatsersten (01.xx.xx) handelt.
Nb: (True <=> inDatum.Tag = 01) oder (False sonst)
*)
BEGIN
	RETURN Date.PruefeObMonatsErster(inDatum);
END PruefeObMonatsErster;

PROCEDURE PruefeObMonatJanuar (inDatum : TDatum) : BOOLEAN;
(*
Vb: --
Prueft, ob es sich bei dem Datum inDatum um den Monat Januar
(xx.01.xx) handelt.
Nb: (True <=> inDatum.Monat = 01) oder (False sonst)
*)
BEGIN
	RETURN Date.PruefeObMonatJanuar(inDatum);
END PruefeObMonatJanuar;

PROCEDURE LiesTagInDatum (D:TDatum):TTag; 
(*
Vb:		keine 
Liefert den Tag des ADO D 
Nb:	keine 
*)
BEGIN
	RETURN Date.LiesTagInDatum(D);
END LiesTagInDatum;

PROCEDURE SetzeTagInDatum (VAR inoutD:TDatum; inTag:TTag); 
(*
Vb: Tag in [1..31] 
Setzt den Tag im ADO D 
Nb:	GetTag(Dneu)=Tag 
*)
BEGIN
	Date.SetzeTagInDatum(inoutD,inTag);
END SetzeTagInDatum;

PROCEDURE LiesMonatInDatum (inD:TDatum):TMonat; 
(*
Vb:		keine 
Liefert den Monat des ADO D 
Nb:	keine 
*)
BEGIN
	RETURN Date.LiesMonatInDatum(inD);
END LiesMonatInDatum;

PROCEDURE SetzeMonatInDatum (VAR inoutD:TDatum; inMonat:TMonat); 
(*
Vb:		keine 
Setze Monat [1..12] des ADO D 
Nb:	keine 
*)
BEGIN
	Date.SetzeMonatInDatum(inoutD,inMonat);
END SetzeMonatInDatum;

PROCEDURE LiesJahrInDatum (inD:TDatum):TJahr; 
(*
Vb:		keine 
Liefert das Jahr des ADO D 
Nb:	keine 
*)
BEGIN
	RETURN Date.LiesJahrInDatum(inD);
END LiesJahrInDatum;

PROCEDURE SetzeJahrInDatum (VAR inoutD:TDatum; inJahr:TJahr); 
(*
Vb:		keine 
Setze das Jahr [1..9999] des ADO D 
Nb:	keine 
*)
BEGIN
	Date.SetzeJahrInDatum(inoutD,inJahr);
END SetzeJahrInDatum;

PROCEDURE SetzeJahresanfang(VAR inoutDatum : TDatum);
BEGIN
	Date.SetzeJahresanfang(inoutDatum);
END SetzeJahresanfang;

PROCEDURE SetzeJahresende(VAR inoutDatum : TDatum);
BEGIN
	Date.SetzeJahresende(inoutDatum);
END SetzeJahresende;  

PROCEDURE SetzeDatumEternity (VAR inoutD:TDatum);
(*
Vb:             keine
Setze Datum auf UNDEF
Nb:     keine
*)
BEGIN
	Date.SetzeDatumEternity(inoutD);
END SetzeDatumEternity;
 
PROCEDURE IstDatumEternity (inD:TDatum):BOOLEAN;
(*
Vb:             keine
TRUE, falls Datum = UNDEF
Nb:     keine
*)
BEGIN
	RETURN Date.IstDatumEternity(inD);
END IstDatumEternity;
   
PROCEDURE SmallerDatum(inSmallerD,inGreaterD:TDatum):BOOLEAN ;
(*
Vb:	keine 
Prft, ob SmallerD ein frheres Datum als GreaterD enthlt 
Nb:	Rckgabewert <=>	SmallerD "<" GreaterD 
*)
BEGIN
	RETURN Date.SmallerDatum(inSmallerD,inGreaterD);
END SmallerDatum;

PROCEDURE MaxDatum (inDatum1, inDatum2:TDatum) : TDatum;
(*
Vb: (PrufeDatum (inDatum1) = true) AND ( PruefeDatum (inDatum2) = true)
Gibt das grere Datum zurck                                                   
Nb: --
*)
BEGIN
	RETURN Date.MaxDatum(inDatum1,inDatum2);
END MaxDatum;

PROCEDURE MinDatum (inDatum1, inDatum2:TDatum) : TDatum;
(*
Vb: (PrufeDatum (inDatum1) = true) AND ( PruefeDatum (inDatum2) = true)
Gibt das kleinere Datum zurck                                                   
Nb: --
*)
BEGIN
	RETURN Date.MinDatum(inDatum1, inDatum2);
END MinDatum;

PROCEDURE IncDatum(VAR inoutD:TDatum); 
(*
Vb: Datum < 31.12.9999 
D wird auf das Datum des nachfolgenden Tages gesetzt 
Nb:	IsEqual(Dec(Dneu),Dalt) and not IsEqual(Dalt,Dneu)
*)
BEGIN
	Date.IncDatum(inoutD);
END IncDatum;

PROCEDURE DecDatum(VAR inoutD:TDatum); 
(*
Vb: Datum > 1.1.1 
D wird auf das Datum des vorhergehenden Tages gesetzt 
Nb:	IsEqual(Inc(Dneu),Dalt) and not IsEqual(Dalt,Dneu) 
*)
BEGIN
	Date.DecDatum(inoutD);
END DecDatum;

PROCEDURE DatumInZeitraum( inD,inVonD,inBisD:TDatum ): BOOLEAN; 
(*
Vb: keine 
prft ob D zwischen vonD und bisD liegt
Nb: true falls inD in [vonD,bisD], false sonst
*)
BEGIN
	RETURN Date.DatumInZeitraum(inD,inVonD,inBisD);
END DatumInZeitraum;

PROCEDURE Wochentag ( inDatum:TDatum):CARDINAL;
(*
vb: --
liefere die Nr des Wochentages zurck: 1=Montag, 7=Sonntag. Falls das Datum undef ist wird 0 returniert.
nb: --
*)
BEGIN
	RETURN Date.Wochentag(inDatum);
END Wochentag;

PROCEDURE AnzahlMonate( inVonD,inBisD:TDatum ): CARDINAL; 
(*
Vb: vonD <= bisD
gib die Anzahl der Monate zwischen vonD und bisD zurck
Semantik: angeschnittene Monate zaehlen mit
Nb: --
*)
BEGIN
	RETURN Date.AnzahlMonate( inVonD, inBisD);
END AnzahlMonate;

PROCEDURE AnzahlWochen( inVonD,inBisD:TDatum ): CARDINAL; 
(*
Vb: vonD <= bisD
gib die Anzal der Wochen zwischen vonD und bisD zurck
Semantik: angeschnittene Wochen zaehlen mit
Nb: --
*)
BEGIN
	RETURN Date.AnzahlWochen(inVonD,inBisD);
END AnzahlWochen;

PROCEDURE AnzahlTage( inVonD,inBisD:TDatum ): CARDINAL; 
(*
Vb: vonD <= bisD
gib die Anzal der Tage zwischen vonD und bisD zurck
Nb: --
*)
BEGIN
	RETURN Date.AnzahlTage(inVonD,inBisD);
END AnzahlTage;

PROCEDURE AnfEndDatumKWZuDatum (inDatum : TDatum; VAR outAnfang, outEnde : TDatum);
(*
Vb: (1 <= inDatum.Tag <= 31) AND (PruefeDatum(inDatum)=True)
Ermittelt zu dem bergebenen Datum die Kalenderwoche, in der das Datum
inDatum liegt.
NB: --
*)
BEGIN
	Date.AnfEndDatumKWZuDatum(inDatum,outAnfang,outEnde);
END AnfEndDatumKWZuDatum;

PROCEDURE AnfEndDatumKWZuMonat (inDatum : TDatum; VAR outAnfang, outEnde : TDatum);
(*
Vb: 1 <= inDatum.Monat <= 12
Ermittelt zu dem bergebenen Monat die Kalenderwochen, in denen der erste und 
letzte Tag des Monats liegt. outAnfang ist das Kalenderdatum des ersten Tages 
der Woche, in der der erste des Monats liegt. outEnde ist das Kalenderdatum des
letzten Tages der Woche, in der der letzte Tag des Monats liegt.
NB: --
*)
BEGIN
	Date.AnfEndDatumKWZuMonat(inDatum,outAnfang,outEnde);
END AnfEndDatumKWZuMonat;


PROCEDURE ErsteWocheInMonat (inDatum:TDatum; VAR outWAnfang, outWEnde:TDatum);
(*
Vb: PrufeDatum (inDatum) = true
Ermittelt das Anfangsdatum und Endedatum der Kalenderwoche, in der der Monatserstevon inDatum liegt. Angeschnitte Wochen zaehlen mit.
Nb: --
*)
BEGIN
	Date. ErsteWocheInMonat(inDatum,outWAnfang,outWEnde);
END ErsteWocheInMonat;
 
PROCEDURE NaechsteWocheInMonat (inDatum:TDatum; VAR inoutWAnfang, inoutWEnde:TDatum):BOOLEAN;
(*
Vb: PrufeDatum (inDatum) = true
inDatum liefert den relevanten Monat. Zu diesem Monat sollen alle folgenden Wochen ausgegeben werden.
inoutWAnfang, inoutWEnde enthalten als Eingabe die aktuelle Woche. Zu dieser Woche wird eine Woche hinzugezaehlt und wieder ausgegeben.
Ist das neue inoutWAnfang nicht mehr im betrachteten Monat (inDatum), dann gibt es keine NaechsteWocheImMonat
NB: (False <=> wenn keine naechste Woche existiert)
*)                                      
BEGIN
	RETURN Date.NaechsteWocheInMonat(inDatum,inoutWAnfang,inoutWEnde);
END NaechsteWocheInMonat;

(************************** Konvertierungsoperatoren ******************************)
  
PROCEDURE DatumAlsString (inDatum : TDatum) : TString;
(*
Vb: --
Konvertiert ein bergebenes Datum inDatum in einen les-/druckbaren String "31.12.2001"
Nb: --
*)
BEGIN
	RETURN Date.DatumAlsString(inDatum);
END DatumAlsString;

PROCEDURE DatumVonString (inString : TString; VAR outDatum:TDatum;
                          VAR outMessage:TString) : BOOLEAN; 
(*
Vb: --
Konvertiert einen bergebenen String "31.12.2001" in ein internes Datum-ADO
Nb: --
*)
BEGIN
	RETURN	Date.DatumVonString(inString,outDatum,outMessage);
END DatumVonString;

PROCEDURE StagAlsString (inStag : TStag) : TString;
(*
Vb: --
Konvertiert ein bergebenes Stag inStag in einen les-/druckbaren String "31.12.2001"
Nb: --
*)
BEGIN
	RETURN STag.StagAlsString(inStag);
END StagAlsString;

PROCEDURE StagVonString (inString : TString; VAR outStag:TStag;
                          VAR outMessage:TString) : BOOLEAN;
(*
Vb: --
Konvertiert einen bergebenen String "31.12.2001" in ein internes Stag-ADO
Nb: --
*)
BEGIN
	RETURN  STag.StagVonString(inString,outStag,outMessage);
END StagVonString;

PROCEDURE MonatVonString (inString : TString;
 VAR outMonat:TMonat; VAR outMessage:TString) : BOOLEAN;
(*
Vb: --
Konvertiert einen uebergeben Monats-String (1..12) in ein internes TMonat-ADO
Nb: --
*)
BEGIN
	RETURN Monat.MonatVonString(inString ,outMonat,outMessage);
END MonatVonString;

PROCEDURE MonatAlsString (inMonat:TMonat) : TString;
(*
Vb: --
Konvertiert ein uebergebes Monats-ADO (1..12) in einen String
Nb: --
*)
BEGIN
       RETURN Monat.MonatAlsString(inMonat);
END MonatAlsString ;

PROCEDURE JahrVonString (inString : TString;
 VAR outJahr:TJahr; VAR outMessage:TString) : BOOLEAN;
(*
Vb: --
Konvertiert einen uebergeben Jahres-String (1900-2100) in ein internes TJahr-ADO
Nb: --
*)
BEGIN
	RETURN Jahr.JahrVonString(inString,outJahr,outMessage);
END JahrVonString;

PROCEDURE JahrAlsString ( inJahr:TJahr) : TString;
(*
Vb: --
Konvertiert einen uebergeben Jahr-ADO  in einen String
Nb: --
*) 
BEGIN
	 RETURN Jahr.JahrAlsString(inJahr);
END JahrAlsString;
   
END Datum.
