(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: DatumFM.mod,v $
# $Author: Sopra $
# $Date: 2001/03/10 09:47:55 $
# $Revision: 1.1.1.1 $
# Bemerkungen: Hier sind die Funktionen und Typen fr's Datum drin!
	hgw, 13.1.2001 19:10 

*)
(******************************************************************************)


IMPLEMENTATION MODULE DatumFM;

(* TS Datum *)
(*   Es geht die Woche von Montag bis Sonntag  *)  

(* DatenTeilSystem zum Erzeugen, Lschen von Datum ADOs. *)
(* Operatoren auf Datums ADOs *)




IMPORT String; 
IMPORT DatumIMPORTE;
FROM Storage IMPORT ALLOCATE, DEALLOCATE;
FROM SYSTEM  IMPORT TSIZE; 

(**************************** Datentypvereinbarungen ***********************)
TYPE TTagDS=[1..31];
TYPE TMonatDS=[1..12]; 
TYPE TJahrDS=[1900..9999];           
TYPE TTag	= POINTER TO TTagDS;
TYPE TMonat	= POINTER TO TMonatDS;
TYPE TJahr	= POINTER TO TJahrDS;
TYPE TStag 	= POINTER TO TStagDS;
TYPE TStagDS	=	RECORD
				T : TTag;
				M : TMonat;
				isUndef:BOOLEAN;
			END;

TYPE TDatum 	= POINTER TO TDatumDS;
TYPE TDatumDS	= 	RECORD
				T:TTag;
				M:TMonat;
				J:TJahr;
				isUndef:BOOLEAN;
			END;
TYPE Monate = [1..12];
TYPE MonatsMenge = SET OF Monate;

(**************************** Datentyp TTag = Tag *****************************)
PROCEDURE CreateTag():TTag;
VAR T:TTag;
BEGIN
	RETURN T;
END CreateTag ;

PROCEDURE CreateMonat():TMonat;
VAR M:TMonat;
BEGIN
	RETURN M;
END CreateMonat ;

PROCEDURE CreateJahr():TJahr;
VAR J:TJahr;
BEGIN
	RETURN J;
END CreateJahr ;
(**************************** Datentyp TStag = Stichtag ***********************)
	

PROCEDURE CreateStag ():TStag;
(* 
Vb:		keine	 
Erzeugt ein neues ADO D vom Typ TStag 
Default-Wert (nicht gesetztes Datum) ist D.isUndef=TRUE;
Nb:	ADO D existiert       
*)
VAR aktStag : TStag;
BEGIN (* -- Create *)
    (* -- Vorbed.: keine *)
     ALLOCATE (aktStag, TSIZE (TStagDS)) ;
     WITH aktStag^ DO
	T := CreateTag();
	M := CreateMonat();
	isUndef:=TRUE;
     END; (* WITH *)
     RETURN aktStag;
    (* -- Nachbed.: RueckgabeADO aktID existiert *)
END CreateStag;

PROCEDURE DisposeStag (VAR inoutD:TStag);
(*  
Vb: keine 
ADO D wird aus dem System entfernt 
Nb:	ADO D existiert nicht mehr 
*) 
BEGIN
	DEALLOCATE (inoutD, TSIZE (TStagDS)); 	
	inoutD:=NIL;
END DisposeStag;

PROCEDURE DuplicateStag ( inD:TStag):TStag;
(* 
Vb:	keine 
Erzeugt das Rckgabe ADO und gleicht die Werte der Attribute an; 
Nb:	IsEqual(D, RckgabeD) and not (D=RckgabeD) 
*) 
VAR Duplikat: TStag;
BEGIN
	Duplikat:=CreateStag();
	WITH Duplikat^ DO
		T^:=inD^.T^;
		M^:=inD^.M^;
		isUndef:=inD^.isUndef;
	END (* WITH *);
	RETURN Duplikat;

END DuplicateStag;
          
PROCEDURE IsEqualStag (inD1,inD2: TStag ):BOOLEAN;
(*
Vb:		keine 
berprft die beiden Datmer auf Wertegleichheit aller Attribute 
Nb:	keine  
*)

VAR gleich: BOOLEAN;
BEGIN
	gleich :=	((inD1^.T^ = inD2^.T^) AND
			(inD1^.M^ = inD2^.M^)) OR
			(inD1^.isUndef = inD2^.isUndef);
	RETURN gleich;
	
END IsEqualStag;

PROCEDURE EqualizeStag (VAR inoutZielD:TStag ; inQuellD:TStag); 
(*
Vb:	keine 
gleicht die Werte der Attribute von ZielD an die von QuellD an, wobei die Identitt der ADO's nicht verndert wird 
Nb:	IsEqual(QuellD,ZielD) and not (QuellD=ZielD)
*)
BEGIN
	WITH inoutZielD^ DO
		T^:=inQuellD^.T^;
		M^:=inQuellD^.M^;
		isUndef:=inQuellD^.isUndef;
	END (* WITH *);
END EqualizeStag;


PROCEDURE LiesTagInStag ( inStag :TStag):TTag; 
(*
Vb:		keine 
Liefert den Tag des ADO  Stag
Nb:	keine 
*)
BEGIN
	RETURN inStag^.T;
END LiesTagInStag;

PROCEDURE SetzeTagInStag (VAR inoutStag:TStag; inTag:TTag); 
(*
Vb: Tag in [1..31] 
Setzt den Tag im ADO Stag
Nb:	GetTag(Dneu)=Tag 
*)
BEGIN
	inoutStag^.T^:=inTag^;
END SetzeTagInStag;

PROCEDURE LiesMonatInStag (inStag:TStag):TMonat; 
(*
Vb:		keine 
Liefert den Monat des ADO  Stag
Nb:	keine 
*)
BEGIN
	RETURN inStag^.M;
END LiesMonatInStag;

PROCEDURE SetzeMonatInStag (VAR inoutStag:TStag; inMonat:TMonat); 
(*
Vb:		keine 
Setze Monat [1..12] des ADO Stag
Nb:	keine 
*)
BEGIN
	inoutStag^.M^:=inMonat^;
END SetzeMonatInStag;

PROCEDURE PruefeStag (inStag: TStag) : BOOLEAN;
(*
Vb: --
Prft, ob es sich bei dem Stichtag inStag um ein gueltiges Datum handelt.
z.B. wird bei inStag = 31.02. ein false geliefert. 
Da ein Stichtag 29.02. nur alle vier Jahre auftreten wrde, ist ein Stichtag 29.02. ebenfalls verboten
nb: (false <=> inStag ungueltig) sonst true
*)
VAR gueltig:BOOLEAN;
BEGIN
	WITH inStag^ DO
		IF (M^ IN MonatsMenge{2,4,6,9,11}) AND (T^ = 31) THEN
			gueltig:=FALSE;
		ELSIF	(M^ = 2) AND ((T^ =29) OR (T^ = 30)) THEN
			gueltig:=FALSE;
		ELSE
			gueltig:=TRUE;
		END (* IF *);
	END (* WITH *); 

	RETURN gueltig;
END PruefeStag;


(************************** Datentyp TDatum ******************************)

PROCEDURE CreateDatum ():TDatum;
(* 
Vb:		keine	 
Erzeugt ein neues ADO D vom Typ TDatum 
Nb:	ADO D existiert       
*)
VAR aktDatum : TDatum;
BEGIN
    (* -- Vorbed.: keine *)
     ALLOCATE (aktDatum, TSIZE (TDatumDS)) ;
     WITH aktDatum^ DO
        T := CreateTag();
        M := CreateMonat();
	J := CreateJahr();
        isUndef:=TRUE;
     END; (* WITH *)
     RETURN aktDatum;
    (* -- Nachbed.: RueckgabeADO aktID existiert *)
END CreateDatum;


PROCEDURE DisposeDatum (VAR inoutD:TDatum);
(*  
Vb: keine 
ADO D wird aus dem System entfernt 
Nb:	ADO D existiert nicht mehr 
*) 
BEGIN
	DEALLOCATE (inoutD, TSIZE (TDatumDS)); 	
	inoutD:=NIL;
END DisposeDatum;


PROCEDURE DuplicateDatum (VAR inD:TDatum):TDatum;
(* 
Vb:	keine 
Erzeugt das Rckgabe ADO und gleicht die Werte der Attribute an; 
Nb:	IsEqual(D, RckgabeD) and not (D=RckgabeD) 
*) 
VAR Duplikat: TDatum;
BEGIN
        Duplikat:=CreateDatum();
        WITH Duplikat^ DO
                T^:=inD^.T^;
                M^:=inD^.M^;
		J^:=inD^.J^;
                isUndef:=inD^.isUndef;
        END (* WITH *);
        RETURN Duplikat;  
END DuplicateDatum;
          
PROCEDURE IsEqualDatum (inD1,inD2: TDatum ):BOOLEAN;
(*
Vb:		keine 
berprft die beiden Konditionen auf Wertegleichheit der aller Attribute 
Nb:	keine  
*)
VAR gleich: BOOLEAN;
BEGIN
        gleich :=       ((inD1^.T^ = inD2^.T^) AND
                        (inD1^.M^ = inD2^.M^)  AND
                        (inD1^.J^ = inD2^.J^)) OR
                        (inD1^.isUndef = inD2^.isUndef);
        RETURN gleich;
                    
END IsEqualDatum;

PROCEDURE EqualizeDatum (VAR inoutZielD:TDatum ; inQuellD:TDatum); 
(*
Vb:	keine 
gleicht die Werte der Attribute von ZielD an die von QuellD an, wobei die Identitt der ADO's nicht verndert wird 
Nb:	IsEqual(QuellD,ZielD) and not (QuellD=ZielD)
*)
BEGIN
        WITH inoutZielD^ DO
                T^:=inQuellD^.T^;
                M^:=inQuellD^.M^;
                J^:=inQuellD^.J^;
                isUndef:=inQuellD^.isUndef;
        END (* WITH *);  
END EqualizeDatum;

PROCEDURE PruefeDatum (inDatum : TDatum) : BOOLEAN;
(*
Vb: --
Prft die Konsistenz (Gueltigkeit des bergebenen Datums.
So ist der 31.02. fr jedes Jahr verboten. Schaltjahre usw. sollten bercksichtigt sein.
nb: (false <=> inDatum ungueltig) sonst true
*)

VAR gueltig:BOOLEAN;
BEGIN
        WITH inDatum^ DO
                IF (M^ IN MonatsMenge{2,4,6,9,11}) AND (T^ = 31) THEN
                        gueltig:=FALSE;
                ELSIF (M^ = 2) AND  (T^ = 30) THEN
                        gueltig:=FALSE;
		ELSIF (M^ = 2) AND ((J^ MOD 4) # 0) AND (T^ = 29) THEN
			gueltig:=FALSE; 
                ELSIF (M^ = 2) AND ((J^ MOD 400)=0) AND (T^ = 29) THEN
			gueltig:=FALSE;
		ELSE
                        gueltig:=TRUE;
                END ;
        END; 
        RETURN gueltig; 
END PruefeDatum;

PROCEDURE PruefeObMonatsErster (inDatum : TDatum) : BOOLEAN;
(*
Vb: --
Prueft, ob es sich bei dem Datum inDatum um den Monatsersten (01.xx.xx) handelt.
Nb: (True <=> inDatum.Tag = 01) oder (False sonst)
*)
BEGIN
	RETURN (inDatum^.T^ = 1);
END PruefeObMonatsErster;

PROCEDURE PruefeObMonatJanuar (inDatum : TDatum) : BOOLEAN;
(*
Vb: --
Prueft, ob es sich bei dem Datum inDatum um den Monat Januar
(xx.01.xx) handelt.
Nb: (True <=> inDatum.Monat = 01) oder (False sonst)
*)
BEGIN
	RETURN (inDatum^.M^ = 1);
END PruefeObMonatJanuar;

PROCEDURE LiesTagInDatum (inD:TDatum):TTag; 
(*
Vb:		keine 
Liefert den Tag des ADO D 
Nb:	keine 
*)
BEGIN
	RETURN inD^.T;
END LiesTagInDatum;

PROCEDURE SetzeTagInDatum (VAR inoutD:TDatum; inTag:TTag); 
(*
Vb: Tag in [1..31] 
Setzt den Tag im ADO D 
Nb:	GetTag(Dneu)=Tag 
*)
BEGIN
	inoutD^.T^ := inTag^;
END SetzeTagInDatum;

PROCEDURE LiesMonatInDatum (inD:TDatum):TMonat; 
(*
Vb:		keine 
Liefert den Monat des ADO D 
Nb:	keine 
*)
BEGIN
	RETURN inD^.M;
END LiesMonatInDatum;

PROCEDURE SetzeMonatInDatum (VAR inoutD:TDatum; inMonat:TMonat); 
(*
Vb:		keine 
Setze Monat [1..12] des ADO D 
Nb:	keine 
*)
BEGIN
	inoutD^.M^:=inMonat^;
END SetzeMonatInDatum;

PROCEDURE LiesJahrInDatum (inD:TDatum):TJahr; 
(*
Vb:		keine 
Liefert das Jahr des ADO D 
Nb:	keine 
*)
BEGIN
	RETURN inD^.J;
END LiesJahrInDatum;

PROCEDURE SetzeJahrInDatum (VAR inoutD:TDatum; inJahr:TJahr); 
(*
Vb:		keine 
Setze das Jahr [1..9999] des ADO D 
Nb:	keine 
*)
BEGIN
	inoutD^.J^ := inJahr^;
END SetzeJahrInDatum;

PROCEDURE SetzeDatumEternity (VAR inoutD:TDatum);
(*
Vb:             keine
Setze Datum auf UNDEF
Nb:     keine
*)
BEGIN
        inoutD^.isUndef:=TRUE;
END SetzeDatumEternity;
 
PROCEDURE IstDatumEternity (inD:TDatum):BOOLEAN;
(*
Vb:             keine
TRUE, falls Datum = UNDEF
Nb:     keine
*)
BEGIN    
	RETURN inD^.isUndef;
END IstDatumEternity;

PROCEDURE SmallerDatum(inSmallerD,inGreaterD:TDatum):BOOLEAN ;
(*
Vb:	keine 
Prft, ob SmallerD ein frheres Datum als GreaterD enthlt 
Nb:	Rckgabewert <=>	SmallerD "<" GreaterD 
*)
VAR Kleiner: BOOLEAN;
BEGIN
	Kleiner:=FALSE;
	WITH inSmallerD^ DO
		IF (J^ < inGreaterD^.J^) THEN 
		  Kleiner:=TRUE;
		ELSIF (J^ = inGreaterD^.J^) THEN
	        	IF (M^ <= inGreaterD^.M^) THEN	
		  	  Kleiner:=TRUE;
			ELSIF (M^ = inGreaterD^.M^) THEN
				IF (T^ < inGreaterD^.T^) THEN
		  	  	  Kleiner:=TRUE;
				END (* IF *);
			END (* IF *);
		END (* IF *);
	END (* WITH *);
	RETURN Kleiner;		
END SmallerDatum;

PROCEDURE MaxDatum (inDatum1, inDatum2:TDatum) : TDatum;
(*
Vb: (PrufeDatum (inDatum1) = true) AND ( PruefeDatum (inDatum2) = true)
Gibt das grere Datum zurck                                                   
Nb: --
*)
BEGIN
	IF SmallerDatum(inDatum1,inDatum2) THEN
		RETURN inDatum2;
	ELSE 
		RETURN inDatum1;
	END (* IF *)
END MaxDatum;

PROCEDURE MinDatum (inDatum1, inDatum2:TDatum) : TDatum;
(*
Vb: (PrufeDatum (inDatum1) = true) AND ( PruefeDatum (inDatum2) = true)
Gibt das kleinere Datum zurck                                                   
Nb: --
*)
BEGIN
	IF SmallerDatum(inDatum1,inDatum2) THEN
                RETURN inDatum1;
        ELSE
                RETURN inDatum2;
        END (* IF *)    
END MinDatum;

PROCEDURE IncDatum(VAR inoutD:TDatum); 
(*
Vb: Datum < 31.12.9999 
D wird auf das Datum des nachfolgenden Tages gesetzt 
Nb:	IsEqual(Dec(Dneu),Dalt) and not IsEqual(Dalt,Dneu)
*)
VAR JD: REAL;
BEGIN
	JD := Datum2JD(inoutD);
	JD := JD + 1.0;
	JD2Datum(JD,inoutD);
END IncDatum;

PROCEDURE DecDatum(VAR inoutD:TDatum); 
(*
Vb: Datum > 1.1.1 
D wird auf das Datum des vorhergehenden Tages gesetzt 
Nb:	IsEqual(Inc(Dneu),Dalt) and not IsEqual(Dalt,Dneu) 
*)
VAR JD: REAL;
BEGIN
	JD := Datum2JD(inoutD);
	JD := JD + 1.0;
	JD2Datum(JD,inoutD);
END DecDatum;

PROCEDURE DatumInZeitraum( inD,inVonD,inBisD:TDatum ): BOOLEAN; 
(*
Vb: keine 
prft ob D zwischen vonD und bisD liegt
Nb: true falls inD in [vonD,bisD], false sonst
*)
BEGIN
	RETURN (SmallerDatum(inVonD, inD) AND 
	        SmallerDatum(inD,inBisD));
	
END DatumInZeitraum;

PROCEDURE AnzahlMonate( inVonD,inBisD:TDatum ): CARDINAL; 
(*
Vb: vonD <= bisD
gib die Anzahl der Monate zwischen vonD und bisD zurck
Semantik: angeschnittene Monate zaehlen mit
Nb: --
*)
BEGIN
	(* Dazu ist mir noch nichts Geniales eingefallen *)
END AnzahlMonate;

PROCEDURE AnzahlWochen( inVonD,inBisD:TDatum ): CARDINAL; 
(*
Vb: vonD <= bisD
gib die Anzal der Wochen zwischen vonD und bisD zurck
Semantik: angeschnittene Wochen zaehlen mit
Nb: --
*)

VAR JD1, JD2: REAL;
BEGIN
	RETURN TRUNC(FLOAT((Datum2JD(inBisD)-Datum2JD(inVonD)))/7.0 + 0.5);
END AnzahlWochen;

PROCEDURE AnzahlTage( inVonD,inBisD:TDatum ): CARDINAL; 
(*
Vb: vonD <= bisD
gib die Anzal der Tage zwischen vonD und bisD zurck
Nb: --
*)
BEGIN
	RETURN TRUNC(Datum2JD(inBisD)-Datum2JD(inVonD));
END AnzahlTage;

PROCEDURE AnfEndDatumKWZuDatum (inDatum : TDatum; outAnfang, outEnde : TDatum);
(*
Vb: (1 <= inDatum.Tag <= 31) AND (PruefeDatum(inDatum)=True)
Ermittelt zu dem bergebenen Datum die Kalenderwoche, in der das Datum
inDatum liegt.
NB: --
*)
BEGIN
	(* Wochentag ist aus dem JD ableitbar. Das Wie wird noch geklrt *)
END AnfEndDatumKWZuDatum;

PROCEDURE AnfEndDatumKWZuMonat (inDatum : TDatum; outAnfang, outEnde : TDatum);
(*
Vb: 1 <= inDatum.Monat <= 12
Ermittelt zu dem bergebenen Monat die Kalenderwochen, in denen der erste und 
letzte Tag des Monats liegt. outAnfang ist das Kalenderdatum des ersten Tages 
der Woche, in der der erste des Monats liegt. outEnde ist das Kalenderdatum des
letzten Tages der Woche, in der der letzte Tag des Monats liegt.
NB: --
*)
BEGIN
END AnfEndDatumKWZuMonat;


PROCEDURE ErsteWocheInMonat (inDatum:TDatum; outWAnfang, outWEnde:TDatum);
(*
Vb: PrufeDatum (inDatum) = true
Ermittelt das Anfangsdatum und Endedatum der Kalenderwoche, in der der Monatserstevon inDatum liegt. Angeschnitte Wochen zaehlen mit.
Nb: --
*)
BEGIN
END ErsteWocheInMonat;
 
PROCEDURE NaechsteWocheInMonat (inDatum:TDatum; inoutWAnfang, inoutWEnde:TDatum):BOOLEAN;
(*
Vb: PrufeDatum (inDatum) = true
inDatum liefert den relevanten Monat. Zu diesem Monat sollen alle folgenden Wochen ausgegeben werden.
inoutWAnfang, inoutWEnde enthalten als Eingabe die aktuelle Woche. Zu dieser Woche wird eine Woche hinzugezaehlt und wieder ausgegeben.
Ist das neue inoutWAnfang nicht mehr im betrachteten Monat (inDatum), dann gibt es keine NaechsteWocheImMonat
NB: (False <=> wenn keine naechste Woche existiert)
*)                                      
BEGIN
END NaechsteWocheInMonat;

(************************** Datentyp TJahr ******************************)

PROCEDURE LetztesJahr (inJahr : TJahr) : TJahr;
(*
Vb: inJahr >= 1901
Liefert die um 1 dekrementierte Jahreszahl von inJahr zurueck.
Nb: --
*)
BEGIN
	inJahr^ := inJahr^ - 1;
	RETURN inJahr;
END LetztesJahr;

PROCEDURE IsEqualJahr (inJahr1, inJahr:TJahr) : BOOLEAN;
(*
Vb: (injahr1 >=1900) AND (inJahr2 >= 1900)
Prueft ob injahr1 = inJahr2
NB: (True <=> inJahr1 = inJahr2)
*)
BEGIN
END IsEqualJahr;


(**************************** Datentyp TStag = Stichtag ***********************)

PROCEDURE IsEqualMonat (inMonat1, inMonat2:TMonat) : BOOLEAN;
(*
Vb: (1<=inMonat1<=12) AND (1<=inMonat2<=12)
Prueft ob inMonat1 = inMonat2
NB: (True <=> inMonat1 = inMonat2)
*)
BEGIN
END IsEqualMonat;


(**************************** Datentyp TTag *************************************)
 
PROCEDURE IsEqualTag (inTag1, inTag2:TTag) : BOOLEAN;
(*
Vb: (1<=inTag1<=31) AND (1<=inTag2<=31)
Prueft ob inTag1 = inTag2
NB: (True <=> inTag1 = inTag2)
*)
BEGIN
END IsEqualTag;
                    
(************************** Konvertierungsoperatoren ******************************)
  
PROCEDURE DatumAlsString (inDatum : TDatum) : TString;
(*
Vb: --
Konvertiert ein bergebenes Datum inDatum in einen les-/druckbaren String "31.12.2001"
Nb: --
*)
BEGIN
END DatumAlsString;

PROCEDURE DatumVonString (inString : TString; VAR outDatum:TDatum;
                          VAR outMessage:TString) : BOOLEAN;
(*
Vb: --
Konvertiert einen bergebenen String "31.12.2001" in ein internes Datum-ADO
Nb: --
*)
BEGIN
END DatumVonString;

PROCEDURE StagAlsString (inStag : TStag) : TString;
(*
Vb: --
Konvertiert ein bergebenes Stag inStag in einen les-/druckbaren String "31.12.2001"
Nb: --
*)
BEGIN
END StagAlsString;

PROCEDURE StagVonString (inString : TString;
 outStag:TStag; VAR outMessage:TString) : BOOLEAN;
(*
Vb: --
Konvertiert einen bergebenen String "31.12.2001" in ein internes Stag-ADO
Nb: --
*)
BEGIN
END StagVonString;

PROCEDURE MonatAlsCard (inMonat : TMonat ) : CARDINAL;
(*
Vb: --
Gibt die Monatszahl 1..12 des Monats als CARDINAL zurck.
Nb: --
*)
BEGIN
END MonatAlsCard;

(********************Funktionen zum Rechnen mit julianischem Datum************)
PROCEDURE Datum2JD( inD:TDatum):REAL;
VAR J1,J2:TJahr;
    JD:REAL;

BEGIN
	ALLOCATE (J1, TSIZE (TJahrDS));
	ALLOCATE (J2, TSIZE (TJahrDS));
	J1^ := inD^.J^ - 1601;
	JD := 2305812.5 + FLOAT(J1^) * 365.0;
	JD := JD + FLOAT(J1^ DIV 4 - J1^ DIV 100 + J1^ DIV 400);
	IF inD^.M^ > 2 THEN
		JD:= JD + FLOAT(TRUNC(30.6 * FLOAT(inD^.M^) - 32.3));
		J2^:= inD^.J^;
		IF J2^ MOD 100 = 0 THEN
			J2^ := J2^ DIV 100;
		END (* IF *);
		IF J2^ MOD 4 = 0 THEN
			JD := JD + 1.0;
		END (* IF *);
	ELSE
		JD := JD + 31.0 * FLOAT(inD^.M^) - 31.0;
	END (* IF *);
	JD := JD + FLOAT(inD^.T^);
	DEALLOCATE (J1, TSIZE (TJahrDS));  
	DEALLOCATE (J2, TSIZE (TJahrDS));  
	RETURN JD;	
END Datum2JD;

PROCEDURE JD2Datum (inJD : REAL; VAR outD:TDatum);
VAR Z,y,m,D:CARDINAL;
    N,F:REAL;

BEGIN
	N := inJD - 1720981.5;
	Z := TRUNC(N);
	F := N - FLOAT(Z);
	y := TRUNC((FLOAT(Z) - 122.1)/365.25);
	m := TRUNC((FLOAT(Z) - FLOAT(TRUNC(365.25*FLOAT(y))))/30.6001);
	outD^.T^ := Z - TRUNC(365.25*FLOAT(y)) - TRUNC(30.6001*FLOAT(m)) + TRUNC(F);
	outD^.M^ := m - 1;
	outD^.J^ := y;
	IF m > 13 THEN
		outD^.M^ := outD^.M^ - 12;
		outD^.J^ := outD^.J^ + 1;
	END (* IF *);
	
END JD2Datum;

END DatumFM.
