(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: Jahr.mod,v $
# $Author: Sopra $
# $Date: 2001/03/12 14:58:26 $
# $Revision: 1.3 $
# Bemerkungen: Hier sind die Funktionen und Typen fuer's ADO Jahr drin!
        
*)
(******************************************************************************)


IMPLEMENTATION MODULE Jahr;

(* TS Datum *)
(* Die Woche geht von Montag(1) bis Sonntag(7)  *)
(* DatenTeilSystem zum Erzeugen, Lschen von Datum ADOs. *)
(* Operatoren auf Jahr ADOs *)


IMPORT String; 
IMPORT WholeStr;
IMPORT DatumIMPORTE;
FROM Storage IMPORT ALLOCATE, DEALLOCATE;
FROM SYSTEM  IMPORT TSIZE; 

TYPE TString	= String.TString;
TYPE TJahrDS	= [0..9999];
TYPE TJahr      = POINTER TO TJahrDS;      

(*************************** Datentyp TJahr = Jahr ****************************)

PROCEDURE CreateJahr():TJahr;
VAR J:TJahr;
BEGIN
        ALLOCATE (J, TSIZE (TJahrDS)) ;
        RETURN J;
END CreateJahr ;

PROCEDURE DisposeJahr (VAR inoutJahr : TJahr);
             (* entfernt das ADO Jahr aus dem System
              wird benoetigt in Kst.DisposeKst (...);*)
BEGIN
        DEALLOCATE (inoutJahr, TSIZE (TJahrDS)) ;
        inoutJahr:=NIL;
END DisposeJahr;


PROCEDURE SmallerJahr (inSmallerJahr, inGreaterJahr : TJahr) : BOOLEAN;
            (* vergleicht zwei Jahreszahlen vom Typ TJahr und
               liefert TRUE, wenn inSmallerJahr < inGreaterJahr
            wird benoetigt in Vtr.BeginntNotImLfdJahr*)
BEGIN
        RETURN inSmallerJahr^ < inGreaterJahr^ ;
END SmallerJahr;

PROCEDURE EqualizeJahr (VAR inoutZielJahr, inJahr : TJahr);
             (* Gleicht den Zustand/ die Attribute des ZielJahres
                an das inJahr an
             wird benoetigt in Kst.EqualizeKst (...);
                               Kst.SetzeJahrinKst (..);*)
BEGIN
        inoutZielJahr^ := inJahr^;
END EqualizeJahr;

PROCEDURE DuplicateJahr (inJahr : TJahr) : TJahr;
              (* Erzeugt ein neues ADO vom Typ TJahr mit
                 Zustandsgleichheit zu inJahr
              wird benoetigt in Kst.LiesJahrinKst (..);   *)
VAR J: TJahr;
BEGIN                                                                                   J:=CreateJahr();
        EqualizeJahr(J,inJahr); 
        RETURN J;
END DuplicateJahr;

PROCEDURE JahrAlsCard (inJahr: TJahr) : CARDINAL;
(*
Vb: --
Gibt die Jahreszahl als CARDINAL zurueck.
Nb: --
*)
BEGIN
        RETURN inJahr^;
END JahrAlsCard;

PROCEDURE SetzeJahr (VAR inoutJahr: TJahr; inV: CARDINAL);
(*
Vb: --
Setze die Jahreszahl inoutJahr  auf inV zurueck. Falls inV ausserhalb des Werte
bereiches wird nichts zugewiesen
Nb: --
*)
BEGIN
        inoutJahr^:=inV;
END SetzeJahr; 

PROCEDURE LetztesJahr (inJahr : TJahr) : TJahr;
(*
Vb: inJahr >= 1901
Liefert die um 1 dekrementierte Jahreszahl von inJahr zurueck.
Nb: --
*)
BEGIN
        inJahr^ := inJahr^ - 1;
        RETURN inJahr;
END LetztesJahr;

PROCEDURE IsEqualJahr (inJahr1, inJahr2:TJahr) : BOOLEAN;
(*
Vb: (injahr1 >=1900) AND (inJahr2 >= 1900)
Prueft ob injahr1 = inJahr2
NB: (True <=> inJahr1 = inJahr2)
*)
BEGIN
        RETURN ( inJahr1^ = inJahr2^ );
END IsEqualJahr;  

(************************** Konvertierungsoperatoren **************************)

PROCEDURE JahrVonString (inString : TString;
 VAR outJahr:TJahr; VAR outMessage:TString) : BOOLEAN;
(*
Vb: --
Konvertiert einen uebergeben Jahres-String (0..9999) in ein internes TJahr-ADO
Nb: --
*)
VAR     CharArray       : ARRAY[1..5] OF CHAR;
        success         : BOOLEAN;
        val             : CARDINAL;
        Result          : WholeStr.ConvResults;
BEGIN
        String.Lies(inString,CharArray);
        WholeStr.StrToCard(CharArray,val,Result);
	IF Result=WholeStr.strAllRight THEN
	        IF (val < 0) OR (val > 9999)  THEN
        	        outMessage:=String.Create();
                	String.Schreibe(outMessage,
                        	"Jahreszahlen < 0 oder > 9999 sind nicht erlaubt!");
               	 	success:=FALSE;
        	ELSE
                	outJahr:=CreateJahr();
                	outJahr^:=val;
                	success:=TRUE;
        	END (* IF *);
	ELSE
                outMessage:=String.Create();
                String.Schreibe(outMessage,
                  "Fehler bei der Konvertierung der Jahreszahl!");
   		success:=FALSE;
		
	END (* IF *);
        RETURN success;
END JahrVonString;

PROCEDURE JahrAlsString (inJ : TJahr):TString;
VAR str         : TString;
    CharArray   : ARRAY [1..5] OF CHAR;
BEGIN
        str:=String.Create();
        WholeStr.CardToStr(inJ^,CharArray);
        String.Schreibe(str,CharArray);
        RETURN str;
END JahrAlsString; 



END Jahr.
