(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: Monat.mod,v $
# $Author: Sopra $
# $Date: 2001/03/10 09:47:56 $
# $Revision: 1.1.1.1 $
# Bemerkungen: Hier sind die Funktionen und Typen fuer's ADO Monat drin!
        
*)
(******************************************************************************)


IMPLEMENTATION MODULE Monat;

(* TS Datum *)
(* Die Woche geht von Montag(1) bis Sonntag(7)  *)
(* DatenTeilSystem zum Erzeugen, Lschen von Datum ADOs. *)
(* Operatoren auf Monats ADOs *)


IMPORT DatumIMPORTE;
IMPORT String;
IMPORT WholeStr;
FROM Storage IMPORT ALLOCATE, DEALLOCATE;
FROM SYSTEM  IMPORT TSIZE;      

TYPE TString	= String.TString;    
TYPE TMonatDS	= [1..12];
TYPE TMonat     = POINTER TO TMonatDS; 

(*************************** Datentyp TMonat = Monat **************************)

PROCEDURE CreateMonat():TMonat;
VAR M:TMonat;
BEGIN
        ALLOCATE (M, TSIZE (TMonatDS)) ;
        RETURN M;
END CreateMonat ;

PROCEDURE DisposeMonat (VAR inoutMonat : TMonat);
BEGIN
        DEALLOCATE (inoutMonat, TSIZE (TMonatDS)) ;
        inoutMonat:=NIL;
END DisposeMonat;

PROCEDURE IsEqualMonat (inMonat1, inMonat2:TMonat) : BOOLEAN;
(*
Vb: (1<=inMonat1<=12) AND (1<=inMonat2<=12)
Prueft ob inMonat1 = inMonat2
NB: (True <=> inMonat1 = inMonat2)
*)
BEGIN
        RETURN (inMonat1^ = inMonat2^);
END IsEqualMonat;

PROCEDURE DuplicateMonat (inMonat : TMonat) : TMonat;
              (* Erzeugt ein neues ADO vom Typ TMonat mit
                 Zustandsgleichheit zu inMonat
              wird benoetigt in Kst.LiesJahrinKst (..);   *)
VAR M: TMonat;
BEGIN
        M:=CreateMonat();
        EqualizeMonat(M,inMonat);
        RETURN M;
END DuplicateMonat;

PROCEDURE EqualizeMonat (VAR inoutZielMonat, inMonat : TMonat);
             (* Gleicht den Zustand/ die Attribute des ZielMonats
                an das inMonat an *)
BEGIN
        inoutZielMonat^ := inMonat^;
END EqualizeMonat;

PROCEDURE MonatAlsCard (inMonat : TMonat ) : CARDINAL;  
(*
Vb: --
Gibt die Monatszahl 1..12 des Monats als CARDINAL zurueck.
Nb: --
*)
BEGIN
        RETURN inMonat^;
END MonatAlsCard; 

PROCEDURE SetzeMonat( VAR inoutM: TMonat; inV: CARDINAL);
BEGIN
        IF (inV >= 1) AND (inV <=12) THEN
                inoutM^ := inV;
        END (* IF *);
END SetzeMonat; 

(************************** Konvertierungsoperatoren **************************)

PROCEDURE MonatVonString (inString : TString;
 VAR outMonat:TMonat; VAR outMessage:TString) : BOOLEAN;
(*
Vb: --
Konvertiert einen uebergeben Monats-String (1..12) in ein internes TMonat-ADO
Nb: --
*)
VAR     CharArray       : ARRAY[1..5] OF CHAR;
        success         : BOOLEAN;
        val             : CARDINAL;
        Result          : WholeStr.ConvResults;
BEGIN
        String.Lies(inString,CharArray);
        WholeStr.StrToCard(CharArray,val,Result);
        IF (val < 1) OR (val > 12) THEN
                outMessage:=String.Create();
                String.Schreibe
                (outMessage,"Monatswerte < 1 oder > 12 sind nicht erlaubt!");
                success:=FALSE;
        ELSE
                outMonat:=CreateMonat();
                outMonat^:=val;
                success:=TRUE;
        END (* IF *);
        RETURN success;
END MonatVonString;

PROCEDURE MonatAlsString (inM : TMonat):TString;
VAR str         : TString;
    CharArray   : ARRAY [1..2] OF CHAR;
BEGIN
        str:=String.Create();
        WholeStr.CardToStr(inM^,CharArray);
        String.Schreibe(str,CharArray);
        RETURN str;
END MonatAlsString;  

END Monat.

                   
