(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: Tag.mod,v $
# $Author: Sopra $
# $Date: 2001/03/10 09:47:56 $
# $Revision: 1.1.1.1 $
# Bemerkungen: Hier sind die Funktionen und Typen fuer's ADO Tag drin!
        
*)
(******************************************************************************)


IMPLEMENTATION MODULE Tag;

(* TS Datum *)
(* Die Woche geht von Montag(1) bis Sonntag(7)  *)
(* DatenTeilSystem zum Erzeugen, Lschen von Datum ADOs. *)
(* Operatoren auf Tages ADOs *)


IMPORT DatumIMPORTE;
IMPORT String;
FROM Storage IMPORT ALLOCATE, DEALLOCATE; 
FROM SYSTEM  IMPORT TSIZE;

(**************************** Datentypvereinbarungen ***********************)

TYPE TTagDS	= [1..31];
TYPE TTag       = POINTER TO TTagDS;  

(**************************** Datentyp TTag = Tag *****************************)
PROCEDURE CreateTag():TTag;
             (* Liefert und initialisiert ein leeres, neues ADO
                vom Typ TJahr
                wird u.a. benoetigt in Kst.CreateKst() *)
VAR T:TTag;
BEGIN
        ALLOCATE (T, TSIZE (TTagDS)) ;
        RETURN T;
END CreateTag ;

PROCEDURE DisposeTag (VAR inoutTag : TTag);
BEGIN
        DEALLOCATE (inoutTag, TSIZE (TTagDS)) ;
        inoutTag:=NIL;
END DisposeTag;

PROCEDURE TagAlsCard (inTag : TTag ) : CARDINAL;
(*
Vb: --
Gibt die Tageszahl 1..31 des Monats als CARDINAL zurueck.

Nb: --
*)
BEGIN
        RETURN inTag^;
END TagAlsCard;

PROCEDURE SetzeTag( VAR inoutT: TTag; inV: CARDINAL);
(*
Vb: --
Setze inoutT auf den Wert inV. Falls inV ausser Wertebereich wird nichts
zugewiesen
Nb:  --
*) 
BEGIN
	IF (inV >= 1) AND (inV <=31) THEN
		inoutT^ := inV;
	END (* IF *);
END SetzeTag;

PROCEDURE IsEqualTag (inTag1, inTag2:TTag) : BOOLEAN;
(*
Vb: (1<=inTag1<=31) AND (1<=inTag2<=31)
Prueft ob inTag1 = inTag2
NB: (True <=> inTag1 = inTag2)
*)
BEGIN
        RETURN (inTag1^ = inTag2^);
END IsEqualTag;
                    
PROCEDURE EqualizeTag( VAR inoutZielTag: TTag; inQuellTag: TTag);
(*
Vb:
Gleicht die beiden ADOs aneinander an
Nb:
*)
BEGIN
	inoutZielTag^:=inQuellTag^;
END EqualizeTag;
END Tag.

                   
