(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
#RCSfile: HKB.mod,v $
#Author: Sopra $ Gabi
#Date: 2001/01/12 11:54:16 $
#Revision: 1.15 $
Bemerkungen: 
*)
(******************************************************************************)
 

IMPLEMENTATION MODULE HKB;

IMPORT HKBIMPORTE;

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

PROCEDURE AufnehmenHK ( inHK : THK; VAR outMessage : TString) : BOOLEAN;
BEGIN
(* Proze D 3.5.2 *)
(*   Vorbed.: HK nicht in Hilfskraefte
     Nachbed.: neue HK aufgenommen
(* -- Ueberpruefung der Plausibilitt der Daten erfolgt innerhalb
   -- von HKe.InsertHK *)

     RETURN HInsertHK (inHK, outMessage);

END (* AufnehmenHK *);

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)


PROCEDURE AendernHK (  inNeuHK : THK; VAR outMessage : TString) : BOOLEAN;
BEGIN
    (* hier wird geprft, ob die HKID berhaupt existiert *)
    IF HExistiertPersIDHK(inNeuHK) THEN
	HUpdateHK (inNeuHK);
        RETURN TRUE
    ELSE
	   (*Fehlermeldung HKID existiert nicht *)
    END (*IF*)
END (* AendernHK *);

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

PROCEDURE LoeschenHK ( inHK : THK; VAR outMessage : TString) : BOOLEAN;
BEGIN
   (* hier wird geprft, ob die HK berhaupt exisitert *)
  
 IF HExistiertPersIDHK(inNeuHK) THEN
         (* hier wird geprft, ob Vertrge existieren*)
         IF NOT VtrBez.ExistVtrZuHK ( HLiesPerIDHK (inHK)) THEN
             RETURN HDeleteHK (inHK, outMessage)
         ELSE
              outMessage := "Vertraege existieren. HK darf nicht geloescht werden!";
              RETURN FALSE
	  END (* IF*)
    ELSE
	   (*Fehlermeldung HKID existiert nicht *)
    END (*IF*)



END (* LoeschenHK *);

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

PROCEDURE BearbeitenNeuVtr ( inVtr : TVtr; VAR outMessage : TString) : BOOLEAN;
VAR KstID : TKstID;
    outWKond: TKond;
    Summe, Betrag, etats: INTEGER;
 
 
BEGIN

(* 	Prfen, ob die  VertragsID bereits existiert *)
    IF NOT Vtre.ExistVtr(inVtr) THEN
	(*Fehlermeldung, VertragsID bereits vergeben*)
    END (*IF, sonst  darf man weitermachen*)

    KstID := VLiesKstIDinVtr ( inVtr ); (*K := Kostenstellen.get (KID); *)

	IF  VIstAbgelaufenVtr(inVtr) (* VD.GueltigBis < Heute*) THEN
	       (* Fehler: Vertrag schon abgelaufen *)
    ELSIF VBeginntNotImLfdJahr(inVtr) (*VD.GueltigVon.Jahr > Heute.Jahr*) THEN
	       (* Fehler: Vertrag beginnt nicht im laufenden Jahr *)
    ELSIF Ksten.IstGesperrtKst() (* K.GesperrtAm <> UNDEF*) OR
      Ksten.IstLiquidiertKst() (* K.LiquidiertAm <> UNDEF*) THEN
	       (* Fehler: Kostenstelle gesperrt oder Liquidiert*)
    ELSE
(*         Summe := 0;  
	FOR alle B in Buchungen mit B.StorniertAm = UNDEF AND 
			B.KostenstellenID = K.ID DO
		Summe += B.Betrag;
*)
  
    Summe:=BelBez.BerGebGelderDerKst(Vtre.LiesKstIDinVtr(inVtr));

    (* Gueltige Kondition(en) ermitteln und Buchungsbetrag berechnen *)

     Betrag:= KBerechneBrutto(VLiesGueltigVoninVtr(inVtr),VLiesGueltigBisinVtr(inVtr),VLiesStdzahlinVtr(inVtr))
     (*  
	FOR alle TK in Tarifkonditionen mit TK.GueltigVon <= VD.GueltigBis AND 
			(VD.GueltigVon <= TK.GueltigBis OR TK.GueltigBis = UNDEF) DO
		Anfang := MAX(TK.GueltigVon, VD.GueltigVon);
		Ende := MIN(TK.GueltigBis, VD.GueltigBis));
		Wochen := (Ende-Anfang).Wochen;
		Betrag += TK.Stundensatz * VD.Stundenzahl * Wochen;
	END FOR
      *)
     
	Summe + := Betrag;
        KHoleGueltigeWKond(VLiesGueltigBisinVtr(inVtr),outWKond); (*WGK := Weihnachtsgeldkonditionen.get(VD.GueltigVon);*)



        (* -- Operation zur Weihnachtsgeldberechnung aufrufen, wie in 
          -- TS_Auto verwendet *)
	(*Etats der durch evtl. erhoehtes Weihnachtsgeld betroffenen 
	Kostenstellen pruefen;
	das Weihnachtsgeld wird wie im Automatischen Betrieb berechnet, allerdings mit 
	den aktuell bekannten Daten*)

	(* IF WGK.Stichtag IN [VD.GueltigVon, VD.GueltigBis] THEN *)
           (* muss noch  geprft werden, Stichtag erst erstellen *)
          Stichtag:= Konden.LiesSTaginWKond(WGK);
          Dat:= Datum.CreateDatum()
          Tag:= Datum.LiesTaginStag()
          Monat:= Datum.LiesMonatinStag()
          Datum.SetzeTagInDatum(Tag);
          Datum.SetzeMonatInDatum(Monat);
          Datum.SetzeJahrInDatum(Aktuelles Jahr);

         (* Summe += Anteil des geschaetzten Weihnachtsgeldes; *)
        Hke.SearchHK(VLiesHKIDinVtr(inVtr), outHK);    (* braucht man nur, um aus der HKID im Vertrag einen ADO HK zu erzeugen*)

        Summe := Summe + Auto.BerechneWGDerHK(outWKond, outHK , Dat:TDatum )
 
        etats:=KBerechneEtatKst(VLiesKstIDinVtr(inVtr));
        OK := etats >= Summe;      
          (* OK := K.Kontingente * K.Aequivalent >= Summe;*)

	IF NOT OK THEN
		(* Fehler: Kostenstellenetat ueberzogen *)
	ELSE
		(* Hilfskraft nach Vertragskonditionen pruefen *)

            (* muss von hier aus berechnet, bzw. aufgerufen werden, die Fkt kommt von Reini aus Auto
               Monate := Anzahl Monate, in denen die Hilfskraft einen Vertrag
							hatte (incl. dem neuen Vertrag)*)


           Monate := AAnzahlMonateImJahr(VLiesHKIDinVtr(inVtr));
           Stunden:=  VtrBez.BerMaxStdzahlDerHK(inVtr);

                  (*  Stunden := VD.Stundenzahl;
            	
        	   Maximale Stundenzahl im Vertragszeitraum berechnen 
        	   FOR alle V in Vertraege mit V.PersonenID = VD.PersonenID DO
			tempMaxStunden := VD.Stundenzahl;
			FOR alle VI in Vertraege mit VI.PersonenID = VD.PersonenID AND
					V.GueltigVon IN [VI.GueltigVon, VI.GueltigBis] DO
				tempMaxStunden := tempMaxStunden + VI.Stundenzahl
			END FOR
			Stunden := Max(Stunden, tempMaxStunden)
	            END FOR
                   *)

	    (* OK := TRUE;*)
                  (* Saldo der Kostenstelle pruefen *)
           OK:= KPruefeVKondInZeitr(VLiesGueltigVoninVtr(inVtr), VLiesGueltigBisinVtr(inVtr));
	        (* OK:= TRUE
			FOR alle VK in Vertragskonditionen mit VK.GueltigVon <= V.GueltigBis AND 
				(V.GueltigVon <= VK.GueltigBis OR VK.GueltigBis = UNDEF) DO
			OK := OK AND Stunden <= VK.Stundenobergrenze AND
					Monate <= VK.Beschaeftigungshoechstdauer
                 *)
	   IF OK THEN
	   	ErzeugenUndBuchenVtr(inVtr: TVtr);
	   ELSE
			(* Fehler: Vertragskondition verletzt *)
END (*BearbeitenNeuVtr*)


(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

PROCEDURE AendernVtr ( inVtr : TVtr;inEndeNeu: TDatum, VAR outMessage : TString) : BOOLEAN;

(* beinhaltet VertragsendePruefen D 3.6.2.2 und 
   verwendet u.a. BerechneBrutto und CreateBu mit Feldzuweisungen
   und InsertBu *)
BEGIN

        (* Prfen, ob Vertrag existiert und die Vorbedingung aus D.3.6.2.2 prfen, 12.01., Gabi *)
	
    IF NOT Vtr.ExistVtr(inVtr) THEN
        (* Fehlermeldung, Vertrag gibts nicht  und Ende*)
    END (*IF*)

    IF   Datum.SmallerDatum(inEndeNeu, VLiesGueltigVoninVtr(inVtr))           (* EndeNeu < V.GueltigVon *) THEN
	(*Fehlermeldung, Vorbeding. nicht erfllt *)
    END

    IF NOT Datum.SmallerDatum(inEndeNeu, VLiesGueltigBisinVtr(inVtr))           (*EndeNeu >= V.GueltiBis*) THEN
	(*Fehlermeldung, Vorbed. nicht erfllt *)
    END

    OK:=  StornierenVtr(inVtr, outMessage)
    IF NOT OK THEN
	(*Fehlermeldung*)
    END (*IF)
    (*Sonst, weitermachen, nmlich mit der nderung des Vertrags*)

    IF  Vtre.IstNochNichtLfdVtr(inVtr) THEN
         (* Vertrag noch nicht laufend *)
         VSetzeGueltigBisinVtr (inoutVtr, inEndeNeu); 
         VSetzeStornoAminVtr (inVtr,UNDEF);
        
          (* Vertrag ungeprft buchen 3.6.2.4*)
            (* Gueltige Kondition(en) ermitteln und Buchungsbetrag berechnen *)

           Betrag:= KBerechneBrutto(VLiesGueltigVoninVtr(inVtr),VLiesGueltigBisinVtr(inVtr),VLiesStdzahlinVtr(inVtr))
        B:= BCreateBu();
        BSetzeKstIDinBu (B, VLiesKstIDinVtr(inVtr));
        BSetzeVtrIDinBu (B, VLiesVtrIDinVtr(inVtr));
        BSetzeBetraginBu (B, Betrag);
        BSetzeBuchungsArtinBu (B, "Gehalt");
	BInsertBu(B, outMEssage);

	(* B := Buchung.create (V.VertragsID, V.KostenstellenID, Betrag, Gehalt);
	    Buchungen.add (B);
	*)    


    ELSEIF Vtre.IstLfdVtr(inVtr, inEndeNeu) THEN
        (*Vertrag laufend*)
         
	NeuVtr:=VDuplicateVtr(inVtr);
        VSetzeGueltigBisinVtr (NeuVtr, inEndeNeu); 
        VSetzeStornoAminVtr (NeuVtr,UNDEF);

          (* Vertrag ungeprft buchen 3.6.2.4*)
            (* Gueltige Kondition(en) ermitteln und Buchungsbetrag berechnen *)

           Betrag:= KBerechneBrutto(VLiesGueltigVoninVtr(NeuVtr),VLiesinGueltigBisinVtr(NeuVtr),VLiesStdzahlinVtr(NeuVtr))
        B:= BCreateBu();
        BSetzeKstIDinBu (B, VLiesKstIDinVtr(NeuVtr));
        BSetzeVtrIDinBu (B, VLiesVtrIDinVtr(NeuVtr));
        BSetzeBetraginBu (B, Betrag);
        BSetzeBuchungsArtinBu (B, "Gehalt");
	BInsertBu(B, outMEssage);

	(* B := Buchung.create (V.VertragsID, V.KostenstellenID, Betrag, Gehalt);
	    Buchungen.add (B);
	*)    
        VInsertVtr(NeuVtr, outMessage);
    ELSE

      (*Fehlermeldung*)
    END (*IF*)


END (*AendernVtr*)

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

PROCEDURE StornierenVtr (inVtr : TVtr; VAR outMessage : TString) : BOOLEAN;
(* interne und externe Prozedur *)
(*  StornierungPruefen D 3.6.2.1 *)
BEGIN
	
    IF NOT Vtr.ExistVtr(inVtr) THEN
        (* Fehlermeldung, Vertrag gibts nicht *)
    END (*IF*)
	
    IF Vtre.IstAbgelaufenVtr(inVTR) THEN
	(* Meldung, Vertrag abgelaufen *)
    ELSE
      SearchKstZuKID(Vtre.LiesKstIDinVtr(inVtr), Kst)
      IF Ksten.IstGesperrtKst(Kst)  OR 
         Ksten.IstLiqudiertKst(Kst) THEN
	(*Meldung Kst gesperrt oder liquidiert *)
    ELSE
	(* VertragStornieren*)
	Buen.StorniereGehaBu(inVtr, outMessage)
	VSetzeStornoAminVtr (inVtr, HEUTE)
        
    END (*IF*)

END (*StornierenVtr*)


(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

PROCEDURE ErzeugenUndBuchenVtr(inVtr:TVtr)
(* Interne Prozedur
PROZESS-SPEZIFIKATION Vertrag erzeugen und buchen (D3.6.1.2)
Eingaben: 	HilfskraftID HID, KostenstellenID KID,
		Vertragsdaten VD
Ausgaben: 	

Vorbedingungen: 							...
Nachbedingungen:							...
*)

BEGIN
(*	V := Vertrag.create(HID,KID);
	V.daten := VD;
---wurde ja bereits gemacht, sonst htten wir keinen ADO TVtr

Prfung, ob ID schon existiert, passiert auch ganz oben bei BearbeitenNeuVtr
*)
        VInsertVtr(inVtr, outMessage)  (* Vertraege.add (V);*)
        Betrag:= KBerechneBrutto(VLiesGueltigVoninVtr(inVtr),VLiesGueltigBisinVtr(inVtr),VLiesStdzahlinVtr(inVtr))

(*      Gueltige Kondition(en) ermitteln und Buchungsbetrag berechnen 
	FOR alle TK in Tarifkonditionen mit TK.GueltigVon <= V.GueltigBis AND 
			(V.GueltigVon <= TK.GueltigBis OR TK.GueltigBis = UNDEF) DO
		Anfang := MAX(TK.GueltigVon, V.GueltigVon);
		Ende := MIN(TK.GueltigBis, V.GueltigBis));
		Wochen := (Ende-Anfang).Wochen;
	 	Betrag += TK.Stundensatz*V.Stundenzahl*Wochen;
*)

        B:= BCreateBu();
        BSetzeKstIDinBu (B, VLiesKstIDinVtr(inVtr));
        BSetzeVtrIDinBu (B, VLiesVtrIDinVtr(inVtr));
        BSetzeBetraginBu (B, Betrag);
        BSetzeBuchungsArtinBu (B, "Gehalt");
	BInsertBu(B, outMEssage);

	(* B := Buchung.create (V.VertragsID, V.KostenstellenID, Betrag, Gehalt);
	    Buchungen.add (B);
	*)    

END (* ErzeugenUndBuchenVtr*)
