(*345678901234567890123456789012345678901234567890123456789012345678901234567890
        10        20        30        40        50         60       70        80
*) (******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: HKOrdner.mod,v $
# $Author: lurk $
# $Date: 2001/03/13 12:16:30 $
# $Revision: 1.3 $
# Bemerkungen: 

IMPLEMENTATION MODULE HKOrdner  ADT HilfskraefteOrdner

                                --  Enthalten in Hilfskraefte

Sigrid Preuss

*)
(******************************************************************************)
 
IMPLEMENTATION MODULE HKOrdner;

(* ADT HilfskraefteOrdner *)

(* IMPORTE *)

FROM HKeIMPORTE  IMPORT TPersID;
FROM HK          IMPORT THK;
FROM String      IMPORT TString;
FROM Stringliste IMPORT TStringliste;

IMPORT HKOrdnerSchablone;


(* Lokale Datenstruktur als Modulgedaechtnis *)

VAR VAR_HKOrdner : THKOrdner;



(*
SEMANTIK
Die Semantik wird mit Hilfe dreier lokaler Integervariablen kap, 
pos und maxkap spezifiziert. Die Variablen kap und pos beschreiben  
den aktuellen Zustand (aktuelle Position und Anzahl der enthaltenen
Elemente) und  maxkap > 0 die Maximalkapazitaet des Ordners, 
d.h. es gilt stets:
            0 <= kap <= maxkap   und    0 <= pos <= kap+1

*)


PROCEDURE       Create ();
BEGIN
  VAR_HKOrdner := HKOrdnerSchablone.Create();
END Create;


PROCEDURE       Dispose ();
BEGIN
  HKOrdnerSchablone.Dispose(VAR_HKOrdner);
END Dispose;




PROCEDURE       Insert(inoutHK : THK; VAR outMessage : TString) : BOOLEAN;
BEGIN
  RETURN HKOrdnerSchablone.Insert(VAR_HKOrdner, inoutHK, outMessage);
END Insert;


PROCEDURE       Delete(inHK : THK; VAR outMessage : TString):BOOLEAN;
BEGIN
  RETURN HKOrdnerSchablone.Delete(VAR_HKOrdner, inHK, outMessage);
END Delete;


PROCEDURE       Search(inPersID : TPersID; VAR outHK : THK) : BOOLEAN;
BEGIN
  RETURN HKOrdnerSchablone.Search(VAR_HKOrdner, inPersID, outHK);
END Search;


PROCEDURE       Update(inHK : THK; VAR outMessage : TString):BOOLEAN;
BEGIN
  RETURN HKOrdnerSchablone.Update(VAR_HKOrdner, inHK, outMessage);
END Update;


PROCEDURE       First (VAR outHK : THK) : BOOLEAN;
BEGIN
  RETURN HKOrdnerSchablone.First(VAR_HKOrdner, outHK);
END First;


PROCEDURE       Next(inoutHK : THK) : BOOLEAN;
BEGIN
  RETURN HKOrdnerSchablone.Next(VAR_HKOrdner, inoutHK);
END Next;



(*************************** StringOperationen ***************************)
 
                                         
PROCEDURE       GibHKeAlsStringliste(): TStringliste;
BEGIN
  RETURN HKOrdnerSchablone.GibHKeAlsStringliste (VAR_HKOrdner);
END GibHKeAlsStringliste;
 
                                         
PROCEDURE       GibAllesAlsStringliste(): TStringliste;
BEGIN
  RETURN HKOrdnerSchablone.GibAllesAlsStringliste (VAR_HKOrdner);
END GibAllesAlsStringliste;



(********************** Backup/Restore-Operationen **********************)


PROCEDURE       BackupInsert (inHK : THK);
(*
Vb:     HK.ExistiertPersID(inHK) = TRUE
Fuegt die Hilfskraft in den Hilfskraefte-Ordner ein.
Es wird kein Identifikator gesetzt, da das Objekt bereits mit einem
Identifikator versehen ist
Nb:    inHK existiert im Hilfskraefte-Ordner
*)

BEGIN
  HKOrdnerSchablone.BackupInsert(VAR_HKOrdner, inHK);
END BackupInsert;




BEGIN

(* Architektur-ADO HilfskraefteOrdner (HKOrdner) erstellen *)

Create();


END HKOrdner.
