(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: HKe.mod,v $
# $Author: lurk $
# $Date: 2001/03/13 10:45:44 $
# $Revision: 1.5 $
# Bemerkungen:    

IMPLEMENTATION MODULE HKe   TS-Export-Schnittstelle Hilfskraefte

Sigrid Preuss

*)
(******************************************************************************)
 
IMPLEMENTATION MODULE HKe;

(* TS Hilfskraefte *)


(* --------------------------------------------------------------------
   -- Enthaltene Komponenten:
   --      ADT  HK, Adresse, DAdresse, Wochentage
   --      ADT  Instantiierungsmodul SortierteHKListe
   --      ADT  HKOrdnerSchablone
   --      ADT  HKOrdner
   --      ADT  HKePersistent
   --------------------------------------------------------------------
*)


FROM Datum       IMPORT TDatum;
FROM String      IMPORT TString;
FROM Stringliste IMPORT TStringliste;

IMPORT Wochentage, DAdresse, Adresse, HK, HKOrdner, HKePersistent, HKeIMPORTE;

TYPE THK        = HK.THK;
     TPraesTage = HK.TPraesTage;
     TAdresse   = Adresse.TAdresse;
     TDAdresse  = DAdresse.TDAdresse;


(* --------------------------------------------------------------------
   -- Durchreichen bzw. Umbenennen der Operationen von
   --   Modul  HKeIMPORTE
   --------------------------------------------------------------------
*)



PROCEDURE       DisposePersID (VAR inoutPersID:TPersID);
BEGIN
  HKeIMPORTE.DisposePersID(inoutPersID);
END DisposePersID;

PROCEDURE       DuplicatePersID (inPersID:TPersID):TPersID;
BEGIN
  RETURN HKeIMPORTE.DuplicatePersID(inPersID);
END DuplicatePersID;

PROCEDURE       IsEqualPersID (inPersID1,inPersID2:TPersID):BOOLEAN;
BEGIN
  RETURN HKeIMPORTE.IsEqualPersID(inPersID1, inPersID2);
END IsEqualPersID;

PROCEDURE       EqualizePersID (inoutZielPersID:TPersID;
                                inQuellePersID:TPersID);
BEGIN
  HKeIMPORTE.EqualizePersID(inoutZielPersID, inQuellePersID);
END EqualizePersID;

PROCEDURE       SamePersID (inPersID1:TPersID;inPersID2:TPersID):BOOLEAN;
BEGIN
  RETURN HKeIMPORTE.SamePersID(inPersID1, inPersID2);
END SamePersID;

PROCEDURE       SmallerPersID (inPersID1:TPersID;inPersID2:TPersID):BOOLEAN;
BEGIN
  RETURN HKeIMPORTE.SmallerPersID(inPersID1, inPersID2);
END SmallerPersID;

PROCEDURE       PruefePersID (inString:TString; VAR outMessage:TString):BOOLEAN;  BEGIN
  RETURN HKeIMPORTE.PruefePersID(inString, outMessage);
END PruefePersID;

PROCEDURE       PersIDAlsString (inPersID       : TPersID) : TString;
BEGIN
  RETURN HKeIMPORTE.PersIDAlsString(inPersID, 5);
END PersIDAlsString;

PROCEDURE       StringInPersID (inString : TString) : TPersID;
BEGIN
  RETURN HKeIMPORTE.StringInPersID(inString);
END StringInPersID;




(* --------------------------------------------------------------------
   -- Durchreichen bzw. Umbenennen der Operationen von
   --   ADT-Modul  HK
   --------------------------------------------------------------------
*)


(* Basis-Operationen *)

PROCEDURE       CreateHK ():THK;
BEGIN
  RETURN HK.Create();
END CreateHK;

PROCEDURE       DisposeHK (VAR inoutHK:THK);
BEGIN
  HK.Dispose(inoutHK);
END DisposeHK;

PROCEDURE       DuplicateHK (inHK:THK):THK;
BEGIN
  RETURN HK.Duplicate(inHK);
END DuplicateHK;

PROCEDURE       IsEqualHK (inHK1,inHK2:THK):BOOLEAN;
BEGIN
  RETURN HK.IsEqual(inHK1,inHK2)
END IsEqualHK;

PROCEDURE       EqualizeHK (inoutZielHK:THK; inQuellHK:THK);
BEGIN
  HK.Equalize(inoutZielHK, inQuellHK);
END EqualizeHK;


(* PersID-Operationen *)
 
PROCEDURE       LiesPersIDHK (inHK:THK):TPersID;
BEGIN
  RETURN HK.LiesPersID(inHK);
END LiesPersIDHK;

PROCEDURE       ExistiertPersIDHK (inHK:THK):BOOLEAN;
BEGIN
  RETURN HK.ExistiertPersID(inHK);
END ExistiertPersIDHK;



(* PraesTage-Operationen *)

PROCEDURE       DisposePraesTage (VAR inoutPraesTage : TPraesTage);

BEGIN
  HK.DisposePraesTage(inoutPraesTage);
END DisposePraesTage;

PROCEDURE       DuplicatePraesTage (inPraesTage : TPraesTage) : TPraesTage;
BEGIN
  RETURN HK.DuplicatePraesTage(inPraesTage);
END DuplicatePraesTage;

PROCEDURE       IsEqualPraesTage (inPraesTage1 : TPraesTage;
                                  inPraesTage2 : TPraesTage) : BOOLEAN;
BEGIN
  RETURN HK.IsEqualPraesTage(inPraesTage1,inPraesTage2)
END IsEqualPraesTage;

PROCEDURE       EqualizePraesTage (inoutZielPraesTage : TPraesTage;
                                   inQuellPraesTage   : TPraesTage);
BEGIN
  HK.EqualizePraesTage(inoutZielPraesTage, inQuellPraesTage);
END EqualizePraesTage;


PROCEDURE       PruefePraesTage (inStringTage : TString;
                                 VAR outMessage : TString) : BOOLEAN;
BEGIN
  RETURN HK.PruefePraesTage(inStringTage, outMessage);
END PruefePraesTage;

PROCEDURE       PraesTageAlsString (inPraesTage : TPraesTage) : TString;
BEGIN
  RETURN HK.PraesTageAlsString(inPraesTage);
END PraesTageAlsString;

PROCEDURE       StringInPraesTage (inStringTage : TString) : TPraesTage;
BEGIN
  RETURN HK.StringInPraesTage(inStringTage);
END StringInPraesTage;



(* Name, Personalnr *) 

PROCEDURE       LiesNameinHK (inHK:THK):TString;
BEGIN
  RETURN HK.LiesName(inHK);
END LiesNameinHK;

PROCEDURE       SetzeNameinHK (inoutHK:THK; inName:TString);
BEGIN
  HK.SetzeName(inoutHK, inName);
END SetzeNameinHK;

PROCEDURE       LiesVornameinHK (inHK:THK):TString;
BEGIN
  RETURN HK.LiesVorname(inHK);
END LiesVornameinHK;

PROCEDURE       SetzeVornameinHK (inoutHK:THK; inVorname:TString);
BEGIN
  HK.SetzeVorname(inoutHK, inVorname);
END SetzeVornameinHK;

PROCEDURE       LiesPersonalnrinHK (inHK:THK):CARDINAL;
BEGIN
  RETURN HK.LiesPersonalnr(inHK);
END LiesPersonalnrinHK;

PROCEDURE       SetzePersonalnrinHK (inoutHK:THK;
                                     inPersonalnummer:CARDINAL);
BEGIN
  HK.SetzePersonalnr(inoutHK, inPersonalnummer);
END SetzePersonalnrinHK;


(* Existenz-Angaben *)

PROCEDURE       LiesGeburtsdatuminHK (inHK:THK):TDatum;
BEGIN
  RETURN HK.LiesGeburtsdatum(inHK);
END LiesGeburtsdatuminHK;

PROCEDURE       SetzeGeburtsdatuminHK (inoutHK:THK; inGeburtsdatum:TDatum);
BEGIN
  HK.SetzeGeburtsdatum(inoutHK, inGeburtsdatum);
END SetzeGeburtsdatuminHK;

PROCEDURE       LiesGeburtsortinHK (inHK:THK):TString;
BEGIN
  RETURN HK.LiesGeburtsort(inHK);
END LiesGeburtsortinHK;

PROCEDURE       SetzeGeburtsortinHK (inoutHK:THK; inGeburtsort:TString);
BEGIN
  HK.SetzeGeburtsort(inoutHK, inGeburtsort);
END SetzeGeburtsortinHK;

PROCEDURE       LiesStaatsanginHK (inHK:THK):TString;
BEGIN
  RETURN HK.LiesStaatsang(inHK);
END LiesStaatsanginHK;

PROCEDURE       SetzeStaatsanginHK (inoutHK:THK; inStaatsangkeit:TString);
BEGIN
  HK.SetzeStaatsang(inoutHK, inStaatsangkeit);
END SetzeStaatsanginHK;

PROCEDURE       LiesGeschlechtinHK (inHK:THK):CHAR;
BEGIN
  RETURN HK.LiesGeschlecht(inHK);
END LiesGeschlechtinHK;

PROCEDURE       SetzeGeschlechtinHK (inoutHK:THK; inGeschlecht:CHAR);
BEGIN
  HK.SetzeGeschlecht(inoutHK, inGeschlecht);
END SetzeGeschlechtinHK;

PROCEDURE       LiesFamstandinHK (inHK:THK):CHAR;
BEGIN
  RETURN HK.LiesFamstand(inHK);
END LiesFamstandinHK;

PROCEDURE       SetzeFamstandinHK (inoutHK:THK; inFamilienstand:CHAR);
BEGIN
  HK.SetzeFamstand(inoutHK, inFamilienstand);
END SetzeFamstandinHK;

PROCEDURE       LiesKinderinHK (inHK:THK):CARDINAL;
BEGIN
  RETURN HK.LiesKinder(inHK);
END LiesKinderinHK;

PROCEDURE       SetzeKinderinHK (inoutHK:THK; inKinder:CARDINAL);
BEGIN
  HK.SetzeKinder(inoutHK, inKinder);
END SetzeKinderinHK;


(* Privat-Adresse *)

PROCEDURE       LiesStrasseinHK (inHK:THK):TString;
BEGIN
  RETURN HK.LiesStrasse(inHK);
END LiesStrasseinHK;

PROCEDURE       SetzeStrasseinHK (inoutHK:THK; inStrasse:TString);
BEGIN
  HK.SetzeStrasse(inoutHK, inStrasse);
END SetzeStrasseinHK;

PROCEDURE       LiesPostleitzahlinHK (inHK:THK):TString;
BEGIN
  RETURN HK.LiesPostleitzahl(inHK);
END LiesPostleitzahlinHK;

PROCEDURE       SetzePostleitzahlinHK (inoutHK:THK; inPLZ:TString);
BEGIN
  HK.SetzePostleitzahl(inoutHK, inPLZ);
END SetzePostleitzahlinHK;

PROCEDURE       LiesStadtinHK (inHK:THK):TString;
BEGIN
  RETURN HK.LiesStadt(inHK);
END LiesStadtinHK;

PROCEDURE       SetzeStadtinHK (inoutHK:THK; inStadt:TString);
BEGIN
  HK.SetzeStadt(inoutHK, inStadt);
END SetzeStadtinHK;

PROCEDURE       LiesLandinHK (inHK:THK):TString;
BEGIN
  RETURN HK.LiesLand(inHK);
END LiesLandinHK;

PROCEDURE       SetzeLandinHK (inoutHK:THK; inLand:TString);
BEGIN
  HK.SetzeLand(inoutHK, inLand);
END SetzeLandinHK;

PROCEDURE       LiesTelefoninHK (inHK:THK):TString;
BEGIN
  RETURN HK.LiesTelefon(inHK);
END LiesTelefoninHK;

PROCEDURE       SetzeTelefoninHK (inoutHK:THK; inTelefon:TString);
BEGIN
  HK.SetzeTelefon(inoutHK, inTelefon);
END SetzeTelefoninHK;

PROCEDURE       LiesFaxinHK (inHK:THK):TString;
BEGIN
  RETURN HK.LiesFax(inHK);
END LiesFaxinHK;

PROCEDURE       SetzeFaxinHK (inoutHK:THK; inFax:TString);
BEGIN
  HK.SetzeFax(inoutHK, inFax);
END SetzeFaxinHK;

PROCEDURE       LieseMailinHK (inHK:THK):TString;
BEGIN
  RETURN HK.LieseMail(inHK);
END LieseMailinHK;

PROCEDURE       SetzeeMailinHK (inoutHK:THK; ineMail:TString);
BEGIN
  HK.SetzeeMail(inoutHK, ineMail);
END SetzeeMailinHK;


(* Dienst-Adresse *)

PROCEDURE       LiesDienstNameinHK (inHK:THK):TString;
BEGIN
  RETURN HK.LiesDienstName(inHK);
END LiesDienstNameinHK;

PROCEDURE       SetzeDienstNameinHK (inoutHK:THK; inDienstName:TString);
BEGIN
  HK.SetzeDienstName(inoutHK, inDienstName);
END SetzeDienstNameinHK;

PROCEDURE       LiesDienstGebaeudeinHK (inHK:THK):TString;
BEGIN
  RETURN HK.LiesDienstGebaeude(inHK);
END LiesDienstGebaeudeinHK;

PROCEDURE       SetzeDienstGebaeudeinHK (inoutHK:THK; inGebaeude:TString);
BEGIN
  HK.SetzeDienstGebaeude(inoutHK, inGebaeude);
END SetzeDienstGebaeudeinHK;

PROCEDURE       LiesDienstZimmerinHK (inHK:THK):TString;
BEGIN
  RETURN HK.LiesDienstZimmer(inHK);
END LiesDienstZimmerinHK;

PROCEDURE       SetzeDienstZimmerinHK (inoutHK:THK; inZimmer:TString);
BEGIN
  HK.SetzeDienstZimmer(inoutHK, inZimmer);
END SetzeDienstZimmerinHK;

PROCEDURE       LiesDienstStrinHK (inHK:THK):TString;
BEGIN
  RETURN HK.LiesDienstStr(inHK);
END LiesDienstStrinHK;

PROCEDURE       SetzeDienstStrinHK (inoutHK:THK; inStrasse:TString);
BEGIN
  HK.SetzeDienstStr(inoutHK, inStrasse);
END SetzeDienstStrinHK;

PROCEDURE       LiesDienstPlzinHK (inHK:THK):TString;
BEGIN
  RETURN HK.LiesDienstPlz(inHK);
END LiesDienstPlzinHK;

PROCEDURE       SetzeDienstPlzinHK(inoutHK:THK; inPLZ:TString);
BEGIN
  HK.SetzeDienstPlz(inoutHK, inPLZ);
END SetzeDienstPlzinHK;

PROCEDURE       LiesDienstStadtinHK (inHK:THK):TString;
BEGIN
  RETURN HK.LiesDienstStadt(inHK);
END LiesDienstStadtinHK;

PROCEDURE       SetzeDienstStadtinHK (inoutHK:THK; inStadt:TString);
BEGIN
  HK.SetzeDienstStadt(inoutHK, inStadt);
END SetzeDienstStadtinHK;

PROCEDURE       LiesDienstLandinHK (inHK:THK):TString;
BEGIN
  RETURN HK.LiesDienstLand(inHK);
END LiesDienstLandinHK;

PROCEDURE       SetzeDienstLandinHK (inoutHK:THK; inLand:TString);
BEGIN
  HK.SetzeDienstLand(inoutHK, inLand);
END SetzeDienstLandinHK;

PROCEDURE       LiesDienstTelinHK (inHK:THK):TString;
BEGIN
  RETURN HK.LiesDienstTel(inHK);
END LiesDienstTelinHK;

PROCEDURE       SetzeDienstTelinHK (inoutHK:THK; inTelefon:TString);
BEGIN
  HK.SetzeDienstTel(inoutHK, inTelefon);
END SetzeDienstTelinHK;

PROCEDURE       LiesDienstFaxinHK (inHK:THK):TString;
BEGIN
  RETURN HK.LiesDienstFax(inHK);
END LiesDienstFaxinHK;

PROCEDURE       SetzeDienstFaxinHK (inoutHK:THK; inFax:TString);
BEGIN
  HK.SetzeDienstFax(inoutHK, inFax);
END SetzeDienstFaxinHK;

PROCEDURE       LiesDiensteMailinHK (inHK:THK):TString;
BEGIN
  RETURN HK.LiesDiensteMail(inHK);
END LiesDiensteMailinHK;

PROCEDURE       SetzeDiensteMailinHK (inoutHK:THK; ineMail:TString);
BEGIN
  HK.SetzeDiensteMail(inoutHK, ineMail);
END SetzeDiensteMailinHK;


(* Bank-Verbindung *)

PROCEDURE       LiesBankinstOrtinHK (inHK:THK):TString; 
BEGIN
  RETURN HK.LiesBankinstOrt(inHK);
END LiesBankinstOrtinHK;

PROCEDURE       SetzeBankinstOrtinHK (inoutHK:THK; inBankinstitut:TString);
BEGIN
  HK.SetzeBankinstOrt(inoutHK, inBankinstitut);
END SetzeBankinstOrtinHK;

PROCEDURE       LiesBlzinHK (inHK:THK):CARDINAL;
BEGIN
  RETURN HK.LiesBlz(inHK);
END LiesBlzinHK;

PROCEDURE       SetzeBlzinHK (inoutHK:THK; inBankleitzahl:CARDINAL);
BEGIN
  HK.SetzeBlz(inoutHK, inBankleitzahl);
END SetzeBlzinHK;

PROCEDURE       LiesKontonrinHK (inHK:THK):TString;
BEGIN
  RETURN HK.LiesKontonr(inHK);
END LiesKontonrinHK;

PROCEDURE       SetzeKontonrinHK (inoutHK:THK; inKontonummer:TString);
BEGIN
  HK.SetzeKontonr(inoutHK, inKontonummer);
END SetzeKontonrinHK;


(* Vertrags-Angaben *)

PROCEDURE       LiesVorStdzahlinHK (inHK:THK):CARDINAL;
BEGIN
  RETURN HK.LiesVorStdzahl(inHK);
END LiesVorStdzahlinHK;

PROCEDURE       SetzeVorStdzahlinHK (inoutHK:THK; inVorStdzahl:CARDINAL);
BEGIN
  HK.SetzeVorStdzahl(inoutHK, inVorStdzahl);
END SetzeVorStdzahlinHK;

PROCEDURE       LiesVerfuegAbinHK (inHK:THK):TDatum;
BEGIN
  RETURN HK.LiesVerfuegAb(inHK);
END LiesVerfuegAbinHK;

PROCEDURE       SetzeVerfuegAbinHK (inoutHK:THK; inVerfuegbarAb:TDatum);
BEGIN
  HK.SetzeVerfuegAb(inoutHK, inVerfuegbarAb);
END SetzeVerfuegAbinHK;

PROCEDURE       LiesPraestageinHK (inHK:THK):TPraesTage;
BEGIN
  RETURN HK.LiesPraestage(inHK);
END LiesPraestageinHK;

PROCEDURE       SetzePraestageinHK (inoutHK:THK;
                                    inPraesenztage:TPraesTage);
BEGIN
  HK.SetzePraestage(inoutHK, inPraesenztage);
END SetzePraestageinHK;

PROCEDURE       LiesAbschlussinHK (inHK:THK):TString;
BEGIN
  RETURN HK.LiesAbschluss(inHK);
END LiesAbschlussinHK;

PROCEDURE       SetzeAbschlussinHK (inoutHK:THK; inAbschluss:TString);
BEGIN
  HK.SetzeAbschluss(inoutHK, inAbschluss);
END SetzeAbschlussinHK;

PROCEDURE       LiesInteresseninHK (inHK:THK):TString;
BEGIN
  RETURN HK.LiesInteressen(inHK);
END LiesInteresseninHK;

PROCEDURE       SetzeInteresseninHK (inoutHK:THK; inInteresse:TString);
BEGIN
  HK.SetzeInteressen(inoutHK, inInteresse);
END SetzeInteresseninHK;

PROCEDURE       LiesBemerkungeninHK (inHK:THK):TString;
BEGIN
  RETURN HK.LiesBemerkungen(inHK);
END LiesBemerkungeninHK;

PROCEDURE       SetzeBemerkungeninHK (inoutHK:THK; inBemerkungen:TString);
BEGIN
  HK.SetzeBemerkungen(inoutHK, inBemerkungen);
END SetzeBemerkungeninHK;


(* --------------------------------------------------------------------
   -- Durchreichen bzw. Umbenennen der Operationen von
   --   ADT-Modul  HKOrdner
   --------------------------------------------------------------------
*)

   

PROCEDURE       InsertHK(inoutHK:THK; VAR outMessage : TString): BOOLEAN;
BEGIN
  RETURN HKOrdner.Insert(inoutHK, outMessage);
END InsertHK;

PROCEDURE       DeleteHK(inHK:THK; VAR outMessage : TString):BOOLEAN;
BEGIN
  RETURN HKOrdner.Delete(inHK, outMessage);
END DeleteHK;

PROCEDURE       SearchHK(inPersID:TPersID; VAR outHK:THK):BOOLEAN;
BEGIN
  RETURN HKOrdner.Search(inPersID, outHK);
END SearchHK;

PROCEDURE       UpdateHK(inHK:THK; VAR outMessage : TString):BOOLEAN;
BEGIN
  RETURN HKOrdner.Update(inHK, outMessage);
END UpdateHK;

PROCEDURE       FirstHK (VAR outHK : THK) : BOOLEAN;
BEGIN
  RETURN HKOrdner.First(outHK);
END FirstHK;

PROCEDURE       NextHK(inoutHK:THK):BOOLEAN;
BEGIN
  RETURN HKOrdner.Next(inoutHK);
END NextHK;



(*************************** StringOperationen ***************************)
 
                                         
PROCEDURE        GibHKeAlsStringlisteinHKe(): TStringliste;
BEGIN
  RETURN HKOrdner.GibHKeAlsStringliste();
END GibHKeAlsStringlisteinHKe;
 

PROCEDURE        GibAllesAlsStringlisteinHKe () : TStringliste;
BEGIN
  RETURN HKOrdner.GibAllesAlsStringliste();
END GibAllesAlsStringlisteinHKe;



(* --------------------------------------------------------------------
   -- Durchreichen bzw. Umbenennen der Operationen von
   --   ADT-Modul  HKePersistent
   --------------------------------------------------------------------
*)
(***************************** DateiOperationen ***************************)


PROCEDURE        LoadinHKe(inHandle : THandle;
                           VAR outMessage : TString) : BOOLEAN;
BEGIN
  RETURN HKePersistent.Load(inHandle, outMessage);
END LoadinHKe;

PROCEDURE        SaveinHKe(inHandle : THandle;
                           VAR outMessage : TString) : BOOLEAN;
BEGIN
  RETURN HKePersistent.Save(inHandle, outMessage);
END SaveinHKe;


END HKe.
