(*345678901234567890123456789012345678901234567890123456789012345678901234567890
        10        20        30        40        50         60       70        80
*)

MODULE HiKSHKe;

   FROM  InOut     IMPORT ReadCard, ReadLn, ReadString,
                          WriteCard, WriteString, WriteLn;
   FROM  Ascii     IMPORT lf;
   FROM  LogDatei  IMPORT OpenLog, CloseLog, WriteLogString, WriteLogChar;
   FROM  TestOpHKe IMPORT OpInsertHKe, OpUpdateHKe, OpDeleteHKe, OpShowListHKe,
                          OpShowHKeAlsStringliste, OpShowAlleAlsStringliste,
                          OpSaveHKe, OpLoadHKe;
   FROM  WholeStr  IMPORT ConvResults, StrToCard;


   VAR Befehl          : CARDINAL;
       TestProcs       : ARRAY[0..20] OF PROC;
       MaxProcNr       : CARDINAL;

  PROCEDURE OperationInsert;
  BEGIN
    WriteString("Operation: Insert");
    WriteLn;
    WriteLogString("============== Begin Operation: Hilfskraefte Insert");
    WriteLogChar(lf);
    OpInsertHKe ();
    WriteLogString("============== Ende Operation: Hilfskraefte Insert");
    WriteLogChar(lf);
    WriteLn
  END OperationInsert;


  PROCEDURE OperationUpdate;
  BEGIN
    WriteString("Operation: Update");
    WriteLn;
    WriteLogString("============== Begin Operation: Hilfskraefte Update");
    WriteLogChar(lf);
    OpUpdateHKe ();
    WriteLogString("============== Ende Operation: Hilfskraefte Update");
    WriteLogChar(lf);
  END OperationUpdate;


  PROCEDURE OperationDelete;
    VAR Zahl : CARDINAL;
  BEGIN
    WriteString("Operation: Delete");
    WriteLn;
    WriteLogString("============== Begin Operation: Hilfskraft Delete");
    WriteLogChar(lf);
    Zahl := PersIDEingeben ();
    OpDeleteHKe (Zahl);
    WriteLogChar(lf);
    WriteLogString("============== Ende Operation: Hilfskraft Delete");
    WriteLogChar(lf);
  END OperationDelete;


  PROCEDURE OperationShowList;
  BEGIN
    WriteString("Operation: Ordnerinhalt anzeigen");
    WriteLn;
    WriteLogString
       ("============== Begin Operation: Hilfskraefte Ordnerinhalt anzeigen");
    WriteLogChar(lf);
    OpShowListHKe ();
    WriteLogString
       ("============== Ende Operation: Hilfskraefte Ordnerinhalt anzeigen");
    WriteLogChar(lf);
  END OperationShowList;


  PROCEDURE OperationShowHKeAlsStringliste;
  BEGIN
    WriteString("Operation: Alle Hilfskraefte als Stringliste");
    WriteLn;
    WriteLogString
       ("============== Begin Operation: Alle Hilfskraefte als Stringliste");
    WriteLogChar(lf);
    OpShowHKeAlsStringliste ();
    WriteLogString
       ("============== Ende Operation: Alle Hilfskraefte als Stringliste");
    WriteLogChar(lf);
  END OperationShowHKeAlsStringliste;


  PROCEDURE OperationShowAlleAlsStringliste;
  BEGIN
    WriteString
   ("Operation: Alle Hilfskraefte mit fast allen Attributen als Stringliste");
    WriteLn;
    WriteLogString
    ("============== Begin Operation: Alle Hilfskraefte mit fast allen Attributen als Stringliste");
    WriteLogChar(lf);
    OpShowAlleAlsStringliste ();
    WriteLogString
       ("============== Ende Operation: Alle Hilfskraefte mit fast allen Attributen als Stringliste");
    WriteLogChar(lf);
  END OperationShowAlleAlsStringliste;


  PROCEDURE OperationSave;
  BEGIN
    WriteString("Operation: Save");
    WriteLn;
    WriteLogString
           ("============== Begin Operation: Save auf HiKS/HilfskraefteOrdner, HiKS/HIDOrdner");
    WriteLogChar(lf);
    OpSaveHKe ();
    WriteLogString
          ("============== Ende Operation: Save auf HiKS/HilfskraefteOrdner, HiKS/HIDOrdner");
    WriteLogChar(lf);
  END OperationSave;

  PROCEDURE OperationLoad;
  BEGIN
    WriteString("Operation: Load");
    WriteLn;
    WriteLogString
           ("============== Begin Operation: Load von HiKS/HilfskraefteOrdner, HiKS/HIDOrdner");
    WriteLogChar(lf);
    OpLoadHKe ();
    WriteLogString
          ("============== Ende Operation: Load von HiKS/HilfskraefteOrdner, HiKS/HIDOrdner");
    WriteLogChar(lf);
  END OperationLoad;


  PROCEDURE Auswahlmenue() : CARDINAL;
  VAR ItemNr : CARDINAL;

     PROCEDURE MenueItem(inItemText : ARRAY OF CHAR);
     BEGIN
       WriteCard (ItemNr, 2);
       WriteString (" --> ");
       WriteString (inItemText);
       WriteLn;
       INC (ItemNr)
    END MenueItem;     

  BEGIN
    ItemNr := 0;
    MenueItem ("Programm beenden");
    MenueItem ("Operation Insert");
    MenueItem ("Operation Update");
    MenueItem ("Operation Delete");
    MenueItem ("Operation OrdnerInhalt ausgeben");
    MenueItem ("Operation Hilfskraefte als Stringliste");
    MenueItem
        ("Operation Hilfskraefte mit fast allen Attributen als Stringliste");
    MenueItem ("Operation Save auf HiKS/HilfskraefteOrdner, HiKS/HIDOrdner");
    MenueItem ("Operation Load von HiKS/HilfskraefteOrdner, HiKS/HIDOrdner");
    RETURN IhreWahl()
  END Auswahlmenue;


  PROCEDURE InitTestProcs;
  VAR ProcNr : CARDINAL;

     PROCEDURE ProcEintragen(inOperation : PROC);
     BEGIN
       TestProcs [ProcNr] := inOperation;
       INC (ProcNr)
     END ProcEintragen;     

  BEGIN
    ProcNr := 0;
    ProcEintragen (Programmende);
    ProcEintragen (OperationInsert);
    ProcEintragen (OperationUpdate);
    ProcEintragen (OperationDelete);
    ProcEintragen (OperationShowList);
    ProcEintragen (OperationShowHKeAlsStringliste);
    ProcEintragen (OperationShowAlleAlsStringliste);
    ProcEintragen (OperationSave);
    ProcEintragen (OperationLoad);
    MaxProcNr := ProcNr;
  END InitTestProcs;

PROCEDURE BefehlAuswerten(inBefehl : CARDINAL);
BEGIN
    IF inBefehl < MaxProcNr THEN
      TestProcs [inBefehl];
    ELSE
      WriteString("Dies war eine falsche Eingabe.");
      WriteLn;
    END; (* IF *)
 END BefehlAuswerten;

PROCEDURE Programmende;
BEGIN
   WriteString("Programmende!");
   WriteLn
END Programmende;

PROCEDURE IhreWahl() : CARDINAL;
VAR outEingabe : CARDINAL;
BEGIN
   WriteString("Befehl Nr.: ");
   ReadCard(outEingabe);
   WriteLn;
   RETURN outEingabe
END IhreWahl;


PROCEDURE PersIDEingeben () : CARDINAL;
VAR Wert : ARRAY [0..50] OF CHAR;
    Zahl : CARDINAL;
    KonvResult : ConvResults;
    EingabeKorrekt : BOOLEAN;
BEGIN
   EingabeKorrekt := FALSE;
   WHILE NOT EingabeKorrekt DO
     WriteString("PersID Eingeben: ");
     ReadString(Wert);
     WriteLn;
     StrToCard(Wert,Zahl,KonvResult);
     IF KonvResult = strAllRight  THEN
        EingabeKorrekt := TRUE;
     ELSE
        WriteString("Eingabe ist keine Zahl "); WriteLn;
     END; (* IF *)
   END; (* WHILE *)
   RETURN Zahl;
END PersIDEingeben;


(*----------------------- Hauptprogramm -------------------------------------*)

BEGIN

   WriteString(" Testen Teilsystem Hilfskraefte");
   WriteLn;

  InitTestProcs;

   (* Alle Meldungen und Inhalte auf Logdatei *)

  OpenLog;

  REPEAT
      Befehl := Auswahlmenue();
      BefehlAuswerten (Befehl);
  UNTIL Befehl = 0;

  CloseLog;


END HiKSHKe.
