(*345678901234567890123456789012345678901234567890123456789012345678901234567890
        10        20        30        40        50         60       70        80
*)

MODULE HiKSHKeBuen;

(* Hptprogr. zum gemeinsamen Testen der teilsysteme Hilfskraefte und
   Buchungen
*)

   FROM  InOut     IMPORT ReadCard, ReadLn, ReadString,
                          WriteCard, WriteString, WriteLn;
   FROM  Ascii     IMPORT lf;
   FROM  LogDatei  IMPORT OpenLog, CloseLog, WriteLogString, WriteLogChar;
   FROM  TestOpHKe IMPORT OpInsertHKe, OpUpdateHKe, OpDeleteHKe, OpShowListHKe,
                          OpShowHKeAlsStringliste, OpSaveHKe, OpLoadHKe;
   FROM  TestOpBuen IMPORT OpInsertBuen, OpUpdateBuen, OpGebGelderKst, 
                           OpStorniereBuZuVtr, OpShowListBuen,
                           OpShowBuenKst, OpShowBuenVtr, OpShowBuenBuArtVtr,
                           OpShowBuenAlsStringliste, OpSaveBuen, OpLoadBuen;
   FROM  WholeStr  IMPORT ConvResults, StrToCard, CardToStr;
   FROM  Ascii     IMPORT nul;
   FROM  SysClock  IMPORT DateTime, GetClock;  (* fuer Betriebssystemdatum *)
   FROM  Strings   IMPORT Append;
   FROM  Datum     IMPORT TDatum, DatumVonString, DisposeDatum;
   FROM  SysDat    IMPORT SetzeSystemDatumInSysDat;

   IMPORT String;


   VAR Befehl          : CARDINAL;
       TestProcs       : ARRAY[0..30] OF PROC;
       MaxProcNr       : CARDINAL;
       (* Fuer Systemdatum setzen (auf Betriebssystemdatum *)
       rc : BOOLEAN;
       heute : TDatum;
       outMessage : String.TString;
       structTime : DateTime;
       stringDatum : String.TString;
       strtag   : ARRAY [1..2] OF CHAR;
       strmonat : ARRAY [1..2] OF CHAR;
       strjahr  : ARRAY [1..4] OF CHAR;
       arrayDatum : ARRAY [1..11] OF CHAR;

  PROCEDURE OperHKeInsert;
  BEGIN
    WriteString("OperHKe: HKe Insert");
    WriteLn;
    WriteLogString("============== Begin OperHKe: Hilfskraefte Insert");
    WriteLogChar(lf);
    OpInsertHKe ();
    WriteLogString("============== Ende OperHKe: Hilfskraefte Insert");
    WriteLogChar(lf);
    WriteLn
  END OperHKeInsert;


  PROCEDURE OperHKeUpdate;
  BEGIN
    WriteString("OperHKe: HKe Update");
    WriteLn;
    WriteLogString("============== Begin OperHKe: Hilfskraefte Update");
    WriteLogChar(lf);
    OpUpdateHKe ();
    WriteLogString("============== Ende OperHKe: Hilfskraefte Update");
    WriteLogChar(lf);
  END OperHKeUpdate;


  PROCEDURE OperHKeDelete;
    VAR Zahl : CARDINAL;
  BEGIN
    WriteString("OperHKe: HKe Delete");
    WriteLn;
    WriteLogString("============== Begin OperHKe: Hilfskraft Delete");
    WriteLogChar(lf);
    Zahl := IDEingeben ();
    OpDeleteHKe (Zahl);
    WriteLogChar(lf);
    WriteLogString("============== Ende OperHKe: Hilfskraft Delete");
    WriteLogChar(lf);
  END OperHKeDelete;


  PROCEDURE OperHKeShowList;
  BEGIN
    WriteString("OperHKe: HKe Ordnerinhalt anzeigen");
    WriteLn;
    WriteLogString
       ("============== Begin OperHKe: Hilfskraefte Ordnerinhalt anzeigen");
    WriteLogChar(lf);
    OpShowListHKe ();
    WriteLogString
       ("============== Ende OperHKe: Hilfskraefte Ordnerinhalt anzeigen");
    WriteLogChar(lf);
  END OperHKeShowList;


  PROCEDURE OperHKeShowHKeAlsStringliste;
  BEGIN
    WriteString("OperHKe: Alle Hilfskraefte als Stringliste");
    WriteLn;
    WriteLogString
       ("============== Begin OperHKe: Alle Hilfskraefte als Stringliste");
    WriteLogChar(lf);
    OpShowHKeAlsStringliste ();
    WriteLogString
       ("============== Ende OperHKe: Alle Hilfskraefte als Stringliste");
    WriteLogChar(lf);
  END OperHKeShowHKeAlsStringliste;



  PROCEDURE OperBuenInsert;
  BEGIN
    WriteString("OperBuen: Buen Insert");
    WriteLn;
    WriteLogString("============== Begin OperBuen: Buchungen Insert");
    WriteLogChar(lf);
    OpInsertBuen ();
    WriteLogString("============== Ende OperBuen: Buchungen Insert");
    WriteLogChar(lf);
    WriteLn
  END OperBuenInsert;


  PROCEDURE OperBuenUpdate;
  BEGIN
    WriteString("OperBuen: Buen Update");
    WriteLn;
    WriteLogString("============== Begin OperBuen: Buchungen Update");
    WriteLogChar(lf);
    OpUpdateBuen ();
    WriteLogString("============== Ende OperBuen: Buchungen Update");
    WriteLogChar(lf);
  END OperBuenUpdate;


  PROCEDURE OperBuenGebGelderKst;
    VAR Zahl : CARDINAL;
  BEGIN
    WriteString("OperBuen: Buen Gebuchte Gelder");
    WriteLn;
    WriteLogString("============== Begin OperBuen: Gebuchte Gelder zu Kst");
    WriteLogChar(lf);
    Zahl := IDEingeben ();
    OpGebGelderKst (Zahl);
    WriteLogString("============== Ende OperBuen: Gebuchte Gelder zu Kst");
    WriteLogChar(lf);
  END OperBuenGebGelderKst;


  PROCEDURE OperBuenStorniereBuZuVtr;
    VAR Zahl : CARDINAL;
  BEGIN
    WriteString("OperBuen: Storniere Buchungen zu Vertrag");
    WriteLn;
    WriteLogString
      ("============== Begin OperBuen: Storniere Buchungen zu Vertrag");
    WriteLogChar(lf);
    Zahl := IDEingeben ();
    OpStorniereBuZuVtr (Zahl);
    WriteLogString
       ("============== Ende OperBuen: Storniere Buchungen zu Vertrag");
    WriteLogChar(lf);
  END OperBuenStorniereBuZuVtr;


  PROCEDURE OperBuenShowList;
  BEGIN
    WriteString("OperBuen: Buen Ordnerinhalt anzeigen");
    WriteLn;
    WriteLogString
            ("============== Begin OperBuen: Buchungen Ordnerinhalt anzeigen");
    WriteLogChar(lf);
    OpShowListBuen ();
    WriteLogString
            ("============== Ende OperBuen: Buchungen Ordnerinhalt anzeigen");
    WriteLogChar(lf);
  END OperBuenShowList;


  PROCEDURE OperBuenShowListKst;
    VAR Zahl : CARDINAL;
  BEGIN
    WriteString("OperBuen: Alle Buchungen zu einer Kostenstelle");
    WriteLn;
    WriteLogString
      ("============== Begin OperBuen: Alle Buchungen zu einer Kostenstelle");
    WriteLogChar(lf);
    Zahl := IDEingeben ();
    OpShowBuenKst (Zahl);
    WriteLogChar(lf);
    WriteLogString
      ("============== Ende OperBuen: Alle Buchungen zu einer Kostenstelle");
    WriteLogChar(lf);
  END OperBuenShowListKst;


  PROCEDURE OperBuenShowListVtr;
    VAR Zahl : CARDINAL;
  BEGIN
    WriteString("OperBuen: Alle Buchungen zu einem Vertrag");
    WriteLn;
    WriteLogString
      ("============== Begin OperBuen: Alle Buchungen zu einem Vertrag");
    WriteLogChar(lf);
    Zahl := IDEingeben ();
    OpShowBuenVtr (Zahl);
    WriteLogChar(lf);
    WriteLogString
      ("============== Ende OperBuen: Alle Buchungen zu einem Vertrag");
    WriteLogChar(lf);
  END OperBuenShowListVtr;


  PROCEDURE OperBuenShowListBuArtVtr;
    VAR Zahl : CARDINAL;
  BEGIN
    WriteString("OperBuen: Alle Buchungen zu einem Vertrag");
    WriteLn;
    WriteLogString
      ("============== Begin OperBuen: Alle Buchungen einer BuArt zu einem Vertrag");
    WriteLogChar(lf);
    Zahl := IDEingeben ();
    OpShowBuenBuArtVtr (Zahl);
    WriteLogChar(lf);
    WriteLogString
      ("============== Ende OperBuen: Alle Buchungen einer BuArt zu einem Vertrag");
    WriteLogChar(lf);
  END OperBuenShowListBuArtVtr;


  PROCEDURE OperBuenShowBuenAlsStringliste;
  BEGIN
    WriteString("OperBuen: Alle Buchungen als Stringliste");
    WriteLn;
    WriteLogString
      ("============== Begin OperBuen: Alle Buchungen als Stringliste");
    WriteLogChar(lf);
    OpShowBuenAlsStringliste ();
    WriteLogChar(lf);
    WriteLogString
      ("============== Ende OperBuen: Alle Buchungen als Stringliste");
    WriteLogChar(lf);
  END OperBuenShowBuenAlsStringliste;


  PROCEDURE OperationSave;
  BEGIN
    WriteString("Operation: Save");
    WriteLn;
    WriteLogString
           ("============== Begin Operation: Save auf HiKS/HilfskraefteOrdner,  HiKS/BuchungenOrdner, HiKS/HIDOrdner");
    WriteLogChar(lf);
    OpSaveHKe ();
    OpSaveBuen ();
    WriteLogString
          ("============== Ende Operation: Save auf HiKS/HilfskraefteOrdner,  HiKS/BuchungenOrdner, HiKS/HIDOrdner");
    WriteLogChar(lf);
  END OperationSave;

  PROCEDURE OperationLoad;
  BEGIN
    WriteString("Operation: Load");
    WriteLn;
    WriteLogString
           ("============== Begin Operation: Load von HiKS/HilfskraefteOrdner,  HiKS/BuchungenOrdner, HiKS/HIDOrdner");
    WriteLogChar(lf);
    OpLoadHKe ();
    OpLoadBuen ();
    WriteLogString
          ("============== Ende Operation: Load von HiKS/HilfskraefteOrdner,  HiKS/BuchungenOrdner, HiKS/HIDOrdner");
    WriteLogChar(lf);
  END OperationLoad;



  PROCEDURE Auswahlmenue() : CARDINAL;
  VAR ItemNr : CARDINAL;

     PROCEDURE MenueItem(inItemText : ARRAY OF CHAR);
     BEGIN
       WriteCard (ItemNr, 2);
       WriteString (" --> ");
       WriteString (inItemText);
       WriteLn;
       INC (ItemNr)
    END MenueItem;     

  BEGIN
    ItemNr := 0;
    MenueItem ("Programm beenden");
    MenueItem ("OperHKe Insert");
    MenueItem ("OperHKe Update");
    MenueItem ("OperHKe Delete");
    MenueItem ("OperHKe OrdnerInhalt ausgeben");
    MenueItem ("OperHKe Hilfskraefte als Stringliste");
    MenueItem ("OperBuen Insert");
    MenueItem ("OperBuen Update");
    MenueItem ("OperBuen Gebuchte Gelder zu einer Kst");
    MenueItem ("OperBuen Storniere Buchungen zu einem Vertrag");
    MenueItem ("OperBuen OrdnerInhalt ausgeben");
    MenueItem ("OperBuen Alle Buchungen zu einer Kostenstelle ausgeben");
    MenueItem ("OperBuen Alle Buchungen zu einem Vertrag ausgeben");
    MenueItem
             ("OperBuen Alle Buchungen einer BuArt zu einem Vertrag ausgeben");
    MenueItem ("OperBuen Alle Buchungen als Stringliste ausgeben");
    MenueItem ("Operation Save auf HiKS/HilfskraefteOrdner, HiKS/BuchungenOrdner, HiKS/HIDOrdner");
    MenueItem ("Operation Load von HiKS/HilfskraefteOrdner, HiKS/BuchungenOrdner, HiKS/HIDOrdner");
    RETURN IhreWahl()
  END Auswahlmenue;


  PROCEDURE InitTestProcs;
  VAR ProcNr : CARDINAL;

     PROCEDURE ProcEintragen(inOperation : PROC);
     BEGIN
       TestProcs [ProcNr] := inOperation;
       INC (ProcNr)
     END ProcEintragen;     

  BEGIN
    ProcNr := 0;
    ProcEintragen (Programmende);
    ProcEintragen (OperHKeInsert);
    ProcEintragen (OperHKeUpdate);
    ProcEintragen (OperHKeDelete);
    ProcEintragen (OperHKeShowList);
    ProcEintragen (OperHKeShowHKeAlsStringliste);
    ProcEintragen (OperBuenInsert);
    ProcEintragen (OperBuenUpdate);
    ProcEintragen (OperBuenGebGelderKst);
    ProcEintragen (OperBuenStorniereBuZuVtr);
    ProcEintragen (OperBuenShowList);
    ProcEintragen (OperBuenShowListKst);
    ProcEintragen (OperBuenShowListVtr);
    ProcEintragen (OperBuenShowListBuArtVtr);
    ProcEintragen (OperBuenShowBuenAlsStringliste);
    ProcEintragen (OperationSave);
    ProcEintragen (OperationLoad);
    MaxProcNr := ProcNr;
  END InitTestProcs;

PROCEDURE BefehlAuswerten(inBefehl : CARDINAL);
BEGIN
    IF inBefehl < MaxProcNr THEN
      TestProcs [inBefehl];
    ELSE
      WriteString("Dies war eine falsche Eingabe.");
      WriteLn;
    END; (* IF *)
 END BefehlAuswerten;

PROCEDURE Programmende;
BEGIN
   WriteString("Programmende!");
   WriteLn
END Programmende;

PROCEDURE IhreWahl() : CARDINAL;
VAR outEingabe : CARDINAL;
BEGIN
   WriteString("Befehl Nr.: ");
   ReadCard(outEingabe);
   WriteLn;
   RETURN outEingabe
END IhreWahl;


PROCEDURE IDEingeben () : CARDINAL;
VAR Wert : ARRAY [0..50] OF CHAR;
    Zahl : CARDINAL;
    KonvResult : ConvResults;
    EingabeKorrekt : BOOLEAN;
BEGIN
   EingabeKorrekt := FALSE;
   WHILE NOT EingabeKorrekt DO
     WriteString("ID Eingeben: ");
     ReadString(Wert);
     WriteLn;
     StrToCard(Wert,Zahl,KonvResult);
     IF KonvResult = strAllRight  THEN
        EingabeKorrekt := TRUE;
     ELSE
        WriteString("Eingabe ist keine Zahl "); WriteLn;
     END; (* IF *)
   END; (* WHILE *)
   RETURN Zahl;
END IDEingeben;


(*----------------------- Hauptprogramm -------------------------------------*)

BEGIN

   WriteString(" Testen Teilsysteme Hilfskraefte, Buchungen");
   WriteLn;

   (* SystemDatum setzen, auf Betriebssystemdatum*)
   GetClock(structTime); (* aktuelles Betriebssystemdatum *)
   (* Betriebssystem-Datum in String wandeln, denn vorerst kann man
   nur mit DatumVonString ein Datum setzen *)
   CardToStr(structTime.day, strtag);
   CardToStr(structTime.month, strmonat);
   CardToStr(structTime.year, strjahr);
   arrayDatum[1] := nul;            (*Leerstring*)
   Append (strtag, arrayDatum);
   Append (".",arrayDatum);
   Append (strmonat, arrayDatum);
   Append (".",arrayDatum);
   Append (strjahr,arrayDatum);
   stringDatum := String.Create();
   String.Schreibe(stringDatum, arrayDatum);
   (* String.Schreibe(stringDatum, "21.11.2001"); *)
   rc := DatumVonString(stringDatum, heute, outMessage);
   SetzeSystemDatumInSysDat(heute);
   String.Dispose(stringDatum);
   DisposeDatum(heute);

  InitTestProcs;

   (* Alle Meldungen und Inhalte auf Logdatei *)

  OpenLog;

  REPEAT
      Befehl := Auswahlmenue();
      BefehlAuswerten (Befehl);
  UNTIL Befehl = 0;

  CloseLog;


END HiKSHKeBuen.
