(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: Konden.mod,v $
# $Author: Sopra $
# $Date: 2001/03/14 18:26:03 $
# $Revision: 1.3 $
Bemerkungen:
*)
(******************************************************************************)
 
IMPLEMENTATION MODULE Konden;

(* TS Konditionen *)

        FROM Datum         IMPORT TDatum, TStag, TTag, TMonat, TJahr;
	FROM String        IMPORT TString;
        FROM Stringliste IMPORT TStringliste;  
        FROM KondenIMPORTE IMPORT THandle;	
	IMPORT KondenOrdner;
	IMPORT KondenSpeichern;
	IMPORT Kondition;



        (* Operationen zur Erzeugung von Ausprgungen des Entittstyps 
	   Kondition *)

	PROCEDURE CreateVertragsKondition (): TKond;
	BEGIN
		RETURN Kondition.CreateVertragsKondition();
	END CreateVertragsKondition;

	PROCEDURE CreateWeihnachtsKondition () : TKond;
	BEGIN
		RETURN Kondition.CreateWeihnachtsKondition();
	END CreateWeihnachtsKondition;

	PROCEDURE CreateTarifKondition() : TKond;
	BEGIN
		RETURN Kondition.CreateTarifKondition();
	END CreateTarifKondition;
        
        (* Standard-Operationen auf dem Entittstyp Kondition *)
	PROCEDURE DisposeKond (VAR inoutKond : TKond);
	BEGIN
		Kondition.Dispose(inoutKond);
	END DisposeKond;

	PROCEDURE DuplicateKond (inQuellKondition : TKond) : TKond;
	BEGIN
		RETURN Kondition.Duplicate(inQuellKondition);
	END DuplicateKond;

	PROCEDURE IsEqualKond (inKond1, inKond2 : TKond) : BOOLEAN;
	BEGIN
		RETURN Kondition.IsEqual(inKond1, inKond2);
	END IsEqualKond;

	PROCEDURE EqualizeKond (VAR inoutZielKondition, inQuellKondition : TKond);
	BEGIN
		Kondition.Equalize(inoutZielKondition, inQuellKondition);
	END EqualizeKond;
        
        (* Operationen auf den Attributen des Entittstyps Kondition *)
	PROCEDURE LiesKIDinKond (VAR inoutKond : TKond):TKID;
	BEGIN
		RETURN Kondition.LiesKID(inoutKond);
	END LiesKIDinKond;

	PROCEDURE SetzeGueltVoninKond (VAR inoutKond: TKond; inD  : TDatum);
	BEGIN
		Kondition.SetzeGueltigVon(inoutKond,inD);
	END SetzeGueltVoninKond;

	PROCEDURE LiesGueltVoninKond (inKondition: TKond) : TDatum;
	BEGIN
		RETURN Kondition.LiesGueltigVon(inKondition);
	END LiesGueltVoninKond;

	PROCEDURE SetzeGueltBisinKond (VAR inoutKond: TKond; inD  : TDatum);
	BEGIN
		Kondition.SetzeGueltigBis(inoutKond,inD);
	END SetzeGueltBisinKond;

	PROCEDURE LiesGueltBisinKond(inKondition: TKond) : TDatum;
	BEGIN
		RETURN Kondition.LiesGueltigBis(inKondition);
	END LiesGueltBisinKond;

	PROCEDURE SetzeBHDinVKond(VAR inoutKond: TKond; inBHD:CARDINAL):BOOLEAN;
	BEGIN
		Kondition.SetzeBHD(inoutKond,inBHD);
		(* Da ich nicht weiss, was hier zurueckgegeben werden soll,
		   wird TRUE zurueckgegeben *)
		RETURN TRUE;
	END SetzeBHDinVKond;

	PROCEDURE LiesBHDinVKond( inKondition: TKond):CARDINAL;
	BEGIN
		RETURN Kondition.LiesBHD(inKondition);
	END LiesBHDinVKond;

	PROCEDURE SetzeSOGinVKond(VAR inoutKond: TKond; inSOG:CARDINAL):BOOLEAN;
	BEGIN
		Kondition.SetzeStundenobergrenze(inoutKond,inSOG);
		(* Da ich nicht weiss, was hier zurueckgegeben werden soll,
		   wird TRUE zurueckgegeben *)
		RETURN TRUE;
	END SetzeSOGinVKond;

	PROCEDURE LiesSOGinVKond( inKondition: TKond):CARDINAL;
	BEGIN
		RETURN Kondition.LiesStundenobergrenze(inKondition);
	END LiesSOGinVKond;

	PROCEDURE SetzeStdSinTKond(VAR inoutKond: TKond; inStdS:CARDINAL):BOOLEAN;
	BEGIN
		Kondition.SetzeStundensatz(inoutKond,inStdS);
                (* Da ich nicht weiss, was hier zurueckgegeben werden soll,
                   wird TRUE zurueckgegeben *)   
		RETURN TRUE;	
	END SetzeStdSinTKond;

	PROCEDURE LiesStdSinTKond( inKondition: TKond):CARDINAL;
	BEGIN
		RETURN Kondition.LiesStundensatz(inKondition);
	END LiesStdSinTKond;

	PROCEDURE SetzeSTaginWKond(VAR inoutKond: TKond; inSTag:TStag):BOOLEAN;
	BEGIN
                Kondition.SetzeStichtag(inoutKond,inSTag);
                (* Da ich nicht weiss, was hier zurueckgegeben werden soll,
                   wird TRUE zurueckgegeben *)
                RETURN TRUE;  

	END SetzeSTaginWKond;

	PROCEDURE LiesSTaginWKond( inKondition: TKond): TStag;
	BEGIN
		 RETURN Kondition.LiesStichtag(inKondition);
	END LiesSTaginWKond;

	PROCEDURE SetzeBemMonatinWKond(VAR inoutKond: TKond; 
		  inBemMonat:TMonat):BOOLEAN;
	BEGIN
                Kondition.SetzeBemessungsmonat(inoutKond,inBemMonat);
                (* Da ich nicht weiss, was hier zurueckgegeben werden soll,
                   wird TRUE zurueckgegeben *)
                RETURN TRUE;
	END SetzeBemMonatinWKond;

	PROCEDURE LiesBemMonatinWKond( inKondition: TKond): TMonat ;

	BEGIN
		RETURN Kondition.LiesBemessungsmonat(inKondition);
	END LiesBemMonatinWKond;

        PROCEDURE KIDalsString ( inKID : TKID ; KIDLaenge: CARDINAL) : TString;
        (* -- Vorbed.: inKID existiert
           -- liefere die Stringrepraesentation von inKID formatiert auf
              KIDLaenge Zeichen zurueck. Wird KIDLaenge=0 angegeben, wird
              der String 'getrimmt' returniert.
           -- Nachbed.: Rueckgabe ADO vom Typ String existiert *) 
	BEGIN
		RETURN Kondition.KIDalsString(inKID,KIDLaenge);
	END KIDalsString;
 
	(* Standardoperationen des Ordners *)
	
	PROCEDURE First(VAR outKond:TKond):BOOLEAN;
        BEGIN
		RETURN KondenOrdner.First(outKond);
	END First;

	PROCEDURE Next(VAR inoutKond:TKond):BOOLEAN;
        BEGIN
		RETURN KondenOrdner.Next(inoutKond);
	END Next;

        (* HiKS spezifische Operationen *)
        PROCEDURE CreateKonditionsOrdner();
	BEGIN
		KondenOrdner.CreateKondenOrdner();
	END CreateKonditionsOrdner;

	PROCEDURE AktiviereKondRestore();
	(* Falls ein Reload vom Sekundaerspeicher erfolgreich war, knnen die von *)
	(* dort geladenen Daten mit Hilfe dieser Prozedur aktiviert werden *)
	(* Mit anderen Worten: Die momentan guletigen Daten werden erst ver-*)
	(* worfen wenn AktiviereKondRestore aufgerufen wird *)
	BEGIN
		KondenOrdner.AktiviereRestore();
	END AktiviereKondRestore;
   
	
	PROCEDURE InsertVKond( inVKond: TKond;
                               VAR outMessage : TString) : BOOLEAN;
        (*
        vb: sei K die neu einzufgende Kondition. Dann muss gelten: ADO 
	Konditionsordner existiert and not isfull and K.GueltigVon > heute
	Fuegt eine Kondition gemaess der Prozessspezifikationen D3.3.1-D3.3.3
	in den Konditionsordner ein. Die restlichen Anweisungen gemaess D3.3
	nach dem Einfuegen bezueglich Vertraege/Buchungen sind entitaets-
	spezifisch und werden im TS PSB modelliert
	 nb: sei KL die letzte Kondition im Konditionsordner mit 
	KL.Entitaetstyp=K.Entitaetstyp. Dann muss gelten: KO vereinigt mit 
	Konditionsordner so dass es keine KE in Konditionsordner gibt mit 
	(KE.Entitaetstyp=K.Entitaetstyp and K.GueltigVon<=KE.GueltigVon) and
	KL.GueltigBis=K.GueltigVon-1Tag
        *) 
	BEGIN
		RETURN KondenOrdner.Insert(inVKond,outMessage);
	END InsertVKond;


	PROCEDURE InsertWKond( inWKond: TKond;
                               VAR outMessage : TString) : BOOLEAN;
        (* Semantik wie bei VKondAufnehmen *)
	BEGIN
		RETURN KondenOrdner.Insert(inWKond,outMessage);
	END InsertWKond;


	PROCEDURE InsertTKond( inTKond: TKond;
                               VAR outMessage : TString) : BOOLEAN;
        (* Semantik wie bei VKondAufnehmen *)
	BEGIN
		RETURN KondenOrdner.Insert(inTKond,outMessage);
	END InsertTKond;


	PROCEDURE HoleGueltigeVKond( inD: TDatum; VAR outVKond:TKond):BOOLEAN;
        (*
        vb: Konditionsordner existiert
        Hole die zum Datum D gltige Vertragskondition
        nb: --
        *)
	BEGIN
		RETURN KondenOrdner.HoleGueltigeVKond(inD,outVKond);
	END HoleGueltigeVKond;

	PROCEDURE HoleGueltigeTKond( inD: TDatum; VAR outTKond:TKond):BOOLEAN;
        (*
        vb: Konditionsordner existiert
        Hole die zum Datum D gltige Tarifkondition
        nb: --
        *)
	BEGIN
		RETURN KondenOrdner.HoleGueltigeTKond(inD,outTKond);
	END HoleGueltigeTKond;

	PROCEDURE HoleGueltigeWKond( inD: TDatum; VAR outWKond:TKond):BOOLEAN;
        (*
        vb: Konditionsordner existiert
        Hole die zum Datum D gltige Weihnachtskondition
        nb: --
        *)
	BEGIN
		RETURN KondenOrdner.HoleGueltigeWKond(inD,outWKond);
	END HoleGueltigeWKond;


	PROCEDURE BerechneBrutto(inGueltigVon: TDatum; inGueltigBis: TDatum;
                                   inStundenzahl: INTEGER): INTEGER;
	(* Gueltige Kondition ermitteln
           FOR alle TK in Tarifkonditionen mit
               TK.GueltigVon <= V.GueltigBis AND
                  (V.GueltigVon <= TK.GueltigBis OR
                    TK.GueltigBis = UNDEF) DO
                Anfang := MAX (TK.GueltigVon, V.GueltigVon);
                Ende := MIN(TK.GueltigBis, V.GueltigBis);
                Wochen := (Ende - Anfang).Wochen;
                Betrag += TK.Stundensatz * V.Stundenzahl * Wochen;
           END (* FOR *)
	S. 46 Prozess 3.6.1.2, ab (* Gueltige Kond. ermittlen ..*)
             bis Betrag+= TK.Stundensatz * 		V.STundenzahl * Wochen;

	*)
	BEGIN
		RETURN KondenOrdner.BerechneBrutto(
			inGueltigVon,inGueltigBis,inStundenzahl);	
	END BerechneBrutto;


	PROCEDURE PruefeVKondInZeitr(   inGueltigVon    : TDatum;
                                	inGueltigBis    : TDatum;
                                	Stunden         : CARDINAL;
                                	Monate          : CARDINAL;
                                	VAR outMessage  : TString):BOOLEAN;
	(* 
           FOR alle VK in Vertragskonditionen mit
               VK.GueltigVon <= V.GueltigBis AND
               (V.GueltigVon <= VK.GueltigBis OR VK.GueltigBis = UNDEF)
                OK := OK AND (Stunden <= VK:Stundenobergrenze AND
                              MONATE <= VK.Beschaeftigungshoechstdauer)
           
 	   S. 45:ab  OK:= TRUE, FOR alle VK ... bis OK:= OK AND....
	*)
	BEGIN
		RETURN KondenOrdner.PruefeVKondInZeitr(
                inGueltigVon,inGueltigBis,Stunden,Monate,outMessage );
	END PruefeVKondInZeitr;


        PROCEDURE FirstTKondImZeitraum( inGueltigVon, inGueltigBis:TDatum;
                                            VAR outKond: TKond) : BOOLEAN; 
        (*
        vb: Konditionsordner existiert
        Hole die zwischen Datum D gltige Weihnachtskondition
        nb: --
        *)
	BEGIN
		RETURN KondenOrdner.FirstTKondImZeitraum(
			inGueltigVon,inGueltigBis,outKond);
	END FirstTKondImZeitraum;

        PROCEDURE FirstVKondImZeitraum( inGueltigVon, inGueltigBis:TDatum;
                                             VAR outKond: TKond) : BOOLEAN; 
        (*
        vb: Konditionsordner existiert
        Hole die zwischen Datum D gltige Vertragskondition
        nb: --
        *)
	BEGIN
		RETURN KondenOrdner.FirstVKondImZeitraum(
			inGueltigVon,inGueltigBis,outKond);
	END FirstVKondImZeitraum;

        PROCEDURE FirstWKondImZeitraum( inGueltigVon, inGueltigBis:TDatum;
                                            VAR outKond: TKond) : BOOLEAN; 
        (*
        vb: Konditionsordner existiert
        Hole die zwischen Datum D gltige Weihnachtskondition
        nb: --
        *)
	BEGIN
		RETURN KondenOrdner.FirstWKondImZeitraum(
			inGueltigVon,inGueltigBis,outKond);
	END FirstWKondImZeitraum;

        PROCEDURE NextTKondImZeitraum( inGueltigVon, inGueltigBis:TDatum; 
                            VAR inoutTKond:TKond):BOOLEAN; 
        (*
        vb: Konditionsordner existiert
        Falls mit ErsteKondition... eine Kondition die im Zeitraum GueltigVon-
	GueltigBis gilt gefunden werden, dann holt diese Prozedur die nchste
	Kondition K vom Typ Tarif fr diesen Zeitraum. Falls es keine solche
	Kondition gibt, wird false zurueck gegeben.
        nb: --
        *)
	BEGIN
		RETURN KondenOrdner.NextTKondImZeitraum(
			inGueltigVon,inGueltigBis,inoutTKond);
	END NextTKondImZeitraum;

        PROCEDURE NextVKondImZeitraum( inGueltigVon, inGueltigBis:TDatum;
                            VAR inoutVKond:TKond):BOOLEAN; 
        (*
        vb: Konditionsordner existiert
        Falls mit ErsteKondition... eine Kondition die im Zeitraum GueltigVon-
        GueltigBis gilt gefunden werden, dann holt diese Prozedur die nchste
        Kondition K vom Typ Vertrag fr diesen Zeitraum. Falls es keine solche
        Kondition gibt, wird false zurueck gegeben.
        nb: --
        *)
	BEGIN
		RETURN KondenOrdner.NextVKondImZeitraum(
			inGueltigVon,inGueltigBis,inoutVKond);
	END NextVKondImZeitraum;

        PROCEDURE NextWKondImZeitraum( inGueltigVon, inGueltigBis:TDatum;
                            VAR inoutWKond:TKond):BOOLEAN; 
        (*
        vb: Konditionsordner existiert
        Falls mit ErsteKondition... eine Kondition die im Zeitraum GueltigVon-
        GueltigBis gilt gefunden werden, dann holt diese Prozedur die nchste
        Kondition K vom Typ Weihnacht fr diesen Zeitraum. Falls es keine solche
        Kondition gibt, wird false zurueck gegeben.
        nb: --
        *)
	BEGIN
		RETURN KondenOrdner.NextWKondImZeitraum(
			inGueltigVon,inGueltigBis,inoutWKond);
	END NextWKondImZeitraum;

	PROCEDURE VKonditionVorhanden() : BOOLEAN;
	(*
	Vb:     keine
	Liefert TRUE falls es eine Kondition vom Typ Vertrag gibt
	Nb:     keine
	*)
	BEGIN
	         RETURN KondenOrdner.VKonditionVorhanden();
	END VKonditionVorhanden;
 
	PROCEDURE TKonditionVorhanden() : BOOLEAN;
	(*
	Vb:     keine
	Liefert TRUE falls es eine Kondition vom Typ Tarif gibt
	Nb:     keine
	*)
	BEGIN
	         RETURN KondenOrdner.TKonditionVorhanden();
	END TKonditionVorhanden;
 
	PROCEDURE WKonditionVorhanden() : BOOLEAN;
	(*
	Vb:     keine
	Liefert TRUE falls es eine Kondition vom Typ Weihnacht gibt
	Nb:     keine
	*)
	BEGIN
	         RETURN KondenOrdner.WKonditionVorhanden();
	END WKonditionVorhanden;        

        (* Stringlisten *)
 
        PROCEDURE GibTKondAlsStringlisteInKonden(): TStringliste;
       	(* Gib die Tarif-Konditionen mit folgender Formatierung als Stringliste
           aus; Formatierung:  Formatierung: KID(5Zeichen); 1 Leerzeichen;
           GueltigVon (10Zeichen); 1 Leerzeichen;
           GueltigBis(10Zeichen); 1 Leerzeichen; Stundensatz(5Zeichen);
           insgesamt also 33 Zeichen *)
        BEGIN
		RETURN KondenOrdner.GibTKondAlsStringliste();
	END GibTKondAlsStringlisteInKonden;
 
 
       	PROCEDURE GibVKondAlsStringlisteInKonden(): TStringliste;
       	(* Gib die Vertrags-Konditionen mit folgender Formatierung als
           Stringliste aus; Formatierung:  Formatierung: KID(5Zeichen);
           1 Leerzeichen;GueltigVon (10Zeichen);
           1 Leerzeichen; GueltigBis(10Zeichen); 1 Leerzeichen;
           Beschftigungshchstdauer(5Zeichen); 1 Leerzeichen;
           Stundenobergrenze(5Zeichen); insgesamt also 39 Zeichen *)  
       	BEGIN
		RETURN KondenOrdner.GibVKondAlsStringliste();
	END GibVKondAlsStringlisteInKonden;
 
 
       	PROCEDURE GibWKondAlsStringlisteInKonden(): TStringliste;
        (* Gib die Weihnachtsgeld-Konditionen mit folgender Formatierung als
           Stringliste aus; Formatierung: KID(5Zeichen); 1 Leerzeichen;
           GueltigVon (10Zeichen); 1 Leerzeichen;
           GueltigBis(10Zeichen); 1 Leerzeichen; Bemessungsmonat(2Zeichen);
           1 Leerzeichen; Stichtag(6Zeichen); insgesamt also 37 Zeichen *)

	BEGIN
		RETURN KondenOrdner.GibWKondAlsStringliste();
        END GibWKondAlsStringlisteInKonden;

        (* Prozeduren zum Laden und Speichern des Teilsystems Konditionen *)

	PROCEDURE LoadInKonden (inH:THandle; VAR outMessage:TString):BOOLEAN; 
	(*
	vb: Datei existiert und ist nicht leer und zum Lesen geoeffnet
	Lade den Inhalt des KonditionsOrdners mit dem Inhalt der Datei auf 
	die inH verweist.
	nb: Konditionsordner ist geladen
	*)
	BEGIN
		RETURN KondenSpeichern.Load(inH,outMessage);
	END LoadInKonden;
	
	PROCEDURE SaveInKonden (inH:THandle; VAR outMessage:TString):BOOLEAN; 	
	(*
	vb: Datei existiert und ist zum Schreiben geoeffnet
	Speichert den Inhalt des KonditionsOrdners in der Datei auf die inH
	verweist.
	nb: KonditionsordnerInhalt ist auf SekundaerSpeicher geschrieben
	*)
	BEGIN
		RETURN KondenSpeichern.Save(inH,outMessage);
	END SaveInKonden;

END Konden.






