MODULE KondenTest;

   FROM InOut IMPORT ReadCard, WriteCard, WriteString, WriteLn;

   FROM InOut IMPORT ReadLn, ReadString;

   FROM SYSTEM  IMPORT TSIZE;

   IMPORT Konden;
   (* Diese Importe sind normalerweise ausserhalb des TS_Konden nicht *)
   (* erfoderlich, da sie innerhaln des TS verborgen bleiben *)
   FROM Kondition IMPORT TKondTyp,LiesEntitaetsTyp;

   IMPORT VDat;
   IMPORT Datum;
   IMPORT HIDVerwaltung;
	 
   IMPORT String;
   IMPORT Stringliste;
   IMPORT WholeStr;

   TYPE TKond=Konden.TKond; 
   	TDatum=Datum.TDatum;
	TMonat=Datum.TMonat;
	 
   VAR Befehl          	: CARDINAL;
       MaxProcNr       	: CARDINAL;
       TestProcs        : ARRAY[0..22] OF PROC;
       aktVKond		: TKond;
       aktWKond		: TKond;
       aktTKond		: TKond;
       VKondExistiert   : BOOLEAN;
       WKondExistiert   : BOOLEAN;
       TKondExistiert   : BOOLEAN;
       TMexistiert      : BOOLEAN;
 

  PROCEDURE CreateVertragsKondition();
  VAR vonDstr,bisDstr,bhdstr,sogstr	: String.TString;
      vonD,bisD				: Datum.TDatum;
      bhd				: CARDINAL;
      sog				: CARDINAL;
      message				: String.TString;   
      result				: WholeStr.ConvResults;
      success				: BOOLEAN;
      CharArray				: ARRAY [1..255] OF CHAR;
  BEGIN
    WriteString("Operation: Konden.CreateVertragsKondition");
    WriteLn;
    IF VKondExistiert THEN
      WriteString ("Es ist bereits eine Vertrags-Kondition in Bearbeitung");
      WriteLn;
    ELSE
      vonDstr:=String.Create();
      bisDstr:=String.Create();
      bhdstr:=String.Create();
      sogstr:=String.Create();
      aktVKond:=Konden.CreateVertragsKondition();	 
      VKondExistiert := TRUE;
      WriteString("Leere Vertrags-Kondition angelegt!");  
      WriteLn;  
      StringEingeben("Gueltig Von                : ",vonDstr);
      StringEingeben("Gueltig Bis                : ",bisDstr);
      StringEingeben("Beschaeftigungshoechstdauer: ",bhdstr);
      StringEingeben("Stundenobergrenze          : ",sogstr);
      IF NOT Datum.DatumVonString(vonDstr,vonD,message) THEN
        success:=FALSE;
      ELSIF NOT Datum.DatumVonString(bisDstr,bisD,message) THEN
        success:=FALSE;
      ELSE
        success:=TRUE;
      END (* IF *);
      String.Lies(bhdstr,CharArray);
      WholeStr.StrToCard(CharArray,bhd,result);
      String.Lies(sogstr,CharArray);
      WholeStr.StrToCard(CharArray,sog,result);
      Konden.SetzeGueltVoninKond(aktVKond,vonD);
      Konden.SetzeGueltBisinKond(aktVKond,bisD);
      IF NOT Konden.SetzeBHDinVKond(aktVKond,bhd) AND success THEN
        message:=String.Create();
        String.Schreibe(message,
           "BHD konnte nicht richtig gesetzt werden!");
      ELSIF NOT Konden.SetzeSOGinVKond(aktVKond,sog) AND success THEN
        message:=String.Create();
        String.Schreibe(message,
           "Stundenobergrenze konnte nicht richtig angelegt werden!");
      END (* IF *);
      IF NOT success THEN
        StringAusgeben(message);
        WriteLn;
        Konden.DisposeKond(aktVKond);
        String.Dispose(message);
      END (* IF *); 
    END; (* IF *)
    WriteLn;
  END CreateVertragsKondition;

  PROCEDURE CreateWeihnachtsKondition();
  VAR vonDstr,bisDstr,stagstr,bmstr	: String.TString;
      vonD,bisD				: Datum.TDatum;
      stag				: Datum.TStag;
      bm				: TMonat;
      message				: String.TString;
      success				: BOOLEAN;
      
  BEGIN
    WriteString("Operation: Konden.CreateWeihnachtsKondition");
    WriteLn;
    IF WKondExistiert THEN
      WriteString ("Es ist bereits eine Weihnachts-Kondition in Bearbeitung");
      WriteLn;
    ELSE
      vonDstr:=String.Create();
      bisDstr:=String.Create();
      stagstr:=String.Create();
      bmstr:=String.Create();
      aktWKond:=Konden.CreateWeihnachtsKondition();
      WKondExistiert:=TRUE;	 
      WriteString("Leere Weihnachts-Kondition angelegt!");  
      WriteLn;
      StringEingeben("Gueltig Von     : ",vonDstr);
      StringEingeben("Gueltig Bis     : ",bisDstr);
      StringEingeben("Stichtag        : ",stagstr);
      StringEingeben("Bemessungsmonat : ",bmstr);
      IF NOT Datum.DatumVonString(vonDstr,vonD,message) THEN
	success:=FALSE;
      ELSIF NOT Datum.DatumVonString(bisDstr,bisD,message) THEN
        success:=FALSE;
      ELSIF NOT Datum.StagVonString(stagstr,stag,message) THEN
	success:=FALSE;
      ELSIF NOT Datum.MonatVonString(bmstr,bm,message) THEN
	success:=FALSE;
      ELSE
	success:=TRUE;
      END (* IF *);
      Konden.SetzeGueltVoninKond(aktWKond,vonD);
      Konden.SetzeGueltBisinKond(aktWKond,bisD);
      IF NOT Konden.SetzeSTaginWKond(aktWKond,stag) AND success THEN
	message:=String.Create(); 
	String.Schreibe(message,
           "Stichtag konnte nicht richtig gesetzt werden!");
      ELSIF NOT Konden.SetzeBemMonatinWKond(aktWKond,bm) AND success THEN 
	message:=String.Create(); 
	String.Schreibe(message,
           "Bemessungsmonat konnte nicht richtig angelegt werden!");
      END (* IF *);
      IF NOT success THEN
	StringAusgeben(message);
	WriteLn;
        Konden.DisposeKond(aktWKond);
        String.Dispose(message);
      END (* IF *);
    END; (* IF *)
    WriteLn;
  END CreateWeihnachtsKondition;

  PROCEDURE CreateTarifKondition();
  VAR vonDstr,bisDstr,ssstr	: String.TString;
      vonD,bisD			: Datum.TDatum;
      ss			: CARDINAL;
      bm			: TMonat;
      message			: String.TString;
      CharArray			: ARRAY [1..255] OF CHAR;
      result			: WholeStr.ConvResults;
      success			: BOOLEAN;      
  BEGIN
    WriteString("Operation: Konden.CreateTarifKondition");
    WriteLn;
    IF TKondExistiert THEN
      WriteString ("Es ist bereits eine Tarif-Kondition in Bearbeitung");
      WriteLn;
    ELSE
      vonDstr:=String.Create();
      bisDstr:=String.Create();
      ssstr:=String.Create();
      aktTKond:=Konden.CreateTarifKondition();	 
      TKondExistiert:=TRUE;
      WriteString("Leere Tarif-Kondition angelegt!");  
      WriteLn;  
      StringEingeben("Gueltig Von : ",vonDstr);
      StringEingeben("Gueltig Bis : ",bisDstr);
      StringEingeben("Stundensatz : ",ssstr);
      IF NOT Datum.DatumVonString(vonDstr,vonD,message) THEN
        success:=FALSE;
      ELSIF NOT Datum.DatumVonString(bisDstr,bisD,message) THEN
        success:=FALSE;
      ELSE
        success:=TRUE;
      END (* IF *);
      String.Lies(ssstr,CharArray);
      WholeStr.StrToCard(CharArray,ss,result);
      Konden.SetzeGueltVoninKond(aktTKond,vonD);
      Konden.SetzeGueltBisinKond(aktTKond,bisD);
      IF NOT Konden.SetzeStdSinTKond(aktTKond,ss) AND success THEN
        message:=String.Create();
        String.Schreibe(message,
           "Stundensatz konnte nicht richtig gesetzt werden!");
      END (* IF *);
      IF NOT success THEN
        StringAusgeben(message);
        WriteLn;
        Konden.DisposeKond(aktTKond);
        String.Dispose(message);
      END (* IF *);
    END; (* IF *)
    WriteLn;
  END CreateTarifKondition;

  PROCEDURE InsertWKond();
  VAR message: String.TString;
      success: BOOLEAN;
  BEGIN
    WriteString("Operation: Konden.InsertWKond");
    WriteLn;
    IF NOT WKondExistiert THEN
      WriteString ("Es ist noch keine Weihnachts-Kondition in Bearbeitung");
      WriteLn;
    ELSE
      WriteString
	("Die Weihnachtskondition wird in den Konditionsordner eingefuegt!");
      WriteLn;
      success:=Konden.InsertWKond(aktWKond,message);
      IF success THEN
        WriteString
	  ("Die Weihnachtskondition ist eingefuegt!");
        WriteLn;
	Konden.DisposeKond(aktWKond);
        WKondExistiert:=FALSE;
      ELSE
        StringAusgeben(message);
        WriteLn;
	String.Dispose(message);
      END (* IF *);
    END (* IF *);
    WriteLn;
  END InsertWKond;
 
  PROCEDURE InsertTKond();
  VAR message: String.TString;
      success: BOOLEAN; 
  BEGIN
    WriteString("Operation: Konden.InsertTKond");
    WriteLn;
    IF NOT TKondExistiert THEN
      WriteString ("Es ist noch keine Tarif-Kondition in Bearbeitung");
      WriteLn;
    ELSE
      WriteString
	("Die Tarifkondition wird in den Konditionsordner eingefuegt!");
      WriteLn;
      success:=Konden.InsertTKond(aktTKond,message);
      IF success THEN
        WriteString
	  ("Die Tarifkondition ist eingefuegt!");
        WriteLn;
        Konden.DisposeKond(aktTKond);
        TKondExistiert:=FALSE;
      ELSE
        StringAusgeben(message);
        WriteLn;
	String.Dispose(message);
      END (* IF *);
    END (* IF *);
    WriteLn;
  END InsertTKond;

  PROCEDURE InsertVKond();
  VAR message: String.TString;
      success: BOOLEAN; 
  BEGIN
    WriteString("Operation: Konden.InsertVKond");
    WriteLn;
    IF NOT VKondExistiert THEN
      WriteString ("Es ist noch keine Vertrags-Kondition in Bearbeitung");
      WriteLn;
    ELSE
      WriteString
	("Die Vertragskondition wird in den Konditionsordner eingefuegt!");
      WriteLn;
      success:=Konden.InsertVKond(aktVKond,message);
      IF success THEN
        WriteString
	  ("Die Vertragskondition ist eingefuegt!");
        WriteLn;
	Konden.DisposeKond(aktVKond);
        VKondExistiert:=FALSE;
      ELSE
        StringAusgeben(message);
        WriteLn;
	String.Dispose(message);
      END (* IF *);
    END (* IF *);
    WriteLn;
  END InsertVKond;
 
  PROCEDURE KondenAusgeben();
  VAR aktKond:TKond;
      return:String.TString;

  BEGIN
    WriteString("Operation: Konden.First und Konden.Next");
    WriteLn; 
    WriteString("Der gesamte Ordnerinhalt wird ausgegeben:");
    WriteLn;
    return:=String.Create();
    IF Konden.First(aktKond) THEN
      REPEAT
	KonditionAusgeben(aktKond);
	StringEingeben("Return druecken!",return);
      UNTIL NOT Konden.Next(aktKond);
      Konden.DisposeKond(aktKond);
    ELSE
      WriteString("Der Konditionenordner ist leer!");
      WriteLn;
    END (* IF *);
    WriteLn;
    String.Dispose(return);
  END KondenAusgeben;

PROCEDURE KonditionAusgeben(aktKond:TKond);
BEGIN
	WriteString("KID                         : ");
	StringAusgeben(Konden.KIDalsString(Konden.LiesKIDinKond(aktKond),5));
	WriteString("gueltig von                 : ");
	StringAusgeben(
		Datum.DatumAlsString(
		Konden.LiesGueltVoninKond(aktKond))); 
	WriteString("gueltig bis                 : ");
	StringAusgeben(
		Datum.DatumAlsString(
		Konden.LiesGueltBisinKond(aktKond))); 
	CASE LiesEntitaetsTyp(aktKond) OF
	   Vertrag: 	WriteString("SubTyp                      : ");
			WriteString("Vertragskondition");
      			WriteLn;
			WriteString("Beschaeftigungshoechstdauer : ");
			WriteCard(Konden.LiesBHDinVKond(aktKond),3);
			WriteLn;
			WriteString("Stundenobergrenze           : ");
			WriteCard(Konden.LiesSOGinVKond(aktKond),3);
			WriteLn;
	   
	  |Tarif:	WriteString("SubTyp                      : ");
			WriteString("Tarifkondition ");
      			WriteLn;
			WriteString("Stundensatz                 : ");
			WriteCard(Konden.LiesStdSinTKond(aktKond),5);
      			WriteLn;
	  |Weihnacht:	WriteString("SubTyp                      : ");
			WriteString("Weihnachtskondition");
      			WriteLn;
			WriteString("Stichtag                    : ");
			StringAusgeben(
				Datum.StagAlsString(
				Konden.LiesSTaginWKond(aktKond)));
			WriteString("Bemessungsmonat             : ");
			WriteCard(
				Datum.MonatAlsCard(
				Konden.LiesBemMonatinWKond(aktKond)),2);
			WriteLn;
	END (* CASE *);
	WriteLn;
END KonditionAusgeben;

  PROCEDURE TarifKondImZeitraum();
  VAR aktKond		: TKond;
      success		: BOOLEAN;
      vonDstr,bisDstr	: String.TString;
      return,message	: String.TString;
      vonD,bisD		: Datum.TDatum;

  BEGIN
    WriteString(
     "Operation: Konden.FirstTKondImZeitraum und Konden.NextTKondImZeitraum");
    WriteLn; 
    WriteString("Alle Tarif Konditionen eines Zeitraumes werden ausgegeben:");
    WriteLn;
    return:=String.Create();
    vonDstr:=String.Create();
    bisDstr:=String.Create();
    StringEingeben("Gueltig Von : ",vonDstr);
    StringEingeben("Gueltig Bis : ",bisDstr);
    IF NOT Datum.DatumVonString(vonDstr,vonD,message) THEN
      success:=FALSE;
    ELSIF NOT Datum.DatumVonString(bisDstr,bisD,message) THEN
      success:=FALSE;
    ELSE
      success:=TRUE;
    END (* IF *);
  
    IF Konden.FirstTKondImZeitraum(vonD,bisD,aktKond) AND success THEN
      REPEAT
	KonditionAusgeben(aktKond);
	StringEingeben("Return druecken!",return);
      UNTIL NOT Konden.NextTKondImZeitraum(vonD,bisD,aktKond);
      Konden.DisposeKond(aktKond);
    ELSE
      IF NOT success THEN 
	StringAusgeben(message);
      ELSE
        WriteString("Der Konditionenordner enthaelt keine Tarifkondition ");
	WriteString("in diesem Zeitraum!");
        WriteLn;
      END (* IF *);
    END (* IF *);
    WriteLn;
    String.Dispose(return);
    String.Dispose(vonDstr);
    String.Dispose(bisDstr);
  END TarifKondImZeitraum;

  PROCEDURE WeihnachtsKondImZeitraum();
  VAR aktKond		: TKond;
      success		: BOOLEAN;
      vonDstr,bisDstr	: String.TString;
      return,message	: String.TString;
      vonD,bisD		: Datum.TDatum;

  BEGIN
    WriteString(
     "Operation: Konden.FirstWKondImZeitraum und Konden.NextWKondImZeitraum");
    WriteLn; 
    WriteString("Alle Weihnachts Konditionen eines Zeitraumes ");
    WriteString("werden ausgegeben:");
    WriteLn;
    return:=String.Create();
    vonDstr:=String.Create();
    bisDstr:=String.Create();
    StringEingeben("Gueltig Von : ",vonDstr);
    StringEingeben("Gueltig Bis : ",bisDstr);
    IF NOT Datum.DatumVonString(vonDstr,vonD,message) THEN
      success:=FALSE;
    ELSIF NOT Datum.DatumVonString(bisDstr,bisD,message) THEN
      success:=FALSE;
    ELSE
      success:=TRUE;
    END (* IF *);
  
    IF Konden.FirstWKondImZeitraum(vonD,bisD,aktKond) AND success THEN
      REPEAT
	KonditionAusgeben(aktKond);
	StringEingeben("Return druecken!",return);
      UNTIL NOT Konden.NextWKondImZeitraum(vonD,bisD,aktKond);
      Konden.DisposeKond(aktKond);
    ELSE
      IF NOT success THEN 
	StringAusgeben(message);
      ELSE
        WriteString("Der Konditionenordner enthaelt keine Weihnachts");
	WriteString("kondition in diesem Zeitraum!");
        WriteLn;
      END (* IF *);
    END (* IF *);
    WriteLn;
    String.Dispose(return);
    String.Dispose(vonDstr);
    String.Dispose(bisDstr);
  END WeihnachtsKondImZeitraum;

  PROCEDURE VertragsKondImZeitraum();
  VAR aktKond		: TKond;
      success		: BOOLEAN;
      vonDstr,bisDstr	: String.TString;
      return,message	: String.TString;
      vonD,bisD		: Datum.TDatum;

  BEGIN
    WriteString(
     "Operation: Konden.FirstVKondImZeitraum und Konden.NextVKondImZeitraum");
    WriteLn; 
    WriteString("Alle Vertrags Konditionen eines Zeitraumes ");
    WriteString("werden ausgegeben:");
    WriteLn;
    return:=String.Create();
    vonDstr:=String.Create();
    bisDstr:=String.Create();
    StringEingeben("Gueltig Von : ",vonDstr);
    StringEingeben("Gueltig Bis : ",bisDstr);
    IF NOT Datum.DatumVonString(vonDstr,vonD,message) THEN
      success:=FALSE;
    ELSIF NOT Datum.DatumVonString(bisDstr,bisD,message) THEN
      success:=FALSE;
    ELSE
      success:=TRUE;
    END (* IF *);
  
    IF Konden.FirstVKondImZeitraum(vonD,bisD,aktKond) AND success THEN
      REPEAT
	KonditionAusgeben(aktKond);
	StringEingeben("Return druecken!",return);
      UNTIL NOT Konden.NextVKondImZeitraum(vonD,bisD,aktKond);
      Konden.DisposeKond(aktKond);
    ELSE
      IF NOT success THEN 
	StringAusgeben(message);
      ELSE
        WriteString("Der Konditionenordner enthaelt keine Vertrags");
	WriteString("kondition in diesem Zeitraum!");
        WriteLn;
      END (* IF *);
    END (* IF *);
    WriteLn;
    String.Dispose(return);
    String.Dispose(vonDstr);
    String.Dispose(bisDstr);
  END VertragsKondImZeitraum;

  PROCEDURE HoleGueltigeTKond();
  VAR aktKond		: TKond;
      success		: BOOLEAN;
      Dstr		: String.TString;
      return,message	: String.TString;
      D			: Datum.TDatum;

  BEGIN
    WriteString(
     "Operation: Konden.HoleGueltigeTKond");
    WriteLn; 
    WriteString("Hole die gueltige Tarifkondition zu einem Zeitpunkt");
    WriteLn;
    return:=String.Create();
    Dstr:=String.Create();
    StringEingeben("Zeitpunkt : ",Dstr);
    IF NOT Datum.DatumVonString(Dstr,D,message) THEN
      success:=FALSE;
    ELSE
      success:=TRUE;
    END (* IF *);
 
    IF success THEN 
      IF Konden.HoleGueltigeTKond(D,aktKond) THEN
        KonditionAusgeben(aktKond);
        Konden.DisposeKond(aktKond);
      ELSE
        WriteString("Der Konditionenordner enthaelt keine Tarif");
	WriteString("kondition fuer dieses Datum!");
        WriteLn;
      END (* IF *);
    ELSE
      StringAusgeben(message);
    END (* IF *);
    WriteLn;
    String.Dispose(return);
    String.Dispose(Dstr);
  END HoleGueltigeTKond;

  PROCEDURE HoleGueltigeWKond();
  VAR aktKond		: TKond;
      success		: BOOLEAN;
      Dstr		: String.TString;
      return,message	: String.TString;
      D			: Datum.TDatum;

  BEGIN
    WriteString(
     "Operation: Konden.HoleGueltigeWKond");
    WriteLn; 
    WriteString("Hole die gueltige Weihnachtskondition zu einem Zeitpunkt");
    WriteLn;
    return:=String.Create();
    Dstr:=String.Create();
    StringEingeben("Zeitpunkt : ",Dstr);
    IF NOT Datum.DatumVonString(Dstr,D,message) THEN
      success:=FALSE;
    ELSE
      success:=TRUE;
    END (* IF *);
  
    IF success THEN 
      IF Konden.HoleGueltigeWKond(D,aktKond) THEN
        KonditionAusgeben(aktKond);
        Konden.DisposeKond(aktKond);
      ELSE
        WriteString("Der Konditionenordner enthaelt keine Weihnachts");
	WriteString("kondition fuer dieses Datum!");
        WriteLn;
      END (* IF *);
    ELSE
      StringAusgeben(message);
    END (* IF *);
    WriteLn;
    String.Dispose(return);
    String.Dispose(Dstr);
  END HoleGueltigeWKond;

  PROCEDURE HoleGueltigeVKond();
  VAR aktKond		: TKond;
      success		: BOOLEAN;
      Dstr		: String.TString;
      return,message	: String.TString;
      D			: Datum.TDatum;

  BEGIN
    WriteString(
     "Operation: Konden.HoleGueltigeVKond");
    WriteLn; 
    WriteString("Hole die gueltige Vertragskondition zu einem Zeitpunkt");
    WriteLn;
    return:=String.Create();
    Dstr:=String.Create();
    StringEingeben("Zeitpunkt : ",Dstr);
    IF NOT Datum.DatumVonString(Dstr,D,message) THEN
      success:=FALSE;
    ELSE
      success:=TRUE;
    END (* IF *);
  
    IF success THEN 
      IF Konden.HoleGueltigeVKond(D,aktKond) THEN
        KonditionAusgeben(aktKond);
        Konden.DisposeKond(aktKond);
      ELSE
        WriteString("Der Konditionenordner enthaelt keine Vertrags");
	WriteString("kondition fuer dieses Datum!");
        WriteLn;
      END (* IF *);
    ELSE
      StringAusgeben(message);
    END (* IF *);
    WriteLn;
    String.Dispose(return);
    String.Dispose(Dstr);
  END HoleGueltigeVKond;

  PROCEDURE BerechneBrutto();
  VAR success		: BOOLEAN;
      message		: String.TString;
      vonDstr,bisDstr   : String.TString;
      stdstr		: String.TString;
      vonD,bisD         : Datum.TDatum;     
      Betrag,std,pf	: CARDINAL;
      CharArray		: ARRAY [1..255] OF CHAR;
      result		: WholeStr.ConvResults;

  BEGIN
    WriteString(
     "Operation: Konden.BerechneBrutto");
    WriteLn;
    WriteString("Buchungsbetrag nach 3.6.1.2 berechnen");
    WriteLn;
    vonDstr:=String.Create();
    bisDstr:=String.Create();
    stdstr:=String.Create();
    StringEingeben("Rechnen von : ",vonDstr);
    StringEingeben("        bis : ",bisDstr);
    StringEingeben("Stundenzahl : ",stdstr);
    IF NOT Datum.DatumVonString(vonDstr,vonD,message) THEN
      success:=FALSE;
    ELSIF NOT Datum.DatumVonString(bisDstr,bisD,message) THEN
      success:=FALSE;
    ELSE
      success:=TRUE;
    END (* IF *);
    IF success THEN                   
      String.Lies(stdstr,CharArray);
      WholeStr.StrToCard(CharArray,std,result);
      Betrag:=CARDINAL(Konden.BerechneBrutto(vonD,bisD,INTEGER(std)));
      WriteLn;
      WriteString("Buchungsbetrag in DM: ");
      WriteCard(TRUNC(FLOAT(Betrag)/100.0),5);
      WriteString(",");
      pf:=Betrag MOD 100;
      IF  pf = 0 THEN
	WriteString("-");
      ELSIF pf < 10 THEN
	WriteString("0");
	WriteCard(pf,1);
      ELSE
	WriteCard(pf,2);
      END (* IF *);
      WriteLn;
    ELSE
      StringAusgeben(message);  
    END (* IF *);
    String.Dispose(vonDstr);
    String.Dispose(bisDstr);
    String.Dispose(stdstr);
    WriteLn;
  END BerechneBrutto;


  PROCEDURE PruefeVKondInZeitr();
  VAR success,ok	: BOOLEAN;
      message		: String.TString;
      vonDstr,bisDstr   : String.TString;
      stdstr,monstr	: String.TString;
      vonD,bisD         : Datum.TDatum;     
      std,mon		: CARDINAL;
      CharArray		: ARRAY [1..255] OF CHAR;
      result		: WholeStr.ConvResults;

  BEGIN
    WriteString(
     "Operation: Konden.PruefeVKondInZeitr");
    WriteLn;
    WriteString("Vertragskonditionen nach 3.6.1.1 (S.45u) pruefen");
    WriteLn;
    vonDstr:=String.Create();
    bisDstr:=String.Create();
    stdstr:=String.Create();
    monstr:=String.Create();
    StringEingeben("pruefen von   : ",vonDstr);
    StringEingeben("        bis   : ",bisDstr);
    StringEingeben("Stundenzahl   : ",stdstr);
    StringEingeben("Anzahl Monate : ",monstr);
    IF NOT Datum.DatumVonString(vonDstr,vonD,message) THEN
      success:=FALSE;
    ELSIF NOT Datum.DatumVonString(bisDstr,bisD,message) THEN
      success:=FALSE;
    ELSE
      success:=TRUE;
    END (* IF *);
    IF success THEN                   
      String.Lies(stdstr,CharArray);
      WholeStr.StrToCard(CharArray,std,result);
      String.Lies(monstr,CharArray);
      WholeStr.StrToCard(CharArray,mon,result);
      ok:=Konden.PruefeVKondInZeitr(vonD,bisD,std,mon,message);
      WriteLn;
      IF ok THEN
        WriteString("Vertragskonditionen werden nicht verletzt!");
      ELSE
        WriteString("Vertragskonditionen sind verletzt!");
	WriteLn;
	StringAusgeben(message); 
	String.Dispose(message); 
      END (* IF *);
      WriteLn;
    ELSE
      StringAusgeben(message);  
    END (* IF *);
    String.Dispose(vonDstr);
    String.Dispose(bisDstr);
    String.Dispose(stdstr);
    String.Dispose(monstr);
    WriteLn;
  END PruefeVKondInZeitr;

  PROCEDURE KompletteListeAusgeben(Testliste:Stringliste.TStringliste);
    VAR AktuellesElement : String.TString;
  BEGIN
    Stringliste.GoStart (Testliste);
    WHILE NOT Stringliste.OffEnd(Testliste) DO
       WriteString(" -> ");
       AktuellesElement := Stringliste.Current(Testliste);
       StringAusgeben (AktuellesElement);
       String.Dispose (AktuellesElement);
       Stringliste.StepNext(Testliste)
    END; (* WHILE *)
    WriteLn;
    WriteString("Aktuelle Position: OffEnd!");
    WriteLn;
  END KompletteListeAusgeben;  


  PROCEDURE GibTKondAlsStringlisteInKonden();
  VAR TarifKondListe: Stringliste.TStringliste;
  BEGIN
    WriteString(
     "Operation: Konden.GibTKondAlsStringlisteInKonden");
    WriteLn;
    WriteString("Tarifkonditionen als Stringliste ausgeben");
    WriteLn;
    TarifKondListe:=Konden.GibTKondAlsStringlisteInKonden();
    KompletteListeAusgeben(TarifKondListe);
    WriteLn;
  END GibTKondAlsStringlisteInKonden;

  PROCEDURE GibWKondAlsStringlisteInKonden();
  VAR WeihnachtsKondListe: Stringliste.TStringliste;
  BEGIN
    WriteString(
     "Operation: Konden.GibWKondAlsStringlisteInKonden");
    WriteLn;
    WriteString("Weihnachtskonditionen als Stringliste ausgeben");
    WriteLn;
    WeihnachtsKondListe:=Konden.GibWKondAlsStringlisteInKonden();
    KompletteListeAusgeben(WeihnachtsKondListe);
    WriteLn;
  END GibWKondAlsStringlisteInKonden;

  PROCEDURE GibVKondAlsStringlisteInKonden();
  VAR VertragsKondListe: Stringliste.TStringliste;
  BEGIN
    WriteString(
     "Operation: Konden.GibVKondAlsStringlisteInKonden");
    WriteLn;
    WriteString("Vertragskonditionen als Stringliste ausgeben");
    WriteLn;
    VertragsKondListe:=Konden.GibVKondAlsStringlisteInKonden();
    KompletteListeAusgeben(VertragsKondListe);
    WriteLn;
  END GibVKondAlsStringlisteInKonden;
  
  PROCEDURE Save();
  VAR  	H 	: VDat.THandleInVDat;
       	M 	: VDat.TModusInVDat;
	message : String.TString;
	Filename: String.TString;
  BEGIN
    WriteString("Operation: Konden.Save");
    WriteLn; 
    WriteString("Der gesamte Ordnerinhalt wird gespeichert:");
    WriteLn;
    M:=VDat.SetWriteInVDat();
    Filename:=String.Create();
    String.Schreibe(Filename,"konditionen.dat");
    IF VDat.OpenInVDat(H,Filename,M) THEN
      IF NOT Konden.SaveInKonden(H,message) THEN
	StringAusgeben(message);
	String.Dispose(message);
      ELSE
	WriteString("Konditionenordner ist gespeichert!");	
	WriteLn;
      END (* IF *);
      IF NOT VDat.CloseInVDat(H) THEN
	WriteString("Die Datei konnte nicht geschlossen werden!");
	WriteLn();
      END (* IF *);
    ELSE
      WriteString("Die Datei konnte nicht geoeffnet werden!");
      WriteLn;
    END (* IF *);
    WriteLn();
  END Save;
 

  PROCEDURE Load();
  VAR   H       : VDat.THandleInVDat;
        M       : VDat.TModusInVDat;
        message : String.TString;
        Filename: String.TString;
  BEGIN
    WriteString("Operation: Konden.Load");
    WriteLn;
    WriteString("Der Ordnerinhalt wird geladen:");
    WriteLn;
    M:=VDat.SetReadInVDat();
    Filename:=String.Create();
    String.Schreibe(Filename,"konditionen.dat");
    IF VDat.OpenInVDat(H,Filename,M) THEN
      IF NOT Konden.LoadInKonden(H,message) THEN
        StringAusgeben(message);
        String.Dispose(message);
      ELSE
        WriteString("Konditionenordner ist geladen!");
        WriteLn;
      END (* IF *);
      IF NOT VDat.CloseInVDat(H) THEN
        WriteString("Die Datei konnte nicht geschlossen werden!");
        WriteLn();
      END (* IF *);
    ELSE
      WriteString("Die Datei konnte nicht geoeffnet werden!");
      WriteLn;
    END (* IF *);
    WriteLn();
  END Load;
      
  PROCEDURE SaveHIDVerwaltung();
  VAR   H       : VDat.THandleInVDat;
        M       : VDat.TModusInVDat;
        message : String.TString;
        Filename: String.TString;
  BEGIN
    WriteString("Operation: SaveHIDVerwaltung.Save");
    WriteLn;
    WriteString("Der Inhalt der HID Verwaltung wird gespeichert:");
    WriteLn;
    M:=VDat.SetWriteInVDat();
    Filename:=String.Create();
    String.Schreibe(Filename,"hid.dat");
    IF VDat.OpenInVDat(H,Filename,M) THEN
      IF NOT HIDVerwaltung.SaveInHID(H,message) THEN
        StringAusgeben(message);
        String.Dispose(message);
      ELSE
        WriteString("HID Ordner ist gespeichert!");
        WriteLn;
      END (* IF *);
      IF NOT VDat.CloseInVDat(H) THEN
        WriteString("Die Datei konnte nicht geschlossen werden!");
        WriteLn();
      END (* IF *);
    ELSE
      WriteString("Die Datei konnte nicht geoeffnet werden!");
      WriteLn;
    END (* IF *);
    WriteLn();
  END SaveHIDVerwaltung;    

  PROCEDURE LoadHIDVerwaltung();
  VAR   H       : VDat.THandleInVDat;
        M       : VDat.TModusInVDat;
        message : String.TString;
        Filename: String.TString;
  BEGIN
    WriteString("Operation: HIDVerwaltung.Load");
    WriteLn;
    WriteString("Der Inhalt der HID Verwaltung wird geladen:");
    WriteLn;
    M:=VDat.SetReadInVDat();
    Filename:=String.Create();
    String.Schreibe(Filename,"hid.dat");
    IF VDat.OpenInVDat(H,Filename,M) THEN
      IF NOT HIDVerwaltung.LoadInHID(H,message) THEN
        StringAusgeben(message);
        String.Dispose(message);
      ELSE
        WriteString("HID Ordner ist geladen!");
        WriteLn;
      END (* IF *);
      IF NOT VDat.CloseInVDat(H) THEN
        WriteString("Die Datei konnte nicht geschlossen werden!");
        WriteLn();
      END (* IF *);
    ELSE
      WriteString("Die Datei konnte nicht geoeffnet werden!");
      WriteLn;
    END (* IF *);
    WriteLn();
  END LoadHIDVerwaltung;    

  PROCEDURE Auswahlmenue() : CARDINAL;
  VAR ItemNr : CARDINAL;

     PROCEDURE MenueItem(inItemText : ARRAY OF CHAR);
     BEGIN
       WriteCard (ItemNr, 2);
       WriteString (" --> ");
       WriteString (inItemText);
       WriteLn;
       INC (ItemNr)
    END MenueItem;     

  BEGIN
    ItemNr := 0;
    MenueItem ("Programm beenden");
    MenueItem ("Konden.CreateTarifKondition");
    MenueItem ("Konden.CreateWeihnachtsKondition");
    MenueItem ("Konden.CreateVertragsKondition");
    MenueItem ("InsertTKond");
    MenueItem ("InsertWKond");
    MenueItem ("InsertVKond");
    MenueItem ("First/Next Iterator ueber alle Konditionen");
    MenueItem ("First/Next TarifKonditionImZeitraum");
    MenueItem ("First/Next WeihnachtsKonditionImZeitraum");
    MenueItem ("First/Next VertragsKonditionImZeitraum");
    MenueItem ("HoleGueltigeTKond");
    MenueItem ("HoleGueltigeWKond");
    MenueItem ("HoleGueltigeVKond");
    MenueItem ("BerechneBrutto");
    MenueItem ("PruefeVKondInZeitr");
    MenueItem ("GibTKondAlsStringlisteInKonden");
    MenueItem ("GibWKondAlsStringlisteInKonden");
    MenueItem ("GibVKondAlsStringlisteInKonden");
    MenueItem ("SaveKonditionen");
    MenueItem ("LoadKonditionen");
    MenueItem ("SaveHIDVerwaltung");
    MenueItem ("LoadHIDVerwaltung");
 
    RETURN IhreWahl()
  END Auswahlmenue;


  PROCEDURE InitTestProcs;
  VAR ProcNr : CARDINAL;

     PROCEDURE ProcEintragen(inOperation : PROC);
     BEGIN
       TestProcs [ProcNr] := inOperation;
       INC (ProcNr)
     END ProcEintragen;     

  BEGIN
    ProcNr := 0;
    ProcEintragen (Programmende);
    ProcEintragen (CreateTarifKondition);
    ProcEintragen (CreateWeihnachtsKondition);
    ProcEintragen (CreateVertragsKondition);
    ProcEintragen (InsertTKond);
    ProcEintragen (InsertWKond);
    ProcEintragen (InsertVKond);
    ProcEintragen (KondenAusgeben);
    ProcEintragen (TarifKondImZeitraum);
    ProcEintragen (WeihnachtsKondImZeitraum);
    ProcEintragen (VertragsKondImZeitraum);
    ProcEintragen (HoleGueltigeTKond);
    ProcEintragen (HoleGueltigeWKond);
    ProcEintragen (HoleGueltigeVKond);
    ProcEintragen (BerechneBrutto);
    ProcEintragen (PruefeVKondInZeitr);
    ProcEintragen (GibTKondAlsStringlisteInKonden);
    ProcEintragen (GibWKondAlsStringlisteInKonden);
    ProcEintragen (GibVKondAlsStringlisteInKonden);
    ProcEintragen (Save);
    ProcEintragen (Load);
    ProcEintragen (SaveHIDVerwaltung);
    ProcEintragen (LoadHIDVerwaltung);

    MaxProcNr := ProcNr;
  END InitTestProcs;

PROCEDURE BefehlAuswerten(inBefehl : CARDINAL);
BEGIN

    IF inBefehl < MaxProcNr THEN
      TestProcs [inBefehl];
    ELSE
      WriteString("Dies war eine falsche Eingabe.");
      WriteLn;
    END; (* IF *)
 END BefehlAuswerten;

PROCEDURE Programmende;
BEGIN
   WriteString("Programmende!");
   WriteLn
END Programmende;

PROCEDURE IhreWahl() : CARDINAL;
VAR outEingabe : CARDINAL;
BEGIN
   WriteString("Befehl Nr.: ");
   ReadCard(outEingabe);
   WriteLn;
   RETURN outEingabe
END IhreWahl;

PROCEDURE StringAusgeben (inStr : String.TString);
   VAR Test : ARRAY[1..50] OF CHAR;
BEGIN
   WriteString("[");
   String.Lies (inStr, Test);
   WriteString(Test);
   WriteString("]");
   WriteLn;
END StringAusgeben;

PROCEDURE StringEingeben (frage: ARRAY OF CHAR; inoutStr : String.TString);
VAR Wert : ARRAY [0..50] OF CHAR;
BEGIN
   WriteString(frage);
   ReadString(Wert);
   String.Schreibe (inoutStr, Wert);
   WriteLn;
END StringEingeben;

BEGIN
  InitTestProcs;
  REPEAT
      Befehl := Auswahlmenue();
      BefehlAuswerten (Befehl);
  UNTIL Befehl = 0;
END KondenTest.
