


(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: PSB.mod,v $
# $Author: Sopra $ Gabi
# $Date: 2001/03/15 09:45:30 $
# $Revision: 1.20 $
Bemerkungen: 

*)
(******************************************************************************)
IMPLEMENTATION MODULE PSB;

FROM PSBIMPORTE	IMPORT 	

			BLiesKstIDinBu, BSetzeKstIDinBu, BInsertBu, BCreateBu,	(* Buen *)
			BSetzeBetraginBu, BSetzeBuchungsArtinBu, BStorniereBuZuVtr, BSetzeVtrIDinBu,
			BSetzeGebuchtAminBu,

			KExistKst, KInsertKst, KIstLiquidiertAminKst,     	(* Ksten *)
			KSetzeKIDinKst, KLiesKIDinKst, KAendernKst,
			KIstGesperrtAminKst, KSetzeGesperrtAminKst,
			KSearchKstZuKID, KKstIDAlsString,

			KLiesGueltVoninKond, KLoescheWKondVorZeitp,          	(* Konden *)
			KLoescheVKondVorZeitp, KLoescheTKondVorZeitp,
			KBerechneBrutto,

			SLiesSystemDatumInSysDat,SSetzeSystemDatumInSysDat,     (* SysDat *)

			VLiesKstIDinVtr, VFirstVtrAbDatum, VNextVtrAbDatum,  	(* VTRE *)
			VVtrIDAlsString, VLiesVtrIDinVtr,
			VLiesGueltigVoninVtr, VLiesGueltigBisinVtr, VLiesStdzahlinVtr,
			VExistVtr,

			HBerRestEtatDerKst, HGehaltBuZurueck,         	(* HKB *)

      			DLiefereDatumEternity, DSmallerDatum;                                 (* Datum *)

FROM String 	IMPORT	Schreibe, Create, Dispose, Anhaengen, TString, Lies;
FROM Datum 	IMPORT	CreateDatum, DisposeDatum, TDatum, TMonat, TJahr, TTag,TStag, DatumAlsString, CreateStag,SetzeTagInStag, SetzeMonatInStag,LiesTagInDatum, LiesJahrInDatum, LiesMonatInDatum, SmallerStag,  LiesJahrInDatum, SmallerJahr;
FROM Ksten	IMPORT  TKstID, TKst, LiesJahrinKst;
FROM Vtre	IMPORT  TVtr, TVtrID,LiesPersIDinVtr, TPersID, BerMaxStdZahlDerHK;
FROM Buen	IMPORT  TBu, TBuArt, (* test*)  TBuID, LiesBuIDBu,BuIDAlsString; (*test*)
FROM Konden	IMPORT	TKond, LiesSTaginWKond, HoleGueltigeWKond,LiesGueltVoninKond, LiesBHDinVKond,LiesSOGinVKond;
FROM VDruck	IMPORT 	Print;
FROM InOut 	IMPORT 	WriteString, WriteLn, WriteInt;
FROM SysDat 	IMPORT 	LiesLetztesAutoDatumInSysDat;
FROM HKB	IMPORT  AnzBMonateDerHK;


(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

PROCEDURE BuildOutMessage(inMA1: ARRAY OF CHAR; kstID: TKstID; inMA3: ARRAY OF CHAR;
			  vtr: TVtr; inMA5: ARRAY OF CHAR; VAR outM: TString);
(*
lokale Funktion
Setzt die Fehlermeldung outM aus den bergebenen ARRAYS OF CHAR, bzw. Typen zusammen,
*)
VAR	inM, kstIDString, vtrIDString : TString;
BEGIN
	inM := Create();
	kstIDString := KKstIDAlsString(kstID);			
	vtrIDString := VVtrIDAlsString(VLiesVtrIDinVtr(vtr));
	
	Schreibe(inM, inMA1);	(* Array of Char in String umwandeln*)
        Anhaengen(inM, outM); 		
	Anhaengen(kstIDString, outM);	(*String anhngen*)	

	Schreibe(inM, inMA3);
        Anhaengen(inM, outM);	
	Anhaengen(vtrIDString, outM);	

       	Schreibe(inM, inMA5);
	Anhaengen(inM, outM);		

	Dispose(inM);
	RETURN;
END BuildOutMessage;
(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

PROCEDURE GuelVonGroeHeute(inGueltigVon: TDatum; VAR outMessage: TString):BOOLEAN;
(*
lokale Funktion
Prft, ob das eingegebene Datum > Heute-Datum ist, wenn ja TRUE zurck, sonst FALSE
*)
VAR	dat : TDatum;
	rc : BOOLEAN;
BEGIN
	rc := FALSE;
	dat := SLiesSystemDatumInSysDat();
	IF  NOT DSmallerDatum(dat, inGueltigVon) THEN (* Guelvon <, dann Fehler*)
	        outMessage := Create();
		Schreibe(outMessage, "GueltigVon-Datum muss grer dem aktuellen Systemdatum sein.");
		rc := FALSE ;
	ELSE
		rc := TRUE;
	END; (*IF*)
	
	
	RETURN rc;
END GuelVonGroeHeute;
(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)


PROCEDURE SearchKstZuVtr(vtr: TVtr; VAR outKst: TKst; VAR outMessage: TString): BOOLEAN;
(*
lokale Funktion
Sucht zur KostenstellenID in einem Vertrag die Daten der Kostenstelle und gibt diese in
outKst zurck, im Fehlerfall wird outMessage gefllt.
*)
VAR rc 		: BOOLEAN;				(* rc = Returncode der Funktion*)
    kstID	: TKstID;
    kstIDString, vtrIDString : TString;
BEGIN
	rc := FALSE;					(* Initialisierung*)

   	kstID := VLiesKstIDinVtr(vtr);	
                                                        (* Kostenstellen zur KstID suchen und Ergebnis prfen*)
	IF NOT KSearchKstZuKID(kstID, outKst) THEN 	(* Kst existiert nicht, Fehlermeldung zusammensetzen*)
		outMessage := Create();
               	BuildOutMessage("SearchKstZuVtr: Kostenstelle mit KstID: ", VLiesKstIDinVtr(vtr),
				" zum Vertrag mit VertragsID: ", vtr,
				" nicht gefunden.", outMessage);	(* outMessage zusammensetzen*)
		rc := FALSE;
	ELSE     		(* gefundene Kst steht in outKst*)
		rc := TRUE;
	END; (*IF*)
	RETURN rc;
END SearchKstZuVtr;
(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)


PROCEDURE KstExistUndNichtLiquidiert(inKst: TKst; VAR outMessage: TString):BOOLEAN;
(*
lokale Funktion
Prft, ob eine Kst existiert und nicht liquidiert und nicht gesperrt ist, wenn eine der Bedingungen verletzt wird,
wird eine Fehlermeldung zurckgegeben.
*)
VAR rc 		: BOOLEAN;		(* rc = Returncode der Funktion*)
    outKst	: TKst;
BEGIN
	rc := FALSE;					(* Initialisierung*)

	(* Prfen, ob Kst existiert*)
							(* Kst existiert nicht*)
	IF NOT KSearchKstZuKID(KLiesKIDinKst(inKst), outKst) THEN (* outKst wird nicht bentigt*)
		outMessage := Create();
		Schreibe(outMessage, "KstExistUndNichtLiquidiert: Kostenstelle existiert nicht.");
		rc := FALSE ;
	ELSE
        	(* Prfen, ob Kst liquidiert ist*)
		IF KIstLiquidiertAminKst(inKst) THEN	(* Kst ist liquidiert *)
			outMessage := Create();
			Schreibe(outMessage, "KstExistUndNichtLiquidiert: Kostenstelle ist liquidiert.");
			rc := FALSE;
(* *)
                (* Prfen, ob Kst gesperrt ist*)
		ELSE IF KIstGesperrtAminKst(inKst) THEN	(* Kst ist gesperrt *)
			outMessage := Create();
			Schreibe(outMessage, "KstExistUndNichtLiquidiert: Kostenstelle ist gesperrt.");
			rc := FALSE;
(* *)			
		     ELSE			(*Kst existiert und Kst ist nicht liquidiert*)
				rc := TRUE;
		     END; (*IF Kstenstelle gesperrt*)		
	      	END; (*IF KIstLiquidiertAminKst(inKst)*)
	END; (*IF NOT KExistKst(inKst)*)
	RETURN rc;	
END KstExistUndNichtLiquidiert;

(******************************************************************************)

PROCEDURE EinrichtenKst (inKst: TKst; VAR outMessage: TString): BOOLEAN;
(*
Die Fkt erwartet ein ADO TKst d.h.inkl. der eingegebenen Werte,
prft, ob die Kst. bereits existiert, wenn nicht wird die neue Kst im KstenOrdner eingefgt.
Existiert die Kst bereits, wird eine Fehlermeldung zurckgegeben
wird versucht, eine kst mit Jahr < aktuellem Jahr einzugeben, wird Fehlermeldung ausgegeben.
*)
VAR rc : 	BOOLEAN;					(* rc = Returncode der Funktion*)
    dat : TDatum;
    jahrkst, aktjahr : TJahr;
BEGIN
	rc := FALSE;						(* Initialisierung *)
	
	(*Prfen, ob Einrichtungsjahr der Kst >= aktuellem Jahr, nur dann kann man eine Kst anlegen.*)
	
	jahrkst := LiesJahrinKst(inKst);
	aktjahr := LiesJahrInDatum(SLiesSystemDatumInSysDat());
	
	IF SmallerJahr(jahrkst, aktjahr) THEN
	    	(*Fehler*)
	    	outMessage := Create();
		Schreibe(outMessage, "Ksten knnen nur fr das aktuelle Jahr oder Folgejahre angelegt werden.");
	    	rc := FALSE;
	    	RETURN rc;
	END; (*IF*)
		
	IF KInsertKst(inKst, outMessage) THEN 	(* Fehler beim Einrichten der Kst *)
                	rc := TRUE;		(* Fehlermessage wird in KInsertKst gesetzt *)
	ELSE					(* Kst wurde eingerichtet*)
	               	rc := FALSE;
	END; (*IF*)
	
	RETURN rc;
END EinrichtenKst;(* EinrichtenKst*)


(******************************************************************************)


PROCEDURE BearbeitenBuchenKst (inBu: TBu; inKst: TKst; VAR outMessage: TString): BOOLEAN;
(*
Fkt. erwartet ein ADO der Typen TKst und TBu,
prft, ob die Kst existiert und noch nicht liquidiert ist
und dann fgt die eingegebene Buchung zur eingegebenen Kst im Buchungsordner ein,
im Fehlerfall wird outMessage zurckgegeben.
*)
VAR rc 		: BOOLEAN;				(* rc = Returncode der Funktion*)
VAR KID 	: TKstID;
BEGIN
        rc := FALSE;					(* Initialisierung *)

	(* Prfen, ob Kst existiert und nicht liquidiert ist*)
	IF KstExistUndNichtLiquidiert(inKst, outMessage) THEN
(*testen*)        	
        	WriteString("BearbeitenBuchenKst: kst ex, nicht liqiduert, nicht gesperrt.");	WriteLn();
(*ende test*)

		BSetzeKstIDinBu(inBu,KLiesKIDinKst(inKst)); (* setzt KstID in Buchung gleich der
								KstID in Kst*)
		(*GebuchtAm setzen*)
		BSetzeGebuchtAminBu(inBu,SLiesSystemDatumInSysDat());								
       	 	rc := BInsertBu(inBu, outMessage);
	ELSE
(*testen*)        	
        	WriteString("BearbeitenBuchenKst: kst ex nicht, ist liqiduert oder gesperrt.");	WriteLn();
(*ende test*)		
		
		rc := FALSE;		(* weil Kst. nicht existiert oder liquidiert ist*)
	END; (*IF*)
	RETURN rc;	
END BearbeitenBuchenKst;
(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)


PROCEDURE BearbeitenAendernKst (inKst: TKst; VAR outMessage: TString): BOOLEAN;
(*
Die Fkt erwartet einen kompletten Typ TKst,
prft, ob die Kst existiert und nicht liquidiert ist
und gibt dann den Typ TKst zur berschreibung der nderungen an den Ordner Kst weiter.
Im Fehlerfall wird outMessage gesetzt.
*)
VAR rc 		: BOOLEAN;				(* rc = Returncode der Funktion*)
BEGIN
        rc := FALSE; 					(* Initialisierung *)

	IF KstExistUndNichtLiquidiert(inKst, outMessage) THEN      (*KS existiert und KS ist nicht liquidiert*)
              	rc:= KAendernKst(inKst, outMessage); 	(* outMessage wird in KAendernKst gesetzt*)
	ELSE	(* Kostenstelle existiert noch nicht oder ist liquidiert*)
		rc := FALSE; (* outMessage wird in KstExistUndNichtLiquidiert gesetzt *)
	END; (*IF*)
	RETURN rc;
END BearbeitenAendernKst;
(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)


PROCEDURE TKondGeprueftEinf (inTKond: TKond; VAR outMessage: TString): BOOLEAN;
(*
Die Fkt erwartet ein ADO TKond (gefllt mit den eingegebenen Werten) und
fhrt damit D 3.3.3 (Tarifkondition geprft einfgen) aus, dh. alle spteren Konditionen
werden gelscht und ein neues Ende des letzten Kondition gesetzt. Fr alle laufenden oder
offenen Vertrge wird anhand der zugehrigen Kst die entsprechende Tarifkondition ermittelt,
der Buchungsbetrag berechnet und gebucht.
Mgliche Fehler: berzogene Kst, gesperrte oder liquidierte Kst, dann wird outMessage gesetzt
*)
VAR rc, rcM,exist, weiter, ok	: BOOLEAN;			(* rc = Returncode, dass kein Fehler aufgetreten*)
    inGueltigVon 	: TDatum;                               (* rcM = Returncode, ok erg.txt gefllt von Problemfllen, rcM = FALSE  = Problem aufgetreten*)
    kst			: TKst;
    vtr			: TVtr;
    vtrID		: TVtrID;	
    bu			: TBu;
    betrag, rest	: INTEGER;
    buArt 		: TBuArt;
    stri		: TString;

    buID : TBuID;
    stArray: ARRAY [0..255] OF CHAR;
    str : TString;
    dat : TDatum;

BEGIN
        rc 	:= FALSE; 				(* Initialisierung *)
        weiter 	:= TRUE;				(* zum Beenden der While-Schleife im Fehlerfall*)
        rcM	:= TRUE;				(* wenn Probleme bei Kst aufgetreten, zb. berbucht....*)

	inGueltigVon := KLiesGueltVoninKond(inTKond);	(* Gueltigkeitsdatum der Kondition auslesen*) 	
	
	(* Prfen, ob das eingegebene Gltigkeitsdatum > Heute-Datum*)
	rc := GuelVonGroeHeute(inGueltigVon, outMessage);
	IF NOT rc THEN
		RETURN rc;
	END; (*IF*)

	
 	(* Alle spteren Konditionen lschen und neues Ende der letzten Kondition setzen*)
        IF KLoescheTKondVorZeitp(inTKond, outMessage) THEN
(*testen*)        	
        	WriteString("TKond: in IF KloeschTKondVorZeitp,lschen der Kond. ok");	WriteLn();
(*ende test*)			

		exist := VFirstVtrAbDatum(inGueltigVon, vtr);      (*prfen, ob es einen offenen Vertrag gibt*)
		IF NOT exist THEN				   (* es gibt keine offenen Vertrge, Fkt.hier schon zu Ende*)
	           rc := TRUE;
(*testen*)        	
        	   WriteString("TKond: in IF NOT exist, Vtr ex. nicht");	WriteLn();
(*ende test*)			
	        END; (*IF*)
	
	        dat := SLiesSystemDatumInSysDat();
		str:= DatumAlsString(dat);
		stri := Create();
	        weiter:= Print(stri, outMessage); (*Leerzeile drucken*)
	        weiter:= Print(str, outMessage);  (* Systemdatum drucken*)
		Schreibe(stri, "Probleme beim Buchen von Tarifkonditionen===========================================================");
	        weiter:= Print(stri, outMessage);		
	        Dispose(stri);
	        	
	
        	WHILE (exist AND weiter) DO			   (* es existiert mindestens ein offener Vertrag *)
(*testen*)        	
        	WriteString("While-Schleife Begin, Vertrge ex.");	WriteLn();
(*ende test*)        	
					      (*und es ist bisher kein Fehler aufgetreten*)	
			IF NOT SearchKstZuVtr(vtr, kst, outMessage) THEN
				rc 	:= FALSE;			(* outMessage wird in SearchKstZuVtr gesetzt*)
				weiter 	:= FALSE;			(* While-Schleife wird beendet*)

(*testen*)        	
        			WriteString("TKond: in IF NOT SearchKstzuVtr, kst. zu Vtr ex nicht.");	WriteLn();
(*ende test*)			
				
				
			ELSE    					
			 	IF KIstGesperrtAminKst(kst) THEN	(* Kst ist gesperrt *)
					stri := Create();
			                BuildOutMessage("Kostenstelle mit KstID: ", KLiesKIDinKst(kst),
							" zum Vertrag mit VertragsID: ", vtr,
							" ist gesperrt.", stri);	(* outMessage zusammensetzen*)
					weiter 	:= Print(stri, outMessage);		
                                	rcM    	:= FALSE;
                                	Dispose(stri);
					(* weiter 	:= TRUE;  vorher FALSE *)

(*testen*)        	
			        	WriteString("TKond: in IF KIstGesperrtAminKst, Kst ist gesperrt.");	WriteLn();
(*ende test*)			
					
				ELSE IF KIstLiquidiertAminKst(kst) THEN  (* Kst ist liquidiert*)
                       			stri 	:= Create();
                                        BuildOutMessage("Kostenstelle mit KstID: ", KLiesKIDinKst(kst),
							" zum Vertrag mit VertragsID: ", vtr,
							" ist liquidiert.", stri);	(* outMessage zusammensetzen*)
					weiter	:= Print(stri, outMessage);
				       	rcM 	:= FALSE;
				       	Dispose(stri);
					
(*testen*)        	
			        	WriteString("TKond: in IF KIstLiquidiertAminKst, Kst ist liquidiert");	WriteLn();
(*ende test*)			

			
					
				  ELSE  	(* Kst nicht gesperrt und nicht liquidiert*)
				
                                        rc 	:= TRUE;

					vtrID 	:= VLiesVtrIDinVtr(vtr);
				(*	str:= BuIDAlsString(ID);
					Lies(str, stArray);
					WriteString("Vtr ID");
					WriteString(stArray);	WriteLn(); *)
					
                                (*      IF NOT BStorniereBuZuVtr (vtrID, outMessage) THEN  *)
                                      								(* Gehaltsbuchung zum Vertrag stornieren*)

                                       (* VExistVtr(inVtr: TVtr; VAR outMessage: TString)*)

                                       (* IF NOT HGehaltBuZurueck(vtr, outMessage) THEN           darf nur aufgerufen werden, wenn Vertrag existiert*)
                                                                              	(*FEHler*)
                                    (*   IF NOT HGehaltBuZurueck(vtr, outMessage) THEN   *) (*hier wrden Gegenbuchungen gemacht*)

                                      	IF NOT BStorniereBuZuVtr (vtrID, outMessage) THEN       (* nur Stornodatum setzen*)
                                      									
						rc 	:= FALSE;                     		(*Fehler beim Stornieren der Buchungen*)
						weiter 	:= FALSE;
(*testen*)        	
        					WriteString("TKond: IF Not HGehaltBuZurueck, Fehler bei Stornieren der Buchung");	WriteLn();
        					
(*ende test*)								
				        ELSE    (*  Gueltige Kondition(en) ermitteln und dazu Buchungsbetrag berechnen*)
				
(*testen*)        	
        					WriteString("TKond: keine Fehler bei Storn. dh. Betrag berechnen und buchen");	WriteLn();
(*ende test*)				
									
					        betrag:=VLiesStdzahlinVtr(vtr);
					        WriteString("Stundenzahl im Vertrag ");
						WriteInt(betrag,10);	WriteLn();
						
					  	dat := VLiesGueltigVoninVtr(vtr);
					  	WriteString("GuelVon vom Vertrag ");
					  	str:= DatumAlsString(dat);
						Lies(str, stArray);
						WriteString(stArray);	WriteLn();

						dat := VLiesGueltigBisinVtr(vtr);
					  	WriteString("GuelBis vom Vertrag ");
					  	str:= DatumAlsString(dat);
						Lies(str, stArray);
						WriteString(stArray);	WriteLn();				  	
					  	
					
	             				betrag:= KBerechneBrutto(VLiesGueltigVoninVtr(vtr),VLiesGueltigBisinVtr(vtr),VLiesStdzahlinVtr(vtr));
 				    		
	             										 					
						WriteString("Berechneter BruttoBetrag ");
						WriteInt(betrag,10);	WriteLn();

	             										                                                         	
                       				bu:= BCreateBu();                       (* neue Buchung kreieren*)
						BSetzeBetraginBu(bu, betrag);		(* Buchungsbetrag in neuer Buchung setzen*)

        	        		        buArt := Gehalt;
						BSetzeBuchungsArtinBu(bu, buArt);    	(* Buchungsart in Buchung auf "Gehalt" setzen*)
						
						(* KstID setzen*)
						BSetzeKstIDinBu(bu, KLiesKIDinKst(kst));

						(* VtrID setzen*)
						BSetzeVtrIDinBu(bu, VLiesVtrIDinVtr(vtr));
						
						(*GebuchtAm setzen*)
						BSetzeGebuchtAminBu(bu,SLiesSystemDatumInSysDat());
						
						(*BGehaltBuZurueck(inVtr : TVtr; VAR outMsg : TString) : BOOLEAN;*)
											
						IF NOT BInsertBu(bu, outMessage) THEN  (* Fehler beim Einfgen in Lager Buchungen, outMessage wird in Insert gesetzt*)
						        WriteString(" Insert Buchung not ok");	WriteLn();
							rc  	:= FALSE;	
							weiter 	:= FALSE;
				
						ELSE    	(*KostenstellenEtats berechnen, aus HKB *)
						
						        WriteString("Insert Buchung ok");	WriteLn();
						        							
	        	              			rest:= HBerRestEtatDerKst(KLiesKIDinKst(kst));
	        	              			
	        	              									 					
							WriteString("Berechneter Rest Etat ");
							WriteInt(rest,10);	WriteLn();

							IF rest < 0 THEN		(* Fehler, Vertrag und berzogene Kst melden *)
								rcM 	:= FALSE;
								stri  := Create();
								BuildOutMessage("Kostenstelle mit KstID: ", KLiesKIDinKst(kst),
										" zum Vertrag mit VertragsID: ", vtr,
										" ist ueberzogen.", stri);	(* outMessage zusammensetzen*)	
								weiter 	:= Print(stri, outMessage);		
								Dispose(stri);				
													
							END; (* IF rest < 0*) 	
(*testen*)        	
        						WriteString("Ende IF NOT BInsertBu");	WriteLn();
(*ende test*)										
			                        END; (* IF NOT BInsertBu(bu, outMessage)*)

					
(*Testen*)        	
        				   	WriteString("Ende IF NOT BStorniereBuZuVtr");	WriteLn();
(*ende test*)						
					END; (* IF NOT BStorniereBuZuVtr (vtrID, outMessage)*)
(*testen*)        	


        				WriteString("Ende IF KIstGesperrtAminKst");	WriteLn();
(*ende test*)						
                                  END; (* IF KIstGesperrtAminKst(kst)*)
(*testen*)        	
        			WriteString("Ende IF KIstLiquidiertAminKst");	WriteLn();
(*ende test*)	
				END; (*	IF KIstLiquidiertAminKst(kst)*)
(*testen*)        	
        		WriteString("Ende IF Not SearchKstZuVtr");	WriteLn();
(*ende test*)					
			END; (* IF NOT SearchKstZuVtr(vtr, kst, outMessage)*)
	 		exist := VNextVtrAbDatum(inGueltigVon, vtr);	(*nchsten Vertrag holen*)
(*testen*)        	
        		WriteString("Ende while");	WriteLn();
(*ende test*)		 		
		END; (*while*)
       	ELSE
		rc := FALSE;	(* Fehler beim Lschen der vorhergehenden Konditionen*)
	END; (* IF KLoescheTKondVorZeitp(inGueltigVon,outMessage)*)
	IF NOT rcM THEN (* Problem mit Ksten aufgetreten*)
		outMessage := Create();
		Schreibe(outMessage, "Problemflle beim Buchen, bitte in Datei erg.txt nachschauen!");
		RETURN rcM;
	ELSE		
		stri := Create();
	        Schreibe(stri, "keine Probleme ");
	        weiter:= Print(stri, outMessage);		
	        Dispose(stri);
		RETURN rc;
	END; (*IF*)	
END TKondGeprueftEinf;
(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)


PROCEDURE WKondGeprueftEinf (inWKond: TKond; VAR outMessage: TString): BOOLEAN ;
(*
Die Fkt erwartet ein ADO TKond (gefllt mit den eingegebenen Werten) und
fhrt damit D 3.3.1 (Weihnachtsgeldkondition geprft einfgen) aus, dh. alle
 spteren Konditionen werden gelscht und ein neues Ende des letzten Kondition gesetzt.
*)
VAR rc, rc1, OK	: BOOLEAN;			(* rc = Returncode, dass kein Fehler aufgetreten*)
    inGueltigVon, aktGuelVon, dat : TDatum;
    stichtagauto, stichtagWK : TStag;
    stag : TTag;
    smonat :TMonat;
    jahrWK, jahrakt : TJahr;
    str : TString;
    stArray: ARRAY [0..255] OF CHAR;
    aktWKond : TKond;

BEGIN
  	rc 	:= FALSE; 				(* Initialisierung *)
	inGueltigVon := KLiesGueltVoninKond(inWKond);	(* Gueltigkeitsdatum der Kondition auslesen*) 	
  		  	
  	(* Prfen, ob das eingegebene Gltigkeitsdatum > Heute-Datum*)
	rc1 := GuelVonGroeHeute(inGueltigVon, outMessage);
	IF NOT rc1 THEN
		RETURN rc1;
	END; (*IF*)
	
	(*Prfen, ob der Stichtag vom letzten Auto-Datum >= dem jetzt noch aktuell gltigen Stichtag ist*)
	(* wenn ja, dann Meldung ausgeben, dass das Datum auf 01.01.Jahr+1 gesetzt wird, dann gilt die Weihnachtskondition ab dem Folgejahr, *)
	(* da die Weihnachtsbuchung fr das aktuelle Jahr bereits abgeschlossen ist *)

	dat	:= LiesLetztesAutoDatumInSysDat();
	
	stag 	:= LiesTagInDatum(dat);
        smonat 	:= LiesMonatInDatum(dat);

        stichtagauto:= CreateStag();
        SetzeTagInStag(stichtagauto, stag);
        SetzeMonatInStag(stichtagauto, smonat);

        dat := SLiesSystemDatumInSysDat();
	OK := HoleGueltigeWKond(dat,aktWKond);
	
	IF OK THEN	(* es ist bereits eine WK vorhanden, dann knnen weitere Prfungen durchgefhrt werden *)
		
	  stichtagWK := LiesSTaginWKond(aktWKond);
		
	  IF SmallerStag(stichtagWK, stichtagauto) THEN
		
		jahrakt := LiesJahrInDatum(dat);
	        aktGuelVon:= LiesGueltVoninKond(aktWKond);
	        jahrWK := LiesJahrInDatum(inGueltigVon);
	
	  	
		IF NOT SmallerJahr(jahrakt, jahrWK) THEN
		        		
			(* Meldung, dass Guelvon von WK auf 01.01. des Folgejahres gesetzt werden muss*)
			rc := FALSE;
		        outMessage := Create();
			Schreibe(outMessage, "Gueltig-Ab bitte auf 01.01.des Folgejahres setzen, da die Weihnachtsgeldbuchungen bereits durchgefhrt wurden.");
			(*RETURN rc;*)
		ELSE
			IF KLoescheWKondVorZeitp(inWKond, outMessage) THEN
        			rc := TRUE;
			END; (* IF KLoescheWKondVorZeitp(inGueltigVon,outMessage)*)
		END; (*IF NOT SmallerJahr(jahrakt, jahrWK)*)	
	  END; (*IF SmallerStag(stichtagWK, stichtagauto)*)


        ELSE    (*es ist noch keine Weihnachtsgeldkondition vorhanden, die neue wird ohne Prfungen auf Autobetrieb aufgenommen*)

		(* Alle spteren Konditionen lschen und neues Ende der letzten Kondition setzen - *)
		IF KLoescheWKondVorZeitp(inWKond, outMessage) THEN
        		rc := TRUE;
		END; (* IF KLoescheWKondVorZeitp(inGueltigVon,outMessage)*)
	
	END; (*IF OK THEN*)
	
	RETURN rc;
	
	
END WKondGeprueftEinf;
(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)


PROCEDURE VKondGeprueftEinf (inVKond: TKond; VAR outMessage: TString): BOOLEAN;
(*
Die Fkt erwartet ein ADO TKond (gefllt mit den eingegebenen Werten) und
fhrt damit D 3.3.2 (Vertragskondition geprft einfgen) aus, dh. alle spteren Konditionen
werden gelscht und ein neues Ende des letzten Kondition gesetzt.
Fr alle laufenden oder offenen Vertrge wird geprft, ob Kst berzogen, gesperrt oder liquidiert ist.
Mgliche Fehler: berzogene Kst, gesperrte oder liquidierte Kst.
*)
VAR rc,rc1, rcM, exist, weiter	: BOOLEAN;			(* rc = Returncode der Funktion*)
    inGueltigVon, dat 	: TDatum;                               (* rcM als Merker, ob Probleme aufgetreten sind*)
    kst			: TKst;
    vtr			: TVtr;
    vtrID		: TVtrID;	
    bu			: TBu;
    betrag, rest	: INTEGER;
    stri, str		: TString;
    buArt		: TBuArt;
    neuBHD, altBHD, anzMo, sogneu, sogalt	: CARDINAL;
    persid	: TPersID;



 stArray: ARRAY [0..255] OF CHAR;


BEGIN
        rc 	:= FALSE; 				(* Initialisierung *)
        weiter 	:= TRUE;  				(* zum Beenden der While-Schleife im Fehlerfall*)
        rcM	:= TRUE;				(* wenn Probleme bei Kst aufgetreten etc, dann erg.txt gefllt. *)

	inGueltigVon := KLiesGueltVoninKond(inVKond);	(* Gueltigkeitsdatum der Kondition auslesen*) 	
	
	(* Prfen, ob das eingegebene Gltigkeitsdatum > Heute-Datum*)
	rc1 := GuelVonGroeHeute(inGueltigVon, outMessage);
	IF NOT rc1 THEN
		RETURN rc1;
	END; (*IF*)

	(* Prfen, ob durch neue Vertragskondition die Beschftigungshchstdauer einer Hilfskraft berzogen wird, dann
	keine neuen VK anlegen *)
	
	

        exist := VFirstVtrAbDatum(inGueltigVon, vtr);             (* prfen, ob es einen offenen Vertrag gibt*)
        IF NOT exist THEN					(* es gibt keine offenen Vertrge, Fkt.hier schon zu Ende*)
           rc := TRUE;
        END; (*IF*)
	
       	WHILE (exist AND weiter) DO			   (* es existiert mindestens ein offener Vertrag
							      und es ist bisher kein Fehler aufgetreten*)	
		IF NOT SearchKstZuVtr(vtr, kst, outMessage) THEN
			rc 	:= FALSE;			(* outMessage wird in SearchKstZuVtr gesetzt*)
			weiter 	:= FALSE;			(* While-Schleife wird beendet*)
		ELSE    					
			persid:= LiesPersIDinVtr(vtr); 	
		        altBHD := AnzBMonateDerHK(persid);
		        neuBHD := LiesBHDinVKond(inVKond);
		        IF neuBHD < altBHD THEN
		        	(*Fehler*)
		        	outMessage := Create();
				Schreibe(outMessage, "berschreitung der BHD, Vertragskondition kann nicht angelegt werden.");
		        	RETURN FALSE;
		        END; (*IF*)
		        (*Prfen, ob Stundenobergrenze berschritten ist*)	
		        sogneu :=  LiesSOGinVKond(inVKond);
		        sogalt := BerMaxStdZahlDerHK(vtr);
		        IF sogneu < sogalt THEN
		        	(*Fehler*)
		        	outMessage := Create();
				Schreibe(outMessage, "berschreitung der Stundenobergrenze, Vertragskondition kann nicht angelegt werden.");
		        	RETURN FALSE;
		        END; (*IF*)
					
		END; (* IF NOT SearchKstZuVtr(vtr, kst, outMessage)*)
 		exist := VNextVtrAbDatum(inGueltigVon, vtr);	(*nchsten Vertrag holen *)
 	END; (*while*)	
	 		
(*-----------------------------------------------------------------*)	 	
	 weiter := TRUE;
	 rc := FALSE;	
 	(* Alle spteren Konditionen lschen und neues Ende der letzten Kondition setzen*)
	IF KLoescheVKondVorZeitp(inVKond, outMessage) THEN
		
	        exist := VFirstVtrAbDatum(inGueltigVon, vtr);             (* prfen, ob es einen offenen Vertrag gibt*)
	        IF NOT exist THEN					(* es gibt keine offenen Vertrge, Fkt.hier schon zu Ende*)
	           rc := TRUE;
	        END; (*IF*)
	
	
	
        	WHILE (exist AND weiter) DO			   (* es existiert mindestens ein offener Vertrag
								      und es ist bisher kein Fehler aufgetreten*)	
			IF NOT SearchKstZuVtr(vtr, kst, outMessage) THEN
				rc 	:= FALSE;			(* outMessage wird in SearchKstZuVtr gesetzt*)
				weiter 	:= FALSE;			(* While-Schleife wird beendet*)
			ELSE    					
			 	IF KIstGesperrtAminKst(kst) THEN	(* Kst ist gesperrt *)
					stri 	:= Create();
			                BuildOutMessage("Kostenstelle mit KstID: ", KLiesKIDinKst(kst),
							" zum Vertrag mit VertragsID: ", vtr,
							" ist gesperrt.", stri);	(* stri zusammensetzen*)
                                	rcM    	:= FALSE;
					weiter 	:= Print(stri, outMessage);
					Dispose(stri);
				ELSE IF KIstLiquidiertAminKst(kst) THEN  (* Kst ist liquidiert*)
                       			stri 	:= Create();
                                        BuildOutMessage("Kostenstelle mit KstID: ", KLiesKIDinKst(kst),
							" zum Vertrag mit VertragsID: ", vtr,
							" ist liquidiert.", stri);	(* stri zusammensetzen*)
				       	rcM 	:= FALSE;
					weiter 	:= Print(stri, outMessage);
					Dispose(stri);
				  ELSE  	(* Kst nicht gesperrt und nicht liquidiert*)
                                        rc 	:= TRUE;

		
				
	        	              		rest:= HBerRestEtatDerKst(KLiesKIDinKst(kst));
	        	              		
						IF rest < 0 THEN		(* Fehler, Vertrag und berzogene Kst melden *)
							rcM 	:= FALSE;
							stri := Create();
							BuildOutMessage("Kostenstelle mit KstID: ", KLiesKIDinKst(kst),
									" zum Vertrag mit VertragsID: ", vtr,
									" ist ueberzogen.", stri);	(* stri zusammensetzen*)	
							weiter 	:= Print(stri, outMessage);		
							Dispose(stri);
						END; (* IF rest < 0*) 	
					
			
                                  END; (* IF KIstGesperrtAminKst(kst)*)
				END; (*	IF KIstLiquidiertAminKst(kst)*)
			END; (* IF NOT SearchKstZuVtr(vtr, kst, outMessage)*)
	 		exist := VNextVtrAbDatum(inGueltigVon, vtr);	(*nchsten Vertrag holen *)
		END; (*while*)
       	ELSE
		rc := FALSE;	(* Fehler beim Lschen der vorhergehenden Konditionen*)
	END; (* IF KLoescheTKondVorZeitp(inGueltigVon,outMessage)*)
	
	IF NOT rcM THEN (*Probleme bei Ksten aufgerufen*)
	        outMessage := Create();
		Schreibe(outMessage, "Problemflle beim Buchen, bitte in Datei erg.txt nachschauen!");
		RETURN rcM;
	ELSE	
		stri := Create();
	        Schreibe(stri, "keine Probleme ");
	        weiter:= Print(stri, outMessage);		
	        Dispose(stri);
		RETURN rc;
	END; (*IF*)	
END VKondGeprueftEinf;
(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)


PROCEDURE SperrenKst (inoutKst: TKst; VAR outMessage: TString):BOOLEAN;
(*
Die Fkt. sperrt die Kostenstelle, dh. sie setzt GesperrtAm = Heute.
Wenn die Kst. bereits gesperrt war, kommt eine Fehlermeldung zurck, ansonsten TRUE
*)
VAR rc 		: BOOLEAN;				(* rc = Returncode der Funktion*)
(* test*)
    rc1:BOOLEAN;
    teststring : TString;
    AequivalentString: TString;
     AequivalentStr: ARRAY[1..200] OF CHAR;	
(*endtest*)

BEGIN
	rc := FALSE;					(* Initialisierung *)
	
      	IF KIstGesperrtAminKst(inoutKst) THEN
		outMessage := Create();
		Schreibe (outMessage, "SperrenKst: Kostenstelle ist bereits gesperrt.");
		rc := FALSE;
      	ELSE      		(* Kst. kann  gesperrt werden *)
      	
(* testen *)      		

      	        AequivalentString:= DatumAlsString (SLiesSystemDatumInSysDat());
      	        Lies(AequivalentString, AequivalentStr);
    		WriteString("Systemdatum:"); WriteString(AequivalentStr); WriteString(":"); WriteLn;

(* ende test *)      	
         	
         	KSetzeGesperrtAminKst(inoutKst, SLiesSystemDatumInSysDat());
         	rc1:=KAendernKst(inoutKst, outMessage);
(* test *)         	
         	WriteString("Sperren nachher.");	WriteLn();
(* ende test*)
         	
		rc := TRUE
      	END; (*IF*)
      	RETURN rc;
END SperrenKst;(* SperrenKst*)


(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)


PROCEDURE EntsperrenKst (inoutKst: TKst; VAR outMessage :TString):BOOLEAN;
(*
Die Fkt. entsperrt eine gesperrte Kst, dh. sie setzt GesperrtAM =
UNDEF und gibt TRUE zurck, wenn das geklappt hat. Sie gibt FALSE zurck, wenn
die Kst. bereits entsperrt war
*)
VAR rc, rc1 		: BOOLEAN;				(* rc = Returncode der Funktion*)
    datum	: TDatum;
BEGIN
	rc := FALSE;					(* Initialisierung *)
	
	IF NOT KIstGesperrtAminKst(inoutKst) THEN
		outMessage := Create();
		Schreibe (outMessage, "EntsperrenKst: Kostenstelle ist nicht gesperrt.");
		rc := FALSE;
	ELSE      	(* Kst. kann  entsperrt werden *)
		datum := CreateDatum();
                DLiefereDatumEternity(datum);			(* datum = UNDEF setzen *)
           	KSetzeGesperrtAminKst(inoutKst, datum);		(* Kst. entsperren *)
           	
           	rc1:=KAendernKst(inoutKst, outMessage);
           	
		DisposeDatum(datum);
	   	rc := TRUE;
      	END; (*IF*)
	RETURN rc;
END EntsperrenKst; (*EntsperrenKst*)

END PSB.