
(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: PSBIMPORTE.mod,v $
# $Author: Sopra $ Gabi
# $Date: 2001/03/13 18:32:11 $
# $Revision: 1.7 $
Bemerkungen: 


*)
(******************************************************************************)
IMPLEMENTATION MODULE PSBIMPORTE;

(* Modul zur Bndelung der Importe des TS_PSB *)


IMPORT Datum;
IMPORT Buen;
IMPORT String;
IMPORT Vtre;
IMPORT Ksten;
IMPORT Konden;
IMPORT HKB;
IMPORT SysDat;


(****************************************************
        IMPORTE aus TS HKB
*****************************************************)

PROCEDURE HBerRestEtatDerKst(inKstID: TKstID): INTEGER;
BEGIN
    RETURN HKB.BerRestEtatDerKst(inKstID);
END HBerRestEtatDerKst;

PROCEDURE HGehaltBuZurueck(inVtr : TVtr; VAR outMsg : TString) : BOOLEAN;
BEGIN
	RETURN HKB.GehaltBuZurueck(inVtr,outMsg);
END HGehaltBuZurueck;

(****************************************************
        IMPORTE aus TS HKe
*****************************************************)                     
 (****************************************************
        IMPORTE aus TS Vtre
*****************************************************)

PROCEDURE VLiesKstIDinVtr(inVtr:TVtr):TKstID;
BEGIN
	RETURN Vtre.LiesKstIDinVtr(inVtr);
END VLiesKstIDinVtr;

PROCEDURE VVtrIDAlsString(inVtrID: TVtrID):TString;
BEGIN
	 RETURN Vtre.VtrIDAlsString(inVtrID);
END VVtrIDAlsString;

PROCEDURE VLiesVtrIDinVtr(inVtr: TVtr): TVtrID;
BEGIN
	RETURN Vtre.LiesVtrIDinVtr (inVtr);
END VLiesVtrIDinVtr;

PROCEDURE VFirstVtrAbDatum(inGueltigVon: TDatum; VAR outVtr: TVtr): BOOLEAN;
BEGIN
        RETURN Vtre.FirstVldVtrAbDatum(inGueltigVon, outVtr);
END VFirstVtrAbDatum;

PROCEDURE VNextVtrAbDatum(inGueltigVon: TDatum; inoutVtr: TVtr): BOOLEAN;
BEGIN
        RETURN Vtre.NextVldVtrAbDatum(inGueltigVon, inoutVtr);
END VNextVtrAbDatum;

PROCEDURE VLiesGueltigVoninVtr(inVtr: TVtr): TDatum;
BEGIN
	RETURN Vtre.LiesGueltigVoninVtr(inVtr);
END VLiesGueltigVoninVtr;

PROCEDURE VLiesGueltigBisinVtr(inVtr: TVtr): TDatum;
BEGIN
   	RETURN Vtre.LiesGueltigBisinVtr(inVtr);
END VLiesGueltigBisinVtr;

PROCEDURE VLiesStdzahlinVtr(inVtr: TVtr): CARDINAL;
BEGIN
       	RETURN Vtre.LiesStdzahlinVtr(inVtr);
END VLiesStdzahlinVtr;

PROCEDURE VExistVtr(inVtr: TVtr; VAR outMessage: TString): BOOLEAN;
BEGIN
	RETURN Vtre.ExistVtr(inVtr, outMessage);
END VExistVtr;

(****************************************************
        IMPORTE aus TS Ksten
*****************************************************)

PROCEDURE KLiesKIDinKst(inKst: TKst): TKstID;
BEGIN
    RETURN Ksten.LiesKIDinKst(inKst);
END KLiesKIDinKst ;

PROCEDURE KSetzeKIDinKst(inK: TKstID; inoutKst: TKst);
BEGIN
    Ksten.SetzeKIDinKst(inK, inoutKst);
END KSetzeKIDinKst;

PROCEDURE KInsertKst(inK: TKst; VAR outMessage: TString): BOOLEAN;
BEGIN
    RETURN Ksten.InsertKst(inK, outMessage);
END KInsertKst;

PROCEDURE KExistKst(inKst: TKst): BOOLEAN;
BEGIN
    RETURN Ksten.ExistKst(inKst);
END KExistKst;

PROCEDURE KIstLiquidiertAminKst(inKst: TKst): BOOLEAN;
BEGIN
     RETURN Ksten.IstLiquidiertAminKst(inKst);
END KIstLiquidiertAminKst;

PROCEDURE KSetzeGesperrtAminKst(inoutKst: TKst; inD: TDatum);
BEGIN
	Ksten.SetzeGesperrtAminKst(inoutKst, inD);
END KSetzeGesperrtAminKst;

PROCEDURE KIstGesperrtAminKst(inKst: TKst): BOOLEAN;
BEGIN
	RETURN Ksten.IstGesperrtAminKst(inKst);
END KIstGesperrtAminKst;

PROCEDURE KAendernKst(inKst: TKst; VAR outMessage : TString): BOOLEAN;
BEGIN
    RETURN Ksten.AendernKst(inKst, outMessage);
END KAendernKst;

PROCEDURE KSearchKstZuKID(inKID: TKstID; VAR outKst: TKst): BOOLEAN;
BEGIN
	RETURN Ksten.SearchKstZuKID(inKID,outKst);
END KSearchKstZuKID;

PROCEDURE KKstIDAlsString(inKstID : TKstID): TString;
BEGIN
	 RETURN Ksten.KstIDAlsString(inKstID);
END KKstIDAlsString;


(****************************************************
        IMPORTE aus TS Datum
*****************************************************)

PROCEDURE DLiefereDatumEternity(VAR inoutD:TDatum);
BEGIN
    Datum.SetzeDatumEternity(inoutD);
END DLiefereDatumEternity;

PROCEDURE DIstDatumEternity(D: TDatum): BOOLEAN;
BEGIN
    RETURN Datum.IstDatumEternity(D);
END DIstDatumEternity;

PROCEDURE DDatumVonString (inString : TString; VAR outDatum:TDatum; VAR outMessage:TString) : BOOLEAN;
BEGIN
          RETURN Datum.DatumVonString(inString,outDatum,outMessage);
END DDatumVonString;

PROCEDURE DSmallerDatum(inSmallerD,inGreaterD:TDatum):BOOLEAN ;
BEGIN
	RETURN Datum.SmallerDatum(inSmallerD,inGreaterD);
END DSmallerDatum;


(****************************************************
        IMPORTE aus TS Konden
*****************************************************)

PROCEDURE KLoescheWKondVorZeitp(inWKond: TKond; VAR outMessage:TString):BOOLEAN;
BEGIN
    RETURN Konden.InsertWKond(inWKond, outMessage);
END KLoescheWKondVorZeitp;

                     
PROCEDURE KLoescheTKondVorZeitp(inTKond: TKond; VAR outMessage : TString) : BOOLEAN;
BEGIN
     RETURN Konden.InsertTKond(inTKond, outMessage);
END KLoescheTKondVorZeitp;

                     
PROCEDURE  KLoescheVKondVorZeitp(inVKond: TKond; VAR outMessage : TString) : BOOLEAN;
BEGIN
     RETURN Konden.InsertVKond(inVKond, outMessage);
END KLoescheVKondVorZeitp;

PROCEDURE KLiesGueltVoninKond (inKond: TKond) : TDatum;
BEGIN
	RETURN Konden.LiesGueltVoninKond(inKond);
END KLiesGueltVoninKond;

PROCEDURE KBerechneBrutto(inGueltigVon: TDatum; inGueltigBis: TDatum; inStundenzahl: INTEGER): INTEGER;
BEGIN
	RETURN Konden.BerechneBrutto(inGueltigVon, inGueltigBis, inStundenzahl);
END KBerechneBrutto;


(****************************************************
        IMPORTE aus TS Buen
*****************************************************)

PROCEDURE BInsertBu(inBu:TBu;  VAR outMessage : TString) : BOOLEAN;
BEGIN
    RETURN Buen.InsertBu(inBu, outMessage);
END BInsertBu;

PROCEDURE BLiesKstIDinBu (inBu:TBu):TKstID;
BEGIN
    RETURN Buen.LiesKstIDinBu(inBu);
END BLiesKstIDinBu;

PROCEDURE BCreateBu():TBu;
BEGIN
    RETURN Buen.CreateBu();
END BCreateBu;

PROCEDURE BSetzeBetraginBu(inoutB: TBu; Betrag:INTEGER);
BEGIN
    Buen.SetzeBetraginBu(inoutB, Betrag);
END BSetzeBetraginBu;

PROCEDURE BSetzeVtrIDinBu (inoutBu : TBu; inVtrID : TVtrID);
BEGIN
	Buen.SetzeVtrIDinBu (inoutBu, inVtrID);
END BSetzeVtrIDinBu;
			
PROCEDURE BSetzeBuchungsArtinBu(inoutB: TBu; BArt: TBuArt);
BEGIN
	Buen.SetzeBuchungsArtinBu(inoutB, BArt);
END BSetzeBuchungsArtinBu;

PROCEDURE BSetzeKstIDinBu(inoutBu:TBu; inKstID:TKstID);
BEGIN
    	Buen.SetzeKstIDinBu(inoutBu, inKstID);
END BSetzeKstIDinBu;

PROCEDURE BStorniereBuZuVtr(inVtrID: TVtrID; VAR outMessage: TString): BOOLEAN;
BEGIN
	RETURN Buen.StorniereBuZuVtr(inVtrID, outMessage);
END BStorniereBuZuVtr;

PROCEDURE BSetzeGebuchtAminBu (inoutBu : TBu; inGebuchtAm : TDatum);
BEGIN
	Buen.SetzeGebuchtAminBu (inoutBu, inGebuchtAm);
END BSetzeGebuchtAminBu;

(****************************************************
        IMPORTE aus TS SysDat
*****************************************************)
PROCEDURE SLiesSystemDatumInSysDat(): TDatum;
BEGIN
   	RETURN SysDat.LiesSystemDatumInSysDat();
END SLiesSystemDatumInSysDat;

PROCEDURE SSetzeSystemDatumInSysDat( inD: TDatum);
BEGIN
  	SysDat.SetzeSystemDatumInSysDat(inD);
END SSetzeSystemDatumInSysDat;  	

(****************************************************
        IMPORTE aus FM HatBuBez
*****************************************************)
(****************************************************
        IMPORTE aus FM BelBez
*****************************************************)
(****************************************************
        IMPORTE aus FM VtrBez
*****************************************************)


END PSBIMPORTE.
