(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile$
# $Author$
# $Date$
# $Revision$
# Bemerkungen:

IMPLEMENTATION MODULE FSetDatumSysVw;

Johannes Magauer

*)
(******************************************************************************)

IMPLEMENTATION MODULE FSetDatumSysVw;

FROM SysReaktFStapel IMPORT Push, Pop, Top, TProc;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT StelleZeileDar, SetzeZeile, LiesZeile, EntferneZeile;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT MeldungAnzeigen;

FROM SYSTEM IMPORT CAST, ADR, ADDRESS, TSIZE;
FROM Storage IMPORT ALLOCATE, DEALLOCATE;
FROM WholeStr IMPORT CardToStr;
FROM InOut IMPORT WriteCard, WriteString, WriteLn;

FROM Datum IMPORT TDatum, DatumVonString, DatumAlsString;
FROM HKB IMPORT BearbeitenNeuVtr;
FROM SysDat IMPORT SetzeSystemDatumInSysDat;

IMPORT String;
IMPORT Stringliste;
IMPORT HKe;
IMPORT Ksten;
IMPORT Vtre;
IMPORT FPruefmodulHK;


  TYPE 	TFDatDS = RECORD
		    WinHdle,
		    OkKnopf,
		    AbbrechenKnopf,
		    DatZ : ADDRESS;		
		  END;	
       	TPFDat = POINTER TO TFDatDS;

  CONST CFOBEN = 170;
  	CFLINKS = 200;
  	CFHOEHE = 350;
  	CFBREITE = 600;
  	CKNOPFOKX = 400;
  	CKNOPFOKY = 150;
  	CKNOPFABBRECHENX = 250;
  	CKNOPFABBRECHENY = 280;
  	CDATX = 30;
  	CDATY = 150;
  	CDAT = 10;
  	
(*************************************************************************************************)
(********************************** PROZEDURE KnoepfeDat() ********************************)
(*************************************************************************************************)

PROCEDURE KnoepfeDat();
  VAR
    hilfsText: String.TString;
    OkHandle, AbbrechenHandle, meineAddr: ADDRESS;
    reaktProc: TProc;
    ichSelbst: TPFDat;

  BEGIN
    (* Initialisierungen *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFDat, meineAddr);
    hilfsText := String.Create();
(*************************************************************************************************)
    String.Schreibe(hilfsText,"---> Eingabe besttigen");
    OkHandle := StelleKnopfDar(hilfsText,ichSelbst^.WinHdle,CKNOPFOKX,CKNOPFOKY,
    				    CAST(PROC,AnlegenKnopfCallback));

    String.Schreibe(hilfsText,"Abbrechen");
    AbbrechenHandle := StelleKnopfDar(hilfsText,ichSelbst^.WinHdle,CKNOPFABBRECHENX,
    				      CKNOPFABBRECHENY,CAST(PROC,AbbrechenKnopfCallback));
(*************************************************************************************************)
    String.Dispose(hilfsText);
    WITH ichSelbst^ DO
      OkKnopf:= OkHandle;
      AbbrechenKnopf:= AbbrechenHandle;
    END (*WITH*)
  END KnoepfeDat;

(*************************************************************************************************)
(******************************* PROCEDURE AbbrechenKnopfCallback() ******************************)
(*************************************************************************************************)

PROCEDURE AbbrechenKnopfCallback();
  BEGIN
    DisposeFDat();
  END AbbrechenKnopfCallback;

(*************************************************************************************************)
(******************************* PROCEDURE AnlegenKnopfCallback() ********************************)
(*************************************************************************************************)

PROCEDURE AnlegenKnopfCallback();
  VAR
    SDat, EMeldung: String.TString;
    error : BOOLEAN;
    dat: TDatum;
    meineAddr: ADDRESS;
    reaktProc: TProc;
    ichSelbst: TPFDat;

  BEGIN		
    (* Initialisierungen *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFDat, meineAddr);
    error := FALSE;

    SDat:= String.Create();
    EMeldung:= String.Create(); 	(* fr Fehlermeldungen beim Attributanlegen in einer HK *)

    LiesZeile(ichSelbst^.DatZ, SDat);

    IF DatumVonString(SDat, dat, EMeldung) THEN
         WriteString("SetzeSystemDatumInSysDat");
         WriteLn;
         SetzeSystemDatumInSysDat(dat);
    ELSE
        MeldungAnzeigen(EMeldung);
        error := TRUE;
    END; (* IF *)

    String.Dispose(SDat);
    String.Dispose(EMeldung);

    IF NOT error THEN
      DisposeFDat();
    END; (* IF *)
  END AnlegenKnopfCallback;

(*************************************************************************************************)
(*********************************** PROCEDURE ZeilenAnlegen() ***********************************)
(*************************************************************************************************)

PROCEDURE ZeilenDat();
  VAR
    hilfsText,
    leerText : String.TString;
    DatHandle, meineAddr: ADDRESS;
    heute : TDatum;
    reaktProc: TProc;
    ichSelbst: TPFDat;
    yWert: INTEGER;

  BEGIN (* Erzeuge den Fensterinhalt *)
    (* Initialisierungen *)
    leerText := String.Create();
    hilfsText := String.Create();
    String.Schreibe(leerText,"");
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFDat, meineAddr);

    hilfsText := DatumAlsString(heute);
    String.Schreibe(hilfsText,"Neues Systemdatum eingeben:");
    DatHandle := StelleZeileDar(hilfsText,leerText,CDAT, ichSelbst^.WinHdle,CDATX,CDATY);

    String.Dispose(hilfsText);
    String.Dispose(leerText);
    WITH ichSelbst^ DO
      DatZ:= DatHandle;
    END; (* WITH *)
END ZeilenDat;

(*************************************************************************************************)
(************************************* PROCEDURE CreateFDat() ************************************)
(*************************************************************************************************)

PROCEDURE Create();
  VAR FensterUeberschrift, Titel: String.TString;
      WinHdle: ADDRESS;
      ichSelbst: TPFDat;
      meineAddr: ADDRESS;
  BEGIN
    (* SHKID:= String.Create();
    SKstID:= String.Create(); *)
    FensterUeberschrift := String.Create();
    Titel := String.Create();

    NEW (ichSelbst);
    String.Schreibe( FensterUeberschrift,"Systemdatum eingeben");
    WinHdle:=NeuesFenster(FensterUeberschrift,CFOBEN,CFLINKS,CFHOEHE,CFBREITE);
    meineAddr:= CAST(ADDRESS, ichSelbst);
    Push(ReaktFDat, meineAddr);

    ichSelbst^.WinHdle:=WinHdle;

    String.Dispose(FensterUeberschrift);
    String.Dispose(Titel);

    ZeilenDat();
    KnoepfeDat();
  END Create;

(*************************************************************************************************)
(************************************* PROCEDURE DisposeFDat() ***********************************)
(*************************************************************************************************)

PROCEDURE DisposeFDat();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFDat;
  BEGIN
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFDat, meineAddr);

    EntferneFenster(ichSelbst^.WinHdle);
    Pop();
    DISPOSE(ichSelbst);
    Top(reaktProc, meineAddr);
    reaktProc();
  END DisposeFDat;

(*************************************************************************************************)
(************************************ PROCEDURE DeaktFDat() **********************************)
(*************************************************************************************************)

PROCEDURE DeaktFDat();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFDat;
  BEGIN
    (*Deaktiviere Knpfe, Listboxen,... *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFDat, meineAddr);
  END DeaktFDat;

(*************************************************************************************************)
(************************************ PROCEDURE ReaktFDat() **********************************)
(*************************************************************************************************)

PROCEDURE ReaktFDat();                                                           		
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFDat;
  BEGIN
   (* Aktiviere alle Fensterinhalte *)
   Top(reaktProc, meineAddr);
   ichSelbst:= CAST(TPFDat, meineAddr);

  END ReaktFDat;

END FSetDatumSysVw.


