(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile$
# $Author$
# $Date$
# $Revision$
# Bemerkungen:

IMPLEMENTATION MODULE FAnlegenHK; 

Johannes Magauer

*)
(******************************************************************************)

IMPLEMENTATION MODULE FAnlegenHK;

FROM SysReaktFStapel IMPORT Push, Pop, Top, TProc;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT StelleZeileDar, SetzeZeile, LiesZeile, EntferneZeile;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT MeldungAnzeigen;

FROM SYSTEM IMPORT CAST, ADR, ADDRESS, TSIZE;
FROM Storage IMPORT ALLOCATE, DEALLOCATE;
FROM WholeStr IMPORT CardToStr;
FROM InOut IMPORT WriteCard, WriteString, WriteLn;

FROM Datum IMPORT TDatum, DatumVonString;
FROM HKB IMPORT AufnehmenHK;

IMPORT RealMath;
IMPORT String;
IMPORT Stringliste;
IMPORT HKe;
IMPORT FPruefmodulHK;


  TYPE 	TFAnlegenDS = RECORD
		        WinHdle, PersNrZ, GebDatZ, GebOrtZ, GeschlechtZ, NameZ,	VornameZ, AdresseM,
                        StrasseZ, PlzZ,	OrtZ, LandZ, TelefonZ, FaxZ, EmailZ, DienstadrM, FirmaZ,
			GebaeudeZ, ZimmerZ, DStrasseZ, DPlzZ, DOrtZ, DLandZ, DTelefonZ, DFaxZ,
                        DEmailZ, PrivatesM, StaatZ, FamilieZ, KinderZ, BVerbindungM,
                        BankZ, BlzZ, KontoZ, InternesM, AbschlussZ, PraesenzZ,
			VerfuegbarZ, StundenZ, InteressenZ, BemerkungenZ,
			AnlegenKnopf, LoeschenKnopf, AbbrechenKnopf : ADDRESS		
		      END;	
       	TPFAnlegen = POINTER TO TFAnlegenDS;

  CONST CFLINKS = 50;
  	CFOBEN = 50;
  	CFHOEHE = 625;
  	CFBREITE = 800;
  	CLINKS = 50;
	CTAB1 = 160; (* x-Wert fr 2. Spalte, Telefon *)
        CTAB2 = 210; (* x-Wert fr 3. Spalte, Personalnr. *)
	CTAB3 = 238; (* x-Wert fr 4. Spalte, Familienstand *)
	CTAB4 = 400; (* x-Wert fr 5. Spalte, Vorname *)
        CTAB5 = 530; (* x-Wert fr 6. Spalte, Zimmer, Ort *)
	CTAB6 = 610; (* x-Wert fr 7. Spalte, Kinder *)
	CZEILE = 20;
	CANZZEILE = 28;
	CABSATZ1 = 4*CZEILE;
	CABSATZ2 = 5*CZEILE;
	CABSATZ3 = 6*CZEILE;
	CABSATZ4 = 3*CZEILE;
	CABSATZ5 = 4*CZEILE;	
        COBEN = 20;
        CKNOEPFEY = COBEN + CANZZEILE*CZEILE;
        CKNOPFANLEGENX = 50;
        CKNOPFLOESCHENX = 350;
        CKNOPFABBRECHENX = 650;
        CNR = 5;
	CDAT = 10;
	CGESCHLECHT = 1;
	CNAME = 45; 		(* 35 *)
	CVORNAME = 43;          (* 35 *)
	CSTRASSE = 45;          (* 35 *)
	CPLZ = 10;
	CORT = 30;		(* 25 *)
	CLAND = 3;
	CTEL = 25;
	CEMAIL = 48;          	(* 35 *)
	CFIRMA = 45;            (* 35 *)
 	CGBDE = 6;
	CZIMMER = 10;
	CFAMST = 1;
	CSTAAT = 3;
	CKINDER = 2;
	CBANK = 35;           	(* 30 *)
	CBLZ = 9;
	CKONTO = 15;
	CABSCHLUSS = 10;
	CPRAESENZ = 27;		(* 20 *)
	CSTUNDEN = 2;
	CINTERESSEN = 97;	(* 65 *)
	CBEMERKUNGEN = 97;   	(* 70 *)
	CMAXKINDER = 20;

(*************************************************************************************************)
(********************************** PROCEDURE MeldungenAnlegen() *********************************)
(*************************************************************************************************)
PROCEDURE MeldungenAnlegen();
  VAR
    hilfsText: String.TString;
    AdresseHandle, DienstadrHandle, PrivateHandle,
    BVerbindungHandle, InternesHandle, meineAddr: ADDRESS;
    reaktProc: TProc;
    ichSelbst: TPFAnlegen;
    yWert: INTEGER;
  BEGIN (* Erzeuge den Fensterinhalt *)
    (* Initialisierungen *)
    yWert := COBEN;
    hilfsText := String.Create();
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFAnlegen, meineAddr);
(*************************************************************************************************)
(****************************************** neuer Absatz *****************************************)
(*************************************************************************************************)
    yWert := yWert + CABSATZ1;
    String.Schreibe(hilfsText,"Adresse:");
    AdresseHandle := StelleMeldungDar(hilfsText, FALSE, ichSelbst^.WinHdle,CLINKS,yWert);
(*************************************************************************************************)
(****************************************** neuer Absatz *****************************************)
(*************************************************************************************************)
    yWert := yWert + CABSATZ2;
    String.Schreibe(hilfsText,"Dienstadresse:");
    DienstadrHandle := StelleMeldungDar(hilfsText, FALSE, ichSelbst^.WinHdle,CLINKS,yWert);
(*************************************************************************************************)
(****************************************** neuer Absatz *****************************************)
(*************************************************************************************************)
    yWert := yWert + CABSATZ3;
    String.Schreibe(hilfsText,"Privates:");
    PrivateHandle := StelleMeldungDar(hilfsText, FALSE, ichSelbst^.WinHdle,CLINKS,yWert);
(*************************************************************************************************)
(****************************************** neuer Absatz *****************************************)
(*************************************************************************************************)
    yWert := yWert + CABSATZ4;
    String.Schreibe(hilfsText,"Bankverbindung:");
    BVerbindungHandle := StelleMeldungDar(hilfsText, FALSE, ichSelbst^.WinHdle,CLINKS,yWert);
(*************************************************************************************************)
(****************************************** neuer Absatz *****************************************)
(*************************************************************************************************)
    yWert := yWert + CABSATZ5;
    String.Schreibe(hilfsText,"Internes:");
    InternesHandle := StelleMeldungDar(hilfsText, FALSE, ichSelbst^.WinHdle,CLINKS,yWert);

    String.Dispose(hilfsText);
    WITH ichSelbst^ DO
      AdresseM:= AdresseHandle;
      DienstadrM:= DienstadrHandle;
      PrivatesM:= PrivateHandle;
      BVerbindungM:= BVerbindungHandle;
      InternesM:= InternesHandle;
    END; (* WITH *)
  END MeldungenAnlegen;

(*************************************************************************************************)
(************************************ PROZEDURE KnoepfeAnlegen() *********************************)
(*************************************************************************************************)

PROCEDURE KnoepfeAnlegen();
  VAR
    hilfsText: String.TString;
    AnlegenHandle, LoeschenHandle, AbbrechenHandle, meineAddr: ADDRESS;
    reaktProc: TProc;
    ichSelbst: TPFAnlegen;
    yWert: INTEGER;

  BEGIN
    (* Initialisierungen *)
    yWert := COBEN;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFAnlegen, meineAddr);
    hilfsText := String.Create();
(*************************************************************************************************)
    String.Schreibe(hilfsText,"Hilfskraft anlegen");
    AnlegenHandle := StelleKnopfDar(hilfsText,ichSelbst^.WinHdle,CKNOPFANLEGENX,CKNOEPFEY,
    				    CAST(PROC,AnlegenKnopfCallback));

    String.Schreibe(hilfsText,"Eingabe lschen");
    LoeschenHandle := StelleKnopfDar(hilfsText,ichSelbst^.WinHdle,CKNOPFLOESCHENX,CKNOEPFEY,
    				     CAST(PROC,LoeschenKnopfCallback));

    String.Schreibe(hilfsText,"Abbrechen");
    AbbrechenHandle := StelleKnopfDar(hilfsText,ichSelbst^.WinHdle,CKNOPFABBRECHENX,CKNOEPFEY,
    				      CAST(PROC,AbbrechenKnopfCallback));
(*************************************************************************************************)
    String.Dispose(hilfsText);
    WITH ichSelbst^ DO
      AnlegenKnopf:= AnlegenHandle;
      LoeschenKnopf:= LoeschenHandle;
      AbbrechenKnopf:= AbbrechenHandle;
    END (*WITH*)
  END KnoepfeAnlegen;

(*************************************************************************************************)
(*********************************** PROCEDURE ZeilenAnlegen() ***********************************)
(*************************************************************************************************)

PROCEDURE ZeilenAnlegen();
  VAR
    hilfsText,
    leerText : String.TString;
    PersNrHandle, GebDatHandle, GebOrtHandle, GeschlechtHandle, NameHandle, VornameHandle,
    StrasseHandle, PlzHandle, OrtHandle, LandHandle, TelefonHandle, FaxHandle, EmailHandle,
    DFirmaHandle, DGebaeudeHandle, DZimmerHandle, DStrasseHandle, DPlzHandle, DOrtHandle,
    DLandHandle, DTelefonHandle, DFaxHandle, DEmailHandle,StaatsbuergerHandle, FamilienstHandle,
    KinderHandle, BInstitutHandle, BLeitzahlHandle, BKontoHandle, AbschlussHandle, PraesenzHandle,
    VerfuegbarHandle, VorStdZahlHandle, InteressenHandle, BemerkungenHandle, meineAddr: ADDRESS;
    reaktProc: TProc;
    ichSelbst: TPFAnlegen;
    yWert: INTEGER;

  BEGIN (* Erzeuge den Fensterinhalt *)
    (* Initialisierungen *)
    yWert := COBEN;
    leerText := String.Create();
    hilfsText := String.Create();
    String.Schreibe(leerText,"");
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFAnlegen, meineAddr);
(*************************************************************************************************)
(******************************************* neue Zeile ******************************************)
(*************************************************************************************************)
    String.Schreibe(hilfsText,"Personalnummer: ");
    PersNrHandle := StelleZeileDar(hilfsText,leerText,CNR,ichSelbst^.WinHdle,CLINKS,yWert);

    String.Schreibe(hilfsText,"Geschlecht (m,f):");
    GeschlechtHandle := StelleZeileDar(hilfsText,leerText, CGESCHLECHT,ichSelbst^.WinHdle,
    				       CTAB4,yWert);
(*************************************************************************************************)
(******************************************** neue Zeile *****************************************)
(*************************************************************************************************)
    yWert := yWert + CZEILE;
    String.Schreibe(hilfsText,"Geburtsdatum:");
    GebDatHandle := StelleZeileDar(hilfsText,leerText,CDAT,ichSelbst^.WinHdle,CLINKS,yWert);

    String.Schreibe(hilfsText,"Geburtsort:");
    GebOrtHandle := StelleZeileDar(hilfsText,leerText,CORT,ichSelbst^.WinHdle,CTAB4,yWert);
(*************************************************************************************************)
(******************************************* neue Zeile ******************************************)
(*************************************************************************************************)
    yWert := yWert + CZEILE;
    String.Schreibe(hilfsText,"Name: ");
    NameHandle := StelleZeileDar(hilfsText,leerText,CNAME, ichSelbst^.WinHdle,CLINKS,yWert);

    String.Schreibe(hilfsText,"Vorname:   ");
    VornameHandle := StelleZeileDar(hilfsText,leerText,CVORNAME, ichSelbst^.WinHdle,CTAB4,yWert);
(*************************************************************************************************)
(******************************************* neue Zeile ******************************************)
(*************************************************************************************************)
    yWert := yWert + 3*CZEILE;
    String.Schreibe(hilfsText,"Strae:");
    StrasseHandle := StelleZeileDar(hilfsText,leerText,CSTRASSE,ichSelbst^.WinHdle,CLINKS,yWert);

    String.Schreibe(hilfsText,"PLZ: ");
    PlzHandle := StelleZeileDar(hilfsText,leerText,CPLZ,ichSelbst^.WinHdle,CTAB4,yWert);

    String.Schreibe(hilfsText,"Ort:");
    OrtHandle := StelleZeileDar(hilfsText,leerText,CORT,ichSelbst^.WinHdle,CTAB5,yWert);
(*************************************************************************************************)
(******************************************* neue Zeile ******************************************)
(*************************************************************************************************)
    yWert := yWert + CZEILE;
    String.Schreibe(hilfsText,"Land:   ");
    LandHandle := StelleZeileDar(hilfsText,leerText,CLAND,ichSelbst^.WinHdle,CLINKS,yWert);

    String.Schreibe(hilfsText,"Telefon:");
    TelefonHandle := StelleZeileDar(hilfsText,leerText,CTEL,ichSelbst^.WinHdle,CTAB1,yWert);

    String.Schreibe(hilfsText,"E-Mail:");
    EmailHandle := StelleZeileDar(hilfsText,leerText,CEMAIL,ichSelbst^.WinHdle,CTAB4,yWert);
(*************************************************************************************************)
(******************************************* neue Zeile ******************************************)
(*************************************************************************************************)
    yWert := yWert + CZEILE;
    String.Schreibe(hilfsText,"        Fax:");
    FaxHandle := StelleZeileDar(hilfsText,leerText,CTEL,ichSelbst^.WinHdle,CTAB1,yWert);
(*************************************************************************************************)
(******************************************* neue Zeile ******************************************)
(*************************************************************************************************)
    yWert := yWert + 3*CZEILE;
    String.Schreibe(hilfsText,"Firma: ");
    DFirmaHandle := StelleZeileDar(hilfsText,leerText,CFIRMA,ichSelbst^.WinHdle,CLINKS,yWert);

    String.Schreibe(hilfsText,"Gebude:");
    DGebaeudeHandle := StelleZeileDar(hilfsText,leerText,CGBDE,ichSelbst^.WinHdle,CTAB4,yWert);

    String.Schreibe(hilfsText,"Zimmer:");
    DZimmerHandle := StelleZeileDar(hilfsText,leerText,CZIMMER,ichSelbst^.WinHdle,CTAB5,yWert);
(*************************************************************************************************)
(******************************************* neue Zeile ******************************************)
(*************************************************************************************************)
    yWert := yWert + CZEILE;
    String.Schreibe(hilfsText,"Strae:");
    DStrasseHandle := StelleZeileDar(hilfsText,leerText,CSTRASSE,ichSelbst^.WinHdle,CLINKS,yWert);

    String.Schreibe(hilfsText,"PLZ:   ");
    DPlzHandle := StelleZeileDar(hilfsText,leerText,CPLZ,ichSelbst^.WinHdle,CTAB4,yWert);

    String.Schreibe(hilfsText,"Ort:");
    DOrtHandle := StelleZeileDar(hilfsText,leerText,CORT,ichSelbst^.WinHdle,CTAB5,yWert);
(*************************************************************************************************)
(******************************************* neue Zeile ******************************************)
(*************************************************************************************************)
    yWert := yWert + CZEILE;
    String.Schreibe(hilfsText,"Land:   ");
    DLandHandle := StelleZeileDar(hilfsText,leerText,CLAND,ichSelbst^.WinHdle,CLINKS,yWert);

    String.Schreibe(hilfsText,"Telefon:");
    DTelefonHandle := StelleZeileDar(hilfsText,leerText,CTEL,ichSelbst^.WinHdle,CTAB1,yWert);

    String.Schreibe(hilfsText,"E-Mail:");
    DEmailHandle := StelleZeileDar(hilfsText,leerText,CEMAIL,ichSelbst^.WinHdle,CTAB4,yWert);
(*************************************************************************************************)
(******************************************* neue Zeile ******************************************)
(*************************************************************************************************)
    yWert := yWert + CZEILE;
    String.Schreibe(hilfsText,"        Fax:");
    DFaxHandle := StelleZeileDar(hilfsText,leerText,CTEL,ichSelbst^.WinHdle,CTAB1,yWert);
(*************************************************************************************************)
(******************************************* neue Zeile ******************************************)
(*************************************************************************************************)
    yWert := yWert + 3*CZEILE;
    String.Schreibe(hilfsText,"Staatsbrgerschaft:");
    StaatsbuergerHandle := StelleZeileDar(hilfsText,leerText,CSTAAT, ichSelbst^.WinHdle,
    					  CLINKS,yWert);

    String.Schreibe(hilfsText,"Familienstand (l,v,w,g):");
    FamilienstHandle := StelleZeileDar(hilfsText,leerText,CFAMST, ichSelbst^.WinHdle,CTAB4,yWert);

    String.Schreibe(hilfsText,"Kinder:");
    KinderHandle := StelleZeileDar(hilfsText,leerText,CKINDER, ichSelbst^.WinHdle,CTAB6,yWert);
(*************************************************************************************************)
(******************************************* neue Zeile ******************************************)
(*************************************************************************************************)
    yWert := yWert + 3*CZEILE;
    String.Schreibe(hilfsText,"Bankinstitut:   ");
    BInstitutHandle := StelleZeileDar(hilfsText,leerText,CBANK,ichSelbst^.WinHdle,CLINKS,yWert);

    String.Schreibe(hilfsText,"Bankleitzahl:");
    BLeitzahlHandle := StelleZeileDar(hilfsText,leerText,CBLZ,ichSelbst^.WinHdle,CTAB4,yWert);
(*************************************************************************************************)
(******************************************* neue Zeile ******************************************)
(*************************************************************************************************)
    yWert := yWert + CZEILE;
    String.Schreibe(hilfsText,"Kontonummer:");
    BKontoHandle := StelleZeileDar(hilfsText,leerText,CKONTO,ichSelbst^.WinHdle,CLINKS,yWert);
(*************************************************************************************************)
(******************************************* neue Zeile ******************************************)
(*************************************************************************************************)
    yWert := yWert + 3*CZEILE;
    String.Schreibe(hilfsText,"Abschluss:      ");
    AbschlussHandle := StelleZeileDar(hilfsText,leerText,CABSCHLUSS,ichSelbst^.WinHdle,
    				      CLINKS,yWert);

    String.Schreibe(hilfsText,"Prsenztage:");
    PraesenzHandle := StelleZeileDar(hilfsText,leerText,CPRAESENZ,ichSelbst^.WinHdle,CTAB4,yWert);
(*************************************************************************************************)
(******************************************* neue Zeile ******************************************)
(*************************************************************************************************)
    yWert := yWert + CZEILE;
    String.Schreibe(hilfsText,"Verfgbar ab: ");
    VerfuegbarHandle := StelleZeileDar(hilfsText,leerText,CDAT,ichSelbst^.WinHdle,CLINKS,yWert);

    String.Schreibe(hilfsText,"Voraussichtliche Stundenzahl: ");
    VorStdZahlHandle := StelleZeileDar(hilfsText,leerText,CSTUNDEN,ichSelbst^.WinHdle,
    				       CTAB4,yWert);
(*************************************************************************************************)
(******************************************* neue Zeile ******************************************)
(*************************************************************************************************)
    yWert := yWert + CZEILE;
    String.Schreibe(hilfsText,"Interessen:     ");
    InteressenHandle := StelleZeileDar(hilfsText,leerText,CINTERESSEN,ichSelbst^.WinHdle,
    				       CLINKS,yWert);
(*************************************************************************************************)
(******************************************* neue Zeile ******************************************)
(*************************************************************************************************)
    yWert := yWert + CZEILE;
    String.Schreibe(hilfsText,"Bemerkungen:");
    BemerkungenHandle := StelleZeileDar(hilfsText,leerText,CBEMERKUNGEN,ichSelbst^.WinHdle,
    					CLINKS,yWert);


    String.Dispose(hilfsText);
    String.Dispose(leerText);
    WITH ichSelbst^ DO
      PersNrZ:= PersNrHandle;
      GebDatZ:= GebDatHandle;
      GebOrtZ:= GebOrtHandle;
      GeschlechtZ:= GeschlechtHandle;
      NameZ:= NameHandle;

      VornameZ:= VornameHandle;
      StrasseZ:= StrasseHandle;
      PlzZ:= PlzHandle;
      OrtZ:= OrtHandle;
      LandZ:= LandHandle;

      TelefonZ:= TelefonHandle;
      FaxZ:= FaxHandle;
      EmailZ:= EmailHandle;
      FirmaZ:= DFirmaHandle;
      GebaeudeZ:= DGebaeudeHandle;

      ZimmerZ:= DZimmerHandle;
      DStrasseZ:= DStrasseHandle;
      DPlzZ:= DPlzHandle;
      DOrtZ:= DOrtHandle;
      DLandZ:= DLandHandle;

      DTelefonZ:= DTelefonHandle;
      DFaxZ:= DFaxHandle;
      DEmailZ:= DEmailHandle;
      StaatZ:= StaatsbuergerHandle;
      FamilieZ:= FamilienstHandle;

      KinderZ:= KinderHandle;
      BankZ:= BInstitutHandle;
      BlzZ:= BLeitzahlHandle;
      KontoZ:= BKontoHandle;
      AbschlussZ:= AbschlussHandle;

      PraesenzZ:= PraesenzHandle;
      VerfuegbarZ:= VerfuegbarHandle;
      StundenZ:= VorStdZahlHandle;
      InteressenZ:= InteressenHandle;
      BemerkungenZ:= BemerkungenHandle;
    END; (* WITH *)
END ZeilenAnlegen;

(*************************************************************************************************)
(******************************* PROCEDURE AbbrechenKnopfCallback() ******************************)
(*************************************************************************************************)

PROCEDURE AbbrechenKnopfCallback();
  BEGIN
    (* erzeugte ADT's die nicht mehr gebraucht werden lschen *)
    (* ZeilenEntfernen(); *)
    DisposeFAnlegen();
  END AbbrechenKnopfCallback;

(*************************************************************************************************)
(******************************** PROCEDURE AnlegenKnopfCallback() *******************************)
(*************************************************************************************************)

PROCEDURE AnlegenKnopfCallback();
(* ADT Hilfskraft erzeugen und einfgen *)
  VAR
    SPersNr, SGeschlecht, SName, SVorname, SStrasse, SPlz, SOrt, SGebOrt, SGebDat, SLand, STelefon,
    SFax, SEmail, SFirma, SGebaeude, SZimmer, SDStrasse, SDPlz, SDOrt, SDLand, SDTelefon, SDFax,
    SDEmail, SStaat, SFamilie, SKinder, SBank, SBlz, SKonto, SAbschluss, SPraesenz, SVerfuegbar,
    SStd, SInteressen, SBemerkungen, SLeer, EMeldung, EMeldung1,
    EZuVieleKinder, SText, SNull : String.TString;
    error, ok : BOOLEAN;
    hk : HKe.THK;
    praesenz : HKe.TPraesTage;
    gebdat, dat: TDatum;
    persNr, kinder, stunden, i, blz : CARDINAL;
    geschlecht, familie: CHAR;
    meineAddr: ADDRESS;
    reaktProc: TProc;
    ichSelbst: TPFAnlegen;

  BEGIN		
    (* Initialisierungen *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFAnlegen, meineAddr);
    hk := HKe.CreateHK();
    error := FALSE;
    geschlecht:= "";
    familie:= "";

    SPersNr:= String.Create();
    SGeschlecht:= String.Create();
    SName:= String.Create();
    SVorname:= String.Create();
    SStrasse:= String.Create();
    SPlz:= String.Create();
    SOrt:= String.Create();

    SGebOrt:= String.Create();
    SGebDat:= String.Create();
    SLand:= String.Create();
    STelefon:= String.Create();
    SFax:= String.Create();

    SEmail:= String.Create();
    SFirma:= String.Create();
    SGebaeude:= String.Create();
    SZimmer:= String.Create();
    SDStrasse:= String.Create();

    SDPlz:= String.Create();
    SDOrt:= String.Create();
    SDLand:= String.Create();
    SDTelefon:= String.Create();
    SDFax:= String.Create();

    SDEmail:= String.Create();
    SStaat:= String.Create();
    SFamilie:= String.Create();
    SKinder:= String.Create();
    SBank:= String.Create();
    SBlz:= String.Create();
    SKonto:= String.Create();
    SAbschluss:= String.Create();
    SPraesenz:= String.Create();

    SVerfuegbar:= String.Create();
    SStd:= String.Create();
    SInteressen:= String.Create();
    SBemerkungen:= String.Create();
    SLeer:= String.Create();
    SText := String.Create();		(* fr Feldbezeichner *)	
    SNull := String.Create();

    EMeldung:= String.Create(); 	(* fr Fehlermeldungen beim Attributanlegen in einer HK *)
    EMeldung1:= String.Create();
    EZuVieleKinder:= String.Create();
    String.Schreibe(EZuVieleKinder,"Geben Sie nur Zahlen < 20 ein!");
    String.Schreibe(SLeer,"");  (* fr Feldabfrage *)
    String.Schreibe(SNull,"0");

    LiesZeile(ichSelbst^.PersNrZ, SPersNr);
    LiesZeile(ichSelbst^.GeschlechtZ, SGeschlecht);
    LiesZeile(ichSelbst^.NameZ, SName);
    LiesZeile(ichSelbst^.VornameZ, SVorname);
    LiesZeile(ichSelbst^.StrasseZ, SStrasse);
    LiesZeile(ichSelbst^.PlzZ, SPlz);
    LiesZeile(ichSelbst^.OrtZ, SOrt);

    LiesZeile(ichSelbst^.GebOrtZ, SGebOrt);
    LiesZeile(ichSelbst^.GebDatZ, SGebDat);
    LiesZeile(ichSelbst^.LandZ, SLand);
    LiesZeile(ichSelbst^.TelefonZ, STelefon);
    LiesZeile(ichSelbst^.FaxZ, SFax);

    LiesZeile(ichSelbst^.EmailZ, SEmail);
    LiesZeile(ichSelbst^.FirmaZ, SFirma);
    LiesZeile(ichSelbst^.GebaeudeZ, SGebaeude);
    LiesZeile(ichSelbst^.ZimmerZ, SZimmer);
    LiesZeile(ichSelbst^.DStrasseZ, SDStrasse);

    LiesZeile(ichSelbst^.DPlzZ, SDPlz);
    LiesZeile(ichSelbst^.DOrtZ, SDOrt);
    LiesZeile(ichSelbst^.DLandZ, SDLand);
    LiesZeile(ichSelbst^.DTelefonZ, SDTelefon);
    LiesZeile(ichSelbst^.DFaxZ, SDFax);

    LiesZeile(ichSelbst^.DEmailZ, SDEmail);
    LiesZeile(ichSelbst^.StaatZ, SStaat);
    LiesZeile(ichSelbst^.FamilieZ, SFamilie);
    LiesZeile(ichSelbst^.KinderZ, SKinder);
    LiesZeile(ichSelbst^.BankZ, SBank);
    LiesZeile(ichSelbst^.BlzZ, SBlz);
    LiesZeile(ichSelbst^.KontoZ, SKonto);
    LiesZeile(ichSelbst^.AbschlussZ, SAbschluss);
    LiesZeile(ichSelbst^.PraesenzZ, SPraesenz);

    LiesZeile(ichSelbst^.VerfuegbarZ, SVerfuegbar);
    LiesZeile(ichSelbst^.StundenZ, SStd);
    LiesZeile(ichSelbst^.InteressenZ, SInteressen);
    LiesZeile(ichSelbst^.BemerkungenZ, SBemerkungen);


    (* Fehlerberprfungen durchfhren *)
    (* Wurde die Eingabelnge berschritten *)
    IF NOT error THEN
        error := PruefeLaengeEingabefelder(ichSelbst);
    END; (* IF *)

    (* eingegebene Personalnummer prfen, umwandeln und Attribut in HK setzen *)
    IF NOT error THEN
        IF NOT String.IsEqual(SPersNr, SLeer) THEN
 	    IF FPruefmodulHK.PruefeCardPos(SPersNr, persNr, EMeldung) THEN
	         WriteString("SetzePersonalnrinHK");
	         WriteLn;
        	HKe.SetzePersonalnrinHK(hk,persNr);	
	     ELSE
	     	String.Schreibe(EMeldung1, "Fehler in Feld Personalnummer: ");
                String.Anhaengen(EMeldung, EMeldung1);
                MeldungAnzeigen(EMeldung1);
                error := TRUE;
            END; (* IF *)
       END; (* IF *)	     	
    END;  (* IF *)

    IF NOT error THEN
        IF NOT String.IsEqual(SGebDat, SLeer) THEN
            IF DatumVonString(SGebDat, gebdat, EMeldung) THEN
                 WriteString("SetzeGeburtsdatuminHK");
                 WriteLn;
                HKe.SetzeGeburtsdatuminHK(hk,gebdat);
            ELSE
                String.Schreibe(EMeldung1, "Fehler in Feld Geburtsdatum: ");
                String.Anhaengen(EMeldung, EMeldung1);
                MeldungAnzeigen(EMeldung1);
                error := TRUE;
            END; (* IF *)
        END; (* IF *)
    END;  (* IF *)

    (* eingegebenes Geschlecht prfen, umwandeln und Attribut in HK setzen *)
    IF NOT error THEN
    	IF NOT String.IsEqual(SGeschlecht, SLeer) THEN    	
            IF FPruefmodulHK.PruefeGeschlecht(SGeschlecht, geschlecht, EMeldung) THEN
                 WriteString("SetzeGeschlechtinHK ");
                 WriteLn;
                HKe.SetzeGeschlechtinHK(hk,geschlecht);
            ELSE
                String.Schreibe(EMeldung1, "Fehler in Feld 'Geschlecht': ");
                String.Anhaengen(EMeldung, EMeldung1);
                MeldungAnzeigen(EMeldung1);
                error := TRUE;
            END; (* IF *)
        END; (* IF *)
    END; (* IF *)

    (* eingegebenen Familienstand prfen, umwandeln und Attribut in HK setzen *)
    IF NOT error THEN	
        IF NOT String.IsEqual(SFamilie, SLeer) THEN    	
            IF FPruefmodulHK.PruefeFamilienstand(SFamilie, familie, EMeldung) THEN
                 WriteString("SetzeFamstandinHK ");
                 WriteLn;
                HKe.SetzeFamstandinHK(hk,familie);
            ELSE
                String.Schreibe(EMeldung1, "Fehler in Feld 'Familienstand': ");
                String.Anhaengen(EMeldung, EMeldung1);
                MeldungAnzeigen(EMeldung1);
                error := TRUE;
            END; (* IF *)
        END; (* IF *)
    END; (* IF *)

    IF NOT error THEN
	IF NOT (String.IsEqual(SKinder, SLeer) OR String.IsEqual(SKinder, SNull)) THEN
            String.Schreibe(EMeldung1, "Fehler in Feld 'Kinder': ");
 	    IF FPruefmodulHK.PruefeCardPos(SKinder, kinder, EMeldung) THEN
 	        IF kinder >= CMAXKINDER THEN
 	            String.Anhaengen(EZuVieleKinder, EMeldung1);
 	            MeldungAnzeigen(EMeldung1);
 	            error := TRUE;
 	        ELSE 	
  		     WriteString("SetzeKinderinHK");
	             WriteLn;
        	    HKe.SetzeKinderinHK(hk,kinder);	
        	END; (* IF *)
	     ELSE            	     	
                String.Anhaengen(EMeldung, EMeldung1);
                MeldungAnzeigen(EMeldung1);
                error := TRUE;
            END; (* IF *)
        ELSE
             WriteString("SetzeKinderinHK");
             WriteLn;
            HKe.SetzeKinderinHK(hk,0);
        END; (* IF *)	
    END;    	

    IF NOT error THEN
        IF NOT String.IsEqual(SBlz, SLeer) THEN
 	    IF FPruefmodulHK.PruefeCardPos(SBlz, blz, EMeldung) THEN
	         WriteString("SetzeBlzinHK");
	         WriteLn;
        	HKe.SetzeBlzinHK(hk,blz);	
	     ELSE
	     	String.Schreibe(EMeldung1, "Fehler in Feld Bankleitzahl: ");
                String.Anhaengen(EMeldung, EMeldung1);
                MeldungAnzeigen(EMeldung1);
                error := TRUE;
            END; (* IF *)
       END; (* IF *)	     	
    END;  (* IF *)

    IF NOT error THEN
        IF NOT String.IsEqual(SKonto, SLeer) THEN
            IF FPruefmodulHK.PruefeStringZahl(SKonto, EMeldung) THEN
                HKe.SetzeKontonrinHK(hk,SKonto);
                 WriteString("SetzeKontonrinHK ");
                 WriteLn;
            ELSE
                String.Schreibe(EMeldung1, "Fehler in Feld Kontonummer: ");
                String.Anhaengen(EMeldung, EMeldung1);
                MeldungAnzeigen(EMeldung1);
                error := TRUE;
            END; (* IF *)
        END; (* IF *)
    END; (* IF *)

    IF NOT error THEN
	IF NOT String.IsEqual(SPraesenz, SLeer) THEN
            IF HKe.PruefePraesTage(SPraesenz, EMeldung) THEN
                praesenz := HKe.StringInPraesTage(SPraesenz);
                HKe.SetzePraestageinHK(hk, praesenz);
                   WriteString("SetzePraestageinHK");
                   WriteLn;
            ELSE
                String.Schreibe(EMeldung1, "Fehler in Feld Praesenztage: ");
                String.Anhaengen(EMeldung, EMeldung1);
                MeldungAnzeigen(EMeldung1);
                error := TRUE;
            END; (* IF *)
        END; (* IF *)
    END;  (* IF *)

    IF NOT error THEN
        IF NOT String.IsEqual(SVerfuegbar, SLeer) THEN
            IF DatumVonString(SVerfuegbar, dat, EMeldung) THEN
                 WriteString("SetzeVerfuegAbinHK");
                 WriteLn;
                HKe.SetzeVerfuegAbinHK(hk,dat);
            ELSE
                String.Schreibe(EMeldung1, "Fehler in Feld 'Verfgbar Ab': ");
                String.Anhaengen(EMeldung, EMeldung1);
                MeldungAnzeigen(EMeldung1);
                error := TRUE;
            END; (* IF *)
        END; (* IF *)
    END;  (* IF *)

    IF NOT error THEN
        IF NOT String.IsEqual(SStd, SLeer) THEN
 	    IF FPruefmodulHK.PruefeCardPos(SStd, stunden, EMeldung) THEN
                 WriteString("SetzeVorStdzahlinHK");
                 WriteLn;
                HKe.SetzeVorStdzahlinHK(hk,stunden);
	     ELSE
	     	String.Schreibe(EMeldung1, "Fehler in Feld Voraussichtliche Stundenzahl: ");
                String.Anhaengen(EMeldung, EMeldung1);
                MeldungAnzeigen(EMeldung1);
                error := TRUE;
            END; (* IF *)
       END; (* IF *)	     	
    END;  (* IF *)

    (* sind die Mussfelder ausgefllt *)
    IF NOT error THEN
        error := Mussfelder(ichSelbst);
    END; (* IF *)

    (* geprfte Felder in Hilfskraft initialisieren *)
    IF NOT error THEN    	
        HKe.SetzeNameinHK(hk,SName);
         WriteString("SetzeNameinHK ");
         WriteLn;
        HKe.SetzeVornameinHK(hk,SVorname);
         WriteString("SetzeVornameinHK ");
         WriteLn;
        HKe.SetzeStrasseinHK(hk,SStrasse);
         WriteString("SetzeStrasseinHK ");
         WriteLn;
        HKe.SetzePostleitzahlinHK(hk,SPlz);
         WriteString("SetzePostleitzahlinHK ");
         WriteLn;
        HKe.SetzeStadtinHK(hk,SOrt);
         WriteString("SetzeStadtinHK ");
         WriteLn;

        IF NOT String.IsEqual(SGebOrt, SLeer) THEN
            HKe.SetzeGeburtsortinHK(hk,SGebOrt);
             WriteString("SetzeGeburtsortinHK ");
             WriteLn;
        END; (* IF *)
        IF NOT String.IsEqual(SLand, SLeer) THEN
            HKe.SetzeLandinHK(hk,SLand);
             WriteString("SetzeLandinHK ");
             WriteLn;
        END; (* IF *)
        IF NOT String.IsEqual(STelefon, SLeer) THEN
            HKe.SetzeTelefoninHK(hk,STelefon);
             WriteString("SetzeTelefoninHK ");
             WriteLn;
        END; (* IF *)
        IF NOT String.IsEqual(SFax, SLeer) THEN
            HKe.SetzeFaxinHK(hk,SFax);
             WriteString("SetzeFaxinHK ");
             WriteLn;
        END; (* IF *)
        IF NOT String.IsEqual(SEmail, SLeer) THEN
            HKe.SetzeeMailinHK(hk,SEmail);
             WriteString("SetzeeMailinHK ");
             WriteLn;
        END; (* IF *)
        IF NOT String.IsEqual(SFirma, SLeer) THEN
            HKe.SetzeDienstNameinHK(hk,SFirma);
             WriteString("SetzeDienstNameinHK ");
             WriteLn;
        END; (* IF *)
        IF NOT String.IsEqual(SGebaeude, SLeer) THEN
            HKe.SetzeDienstGebaeudeinHK(hk,SGebaeude);
             WriteString("SetzeDienstGebaeudeinHK ");
             WriteLn;
        END; (* IF *)
        IF NOT String.IsEqual(SZimmer, SLeer) THEN
            HKe.SetzeDienstZimmerinHK(hk,SZimmer);
             WriteString("SetzeDienstZimmerinHK ");
             WriteLn;
        END; (* IF *)
        IF NOT String.IsEqual(SDStrasse, SLeer) THEN
            HKe.SetzeDienstStrinHK(hk,SDStrasse);
             WriteString("SetzeDienstStrinHK ");
             WriteLn;
        END; (* IF *)
        IF NOT String.IsEqual(SDPlz, SLeer) THEN
            HKe.SetzeDienstPlzinHK(hk,SDPlz);
             WriteString("SetzeDienstPlzinHK ");
             WriteLn;
        END; (* IF *)
        IF NOT String.IsEqual(SDOrt, SLeer) THEN
            HKe.SetzeDienstStadtinHK(hk,SDOrt);
             WriteString("SetzeDienstStadtinHK ");
             WriteLn;
        END; (* IF *)
        IF NOT String.IsEqual(SDLand, SLeer) THEN
            HKe.SetzeDienstLandinHK(hk,SDLand);
             WriteString("SetzeDienstLandinHK ");
             WriteLn;
        END; (* IF *)
        IF NOT String.IsEqual(SDTelefon, SLeer) THEN
            HKe.SetzeDienstTelinHK(hk,SDTelefon);
             WriteString("SetzeDienstTelinHK ");
             WriteLn;
        END; (* IF *)
        IF NOT String.IsEqual(SDFax, SLeer) THEN
            HKe.SetzeDienstFaxinHK(hk,SDFax);
             WriteString("SetzeDienstFaxinHK ");
             WriteLn;
        END; (* IF *)
        IF NOT String.IsEqual(SDEmail, SLeer) THEN
            HKe.SetzeDiensteMailinHK(hk,SDEmail);
             WriteString("SetzeDiensteMailinHK ");
             WriteLn;
        END; (* IF *)
        IF NOT String.IsEqual(SStaat, SLeer) THEN
            HKe.SetzeStaatsanginHK(hk,SStaat);
             WriteString("SetzeStaatsanginHK ");
             WriteLn;
        END; (* IF *)
        IF NOT String.IsEqual(SBank, SLeer) THEN
            HKe.SetzeBankinstOrtinHK(hk,SBank);
             WriteString("SetzeBankinstOrtinHK ");
             WriteLn;
        END; (* IF *)
        IF NOT String.IsEqual(SAbschluss, SLeer) THEN
            HKe.SetzeAbschlussinHK(hk,SAbschluss);
             WriteString("SetzeAbschlussinHK ");
             WriteLn;
        END; (* IF *)
        IF NOT String.IsEqual(SInteressen, SLeer) THEN
            HKe.SetzeInteresseninHK(hk,SInteressen);
             WriteString("SetzeInteresseninHK ");
             WriteLn;
        END; (* IF *)
        IF NOT String.IsEqual(SBemerkungen, SLeer) THEN
            HKe.SetzeBemerkungeninHK(hk,SBemerkungen);
             WriteString("SetzeBemerkungeninHK ");
             WriteLn;
        END; (* IF *)

        (* IF NOT HKe.InsertHK(hk, EMeldung) THEN
            MeldungAnzeigen(EMeldung); *)
	IF NOT AufnehmenHK(hk, EMeldung) THEN
            MeldungAnzeigen(EMeldung);
        ELSE
            WriteString("InsertHK ");
            WriteLn;
        END; (* IF *)
    END; (* IF *)


    (* nicht mehr bentigten Speicher vor dem Schlieen des Fensters freigeben *)
    String.Dispose(SPersNr);
    String.Dispose(SGeschlecht);
    String.Dispose(SName);
    String.Dispose(SVorname);
    String.Dispose(SStrasse);
    String.Dispose(SPlz);
    String.Dispose(SOrt);

    String.Dispose(SGebOrt);
    String.Dispose(SGebDat);
    String.Dispose(SLand);
    String.Dispose(STelefon);
    String.Dispose(SFax);

    String.Dispose(SEmail);
    String.Dispose(SFirma);
    String.Dispose(SGebaeude);
    String.Dispose(SZimmer);
    String.Dispose(SDStrasse);

    String.Dispose(SDPlz);
    String.Dispose(SDOrt);
    String.Dispose(SDLand);
    String.Dispose(SDTelefon);
    String.Dispose(SDFax);

    String.Dispose(SDEmail);
    String.Dispose(SStaat);
    String.Dispose(SKinder);
    String.Dispose(SFamilie);
    String.Dispose(SBank);
    String.Dispose(SBlz);
    String.Dispose(SKonto);
    String.Dispose(SAbschluss);
    String.Dispose(SPraesenz);

    String.Dispose(SVerfuegbar);
    String.Dispose(SStd);
    String.Dispose(SInteressen);
    String.Dispose(SBemerkungen);
    String.Dispose(SLeer);
    String.Dispose(SText);	
    String.Dispose(SNull);

    String.Dispose(EMeldung);
    String.Dispose(EMeldung1);
    String.Dispose(EZuVieleKinder);

    HKe.DisposeHK(hk);
     WriteString("DisposeHK ");
     WriteLn;
    IF NOT error THEN
      DisposeFAnlegen();
    END; (* IF *)
  END AnlegenKnopfCallback;

(*************************************************************************************************)
(*************************************************************************************************)
(*************************************************************************************************)

PROCEDURE Mussfelder(inIchSelbst: TPFAnlegen): BOOLEAN;
(* berprft ob die Mussfelder ausgefllt wurden *)
  VAR
    EMussfeld, EMussfeld1,	(* Fehlermeldung *)
    SName, SVorname, SStrasse, SOrt, SPlz, SGebDat : String.TString;
    error: BOOLEAN;

  BEGIN		
    (* Initialisierungen *)
    EMussfeld:= String.Create();
    EMussfeld1:= String.Create();
    String.Schreibe(EMussfeld,"Bitte fllen Sie mindestens die Eingabefelder 'Name', 'Vorname',");
    String.Schreibe(EMussfeld1," 'Strasse', 'Plz', 'Ort' und 'Geburtsdatum' aus!");
    String.Anhaengen(EMussfeld1, EMussfeld);
    SName:= String.Create();
    SVorname:= String.Create();
    SStrasse:= String.Create();
    SOrt:= String.Create();
    SPlz:= String.Create();
    SGebDat:= String.Create();
    LiesZeile(inIchSelbst^.NameZ, SName);
    LiesZeile(inIchSelbst^.VornameZ, SVorname);
    LiesZeile(inIchSelbst^.StrasseZ, SStrasse);
    LiesZeile(inIchSelbst^.OrtZ, SOrt);
    LiesZeile(inIchSelbst^.PlzZ, SPlz);
    LiesZeile(inIchSelbst^.GebDatZ, SGebDat);
    error := FALSE;

    (* berprfungsroutine *)
    IF (String.Laenge(SName) = 0) OR (String.Laenge(SVorname) = 0) OR (String.Laenge(SGebDat) = 0) OR
       (String.Laenge(SStrasse) = 0) OR (String.Laenge(SPlz) = 0) OR (String.Laenge(SOrt) = 0)
    THEN
       MeldungAnzeigen(EMussfeld);	
       error := TRUE;
    END; (* IF *)

    String.Dispose(EMussfeld);
    String.Dispose(EMussfeld1);
    String.Dispose(SName);
    String.Dispose(SVorname);
    String.Dispose(SStrasse);
    String.Dispose(SOrt);
    String.Dispose(SPlz);
    String.Dispose(SGebDat);
    RETURN error;
  END Mussfelder;

(*************************************************************************************************)

PROCEDURE PruefeLaengeEingabefelder(inIchSelbst: TPFAnlegen): BOOLEAN;
(* berprft die Lnge der Eingaben *)
  VAR
    EMeldung, EMeldung1, EMeldung2, EFeld, EZahl,	(* Fehlermeldungen *)
    SPersNr, SGebOrt, SGeschlecht, SName, SVorname, SStrasse, SPlz, SOrt, SLand, STelefon, SFax,
    SEmail, SFirma, SGebaeude, SZimmer, SDStrasse, SDPlz, SDOrt, SDLand,
    SDTelefon, SDFax, SDEmail, SStaat, SKinder, SBank, SBlz, SKonto,
    SAbschluss, SPraesenz, SStunden, SInteressen, SBemerkungen : String.TString;
    str: ARRAY [0..1] OF CHAR;
    error: BOOLEAN;

  BEGIN		
    (* Initialisierungen *)
    EMeldung:= String.Create();
    EMeldung1:= String.Create();
    EMeldung2:= String.Create();
    EFeld:= String.Create();
    EZahl:= String.Create();

    SPersNr:= String.Create();
    SGeschlecht:= String.Create();
    SGebOrt:= String.Create();
    SName:= String.Create();
    SVorname:= String.Create();

    SStrasse:= String.Create();
    SPlz:= String.Create();
    SOrt:= String.Create();
    SLand:= String.Create();
    STelefon:= String.Create();

    SFax:= String.Create();
    SEmail:= String.Create();
    SFirma:= String.Create();
    SGebaeude:= String.Create();
    SZimmer:= String.Create();

    SDStrasse:= String.Create();
    SDPlz:= String.Create();
    SDOrt:= String.Create();
    SDLand:= String.Create();
    SDTelefon:= String.Create();

    SDFax:= String.Create();
    SDEmail:= String.Create();
    SStaat:= String.Create();
    SKinder:= String.Create();
    SBank:= String.Create();

    SBlz:= String.Create();
    SKonto:= String.Create();
    SAbschluss:= String.Create();
    SPraesenz:= String.Create();
    SStunden:= String.Create();

    SInteressen:= String.Create();
    SBemerkungen:= String.Create();

    String.Schreibe(EMeldung,"In das Eingabefeld '");
    String.Schreibe(EMeldung1,"' drfen Sie hchstens ");
    String.Schreibe(EMeldung2," Zeichen eingeben!");

    LiesZeile(inIchSelbst^.PersNrZ, SPersNr);
    LiesZeile(inIchSelbst^.GeschlechtZ, SGeschlecht);
    LiesZeile(inIchSelbst^.GebOrtZ, SGebOrt);
    LiesZeile(inIchSelbst^.NameZ, SName);
    LiesZeile(inIchSelbst^.VornameZ, SVorname);

    LiesZeile(inIchSelbst^.StrasseZ, SStrasse);
    LiesZeile(inIchSelbst^.PlzZ, SPlz);
    LiesZeile(inIchSelbst^.OrtZ, SOrt);
    LiesZeile(inIchSelbst^.LandZ, SLand);
    LiesZeile(inIchSelbst^.TelefonZ, STelefon);

    LiesZeile(inIchSelbst^.FaxZ, SFax);
    LiesZeile(inIchSelbst^.EmailZ, SEmail);
    LiesZeile(inIchSelbst^.FirmaZ, SFirma);
    LiesZeile(inIchSelbst^.GebaeudeZ, SGebaeude);
    LiesZeile(inIchSelbst^.ZimmerZ, SZimmer);

    LiesZeile(inIchSelbst^.DStrasseZ, SDStrasse);
    LiesZeile(inIchSelbst^.DPlzZ, SDPlz);
    LiesZeile(inIchSelbst^.DOrtZ, SDOrt);
    LiesZeile(inIchSelbst^.DLandZ, SDLand);
    LiesZeile(inIchSelbst^.DTelefonZ, SDTelefon);

    LiesZeile(inIchSelbst^.DFaxZ, SDFax);
    LiesZeile(inIchSelbst^.DEmailZ, SDEmail);
    LiesZeile(inIchSelbst^.StaatZ, SStaat);
    LiesZeile(inIchSelbst^.KinderZ, SKinder);
    LiesZeile(inIchSelbst^.BankZ, SBank);

    LiesZeile(inIchSelbst^.BlzZ, SBlz);
    LiesZeile(inIchSelbst^.KontoZ, SKonto);
    LiesZeile(inIchSelbst^.AbschlussZ, SAbschluss);
    LiesZeile(inIchSelbst^.PraesenzZ, SPraesenz);
    LiesZeile(inIchSelbst^.StundenZ, SStunden);

    LiesZeile(inIchSelbst^.InteressenZ, SInteressen);
    LiesZeile(inIchSelbst^.BemerkungenZ, SBemerkungen);
    error := FALSE;


    (* berprfungsroutine Eingabefeld Personalnummer*)
    IF (NOT error) AND (String.Laenge(SPersNr) > CNR) THEN
        String.Schreibe(EFeld,"Personalnummer");
        CardToStr(CNR, str);
        error := TRUE;
    END; (* IF *)

    IF (NOT error) AND (String.Laenge(SGeschlecht) > CGESCHLECHT) THEN
        String.Schreibe(EFeld,"Geschlecht");
        CardToStr(CGESCHLECHT, str);
        error := TRUE;
    END; (* IF *)

    IF (NOT error) AND (String.Laenge(SGebOrt) > CORT) THEN
        String.Schreibe(EFeld,"Geburtsort");
        CardToStr(CORT, str);
        error := TRUE;
    END; (* IF *)

    (* berprfungsroutine Eingabefeld Name*)
    IF (NOT error) AND (String.Laenge(SName) > CNAME) THEN
        String.Schreibe(EFeld,"Name");
        CardToStr(CNAME, str);
        error := TRUE;
    END; (* IF *)

    (* berprfungsroutine Eingabefeld Vorname *)
    IF (NOT error) AND (String.Laenge(SVorname) > CVORNAME) THEN
        String.Schreibe(EFeld,"Vorname");
        CardToStr(CVORNAME, str);
        error := TRUE;
    END; (* IF *)

    (* berprfungsroutine Eingabefeld Strasse *)
    IF (NOT error) AND (String.Laenge(SStrasse) > CSTRASSE) THEN
        String.Schreibe(EFeld,"Strae");
        CardToStr(CSTRASSE, str);
        error := TRUE;
    END; (* IF *)

    (* berprfungsroutine Eingabefeld PLZ *)
    IF (NOT error) AND (String.Laenge(SPlz) > CPLZ) THEN
        String.Schreibe(EFeld,"Plz");
        CardToStr(CPLZ, str);
        error := TRUE;
    END; (* IF *)

    (* berprfungsroutine Eingabefeld Ort *)
    IF (NOT error) AND (String.Laenge(SOrt) > CORT) THEN
        String.Schreibe(EFeld,"Ort");
        CardToStr(CORT, str);
        error := TRUE;
    END; (* IF *)

    (* berprfungsroutine Eingabefeld Land *)
    IF (NOT error) AND (String.Laenge(SLand) > CLAND) THEN
        String.Schreibe(EFeld,"Land");
        CardToStr(CLAND, str);
        error := TRUE;
    END; (* IF *)

    (* berprfungsroutine Eingabefeld Telefonnummer *)
    IF (NOT error) AND (String.Laenge(STelefon) > CTEL) THEN
        String.Schreibe(EFeld,"Telefon");
        CardToStr(CTEL, str);
        error := TRUE;
    END; (* IF *)

    (* berprfungsroutine Eingabefeld Fax *)
    IF (NOT error) AND (String.Laenge(SFax) > CTEL) THEN
        String.Schreibe(EFeld,"Fax");
        CardToStr(CTEL, str);
        error := TRUE;
    END; (* IF *)

    (* berprfungsroutine Eingabefeld Email *)
    IF (NOT error) AND (String.Laenge(SEmail) > CEMAIL) THEN
        String.Schreibe(EFeld,"E-Mail");
        CardToStr(CEMAIL, str);
        error := TRUE;
    END; (* IF *)

    (* berprfungsroutine Eingabefeld Firma *)
    IF (NOT error) AND (String.Laenge(SFirma) > CFIRMA) THEN
        String.Schreibe(EFeld,"Firma");
        CardToStr(CFIRMA, str);
        error := TRUE;
    END; (* IF *)

    (* berprfungsroutine Eingabefeld Gebude *)
    IF (NOT error) AND (String.Laenge(SGebaeude) > CGBDE) THEN
        String.Schreibe(EFeld,"Gebude");
        CardToStr(CGBDE, str);
        error := TRUE;
    END; (* IF *)

    (* berprfungsroutine Eingabefeld Zimmer *)
    IF (NOT error) AND (String.Laenge(SZimmer) > CZIMMER) THEN
        String.Schreibe(EFeld,"Zimmer");
        CardToStr(CZIMMER, str);
        error := TRUE;
    END; (* IF *)

    (* berprfungsroutine Eingabefeld Dienstadresse Strasse *)
    IF (NOT error) AND (String.Laenge(SDStrasse) > CSTRASSE) THEN
        String.Schreibe(EFeld,"Dienstadresse Strae");
        CardToStr(CSTRASSE, str);
        error := TRUE;
    END; (* IF *)

    (* berprfungsroutine Eingabefeld Dienstadresse PLZ *)
    IF (NOT error) AND (String.Laenge(SDPlz) > CPLZ) THEN
        String.Schreibe(EFeld,"Dienstadresse Plz");
        CardToStr(CPLZ, str);
        error := TRUE;
    END; (* IF *)

    (* berprfungsroutine Eingabefeld Dienstadresse Ort *)
    IF (NOT error) AND (String.Laenge(SDOrt) > CORT) THEN
        String.Schreibe(EFeld,"Dienstadresse Ort");
        CardToStr(CORT, str);
        error := TRUE;
    END; (* IF *)

    (* berprfungsroutine Eingabefeld Dienstadresse Land *)
    IF (NOT error) AND (String.Laenge(SDLand) > CLAND) THEN
        String.Schreibe(EFeld,"Dienstadresse Land");
        CardToStr(CLAND, str);
        error := TRUE;
    END; (* IF *)

    (* berprfungsroutine Eingabefeld Dienstadresse Telefonnummer *)
    IF (NOT error) AND (String.Laenge(SDTelefon) > CTEL) THEN
        String.Schreibe(EFeld,"Dienstadresse Telefon");
        CardToStr(CTEL, str);
        error := TRUE;
    END; (* IF *)

    (* berprfungsroutine Eingabefeld Dienstadresse Fax *)
    IF (NOT error) AND (String.Laenge(SDFax) > CTEL) THEN
        String.Schreibe(EFeld,"Dienstadresse Fax");
        CardToStr(CTEL, str);
        error := TRUE;
    END; (* IF *)

    (* berprfungsroutine Eingabefeld Dienstadresse Email *)
    IF (NOT error) AND (String.Laenge(SDEmail) > CEMAIL) THEN
        String.Schreibe(EFeld,"Dienstadresse E-Mail");
        CardToStr(CEMAIL, str);
        error := TRUE;
    END; (* IF *)

    (* berprfungsroutine Eingabefeld Staatsbrgerschaft *)
    IF (NOT error) AND (String.Laenge(SStaat) > CLAND) THEN
        String.Schreibe(EFeld,"Staatsbrgerschaft");
        CardToStr(CLAND, str);
        error := TRUE;
    END; (* IF *)

    (* berprfungsroutine Eingabefeld Kinder *)
    IF (NOT error) AND (String.Laenge(SKinder) > CKINDER) THEN
        String.Schreibe(EFeld,"Kinder");
        CardToStr(CKINDER, str);
        error := TRUE;
    END; (* IF *)

    (* berprfungsroutine Eingabefeld Bankinstitut *)
    IF (NOT error) AND (String.Laenge(SBank) > CBANK) THEN
        String.Schreibe(EFeld,"Bankinstitut");
        CardToStr(CBANK, str);
        error := TRUE;
    END; (* IF *)

    (* berprfungsroutine Eingabefeld  Bankleitzahl *)
    IF (NOT error) AND (String.Laenge(SBlz) > CBLZ) THEN
        String.Schreibe(EFeld,"Bankleitzahl");
        CardToStr(CBLZ, str);
        error := TRUE;
    END; (* IF *)

    (* berprfungsroutine Eingabefeld Kontonummer *)
    IF (NOT error) AND (String.Laenge(SKonto) > CKONTO) THEN
        String.Schreibe(EFeld,"Kontonummer");
        CardToStr(CKONTO, str);
        error := TRUE;
    END; (* IF *)

    (* berprfungsroutine Eingabefeld Abschluss *)
    IF (NOT error) AND (String.Laenge(SAbschluss) > CABSCHLUSS) THEN
        String.Schreibe(EFeld,"Abschluss");
        CardToStr(CABSCHLUSS, str);
        error := TRUE;
    END; (* IF *)

    (* berprfungsroutine Eingabefeld Prsenztage *)
    IF (NOT error) AND (String.Laenge(SPraesenz) > CPRAESENZ) THEN
        String.Schreibe(EFeld,"Prsenztage");
        CardToStr(CPRAESENZ, str);
        error := TRUE;
    END; (* IF *)

    (* berprfungsroutine Eingabefeld Voraussichtliche Stundenzahl *)
    IF (NOT error) AND (String.Laenge(SStunden) > CSTUNDEN) THEN
        String.Schreibe(EFeld,"Voraussichtliche Stundenzahl");
        CardToStr(CSTUNDEN, str);
        error := TRUE;
    END; (* IF *)

    (* berprfungsroutine Eingabefeld Interessen *)
    IF (NOT error) AND (String.Laenge(SInteressen) > CINTERESSEN) THEN
        String.Schreibe(EFeld,"Interessen");
        CardToStr(CINTERESSEN, str);
        error := TRUE;
    END; (* IF *)

    (* berprfungsroutine Eingabefeld Bemerkungen *)
    IF (NOT error) AND (String.Laenge(SBemerkungen) > CBEMERKUNGEN) THEN
        String.Schreibe(EFeld,"Bemerkungen");
        CardToStr(CBEMERKUNGEN, str);
        error := TRUE;
    END; (* IF *)


    (* Fehlermeldung ausgeben *)
    IF error THEN
        String.Schreibe(EZahl, str);
        String.Anhaengen(EFeld, EMeldung);
        String.Anhaengen(EMeldung1, EMeldung);
        String.Anhaengen(EZahl, EMeldung);
        String.Anhaengen(EMeldung2, EMeldung);
        MeldungAnzeigen(EMeldung);
    END; (* IF *)

    String.Dispose(EMeldung);
    String.Dispose(EMeldung1);
    String.Dispose(EMeldung2);
    String.Dispose(EFeld);
    String.Dispose(EZahl);

    String.Dispose(SPersNr);
    String.Dispose(SGeschlecht);
    String.Dispose(SGebOrt);
    String.Dispose(SName);
    String.Dispose(SVorname);

    String.Dispose(SStrasse);
    String.Dispose(SPlz);
    String.Dispose(SOrt);
    String.Dispose(SLand);
    String.Dispose(STelefon);

    String.Dispose(SFax);
    String.Dispose(SEmail);
    String.Dispose(SFirma);
    String.Dispose(SGebaeude);
    String.Dispose(SZimmer);

    String.Dispose(SDStrasse);
    String.Dispose(SDPlz);
    String.Dispose(SDOrt);
    String.Dispose(SDLand);
    String.Dispose(SDTelefon);

    String.Dispose(SDFax);
    String.Dispose(SDEmail);
    String.Dispose(SStaat);
    String.Dispose(SKinder);
    String.Dispose(SBank);

    String.Dispose(SBlz);
    String.Dispose(SKonto);
    String.Dispose(SAbschluss);
    String.Dispose(SPraesenz);
    String.Dispose(SStunden);

    String.Dispose(SInteressen);
    String.Dispose(SBemerkungen);
    RETURN error;
  END PruefeLaengeEingabefelder;

(*************************************************************************************************)
(******************************** PROCEDURE LoeschenKnopfCallback() ******************************)
(*************************************************************************************************)

PROCEDURE LoeschenKnopfCallback();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFAnlegen;
  BEGIN
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFAnlegen, meineAddr);
    (* ZeilenEntfernen(); *)
    (* ZeilenAnlegen();  *)
    (* AnzeigenMeldung("Eingabefelder werden gelscht."); *)

    (* MeldungenEntfernen(); *)
    (* ZeilenEntfernen();   *)
    (* KnoepfeEntfernen(); *)
    EntferneFenster(ichSelbst^.WinHdle);
    DISPOSE(ichSelbst);
    Pop();
    CreateFAnlegen();
  END LoeschenKnopfCallback;

(*************************************************************************************************)
(*********************************** PROCEDURE CreateFAnlegen() **********************************)
(*************************************************************************************************)

PROCEDURE CreateFAnlegen();
  VAR FensterUeberschrift: String.TString;
      WinHdle: ADDRESS;
      ichSelbst: TPFAnlegen;
      meineAddr: ADDRESS;
  BEGIN
    NEW (ichSelbst);
    FensterUeberschrift := String.Create();
    String.Schreibe( FensterUeberschrift,"Anlegen einer Hilfskraft");
    WinHdle:=NeuesFenster(FensterUeberschrift,CFOBEN,CFLINKS,CFHOEHE,CFBREITE);
    String.Dispose(FensterUeberschrift);
    meineAddr:= CAST(ADDRESS, ichSelbst);
    Push(ReaktFAnlegen, meineAddr);
    ichSelbst^.WinHdle:=WinHdle;
    MeldungenAnlegen();
    ZeilenAnlegen(); (* Eingabefelder aufbauen *)
    KnoepfeAnlegen();
  END CreateFAnlegen;

(*************************************************************************************************)
(*********************************** PROCEDURE DisposeFAnlegen() *********************************)
(*************************************************************************************************)

PROCEDURE DisposeFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFAnlegen;
  BEGIN
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFAnlegen, meineAddr);
   (* MeldungenEntfernen(); *)
   (* ZeilenEntfernen(); *)
   (* KnoepfeEntfernen(); *)
    EntferneFenster(ichSelbst^.WinHdle);

    Pop();
    DISPOSE(ichSelbst);
    Top(reaktProc, meineAddr);
    reaktProc();
  END DisposeFAnlegen;

(*************************************************************************************************)
(********************************** PROCEDURE MeldungenEntfernen() *******************************)
(*************************************************************************************************)

(* PROCEDURE MeldungenEntfernen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFAnlegen;
  BEGIN
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFAnlegen, meineAddr);
    EntferneMeldung(ichSelbst^.AdresseM);
    EntferneMeldung(ichSelbst^.DienstadrM);
    EntferneMeldung(ichSelbst^.PrivatesM);
    EntferneMeldung(ichSelbst^.BVerbindungM);
    EntferneMeldung(ichSelbst^.InternesM);
  END MeldungenEntfernen; *)

(*************************************************************************************************)
(*********************************** PROCEDURE ZeilenEntfernen() *********************************)
(*************************************************************************************************)
(*
PROCEDURE ZeilenEntfernen();
  VAR text, leer: String.TString;
      meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFAnlegen;
  BEGIN
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFAnlegen, meineAddr);
    * text:= String.Create();
    leer:= String.Create();
    String.Schreibe(leer,"");

    LiesZeile(ichSelbst^.PersNrZ, text);
    IF ichSelbst^.PersNrZ <> NIL THEN
        MeldungAnzeigen(text);
    END;  IF
    EntferneZeile(ichSelbst^.PersNrZ);
    EntferneZeile(ichSelbst^.GebDatZ);
    EntferneZeile(ichSelbst^.GebOrtZ);
    EntferneZeile(ichSelbst^.GeschlechtZ);
    EntferneZeile(ichSelbst^.NameZ);

    EntferneZeile(ichSelbst^.VornameZ);
    EntferneZeile(ichSelbst^.StrasseZ);
    EntferneZeile(ichSelbst^.PlzZ);
    EntferneZeile(ichSelbst^.OrtZ);
    EntferneZeile(ichSelbst^.LandZ);

    EntferneZeile(ichSelbst^.TelefonZ);
    EntferneZeile(ichSelbst^.FaxZ);
    EntferneZeile(ichSelbst^.EmailZ);
    EntferneZeile(ichSelbst^.FirmaZ);
    EntferneZeile(ichSelbst^.GebaeudeZ);

    EntferneZeile(ichSelbst^.ZimmerZ);
    EntferneZeile(ichSelbst^.DStrasseZ);
    EntferneZeile(ichSelbst^.DPlzZ);
    EntferneZeile(ichSelbst^.DOrtZ);
    EntferneZeile(ichSelbst^.DLandZ);

    EntferneZeile(ichSelbst^.DTelefonZ);
    EntferneZeile(ichSelbst^.DFaxZ);
    EntferneZeile(ichSelbst^.DEmailZ);
    EntferneZeile(ichSelbst^.StaatZ);
    EntferneZeile(ichSelbst^.FamilieZ);

    EntferneZeile(ichSelbst^.KinderZ);
    EntferneZeile(ichSelbst^.BankZ);
    EntferneZeile(ichSelbst^.BlzZ);
    EntferneZeile(ichSelbst^.KontoZ);
    EntferneZeile(ichSelbst^.AbschlussZ);

    EntferneZeile(ichSelbst^.PraesenzZ);
    EntferneZeile(ichSelbst^.VerfuegbarZ);
    EntferneZeile(ichSelbst^.StundenZ);
    EntferneZeile(ichSelbst^.InteressenZ);
    EntferneZeile(ichSelbst^.BemerkungenZ);

   * String.Dispose(text);
    String.Dispose(leer); *
  END ZeilenEntfernen;    *)

(*************************************************************************************************)
(*********************************** PROCEDURE KnoepfeEntfernen() ********************************)
(*************************************************************************************************)

(* PROCEDURE KnoepfeEntfernen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFAnlegen;
  BEGIN
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFAnlegen, meineAddr);
    EntferneKnopf(ichSelbst^.AnlegenKnopf);
    EntferneKnopf(ichSelbst^.LoeschenKnopf);
    EntferneKnopf(ichSelbst^.AbbrechenKnopf);
  END KnoepfeEntfernen;     *)

(*************************************************************************************************)
(************************************ PROCEDURE DeaktFAnlegen() **********************************)
(*************************************************************************************************)

PROCEDURE DeaktFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFAnlegen;
  BEGIN
    (*Deaktiviere Knpfe, Listboxen,... *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFAnlegen, meineAddr);
    SetzeKnopf(ichSelbst^.AnlegenKnopf, FALSE);
    SetzeKnopf(ichSelbst^.LoeschenKnopf, FALSE);
    SetzeKnopf(ichSelbst^.AbbrechenKnopf, FALSE);
  END DeaktFAnlegen;

(*************************************************************************************************)
(************************************ PROCEDURE ReaktFAnlegen() **********************************)
(*************************************************************************************************)

PROCEDURE ReaktFAnlegen();                                                           		
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFAnlegen;
  BEGIN
   (* Aktiviere alle Fensterinhalte *)
   Top(reaktProc, meineAddr);
   ichSelbst:= CAST(TPFAnlegen, meineAddr);
   SetzeKnopf(ichSelbst^.AnlegenKnopf, TRUE);
   SetzeKnopf(ichSelbst^.LoeschenKnopf, TRUE);
   SetzeKnopf(ichSelbst^.AbbrechenKnopf, TRUE);
  END ReaktFAnlegen;

(*************************************************************************************************)
(*********************************** PROCEDURE AnzeigenMeldung() *********************************)
(*************************************************************************************************)
(*
PROCEDURE AnzeigenMeldung(inStr:ARRAY OF CHAR);                                                           		
  VAR
      MeldText: String.TString;
  BEGIN
    MeldText := String.Create();
    String.Schreibe(MeldText, inStr);
    MeldungAnzeigen(MeldText);
    String.Dispose(MeldText);
  END AnzeigenMeldung; *)

END FAnlegenHK.


