(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile$
# $Author$
# $Date$
# $Revision$
# Bemerkungen:

IMPLEMENTATION MODULE FPruefmodulHK;

Johannes Magauer

*)
(******************************************************************************)

IMPLEMENTATION MODULE FPruefmodulHK;

IMPORT String;
FROM WholeStr IMPORT ConvResults, StrToCard;

PROCEDURE PruefeStringZahl(VAR inString: String.TString; outMessage: String.TString): BOOLEAN;
(* prft ob der String inString nur aus Ziffern besteht.
   ja --> Rckgabewert TRUE, inString wird nicht verndert, outMessage = "";
   nein --> Rckgabewert FALSE, inString wird nicht verndert,
            outMessage enthlt eine Fehlermeldung *)
  VAR
    ok: BOOLEAN;
    str: ARRAY [0..255] OF CHAR;
    i: CARDINAL;

  BEGIN		
    ok := TRUE;
    String.Lies(inString, str);
    FOR i:= 0 TO (String.Laenge(inString)-1) DO
        IF (str[i] < '0') OR (str[i] > '9') THEN
            ok := FALSE;
            String.Schreibe(outMessage, "Geben Sie bitte nur ganze Zahlen ein.");
        END; (* IF *)
    END; (* FOR *)
    RETURN ok;
  END PruefeStringZahl;

(*************************************************************************************************)

PROCEDURE PruefeCardPos(inString: String.TString; VAR inoutCard: CARDINAL;
		     outMessage: String.TString): BOOLEAN;
(* Prft ob der String inString eine Kardinalzahl >0 ist
   ja --> Rckgabewert TRUE, inString wird nicht verndert, inoutCard = entsprechende Kardinalzahl,
   outMessage = "";
   nein --> Rckgabewert FALSE, inString wird nicht verndert, inoutCard = 0 oder 1,
   outMessage.enthlt eine Fehlermeldung *)
  VAR
    ok: BOOLEAN;
    str: ARRAY [0..255] OF CHAR;
    res: ConvResults;

  BEGIN		
    (* Initialisierungen *)
    ok := TRUE;
    inoutCard := 1;
    String.Schreibe(outMessage,"");
    String.Lies(inString, str); 	(* String fr StrToCard in ARRAY OF CHAR umwandeln *)
    StrToCard(str, inoutCard, res); (* ARRAY OF CHAR in CARDINAL umwandeln *)

        (* berprfung *)
    IF (res <> strAllRight) OR (inoutCard = 0) THEN
        String.Schreibe(outMessage,"Sie drfen nur positive Zahlen eingeben.");
        ok := FALSE;
    END; (* IF *)
    RETURN ok;
  END PruefeCardPos;

(*************************************************************************************************)

PROCEDURE PruefeGeschlecht(inString: String.TString; VAR inoutGeschlecht: CHAR;
			   outMessage: String.TString): BOOLEAN;
(* Prft ob der String inString = "f" oder "m" ist.
   ja --> Rckgabewert TRUE, inString wird nicht verndert, inoutGeschlecht = entsprechender Char,
   outMessage = "";
   nein --> Rckgabewert FALSE, inString wird nicht verndert, inoutGeschlecht = 'f',
   outMessage.enthlt eine Fehlermeldung *)
  VAR
    ok: BOOLEAN;
    str: ARRAY [0..0] OF CHAR;

  BEGIN		
    (* Initialisierungen *)
    ok := TRUE;
    String.Schreibe(outMessage,"");
    String.Lies(inString, str);	(* String in CHAR umwandeln *)
    inoutGeschlecht := str[0];
    IF (inoutGeschlecht <> 'f') AND (inoutGeschlecht <> 'm') THEN
        String.Schreibe(outMessage,"Geben Sie bitte 'f' fr Frau oder 'm' fr Mann ein!");
        inoutGeschlecht := 'f';
        ok:= FALSE;
    END; (* IF *)
    RETURN ok;
  END PruefeGeschlecht;

(*************************************************************************************************)

PROCEDURE PruefeFamilienstand(inString: String.TString; VAR inoutFamilie: CHAR;
			      outMessage: String.TString): BOOLEAN;
(* Prft ob der String inString = "l", "v", "w" oder "g" ist.
   ja --> Rckgabewert TRUE, inString wird nicht verndert, inoutFamilie = entsprechender Char,
   outMessage = "";
   nein --> Rckgabewert FALSE, inString wird nicht verndert, inoutFamilie = '',
   outMessage.enthlt eine Fehlermeldung *)
  VAR
    ok: BOOLEAN;
    str: ARRAY [0..0] OF CHAR;
    anhang: String.TString;

  BEGIN	
    anhang:= String.Create();	
    (* Initialisierungen *)
    ok := TRUE;
    String.Schreibe(outMessage,"");
    String.Lies(inString, str);	(* String in CHAR umwandeln *)
    inoutFamilie := str[0];
    IF (inoutFamilie <> 'l') AND (inoutFamilie <> 'v')
    			     AND (inoutFamilie <> 'w') AND (inoutFamilie <> 'g') THEN
        String.Schreibe(outMessage,"Geben Sie bitte 'l' fr ledig, 'v' fr verheiratet, 'w' fr ");
        String.Schreibe(anhang,"Witwe(r) oder 'g' fr geschieden ein!");
        String.Anhaengen(anhang, outMessage);
        inoutFamilie:= '';
        ok := FALSE;
    END; (* IF *)
    String.Dispose(anhang);
    RETURN ok;
  END PruefeFamilienstand;
END FPruefmodulHK.
