(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: FSelektionHK.mod,v $
# $Author: Sopra $
# $Date: 2001/03/12 16:39:46 $
# $Revision: 1.3 $
# Bemerkungen:

IMPLEMENTATION MODULE FSelektionHK;

Johannes Magauer

*)
(******************************************************************************)

IMPLEMENTATION MODULE FSelektionHK;

FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT StelleListeDar, LiesListenelement, EntferneListe;
FROM X_Grafik IMPORT MeldungAnzeigen;

FROM SYSTEM IMPORT CAST, ADDRESS, TSIZE;
FROM Storage IMPORT ALLOCATE, DEALLOCATE;
FROM WholeStr IMPORT ConvResults, StrToCard;
IMPORT String;
IMPORT Stringliste;

FROM SysReaktFStapel IMPORT Push, Pop, Top, TProc;
FROM FAendernHK IMPORT CreateFAendern;
IMPORT HKe;


(* ACHTUNG : Das Programm entfernt keine erzeugten Strings und
** Stringlisten. Die X-Grafik-Bibliothek kopiert alle Strings, so
** dass diese nach Erzeugung der Fenster geloescht werden koennten. 
** Das Schliessen eines Fensters ueber die Window s-Menue-Leiste wird 
** von der X-Grafik-Bibliothek nicht erkannt und ist verboten. 
*)

  TYPE 	TFSelektionHKDS = RECORD
		     WinHdle,
		     ListenHdle,
		     AbbrechenHdle: ADDRESS;
		   END;	
       	TPFSelektion = POINTER TO TFSelektionHKDS;

  CONST CFLINKS = 50;
  	CFOBEN = 50;
  	CFHOEHE = 300;
  	CFBREITE = 500;
	CKNOPFX = 380;
	CKNOPFY = 260;   	       	

  VAR
     ichSelbst: TPFSelektion; (* Zeiger auf ADT Fenster FSelektion *)
     meineAddr: ADDRESS; (* Addresse dazu *)
     reaktProc: TProc;


(* --------------------------------------------------------------- *)

PROCEDURE KnoepfeAnlegen();
  VAR
    AbbrechenKnopfText: String.TString;
    AbbrechenKnopfHandle: ADDRESS;

  BEGIN
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSelektion, meineAddr);
    (* Aktuellen Stapeleintrag holen, und Zeiger auf ADT Fenster generieren *)

    AbbrechenKnopfText := String.Create();
    String.Schreibe(AbbrechenKnopfText,"Abbrechen");
    AbbrechenKnopfHandle := StelleKnopfDar(AbbrechenKnopfText,ichSelbst^.WinHdle,CKNOPFX,
					   CKNOPFY,CAST(PROC,AbbrechenKnopfCallback));
    String.Dispose(AbbrechenKnopfText);

    WITH ichSelbst^ DO
      AbbrechenHdle:= AbbrechenKnopfHandle;
    END (*WITH*)
  END KnoepfeAnlegen;

PROCEDURE StelleDarListe();
  VAR
    Ueberschrift: String.TString;
    HKeStringListe: Stringliste.TStringliste;
  BEGIN
    HKeStringListe := Stringliste.Create();
    HKeStringListe := HKe.GibHKeAlsStringlisteinHKe();
    IF Stringliste.IsEmpty(HKeStringListe) THEN
        AusgebenMeldung("Sie mssen zuerst eine Hilfskraft anlegen.");
        Stringliste.Dispose(HKeStringListe);
        DisposeFSelektion();
    ELSE
        Ueberschrift := String.Create();
        String.Schreibe (Ueberschrift, "Hilfskrfte, Auswahl mit linker Maustaste");
        ichSelbst^.ListenHdle := StelleListeDar(HKeStringListe,Ueberschrift,9,
                             ichSelbst^.WinHdle,50,40,CAST(PROC,ListeCallback));

       (* WHILE NOT (Stringliste.IsEmpty(HKeStringListe)) DO
            Stringliste.GoStart(HKeStringListe);
            Stringliste.Delete(HKeStringListe);
        END; *)
        String.Dispose(Ueberschrift);
        Stringliste.Dispose(HKeStringListe);
    END; (* IF *)
  END StelleDarListe;

PROCEDURE ListeCallback(Nr:INTEGER);
  VAR
    ElementString,
    HKeIDString: String.TString;
    hilfskraftID: HKe.TPersID;
    hk: HKe.THK;
    dummy: BOOLEAN;
  BEGIN
    ElementString := String.Create();
    HKeIDString := String.Create();
    LiesListenelement(ichSelbst^.ListenHdle, Nr, ElementString);
    String.Auslesen(ElementString,0,5,HKeIDString);
    hilfskraftID:= HKe.StringInPersID(HKeIDString);
    dummy:= HKe.SearchHK(hilfskraftID, hk);

    EntferneListe(ichSelbst^.ListenHdle);
    KnoepfeEntfernen();
    EntferneFenster(ichSelbst^.WinHdle);
    Pop();
    DISPOSE(ichSelbst);
    String.Dispose(ElementString);
    String.Dispose(HKeIDString);

    CreateFAendern(hk);
    (* Neues Fenster erzeugen *)
  END ListeCallback;

PROCEDURE AbbrechenKnopfCallback();
  BEGIN
    DisposeFSelektion();
  END AbbrechenKnopfCallback;


PROCEDURE DisposeFSelektion();
  BEGIN
    IF ichSelbst^.ListenHdle <> NIL THEN
        EntferneListe(ichSelbst^.ListenHdle);
    END; (* IF *)
    KnoepfeEntfernen();
    EntferneFenster(ichSelbst^.WinHdle);
    Pop();
    DISPOSE(ichSelbst);
    Top(reaktProc, meineAddr);
    reaktProc();
  END DisposeFSelektion;

PROCEDURE KnoepfeEntfernen();
  BEGIN
    EntferneKnopf(ichSelbst^.AbbrechenHdle);
END KnoepfeEntfernen;

PROCEDURE DeaktFSelektion();
  BEGIN
    SetzeKnopf(ichSelbst^.AbbrechenHdle, FALSE);
  END DeaktFSelektion;

PROCEDURE ReaktFSelektion();                                                           		
  BEGIN
    (* Aktiviere alle Fensterinhalte *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSelektion, meineAddr);
    (* Aktuellen Stapeleintrag holen, und Zeiger auf ADT Fenster generieren *)

    SetzeKnopf(ichSelbst^.AbbrechenHdle, TRUE);
  END ReaktFSelektion;

PROCEDURE CreateFSelektion();
  VAR
    FensterUeberschrift: String.TString;
  BEGIN
    NEW (ichSelbst);
    FensterUeberschrift := String.Create();
    String.Schreibe( FensterUeberschrift,"Selektion einer Hilfskraft");
    ichSelbst^.WinHdle:=NeuesFenster(FensterUeberschrift,CFOBEN,CFLINKS,CFHOEHE,CFBREITE);
    ichSelbst^.ListenHdle := NIL;
    String.Dispose(FensterUeberschrift);
    meineAddr:= CAST(ADDRESS, ichSelbst);
    Push(ReaktFSelektion, meineAddr);
    KnoepfeAnlegen();
    StelleDarListe();
  END CreateFSelektion;

PROCEDURE AusgebenMeldung(inStr:ARRAY OF CHAR);
   VAR
    MeldText: String.TString;
  BEGIN
    MeldText := String.Create();
    String.Schreibe(MeldText, inStr);
    MeldungAnzeigen(MeldText);
    String.Dispose(MeldText);
  END AusgebenMeldung;

END FSelektionHK.
