(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: FAnlegenKst.mod,v $
# $Author: Sopra $
# $Date: 2001/03/13 14:47:56 $
# $Revision: 1.10 $
# Bemerkungen:

IMPLEMENTATION MODULE FAnlegenKst; 
Funktion: Anlegen einer Kostenstelle im Hiks

JZ

V 0.6   26.2.01  20:30


*)
(******************************************************************************)

IMPLEMENTATION MODULE FAnlegenKst;

(* System-Importe *)
FROM X_Grafik IMPORT StelleListeDar,EntferneListe;
FROM X_Grafik IMPORT LiesListenelement, AendereListenelement;
FROM X_Grafik IMPORT StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM X_Grafik IMPORT StelleTextDar, EntferneText;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT InitialisiereGrafik, StarteGrafik;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT MeldungAnzeigen, JaNeinAbfrage;
FROM X_Grafik IMPORT StringEingabeFenster, StringEingabeAuslesen;
FROM X_Grafik IMPORT StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT LiesMenueEintrag, EntferneMenue;

FROM SYSTEM 	IMPORT CAST, ADR, ADDRESS, TSIZE;
FROM Storage 	IMPORT ALLOCATE, DEALLOCATE;
FROM InOut 	IMPORT WriteCard, WriteLn, WriteString, WriteInt;
IMPORT  WholeConv;
IMPORT  WholeStr;
IMPORT  ConvTypes;
IMPORT  String;  (*  "String" TString *)
IMPORT  Strings; (*  "Str"   Strings  enthaelt Operationen fuer ARRAY OF CHAR Datentypen !! *)
IMPORT  Stringliste;


(* HiKS-Importe *)
FROM SysReaktFStapel  IMPORT Push, Pop, Top, TProc;
IMPORT 	Datum;
FROM Ksten IMPORT	TKstID, TKst,
			CreateKst, DisposeKstID,
			SetzeKIDinKst, LiesKIDinKst,
 			SetzeEingAminKst, LiesEingAminKst,
 			SetzeGesperrtAminKst, LiesGesperrtAminKst,
 			IstGesperrtAminKst, SetzeLiquidAminKst, 	
			LiesLiquidAminKst, IstLiquidiertAminKst,
			SetzeNameinKst, LiesNameinKst,
			SetzeJahrinKst, LiesJahrinKst,
			SetzeKontinginKst, LiesKontinginKst,
			SetzeAequivinKst, LiesAequivinKst,
			ExistKst,
			KstIDAlsString, StringInKstID,  PruefeKstID,
			GibKstenAlsStringlisteInKsten,
			InsertKst,
			SearchKstZuKID;

FROM PSB IMPORT	 EinrichtenKst;



  TYPE 	TFAnlegenKstDS = RECORD
		           WinHdle : ADDRESS;
		           AnlegenKnopfHdle,
			   AbbrechenKnopfHdle:ADDRESS;  		
			   KstIDHdle,
			   NameHdle,
			   JahrHdle,
			   KontingentHdle,
			   AequivalentHdle : ADDRESS
  	      		 END;	
        TPFAnlegenKst = POINTER TO TFAnlegenKstDS;


(* --------------------------------------------------------------- *)

PROCEDURE AktivFAnlegen();
  CONST
    KnopfYPos=INT(230);
    AnlegenKnopfXPos=INT(40);
    LoeschenKnopfXPos=INT(210);
    AbbrechenKnopfXPos=INT(370);
  VAR
    Text     : String.TString;
    reaktProc: TProc;
    meineAddr: ADDRESS; 
    ichSelbst: TPFAnlegenKst;
  BEGIN
    IF TRACE THEN WriteString("FAnlegenKst.AktivFAnlegen Begin"); WriteLn; END;
    (* Erzeuge den Fensterinhalt *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFAnlegenKst, meineAddr);

    InitEingabeFelder();

    Text := String.Create();
    String.Schreibe(Text,"Kostenstelle anlegen");
    ichSelbst^.AnlegenKnopfHdle:=StelleKnopfDar(Text, ichSelbst^.WinHdle, AnlegenKnopfXPos,
    						 KnopfYPos, CAST(PROC,AnlegenKnopfCallback));

    String.Schreibe(Text,"Abbrechen");
    ichSelbst^.AbbrechenKnopfHdle:=StelleKnopfDar(Text, ichSelbst^.WinHdle, AbbrechenKnopfXPos,
    						 KnopfYPos, CAST(PROC,AbbrechenKnopfCallback));
    String.Dispose(Text);

    IF TRACE THEN WriteString("FAnlegenKst.AktivFAnlegen End"); WriteLn; END;
  END AktivFAnlegen;



PROCEDURE AbbrechenKnopfCallback();
  BEGIN
    IF TRACE THEN WriteString("FAnlegenKst.AbbrechenKnopfCallback Begin"); WriteLn; END;
    DisposeFAnlegen();
    IF TRACE THEN WriteString("FAnlegenKst.AbbrechenKnopfCallback End"); WriteLn; END;
  END AbbrechenKnopfCallback;



PROCEDURE AnlegenKnopfCallback();
  CONST
  VAR
    DatumString, MeldString, KstIDString, NameString, JahrString,
    			KontingentString, AequivalentString: String.TString;
    DatumStr, TextStr, MeldStr, KstIDStr, NameStr, JahrStr, KontingentStr,
    				AequivalentStr: ARRAY[1..200] OF CHAR;
    Kontingent: CARDINAL;
    Aequivalent: CARDINAL;
    KstIDCard: CARDINAL;
    reaktProc: TProc;
    meineAddr: ADDRESS; 
    ichSelbst: TPFAnlegenKst;
    DatenOkay: BOOLEAN;

    KstID: TKstID;
    Kst: TKst;
    Jahr: Datum.TJahr;

  BEGIN
    IF TRACE THEN WriteString("FAnlegenKst.AnlegenKnopfCallback Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFAnlegenKst, meineAddr);

    KstIDString:=String.Create();
    NameString:=String.Create();
    JahrString:=String.Create();
    KontingentString:=String.Create();
    AequivalentString:=String.Create();
    MeldString:=String.Create();
    DatumString:=String.Create();


    LiesZeile(ichSelbst^.KstIDHdle, KstIDString);
    String.Lies(KstIDString, KstIDStr); 

    LiesZeile(ichSelbst^.NameHdle, NameString);
    String.Lies(NameString, NameStr); 

    LiesZeile(ichSelbst^.JahrHdle, JahrString);
    String.Lies(JahrString, JahrStr); 

    LiesZeile(ichSelbst^.KontingentHdle, KontingentString);
    String.Lies(KontingentString, KontingentStr); 

    LiesZeile(ichSelbst^.AequivalentHdle, AequivalentString);
    String.Lies(AequivalentString, AequivalentStr); 

    IF TRACEDATEN THEN
      WriteString("Eingegeben wurde: KstID:"); WriteString(KstIDStr); WriteString(":");
      WriteString("Name:"); WriteString(NameStr); WriteString(":");
      WriteString("Jahr:"); WriteString(JahrStr); WriteString(":");
      WriteString("Kontingent:"); WriteString(KontingentStr); WriteString(":");
      WriteString("Aequivalent:"); WriteString(AequivalentStr); WriteString(":"); WriteLn;
    END;


    (*      D a t e n     p r u e f e n       *)
    DatenOkay:=TRUE;

    KstID:=NIL;
    (* KstID Prfen *)
    IF NOT (StrToCardinal(KstIDStr,KstIDCard)) THEN
      DatenOkay:=FALSE;
      AusgebenMeldung("Die KostenstellenID ist ungueltig (nicht positiv ganzzahlig)");
    ELSE
      IF KstIDCard > 99999 THEN
        DatenOkay:=FALSE;
        AusgebenMeldung("Die KostenstellenID ist ungueltig (darf nicht grer als 99999 sein)");
      ELSE
        IF  PruefeKstID(KstIDString, MeldString) THEN
          KstID:=StringInKstID(KstIDString);
        ELSE
          DatenOkay:=FALSE;
          String.Lies(MeldString, MeldStr);
          Strings.Append("Medlung zu KstID:", MeldStr);
          AusgebenMeldung(MeldStr);
        END;
      END;
    END;


    (* prfen,ob beim Namen etwas eingegeben wurde *)
    IF Strings.Equal(NameStr,"") THEN
      DatenOkay:=FALSE;
      Strings.Assign("Name mu eingegeben werden",MeldStr);
      AusgebenMeldung(MeldStr);
    END;


    (* Jahr prfen und konvertieren *)
    Jahr:=NIL;
    IF Datum.JahrVonString(JahrString, Jahr, MeldString) THEN
	;
    ELSE
       DatenOkay:=FALSE;
       String.Lies(MeldString, MeldStr);
       TextStr:="";
       Strings.Append(MeldStr, TextStr);
       AusgebenMeldung(TextStr);
    END;


    (* Kontingent prfen und konvertieren *)
    IF StrToCardinal(KontingentStr,Kontingent) THEN
      IF TRACEDATEN THEN
        WriteString("Kontingent:"); WriteCard(Kontingent,5); WriteString(":");
      END;
      IF Kontingent > 99 THEN
        DatenOkay:=FALSE;
        AusgebenMeldung("Das Kontingent ist ungueltig (darf nicht grer als 99 sein)");
      ELSE
	;
      END;
    ELSE
      DatenOkay:=FALSE;
      AusgebenMeldung("Das Kontingent ist ungueltig (nicht positiv ganzzahlig)");
    END;


    (* Aequivalent prfen und konvertieren *)
    IF StrToCardinal(AequivalentStr,Aequivalent) THEN
      IF TRACEDATEN THEN
        WriteString("Aequivalent:"); WriteCard(Aequivalent,5); WriteString(":");
      END;
      IF Aequivalent > 30000000 THEN
        DatenOkay:=FALSE;
        AusgebenMeldung("Das Aequivalent ist ungueltig (darf maximal 30.000.000 sein)");
      ELSE
	;
      END;
    ELSE
      DatenOkay:=FALSE;
      AusgebenMeldung("Das Aequivalent ist ungueltig (nicht positiv ganzzahlig)");
    END;
    IF TRACEDATEN THEN
      WriteLn;
    END;


    (* Sind die eingegeben Kostenstellendaten okay, dann wird die Kostenstelle angelegt *)
    IF DatenOkay THEN
       Kst:=CreateKst();
       SetzeKIDinKst(KstID,Kst);
       SetzeNameinKst(Kst,NameString);
       SetzeJahrinKst(Kst,Jahr);
       SetzeKontinginKst(Kst,Kontingent);
       SetzeAequivinKst(Kst,Aequivalent);

       IF EinrichtenKst(Kst,MeldString) THEN
(*
       IF InsertKst(Kst,MeldString) THEN
*)
         AusgebenMeldung("Kostenstelle wurde angelegt");
       ELSE
         String.Lies(MeldString, MeldStr);
         TextStr:="Meldung zu Kst anlegen: ";
         Strings.Append(MeldStr, TextStr);
         AusgebenMeldung(TextStr);
       END;

    END;


    (* bereinigen *)
    IF KstID <> NIL THEN
      DisposeKstID(KstID);
    END;
    IF Jahr <> NIL THEN
      Datum.DisposeJahr(Jahr);
    END;
    String.Dispose(KstIDString);
    String.Dispose(NameString);
    IF JahrString <> NIL THEN
      String.Dispose(JahrString);
    END;
    String.Dispose(KontingentString);
    String.Dispose(AequivalentString);
    String.Dispose(MeldString);
    String.Dispose(DatumString);
    IF TRACE THEN WriteString("FAnlegenKst.AnlegenKnopfCallback End"); WriteLn; END;
  END AnlegenKnopfCallback;



PROCEDURE CreateFAnlegen();
  CONST
      FXPos=INT(300);
      FYPos=INT(300);
      FHoehe=INT(300);
      FBreite=INT(500);
  VAR FensterUeberschrift: String.TString;
      ichSelbst: TPFAnlegenKst;
      meineAddr: ADDRESS;
  BEGIN
    IF TRACE THEN WriteString("FAnlegenKst.CreateFAnlegen Begin"); WriteLn; END;

    (* Fenstar ADO anlegen; ReaktProcedur- und ADO-Adresse auf den Stapel geben *)
    NEW (ichSelbst);
    meineAddr:= CAST(ADDRESS, ichSelbst);
    Push(ReaktFAnlegen, meineAddr);

    FensterUeberschrift := String.Create();
    String.Schreibe( FensterUeberschrift,"Kostenstelle anlegen");
    ichSelbst^.WinHdle:=NeuesFenster(FensterUeberschrift,FXPos,FYPos,FHoehe,FBreite);
    String.Dispose(FensterUeberschrift);

    AktivFAnlegen();

    IF TRACE THEN WriteString("FAnlegenKst.CreateFAnlegen End"); WriteLn; END;
  END CreateFAnlegen;



PROCEDURE DisposeFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFAnlegenKst;
  BEGIN
    IF TRACE THEN WriteString("FAnlegenKst.DisposeFAnlegen Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFAnlegenKst, meineAddr);

(*  LoeschenEingabeFelder();
    EntferneKnopf(ichSelbst^.AnlegenKnopfHdle);
    EntferneKnopf(ichSelbst^.AbbrechenKnopfHdle);    *)

    EntferneFenster(ichSelbst^.WinHdle);

    (* Fenster ADO loeschen; Stapelelement des aktuellen Fensters entfernen und
       ReaktProcedur des uebergeordneten Fensters aufrufen *)
    DISPOSE(ichSelbst);
    Pop();
    Top(reaktProc, meineAddr);
    reaktProc();
    IF TRACE THEN WriteString("FAnlegenKst.DisposeFAnlegen End"); WriteLn; END;
  END DisposeFAnlegen;



PROCEDURE DeaktFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFAnlegenKst;
  BEGIN
    IF TRACE THEN WriteString("FAnlegenKst.DeaktFAnlegen Begin"); WriteLn; END;
    (* Deaktiviere Knpfe *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFAnlegenKst, meineAddr);
    SetzeKnopf(ichSelbst^.AnlegenKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.AbbrechenKnopfHdle, FALSE);
    IF TRACE THEN WriteString("FAnlegenKst.DeaktFAnlegen End"); WriteLn; END;
  END DeaktFAnlegen;



PROCEDURE ReaktFAnlegen();                                                           		
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFAnlegenKst;
  BEGIN
    IF TRACE THEN WriteString("FAnlegenKst.ReaktFAnlegen Begin"); WriteLn; END;
    (* Aktiviere alle Knpfe *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFAnlegenKst, meineAddr);
    SetzeKnopf(ichSelbst^.AnlegenKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.AbbrechenKnopfHdle, TRUE);
    IF TRACE THEN WriteString("FAnlegenKst.ReaktFAnlegen End"); WriteLn; END;
  END ReaktFAnlegen;



PROCEDURE InitEingabeFelder();               
  CONST
      XPos=INT(40);
      KstIDYPos=INT(50);
      KstIDLaen=INT(5);
      NameYPos=INT(70);
      NameLaen=INT(20);           
      JahrYPos=INT(90);
      JahrLaen=INT(4);           
      KontingentYPos=INT(110);
      KontingentLaen=INT(5);
      AequivalentYPos=INT(130);
      AequivalentLaen=INT(9);
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFAnlegenKst;
      Text,
      Inhalt: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FAnlegenKst.InitEingabeFelder Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFAnlegenKst, meineAddr);

    Text := String.Create();
    Inhalt := String.Create();
    String.Schreibe(Text,"KostenstellenID:");
    ichSelbst^.KstIDHdle:=StelleZeileDar(Text, Inhalt, KstIDLaen,
				ichSelbst^.WinHdle, XPos, KstIDYPos);  
    String.Schreibe(Text,"Name:");
    ichSelbst^.NameHdle:=StelleZeileDar(Text, Inhalt, NameLaen,
				ichSelbst^.WinHdle, XPos, NameYPos);  
    String.Schreibe(Text,"Jahr (JJJJ):");
    ichSelbst^.JahrHdle:=StelleZeileDar(Text, Inhalt, JahrLaen,
				ichSelbst^.WinHdle, XPos, JahrYPos);  
    String.Schreibe(Text,"Kontingent:");
    ichSelbst^.KontingentHdle:=StelleZeileDar(Text, Inhalt, KontingentLaen,
				ichSelbst^.WinHdle, XPos, KontingentYPos);  
    String.Schreibe(Text,"quivalent (Pfennig):");
    ichSelbst^.AequivalentHdle:=StelleZeileDar(Text, Inhalt, AequivalentLaen,
				ichSelbst^.WinHdle, XPos, AequivalentYPos);  
    String.Dispose(Text);
    String.Dispose(Inhalt);
    IF TRACE THEN WriteString("FAnlegenKst.InitEingabeFelder End"); WriteLn; END;
  END InitEingabeFelder;



PROCEDURE LoeschenEingabeFelder();               
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFAnlegenKst;
  BEGIN
    IF TRACE THEN WriteString("FAnlegenKst.LoeschenEingabeFelder Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFAnlegenKst, meineAddr);
    EntferneZeile(ichSelbst^.KstIDHdle);
    EntferneZeile(ichSelbst^.NameHdle);
    EntferneZeile(ichSelbst^.JahrHdle);
    EntferneZeile(ichSelbst^.KontingentHdle);
    EntferneZeile(ichSelbst^.AequivalentHdle);
    IF TRACE THEN WriteString("FAnlegenKst.LoeschenEingabeFelder End"); WriteLn; END;
  END LoeschenEingabeFelder;



PROCEDURE AusgebenMeldung(inStr:ARRAY OF CHAR);
   VAR 
    MeldText: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FAnlegenKst.AusgebenMeldung Begin"); WriteLn; END;
    MeldText := String.Create();
    String.Schreibe(MeldText, inStr);
    MeldungAnzeigen(MeldText); 
    String.Dispose(MeldText);
    IF TRACE THEN WriteString("FAnlegenKst.AusgebenMeldung End"); WriteLn; END;
  END AusgebenMeldung;



PROCEDURE StrToCardinal(inStr:ARRAY OF CHAR; VAR outCard:CARDINAL):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToCard(inStr,outCard,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToCardinal;


PROCEDURE StrToInteger(inStr:ARRAY OF CHAR; VAR outInt:INTEGER):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToInt(inStr,outInt,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToInteger;




CONST
  TRACE=FALSE;
  TRACEDATEN=TRUE;
VAR
BEGIN;
END FAnlegenKst.
