(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: FBearbKst.mod,v $
# $Author: Sopra $
# $Date: 2001/03/13 14:47:57 $
# $Revision: 1.10 $
# Bemerkungen:

IMPLEMENTATION MODULE FBearbKst;
Funktion: Bearbeiten der uebergebenen Kostenstelle

JZ

V 0.7   2.3.01  17:20

*)
(******************************************************************************)

IMPLEMENTATION MODULE FBearbKst;

(* System-Importe *)
FROM X_Grafik IMPORT StelleListeDar,EntferneListe;
FROM X_Grafik IMPORT LiesListenelement, AendereListenelement;
FROM X_Grafik IMPORT StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM X_Grafik IMPORT StelleTextDar, EntferneText;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT InitialisiereGrafik, StarteGrafik;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT MeldungAnzeigen, JaNeinAbfrage;
FROM X_Grafik IMPORT StringEingabeFenster, StringEingabeAuslesen;
FROM X_Grafik IMPORT StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT LiesMenueEintrag, EntferneMenue;

FROM SYSTEM IMPORT 	CAST, ADR, ADDRESS, TSIZE;
FROM Storage IMPORT 	ALLOCATE, DEALLOCATE;
FROM InOut IMPORT 	WriteCard, WriteLn, WriteString, WriteInt;
IMPORT WholeConv;
IMPORT WholeStr;
IMPORT ConvTypes;
IMPORT String;  (*  "String" TString *)
IMPORT Strings; (*  "Str"   Strings  enthaelt Operationen fuer ARRAY OF CHAR Datentypen !! *)
IMPORT Stringliste;



(* HiKS-Importe *)
FROM SysReaktFStapel IMPORT Push, Pop, Top, TProc;
IMPORT Datum;
FROM Ksten IMPORT	TKstID, TKst, CreateKst, DisposeKstID,
			SetzeKIDinKst, LiesKIDinKst,
 			SetzeEingAminKst, LiesEingAminKst,
 			SetzeGesperrtAminKst, LiesGesperrtAminKst, IstGesperrtAminKst,
 			SetzeLiquidAminKst, LiesLiquidAminKst, IstLiquidiertAminKst,
			SetzeNameinKst, LiesNameinKst,
			SetzeJahrinKst, LiesJahrinKst,
			SetzeKontinginKst, LiesKontinginKst,
			SetzeAequivinKst, LiesAequivinKst,
			ExistKst,
			KstIDAlsString, StringInKstID, PruefeKstID,
			GibKstenAlsStringlisteInKsten,
			InsertKst, AendernKst,
			SearchKstZuKID;


FROM PSB IMPORT		SperrenKst,
			EntsperrenKst,
                	BearbeitenAendernKst;



  TYPE 	TFBearbKstTDS = RECORD
		           WinHdle : ADDRESS;
		           AendernKnopfHdle,
			   SperrenKnopfHdle,
			   EntsperrenKnopfHdle,
			   AbbrechenKnopfHdle:ADDRESS;  		      
			   KstIDHdle,
			   NameHdle,
			   JahrHdle,
			   GesperrtAmHdle,
			   KontingentHdle,
			   AequivalentHdle : ADDRESS;
  	      		   Kst: TKst;
			   KstID: TKstID;
  	   		   KstIDString: String.TString;
  	      		 END;	
        TPFBearbKstT = POINTER TO TFBearbKstTDS;



(* --------------------------------------------------------------- *)

PROCEDURE AktivFAnlegen();
  CONST
    KnopfY1Pos=INT(210);
    KnopfY2Pos=INT(250);
    AendernKnopfXPos=INT(310);
    SperrenKnopfXPos=INT(40);
    EntsperrenKnopfXPos=INT(40);
    AbbrechenKnopfXPos=INT(310);
  VAR
    KnopfText: String.TString;
    reaktProc: TProc;
    meineAddr: ADDRESS; 
    ichSelbst: TPFBearbKstT;
  BEGIN
    IF TRACE THEN WriteString("FBearbKstT.AktivFAnlegen Begin"); WriteLn; END;

    (* Erzeuge den Fensterinhalt *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBearbKstT, meineAddr);

    InitEinAusgabeFelder();

    KnopfText := String.Create();
    String.Schreibe(KnopfText,"Kostenstelle aendern");
    ichSelbst^.AendernKnopfHdle:=StelleKnopfDar(KnopfText,
	ichSelbst^.WinHdle, AendernKnopfXPos, KnopfY1Pos, CAST(PROC,AendernKnopfCallback));

    String.Schreibe(KnopfText,"Kostenstelle sperren");
    ichSelbst^.SperrenKnopfHdle:=StelleKnopfDar(KnopfText,
	ichSelbst^.WinHdle, SperrenKnopfXPos, KnopfY1Pos, CAST(PROC,SperrenKnopfCallback));

    String.Schreibe(KnopfText,"Kostenstelle entsperren");
    ichSelbst^.EntsperrenKnopfHdle:=StelleKnopfDar(KnopfText,
	ichSelbst^.WinHdle, EntsperrenKnopfXPos, KnopfY2Pos, CAST(PROC,EntsperrenKnopfCallback));

    String.Schreibe(KnopfText,"Abbrechen");
    ichSelbst^.AbbrechenKnopfHdle:=StelleKnopfDar(KnopfText,
	ichSelbst^.WinHdle, AbbrechenKnopfXPos, KnopfY2Pos, CAST(PROC,AbbrechenKnopfCallback));

    String.Dispose(KnopfText);
    IF TRACE THEN WriteString("FBearbKstT.AktivFAnlegen End"); WriteLn; END;
  END AktivFAnlegen;



PROCEDURE AbbrechenKnopfCallback();
  VAR
    reaktProc: TProc;
    meineAddr: ADDRESS;
    ichSelbst: TPFBearbKstT;
  BEGIN
    IF TRACE THEN WriteString("FBearbKstT.AbbrechenKnopfCallback Begin"); WriteLn; END;
    DisposeFAnlegen();
    IF TRACE THEN WriteString("FBearbKstT.AbbrechenKnopfCallback End"); WriteLn; END;
  END AbbrechenKnopfCallback;




PROCEDURE AendernKnopfCallback();
  CONST
  VAR
    MeldString, KstIDString, NameString, JahrString, KontingentString,
						AequivalentString: String.TString;
    MeldStr, KstIDStr, NameStr, JahrStr, KontingentStr, AequivalentStr: ARRAY[1..200] OF CHAR;
    Text: ARRAY[1..200] OF CHAR;
    Kontingent: CARDINAL;
    Aequivalent: CARDINAL;
    reaktProc: TProc;
    meineAddr: ADDRESS; 
    ichSelbst: TPFBearbKstT;
    Format: ConvTypes.ConvResults;
    DatenOkay: BOOLEAN;

    KstID: TKstID;
    Kst: TKst;
    Jahr: Datum.TJahr;

  BEGIN
    IF TRACE THEN WriteString("FBearbKstT.AendernKnopfCallback Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBearbKstT, meineAddr);

    DatenOkay:=TRUE;

    MeldString:=String.Create();
    KontingentString:=String.Create();
    AequivalentString:=String.Create();

    String.Lies(ichSelbst^.KstIDString, KstIDStr);

    LiesZeile(ichSelbst^.KontingentHdle, KontingentString);
    String.Lies(KontingentString, KontingentStr); 

    LiesZeile(ichSelbst^.AequivalentHdle, AequivalentString);
    String.Lies(AequivalentString, AequivalentStr); 

    IF TRACEDATEN THEN
      WriteString("Aendern Kst: KstID:"); WriteString(KstIDStr); WriteString(":");
      WriteString("Kontingent:"); WriteString(KontingentStr); WriteString(":");
      WriteString("Aequivalent:"); WriteString(AequivalentStr); WriteString(":"); WriteLn;
    END;


    (* Kontingent prfen und konvertieren *)
    IF StrToCardinal(KontingentStr,Kontingent) THEN
      IF TRACEDATEN THEN
        WriteString("Kontingent:"); WriteCard(Kontingent,5); WriteString(":");
      END;
      IF Kontingent > 99 THEN
        DatenOkay:=FALSE;
        AusgebenMeldung("Das Kontingent ist ungueltig (darf nicht grer als 99 sein)");
      ELSE
	;
      END;
    ELSE
      DatenOkay:=FALSE;
      AusgebenMeldung(" Das Kontingent ist ungueltig (nicht positiv ganzzahlig)");
    END;

    (* Aequivalent prfen und konvertieren *)
    IF StrToCardinal(AequivalentStr,Aequivalent) THEN
      IF TRACEDATEN THEN
        WriteString("Aequivalent:"); WriteCard(Aequivalent,5); WriteString(":");
      END;
      IF Aequivalent > 30000000 THEN
        DatenOkay:=FALSE;
        AusgebenMeldung("Das Aequivalent ist ungueltig (darf maximal 30.000.000 sein)");
      ELSE
	;
      END;
    ELSE
      DatenOkay:=FALSE;
      AusgebenMeldung(" Das Aequivalent ist ungueltig (nicht positivganzzahlig)");
    END;
    IF TRACEDATEN THEN
      WriteLn;
    END;


    (* Sind die eingegeben Kostenstellendaten okay, dann wird die Kostenstelle geaendert *)
    IF DatenOkay THEN
       SetzeKontinginKst(ichSelbst^.Kst,Kontingent);
       SetzeAequivinKst(ichSelbst^.Kst,Aequivalent);


       IF BearbeitenAendernKst(ichSelbst^.Kst, MeldString) THEN
         AusgebenMeldung("Kostenstelle wurde geaendert");

(*
         IF AendernKst(ichSelbst^.Kst, MeldString) THEN
           AusgebenMeldung("Kostenstelle wurde geaendert");
         ELSE
           String.Lies(MeldString, MeldStr);
           Text:="Meldung Kst:";
           Strings.Append(MeldStr, Text);
           AusgebenMeldung(Text);
         END;
*)
       ELSE
         String.Lies(MeldString, MeldStr);
         Text:="Meldung Kst:";
         Strings.Append(MeldStr, Text);
         AusgebenMeldung(Text);
       END;

    END;

    DisposeFAnlegen();

    String.Dispose(MeldString);
    String.Dispose(KontingentString);
    String.Dispose(AequivalentString);
    IF TRACE THEN WriteString("FBearbKstT.AendernKnopfCallback End"); WriteLn; END;
  END AendernKnopfCallback;




PROCEDURE SperrenKnopfCallback();
  VAR
    reaktProc: TProc;
    meineAddr: ADDRESS;
    ichSelbst: TPFBearbKstT;
    MeldString: String.TString;
    Text, MeldStr: ARRAY[1..200] OF CHAR;
    DatumString, KstIDString, NameString, JahrString, KontingentString,GesperrtAmString,
						AequivalentString: String.TString;
    KstIDStr, NameStr, JahrStr, KontingentStr, AequivalentStr,
      						GesperrtAmStr: ARRAY[1..200] OF CHAR;
    GesperrtAm,
    ZWDatum: Datum.TDatum;
  BEGIN
    IF TRACE THEN WriteString("FBearbKstT.SperrenKnopfCallback Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBearbKstT, meineAddr);

    MeldString:=String.Create();

    DatumString := String.Create();
    String.Schreibe(DatumString,"02.03.2001");
    GesperrtAm:=Datum.CreateDatum();
    IF Datum.DatumVonString(DatumString, GesperrtAm, MeldString) THEN
      ;
    ELSE
      String.Lies(MeldString, MeldStr);
      Strings.Append("Meldung zu Datum:", MeldStr);
      AusgebenMeldung(MeldStr);
    END;


    IF SperrenKst(ichSelbst^.Kst, MeldString) THEN
      AusgebenMeldung("Kostenstelle wurde gesperrt");
(*
      SetzeGesperrtAminKst(ichSelbst^.Kst, GesperrtAm);
      IF AendernKst(ichSelbst^.Kst, MeldString) THEN
        AusgebenMeldung("Kostenstelle wurde gesperrt");
      ELSE
        String.Lies(MeldString, MeldStr);
        Text:="Meldung Kst:";
        Strings.Append(MeldStr, Text);
        AusgebenMeldung(Text);
      END;
*)
    ELSE
      String.Lies(MeldString, MeldStr);
      Text:="Meldung Kst:";
      Strings.Append(MeldStr, Text);
      AusgebenMeldung(Text);
    END;


    DisposeFAnlegen();

    String.Dispose(MeldString);
    IF TRACE THEN WriteString("FBearbKstT.SperrenKnopfCallback End"); WriteLn; END;
  END SperrenKnopfCallback;



PROCEDURE EntsperrenKnopfCallback();
  VAR
    reaktProc: TProc;
    meineAddr: ADDRESS;
    ichSelbst: TPFBearbKstT;
    MeldString: String.TString;
    Text, MeldStr: ARRAY[1..200] OF CHAR;
    DatumString, KstIDString, NameString, JahrString, KontingentString,GesperrtAmString,
						AequivalentString: String.TString;
    KstIDStr, NameStr, JahrStr, KontingentStr, AequivalentStr,
      						GesperrtAmStr: ARRAY[1..200] OF CHAR;
    GesperrtAm,
    ZWDatum: Datum.TDatum;
  BEGIN
    IF TRACE THEN WriteString("FBearbKstT.EntsperrenKnopfCallback Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBearbKstT, meineAddr);

    MeldString:=String.Create();


    IF EntsperrenKst(ichSelbst^.Kst, MeldString) THEN
      AusgebenMeldung("Kostenstelle wurde entsperrt");
(*
      GesperrtAm:=Datum.CreateDatum();
      SetzeGesperrtAminKst(ichSelbst^.Kst, GesperrtAm);
      IF AendernKst(ichSelbst^.Kst, MeldString) THEN
        ;
      ELSE
        String.Lies(MeldString, MeldStr);
        Text:="Meldung Kst:";
        Strings.Append(MeldStr, Text);
        AusgebenMeldung(Text);
      END;
*)
    ELSE
      String.Lies(MeldString, MeldStr);
      Text:="Meldung Kst:";
      Strings.Append(MeldStr, Text);
      AusgebenMeldung(Text);
    END;

    DisposeFAnlegen();

    String.Dispose(MeldString);
    IF TRACE THEN WriteString("FBearbKstT.EntsperrenKnopfCallback End"); WriteLn; END;
  END EntsperrenKnopfCallback;




PROCEDURE CreateFAnlegen(inKstIDString:String.TString);
  CONST
      FXPos=INT(300);
      FYPos=INT(300);
      FHoehe=INT(300);
      FBreite=INT(500);
  VAR FensterUeberschrift: String.TString;
      WinHdle: ADDRESS;
      ichSelbst: TPFBearbKstT;
      meineAddr: ADDRESS;
      reaktProc: TProc;
  BEGIN
    IF TRACE THEN WriteString("FBearbKstT.CreateFAnlegen Begin"); WriteLn; END;

    (* Fenstar ADO anlegen; ReaktProcedur- und ADO-Adresse auf den Stapel geben *)
    NEW (ichSelbst);
    meineAddr:= CAST(ADDRESS, ichSelbst);
    Push(ReaktFAnlegen, meineAddr);

    FensterUeberschrift := String.Create();
    String.Schreibe( FensterUeberschrift,"Kostenstelle bearbeiten");
    ichSelbst^.WinHdle:=NeuesFenster(FensterUeberschrift,FXPos,FYPos,FHoehe,FBreite);
    String.Dispose(FensterUeberschrift);

    ichSelbst^.KstIDString:=String.Duplicate(inKstIDString);

    AktivFAnlegen();

    IF TRACE THEN WriteString("FBearbKstT.CreateFAnlegen End"); WriteLn; END;
  END CreateFAnlegen;



PROCEDURE DisposeFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFBearbKstT;

  BEGIN
    IF TRACE THEN WriteString("FBearbKstT.DisposeFAnlegen Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBearbKstT, meineAddr);

(*  LoeschenEinAusgabeFelder();
    EntferneKnopf(ichSelbst^.AendernKnopfHdle);
    EntferneKnopf(ichSelbst^.SperrenKnopfHdle);
    EntferneKnopf(ichSelbst^.EntsperrenKnopfHdle);
    EntferneKnopf(ichSelbst^.AbbrechenKnopfHdle);  *)

    EntferneFenster(ichSelbst^.WinHdle);

    (* Fenster ADO loeschen; Stapelelement des aktuellen Fensters entfernen und
       ReaktProcedur des uebergeordneten Fensters aufrufen *)
    DISPOSE(ichSelbst);
    Pop();
    Top(reaktProc, meineAddr);
    reaktProc();
    IF TRACE THEN WriteString("FBearbKstT.DisposeFAnlegen End"); WriteLn; END;
  END DisposeFAnlegen;



PROCEDURE DeaktFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFBearbKstT;
  BEGIN
    IF TRACE THEN WriteString("FBearbKstT.DeaktFAnlegen Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBearbKstT, meineAddr);

    (*  Deaktiviere Knpfe  *)
    SetzeKnopf(ichSelbst^.AendernKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.SperrenKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.EntsperrenKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.AbbrechenKnopfHdle, FALSE);

    IF TRACE THEN WriteString("FBearbKstT.DeaktFAnlegen End"); WriteLn; END;
  END DeaktFAnlegen;



PROCEDURE ReaktFAnlegen();                                                           		
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFBearbKstT;
  BEGIN
    IF TRACE THEN WriteString("FBearbKstT.ReaktFAnlegen Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBearbKstT, meineAddr);

    (* Aktiviere alle Knoepfe *)
    SetzeKnopf(ichSelbst^.AendernKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.SperrenKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.EntsperrenKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.AbbrechenKnopfHdle, TRUE);

    IF TRACE THEN WriteString("FBearbKstT.ReaktFAnlegen End"); WriteLn; END;
  END ReaktFAnlegen;



PROCEDURE InitEinAusgabeFelder();
  CONST
      XPos=INT(40);
      KstIDYPos=INT(50);
      KstIDLaen=INT(5);           
      NameYPos=INT(70);
      NameLaen=INT(20);           
      JahrYPos=INT(90);
      JahrLaen=INT(4);           
      KontingentYPos=INT(110);
      KontingentLaen=INT(5);
      AequivalentYPos=INT(130);
      AequivalentLaen=INT(9);
      GesperrtAmYPos=INT(150);
      GesperrtAmLaen=INT(10);
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFBearbKstT;
      Text, Inhalt: String.TString;
      MeldStr: ARRAY [1..200] OF CHAR;
      ZWString, MeldString: String.TString;
      DatumString, KstIDString, NameString, JahrString, KontingentString,GesperrtAmString,
						AequivalentString: String.TString;
      KstIDStr, NameStr, JahrStr, KontingentStr, AequivalentStr,
      						GesperrtAmStr: ARRAY[1..200] OF CHAR;
      Kontingent: CARDINAL;
      Aequivalent: CARDINAL;

      Jahr: Datum.TJahr;
      EingegebenAm,
      GesperrtAm,
      LiquidiertAm: Datum.TDatum;
      ZWDatum: Datum.TDatum;

  BEGIN
    IF TRACE THEN WriteString("FBearbKstT.InitEinAusgabeFelde Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBearbKstT, meineAddr);

    Text := String.Create();
    Inhalt := String.Create();

    KstIDString:=ichSelbst^.KstIDString;
    IF  PruefeKstID(KstIDString, MeldString) THEN
        ichSelbst^.KstID:=StringInKstID(KstIDString);
    ELSE
        String.Lies(MeldString, MeldStr);
        Strings.Append("Medlung zu KstID:", MeldStr);
        AusgebenMeldung(MeldStr);
        RETURN;
    END;


    ichSelbst^.Kst:=NIL;
    IF SearchKstZuKID(ichSelbst^.KstID, ichSelbst^.Kst) THEN
      NameString:=LiesNameinKst(ichSelbst^.Kst);

      Jahr:=LiesJahrinKst(ichSelbst^.Kst);

      Kontingent:=LiesKontinginKst(ichSelbst^.Kst);
      Aequivalent:=LiesAequivinKst(ichSelbst^.Kst);
      EingegebenAm:=LiesEingAminKst(ichSelbst^.Kst);
      GesperrtAm:=LiesGesperrtAminKst(ichSelbst^.Kst);
      LiquidiertAm:=LiesLiquidAminKst(ichSelbst^.Kst);


      String.Schreibe(Text,"KostenstellenID:  ");
      String.Anhaengen(KstIDString, Text);
      ichSelbst^.KstIDHdle:=StelleMeldungDar(Text, FALSE, ichSelbst^.WinHdle, XPos, KstIDYPos);

(*
      ZWString := String.Create();
      String.Schreibe(ZWString,"Name der Kostenstelle");
      NameString:=ZWString;
*)

      String.Schreibe(Text,"Name:  ");
      String.Anhaengen(NameString, Text);
      ichSelbst^.NameHdle:=StelleMeldungDar(Text, FALSE, ichSelbst^.WinHdle, XPos, NameYPos);



    (*  Jahr ausgeben  *)
(*
      DatumString := String.Create();
      String.Schreibe(DatumString,"01.01.2001");

      Datum:=Datum.CreateDatum();
      IF Datum.DatumVonString(DatumString, Datum, MeldString) THEN
        Datum.SetzeJahrInDatum(Datum, Jahr);
      ELSE
        String.Lies(MeldString, MeldStr);
        Strings.Append("Meldung zu Datum:", MeldStr);
        AusgebenMeldung(MeldStr);
      END;
      DatumString:=Datum.DatumAlsString(Datum);
*)



(*
      JahrString := String.Create();
      String.Auslesen(DatumString,6,4,JahrString);
*)
      JahrString:=Datum.JahrAlsString(Jahr);

      String.Schreibe(Text,"Jahr:  ");
      String.Anhaengen(JahrString, Text);
      ichSelbst^.JahrHdle:=StelleMeldungDar(Text, FALSE, ichSelbst^.WinHdle, XPos, JahrYPos);


(*
      ZWString := String.Create();
      String.Schreibe(ZWString,"01.12.2001");
      GesperrtAmString:=ZWString;


      GesperrtAmString:=Datum.DatumAlsString(GesperrtAm);
*)

      IF Datum.IstDatumEternity(GesperrtAm) THEN
        ZWString := String.Create();
        String.Schreibe(ZWString,"nicht gesperrt");
        GesperrtAmString:=ZWString;              (* nur wenn UNDEF *)
      ELSE
        GesperrtAmString:=Datum.DatumAlsString(GesperrtAm);
      END;

      String.Schreibe(Text,"gesperrt am:  ");
      String.Anhaengen(GesperrtAmString, Text);
      ichSelbst^.GesperrtAmHdle:=StelleMeldungDar(Text, FALSE, ichSelbst^.WinHdle, XPos, GesperrtAmYPos);


(*
      Kontingent:=123;
*)
      WholeStr.CardToStr(Kontingent, KontingentStr);
      KontingentString := String.Create();
      String.Schreibe(KontingentString, KontingentStr);
      String.Schreibe(Text,"Kontingent:");
      ichSelbst^.KontingentHdle:=StelleZeileDar(Text, KontingentString, KontingentLaen,
	    					ichSelbst^.WinHdle, XPos, KontingentYPos);


(*	    									
      Aequivalent:=4711;
*)
      WholeStr.CardToStr(Aequivalent, AequivalentStr);
      AequivalentString := String.Create();
      String.Schreibe(AequivalentString, AequivalentStr);
      String.Schreibe(Text,"quivalent (Pfennig):");
      ichSelbst^.AequivalentHdle:=StelleZeileDar(Text, AequivalentString, AequivalentLaen,
						ichSelbst^.WinHdle, XPos, AequivalentYPos);

 (* ist vielleicht fuer Stabilitt guenstig ?!?? 						
      SetzeZeile(ichSelbst^.KontingentHdle, TRUE);
      SetzeZeile(ichSelbst^.AequivalentHdle, TRUE);
*)

    ELSE
      MeldString := String.Create();
      String.Schreibe(MeldString,"Die Kst wurden nicht gefunden !? KstID:");
      String.Anhaengen(KstIDString, MeldString);
      String.Lies(MeldString, MeldStr);
      AusgebenMeldung(MeldStr);
    END;



    String.Dispose(Text);
    String.Dispose(Inhalt);


    IF TRACE THEN WriteString("FBearbKstT.InitEinAusgabeFelde End"); WriteLn; END;
  END InitEinAusgabeFelder;



PROCEDURE LoeschenEinAusgabeFelder();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFBearbKstT;
  BEGIN
    IF TRACE THEN WriteString("FBearbKstT.LoeschenEinAusgabeFelde Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBearbKstT, meineAddr);

    EntferneMeldung(ichSelbst^.KstIDHdle);
    EntferneMeldung(ichSelbst^.NameHdle);
    EntferneMeldung(ichSelbst^.JahrHdle);
    EntferneMeldung(ichSelbst^.GesperrtAmHdle);
    EntferneZeile(ichSelbst^.KontingentHdle);
    EntferneZeile(ichSelbst^.AequivalentHdle);

    IF TRACE THEN WriteString("FBearbKstT.LoeschenEinAusgabeFelde End"); WriteLn; END;
  END LoeschenEinAusgabeFelder;



PROCEDURE AusgebenMeldung(inStr:ARRAY OF CHAR);
   VAR 
    MeldText: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FBearbKstT.AusgebenMeldung Begin"); WriteLn; END;

    MeldText := String.Create();
    String.Schreibe(MeldText, inStr);
    MeldungAnzeigen(MeldText); 
    String.Dispose(MeldText);

    IF TRACE THEN WriteString("FBearbKstT.AusgebenMeldung End"); WriteLn; END;
  END AusgebenMeldung;




PROCEDURE StrToCardinal(inStr:ARRAY OF CHAR; VAR outCard:CARDINAL):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToCard(inStr,outCard,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToCardinal;


PROCEDURE StrToInteger(inStr:ARRAY OF CHAR; VAR outInt:INTEGER):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToInt(inStr,outInt,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToInteger;





CONST
  TRACE=FALSE;
  TRACEDATEN=TRUE;
VAR
BEGIN;
END FBearbKst.
