(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: FKondTkAnz.mod,v $
# $Author: Sopra $
# $Date: 2001/03/13 16:45:18 $
# $Revision: 1.3 $
# Bemerkungen:

IMPLEMENTATION MODULE FKondTkAnz;
Funktion: aktuelle Tarifkonditoin anzeigen

JZ

V 0.6   28.2.01  18:54

*)
(******************************************************************************)


IMPLEMENTATION MODULE FKondTkAnz;

(* System-Importe *)
FROM X_Grafik IMPORT StelleListeDar,EntferneListe;
FROM X_Grafik IMPORT LiesListenelement, AendereListenelement;
FROM X_Grafik IMPORT StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM X_Grafik IMPORT StelleTextDar, EntferneText;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT InitialisiereGrafik, StarteGrafik;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT MeldungAnzeigen, JaNeinAbfrage;
FROM X_Grafik IMPORT StringEingabeFenster, StringEingabeAuslesen;
FROM X_Grafik IMPORT StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT LiesMenueEintrag, EntferneMenue;

FROM SYSTEM IMPORT 	CAST, ADR, ADDRESS, TSIZE;
FROM Storage IMPORT 	ALLOCATE, DEALLOCATE;
FROM InOut IMPORT 	WriteCard, WriteLn, WriteString, WriteInt;
IMPORT WholeConv;
IMPORT WholeStr;
IMPORT ConvTypes;
IMPORT String;  (*  "String" TString *)
IMPORT Strings; (*  "Str"   Strings  enthaelt Operationen fuer ARRAY OF CHAR Datentypen !! *)
IMPORT Stringliste;


(* HiKS-Importe *)
FROM SysReaktFStapel IMPORT Push, Pop, Top, TProc;
IMPORT Datum;
IMPORT SysDat;
FROM Konden IMPORT 	TKond, CreateTarifKondition, DisposeKond,
			SetzeGueltVoninKond, LiesGueltVoninKond,
			SetzeGueltBisinKond, LiesGueltBisinKond,
			SetzeStdSinTKond, LiesStdSinTKond,
			HoleGueltigeTKond,
			CreateKonditionsOrdner,
			InsertTKond,
			LoadInKonden, SaveInKonden;

(*
FROM PSB IMPORT	TKondGeprueftEinf;
*)



  TYPE 	TFKondTkAnzDS = RECORD
		           WinHdle : ADDRESS;
		           AnlegenKnopfHdle,
			   LoeschenKnopfHdle,
			   AbbrechenKnopfHdle:ADDRESS;  		      
			   GueltigabHdle,
			   GueltigbisHdle,
			   StundensatzHdle : ADDRESS
  	      		 END;	
        TPFKondTkAnz = POINTER TO TFKondTkAnzDS;


(* --------------------------------------------------------------- *)

PROCEDURE AktivFAnlegen();
  CONST
    KnopfYPos=INT(180);
    AnlegenKnopfXPos=INT(10);
    LoeschenKnopfXPos=INT(260);
    AbbrechenKnopfXPos=INT(390);
  VAR
    Text     : String.TString;
    reaktProc: TProc;
    meineAddr: ADDRESS; 
    ichSelbst: TPFKondTkAnz;
  BEGIN
    IF TRACE THEN WriteString("FKondTkAnz.AktivFAnlegen Begin"); WriteLn; END;
    (* Erzeuge den Fensterinhalt *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondTkAnz, meineAddr);

    InitEingabeFelder();

    Text := String.Create();
    String.Schreibe(Text,"Abbrechen");
    ichSelbst^.AbbrechenKnopfHdle:=StelleKnopfDar(Text, ichSelbst^.WinHdle, AbbrechenKnopfXPos,
    							 KnopfYPos, CAST(PROC,AbbrechenKnopfCallback));
    String.Dispose(Text);

    IF TRACE THEN WriteString("FKondTkAnz.AktivFAnlegen End"); WriteLn; END;
  END AktivFAnlegen;



PROCEDURE AbbrechenKnopfCallback();
  BEGIN
    IF TRACE THEN WriteString("FKondTkAnz.AbbrechenKnopfCallback Begin"); WriteLn; END;
    DisposeFAnlegen();
    IF TRACE THEN WriteString("FKondTkAnz.AbbrechenKnopfCallback End"); WriteLn; END;
  END AbbrechenKnopfCallback;




PROCEDURE CreateFAnlegen();
  CONST
      FXPos=INT(300);
      FYPos=INT(300);
      FHoehe=INT(250);
      FBreite=INT(500);
  VAR FensterUeberschrift: String.TString;
      WinHdle: ADDRESS;
      ichSelbst: TPFKondTkAnz;
      meineAddr: ADDRESS;
  BEGIN
    IF TRACE THEN WriteString("FKondTkAnz.CreateFAnlegen Begin"); WriteLn; END;

    (* Fenstar ADO anlegen; ReaktProcedur- und ADO-Adresse auf den Stapel geben *)
    NEW (ichSelbst);
    meineAddr:= CAST(ADDRESS, ichSelbst);
    Push(ReaktFAnlegen, meineAddr);

    FensterUeberschrift := String.Create();
    String.Schreibe( FensterUeberschrift,"aktuelle Tarifkondition anzeigen");
    ichSelbst^.WinHdle:=NeuesFenster(FensterUeberschrift,FXPos,FYPos,FHoehe,FBreite);
    String.Dispose(FensterUeberschrift);

    AktivFAnlegen();

    IF TRACE THEN WriteString("FKondTkAnz.CreateFAnlegen End"); WriteLn; END;
  END CreateFAnlegen;



PROCEDURE DisposeFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFKondTkAnz;
  BEGIN
    IF TRACE THEN WriteString("FKondTkAnz.DisposeFAnlegen Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondTkAnz, meineAddr);

(*  LoeschenEingabeFelder();
    EntferneKnopf(ichSelbst^.AbbrechenKnopfHdle);  *)

    EntferneFenster(ichSelbst^.WinHdle);

    (* Fenster ADO loeschen; Stapelelement des aktuellen Fensters entfernen und
       ReaktProcedur des uebergeordneten Fensters aufrufen *)
    DISPOSE(ichSelbst);
    Pop();
    Top(reaktProc, meineAddr);
    reaktProc();
    IF TRACE THEN WriteString("FKondTkAnz.DisposeFAnlegen End"); WriteLn; END;
  END DisposeFAnlegen;



PROCEDURE DeaktFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFKondTkAnz;
  BEGIN
    IF TRACE THEN WriteString("FKondTkAnz.DeaktFAnlegen Begin"); WriteLn; END;
    (*Deaktiviere Knpfe *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondTkAnz, meineAddr);
    SetzeKnopf(ichSelbst^.AbbrechenKnopfHdle, FALSE);
    IF TRACE THEN WriteString("FKondTkAnz.DeaktFAnlegen End"); WriteLn; END;
  END DeaktFAnlegen;



PROCEDURE ReaktFAnlegen();                                                           		
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFKondTkAnz;
  BEGIN
    IF TRACE THEN WriteString("FKondTkAnz.ReaktFAnlegen Begin"); WriteLn; END;
    (* Aktiviere alle Fensterinhalte *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondTkAnz, meineAddr);
    SetzeKnopf(ichSelbst^.AbbrechenKnopfHdle, TRUE);
    IF TRACE THEN WriteString("FKondTkAnz.ReaktFAnlegen End"); WriteLn; END;
  END ReaktFAnlegen;



PROCEDURE InitEingabeFelder();               
  CONST
      XPos=INT(40);
      GueltigabYPos=INT(50);
      GueltigabLaen=INT(10);
      GueltigbisYPos=INT(75);
      GueltigbisLaen=INT(10);
      StundensatzYPos=INT(100);
      StundensatzLaen=INT(2);
  VAR
    Text, Inhalt: String.TString;
    ZWDatumString, GueltigabString, GueltigbisString, MeldString,
    					StundensatzString: String.TString;
    ZWDatumStr, GueltigabStr, GueltigbisStr, TextStr, MeldStr, StundensatzStr: ARRAY[1..200] OF CHAR;
    reaktProc: TProc;
    meineAddr: ADDRESS;
    ichSelbst: TPFKondTkAnz;
    DatenOkay: BOOLEAN;
    Stundensatz: CARDINAL;
    ZWDatum: Datum.TDatum;
    TK: TKond;
    Gueltigab, Gueltigbis, Heute: Datum.TDatum;
  BEGIN
    IF TRACE THEN WriteString("FKondTkAnz.InitEingabeFelder Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondTkAnz, meineAddr);

    Text := String.Create();
    Inhalt := String.Create();
    MeldString := String.Create();
    ZWDatumString := String.Create();


(* ( * *)
    String.Schreibe(ZWDatumString,"25.2.2001");
    IF Datum.DatumVonString(ZWDatumString, ZWDatum, MeldString) THEN
	;
    ELSE
      DatenOkay:=FALSE;
      String.Lies(MeldString, MeldStr);
      TextStr:="Dubios: ";
      Strings.Append(MeldStr, TextStr);
      AusgebenMeldung(TextStr);
    END;
    Heute:=Datum.DuplicateDatum(ZWDatum);
(* * ) *)
(*
    SysDat.SetzeSystemDatumInSysDat(Heute);
*)
    Heute:=SysDat.LiesSystemDatumInSysDat();



    IF HoleGueltigeTKond(Heute, TK) THEN
      Gueltigab:=LiesGueltVoninKond(TK);
      GueltigabString:=Datum.DatumAlsString(Gueltigab);
      Gueltigbis:=LiesGueltBisinKond(TK);
      GueltigbisString:=Datum.DatumAlsString(Gueltigbis);
      Stundensatz:=LiesStdSinTKond(TK);

      WholeStr.CardToStr(Stundensatz, StundensatzStr);
      StundensatzString := String.Create();
      String.Schreibe(StundensatzString, StundensatzStr);

      String.Schreibe(Text,"Gltig ab:  ");
      String.Anhaengen(GueltigabString, Text);
      ichSelbst^.GueltigabHdle:=StelleMeldungDar(Text, FALSE, ichSelbst^.WinHdle, XPos, GueltigabYPos);

      String.Schreibe(Text,"Gltig bis:  ");
      String.Anhaengen(GueltigbisString, Text);
      ichSelbst^.GueltigbisHdle:=StelleMeldungDar(Text, FALSE, ichSelbst^.WinHdle, XPos, GueltigbisYPos);

      String.Schreibe(Text,"Stundensatz (Pfennige/Stunde):  ");
      String.Anhaengen(StundensatzString, Text);
      ichSelbst^.StundensatzHdle:=StelleMeldungDar(Text, FALSE, ichSelbst^.WinHdle, XPos, StundensatzYPos);

      DisposeKond(TK);
      String.Dispose(GueltigabString);
      String.Dispose(GueltigbisString);
      String.Dispose(StundensatzString);
    ELSE
      String.Schreibe(MeldString,"aktuelle TK wurden nicht gefunden !?");
      String.Lies(MeldString, MeldStr);
      AusgebenMeldung(MeldStr);
    END;



    String.Dispose(Text);
    String.Dispose(Inhalt);
    String.Dispose(MeldString);
    String.Dispose(ZWDatumString);
    IF TRACE THEN WriteString("FKondTkAnz.InitEingabeFelder End"); WriteLn; END;
  END InitEingabeFelder;



PROCEDURE LoeschenEingabeFelder();               
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFKondTkAnz;
  BEGIN
    IF TRACE THEN WriteString("FKondTkAnz.LoeschenEingabeFelder Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondTkAnz, meineAddr);
    EntferneZeile(ichSelbst^.GueltigabHdle);
    EntferneZeile(ichSelbst^.GueltigbisHdle);
    EntferneZeile(ichSelbst^.StundensatzHdle);
    IF TRACE THEN WriteString("FKondTkAnz.LoeschenEingabeFelder End"); WriteLn; END;
  END LoeschenEingabeFelder;



PROCEDURE AusgebenMeldung(inStr:ARRAY OF CHAR);
   VAR 
    ichSelbst: TPFKondTkAnz;
    reaktProc: TProc;
    meineAddr: ADDRESS;
    MeldText: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FKondTkAnz.AusgebenMeldung Begin"); WriteLn; END;
    MeldText := String.Create();
    String.Schreibe(MeldText, inStr);
    MeldungAnzeigen(MeldText); 
    String.Dispose(MeldText);
    IF TRACE THEN WriteString("FKondTkAnz.AusgebenMeldung End"); WriteLn; END;
  END AusgebenMeldung;



PROCEDURE StrToCardinal(inStr:ARRAY OF CHAR; VAR outCard:CARDINAL):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToCard(inStr,outCard,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToCardinal;


PROCEDURE StrToInteger(inStr:ARRAY OF CHAR; VAR outInt:INTEGER):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToInt(inStr,outInt,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToInteger;




CONST
  TRACE=FALSE;
VAR
BEGIN;
END FKondTkAnz.
