(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile$
# $Author$
# $Date$
# $Revision$
# Bemerkungen:

IMPLEMENTATION MODULE FKondTkEin;
Funktion: Tarifkondition einfuegen

JZ

V 0.6   28.2.01  18:55

*)
(******************************************************************************)


IMPLEMENTATION MODULE FKondTkEin;

(* System-Importe *)
FROM X_Grafik IMPORT StelleListeDar,EntferneListe;
FROM X_Grafik IMPORT LiesListenelement, AendereListenelement;
FROM X_Grafik IMPORT StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM X_Grafik IMPORT StelleTextDar, EntferneText;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT InitialisiereGrafik, StarteGrafik;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT MeldungAnzeigen, JaNeinAbfrage;
FROM X_Grafik IMPORT StringEingabeFenster, StringEingabeAuslesen;
FROM X_Grafik IMPORT StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT LiesMenueEintrag, EntferneMenue;

FROM SYSTEM IMPORT 	CAST, ADR, ADDRESS, TSIZE;
FROM Storage IMPORT 	ALLOCATE, DEALLOCATE;
FROM InOut IMPORT 	WriteCard, WriteLn, WriteString, WriteInt;
IMPORT WholeConv;
IMPORT WholeStr;
IMPORT ConvTypes;
IMPORT String;  (*  "String" TString *)
IMPORT Strings; (*  "Str"   Strings  enthaelt Operationen fuer ARRAY OF CHAR Datentypen !! *)
IMPORT Stringliste;


(* HiKS-Importe *)
FROM SysReaktFStapel IMPORT 	Push, Pop, Top, TProc;
IMPORT Datum;
FROM Konden IMPORT 	TKond, CreateTarifKondition, DisposeKond,
			SetzeGueltVoninKond, LiesGueltVoninKond,
			SetzeGueltBisinKond, LiesGueltBisinKond,
			SetzeStdSinTKond, LiesStdSinTKond,
			HoleGueltigeTKond,
			CreateKonditionsOrdner,
			InsertTKond,
			LoadInKonden, SaveInKonden;

(*
FROM PSB IMPORT	TKondGeprueftEinf;
*)


  TYPE 	TFKondTkEinDS = RECORD
		           WinHdle : ADDRESS;
		           AnlegenKnopfHdle,
			   LoeschenKnopfHdle,
			   AbbrechenKnopfHdle:ADDRESS;  		      
			   GueltigabHdle,
			   StundensatzHdle : ADDRESS
  	      		 END;	
        TPFKondTkEin = POINTER TO TFKondTkEinDS;


(* --------------------------------------------------------------- *)

PROCEDURE AktivFAnlegen();
  CONST
    KnopfYPos=INT(180);
    AnlegenKnopfXPos=INT(50);
    LoeschenKnopfXPos=INT(260);
    AbbrechenKnopfXPos=INT(370);
  VAR
    Text     : String.TString;
    reaktProc: TProc;
    meineAddr: ADDRESS; 
    ichSelbst: TPFKondTkEin;
  BEGIN
    IF TRACE THEN WriteString("FKondTkEin.AktivFAnlegen Begin"); WriteLn; END;

    (* Erzeuge den Fensterinhalt *)
    InitEingabeFelder();

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondTkEin, meineAddr);

    Text := String.Create();

    String.Schreibe(Text,"Tarifkondition anlegen");
    ichSelbst^.AnlegenKnopfHdle:=StelleKnopfDar(Text, ichSelbst^.WinHdle, AnlegenKnopfXPos,
    						 KnopfYPos, CAST(PROC,AnlegenKnopfCallback));

    String.Schreibe(Text,"Abbrechen");
    ichSelbst^.AbbrechenKnopfHdle:=StelleKnopfDar(Text, ichSelbst^.WinHdle, AbbrechenKnopfXPos,
    						 KnopfYPos, CAST(PROC,AbbrechenKnopfCallback));

    String.Dispose(Text);
    IF TRACE THEN WriteString("FKondTkEin.AktivFAnlegen End"); WriteLn; END;
  END AktivFAnlegen;



PROCEDURE AbbrechenKnopfCallback();
  BEGIN
    IF TRACE THEN WriteString("FKondTkEin.AbbrechenKnopfCallback Begin"); WriteLn; END;
    DisposeFAnlegen();
    IF TRACE THEN WriteString("FKondTkEin.AbbrechenKnopfCallback End"); WriteLn; END;
  END AbbrechenKnopfCallback;



PROCEDURE AnlegenKnopfCallback();
  CONST
  VAR
    DatumString, GueltigabString, MeldString, StundensatzString: String.TString;
    DatumStr, GueltigabStr, TextStr, MeldStr, StundensatzStr: ARRAY[1..200] OF CHAR;
    reaktProc: TProc;
    meineAddr: ADDRESS; 
    ichSelbst: TPFKondTkEin;
    DatenOkay: BOOLEAN;
    Stundensatz: CARDINAL;
    TK: TKond;
    Gueltigab: Datum.TDatum;
  BEGIN
    IF TRACE THEN WriteString("FKondTkEin.AnlegenKnopfCallback Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondTkEin, meineAddr);

    GueltigabString:=String.Create();
    StundensatzString:=String.Create();
    MeldString:=String.Create();

    LiesZeile(ichSelbst^.GueltigabHdle, GueltigabString);
    String.Lies(GueltigabString, GueltigabStr);

    LiesZeile(ichSelbst^.StundensatzHdle, StundensatzString);
    String.Lies(StundensatzString, StundensatzStr);

    IF TRACEDATEN THEN
      WriteString("TK einfuegen: Gueltig ab:"); WriteString(GueltigabStr); WriteString(":");
      WriteString("Stundensatz:"); WriteString(StundensatzStr); WriteString(":");
      WriteLn;
    END;



    (*      D a t e n     P r u e f e n       *)
    DatenOkay:=TRUE;

    TK:=CreateTarifKondition();

    (* Gueltigab Prfen und konvertieren *)
    IF Datum.DatumVonString(GueltigabString, Gueltigab, MeldString) THEN
      IF TRACEDATEN THEN
        MeldString:=Datum.DatumAlsString(Gueltigab);
        String.Lies(MeldString, MeldStr);
        WriteString("Gueltig ab:"); WriteString(MeldStr); WriteString(":");
      END;
    ELSE
      DatenOkay:=FALSE;
      String.Lies(MeldString, MeldStr);
      TextStr:="Gltig ab: ";
      Strings.Append(MeldStr, TextStr);
      AusgebenMeldung(TextStr);
    END;

    (* Stundensatz prfen und konvertieren *)
    IF StrToCardinal(StundensatzStr,Stundensatz) THEN
      IF TRACEDATEN THEN
        WriteString("Stundensatz:"); WriteCard(Stundensatz,5); WriteString(":");
      END;
      IF SetzeStdSinTKond(TK,Stundensatz) THEN
        ;
      ELSE
        DatenOkay:=FALSE;
        MeldStr:="Stundensatz kann nicht gesetz werden !?";
        AusgebenMeldung(MeldStr);
      END;
    ELSE
      DatenOkay:=FALSE;
      AusgebenMeldung(" Der Stundensatz ist ungueltig (nicht positiv ganzzahlig)");
    END;
    IF TRACEDATEN THEN
      WriteLn;
    END;



    (* Sind die eingegebenen Tarifkonditionsdaten okay, dann wird die TK angelegt *)
    IF DatenOkay THEN
       SetzeGueltVoninKond(TK,Gueltigab);
(*
       IF TKondGeprueftEinf(TK,MeldString) THEN
         AusgebenMeldung("Tarifkondition wurde angelegt");
*)
       IF InsertTKond(TK,MeldString) THEN
         AusgebenMeldung("Tarifkondition wurde angelegt");
       ELSE
         String.Lies(MeldString, MeldStr);
         TextStr:="Meldung zu TK anlegen:";
         Strings.Append(MeldStr, TextStr);
         AusgebenMeldung(TextStr);
       END;
    END;



    DisposeKond(TK);
    IF Gueltigab <> NIL THEN
      Datum.DisposeDatum(Gueltigab);
    END;
    String.Dispose(GueltigabString);
    String.Dispose(StundensatzString);
    String.Dispose(MeldString);
    IF TRACE THEN WriteString("FKondTkEin.AnlegenKnopfCallback End"); WriteLn; END;
  END AnlegenKnopfCallback;




PROCEDURE CreateFAnlegen();
  CONST
      FXPos=INT(300);
      FYPos=INT(300);
      FHoehe=INT(250);
      FBreite=INT(500);
  VAR FensterUeberschrift: String.TString;
      WinHdle: ADDRESS;
      ichSelbst: TPFKondTkEin;
      meineAddr: ADDRESS;
  BEGIN
    IF TRACE THEN WriteString("FKondTkEin.CreateFAnlegen Begin"); WriteLn; END;

    (* Fenstar ADO anlegen; ReaktProcedur- und ADO-Adresse auf den Stapel geben *)
    NEW(ichSelbst);
    meineAddr:= CAST(ADDRESS, ichSelbst);
    Push(ReaktFAnlegen, meineAddr);

    FensterUeberschrift := String.Create();
    String.Schreibe( FensterUeberschrift,"Tarifkondition anlegen");
    ichSelbst^.WinHdle:=NeuesFenster(FensterUeberschrift,FXPos,FYPos,FHoehe,FBreite);
    String.Dispose(FensterUeberschrift);

    AktivFAnlegen();

    IF TRACE THEN WriteString("FKondTkEin.CreateFAnlegen End"); WriteLn; END;
  END CreateFAnlegen;



PROCEDURE DisposeFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFKondTkEin;
  BEGIN
    IF TRACE THEN WriteString("FKondTkEin.DisposeFAnlegen Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondTkEin, meineAddr);

(*  LoeschenEingabeFelder();
    EntferneKnopf(ichSelbst^.AnlegenKnopfHdle);
    EntferneKnopf(ichSelbst^.AbbrechenKnopfHdle);  *)

    EntferneFenster(ichSelbst^.WinHdle);

    (* Fenster ADO loeschen; Stapelelement des aktuellen Fensters entfernen und
       ReaktProcedur des uebergeordneten Fensters aufrufen *)
    DISPOSE(ichSelbst);
    Pop();
    Top(reaktProc, meineAddr);
    reaktProc();
    IF TRACE THEN WriteString("FKondTkEin.DisposeFAnlegen End"); WriteLn; END;
  END DisposeFAnlegen;



PROCEDURE DeaktFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFKondTkEin;
  BEGIN
    IF TRACE THEN WriteString("FKondTkEin.DeaktFAnlegen Begin"); WriteLn; END;
    (* Deaktiviere Knpfe *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondTkEin, meineAddr);
    SetzeKnopf(ichSelbst^.AnlegenKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.AbbrechenKnopfHdle, FALSE);
    IF TRACE THEN WriteString("FKondTkEin.DeaktFAnlegen End"); WriteLn; END;
  END DeaktFAnlegen;



PROCEDURE ReaktFAnlegen();                                                           		
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFKondTkEin;
  BEGIN
    IF TRACE THEN WriteString("FKondTkEin.ReaktFAnlegen Begin"); WriteLn; END;
    (* Aktiviere alle Fensterinhalte *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondTkEin, meineAddr);
    SetzeKnopf(ichSelbst^.AnlegenKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.AbbrechenKnopfHdle, TRUE);
    IF TRACE THEN WriteString("FKondTkEin.ReaktFAnlegen End"); WriteLn; END;
  END ReaktFAnlegen;



PROCEDURE InitEingabeFelder();               
  CONST
      XPos=INT(40);
      GueltigabYPos=INT(55);
      GueltigabLaen=INT(9);
      StundensatzYPos=INT(85);
      StundensatzLaen=INT(4);
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFKondTkEin;
      Text, Inhalt: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FKondTkEin.InitEingabeFelder Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondTkEin, meineAddr);

    Text := String.Create();
    Inhalt := String.Create();

    String.Schreibe(Text,"Gltig ab (TT.MM.JJJJ):");
    ichSelbst^.GueltigabHdle:=StelleZeileDar(Text, Inhalt, GueltigabLaen,
				ichSelbst^.WinHdle, XPos, GueltigabYPos);

    String.Schreibe(Text,"Stundensatz:");
    ichSelbst^.StundensatzHdle:=StelleZeileDar(Text, Inhalt, StundensatzLaen,
				ichSelbst^.WinHdle, XPos, StundensatzYPos);

    String.Dispose(Text);
    String.Dispose(Inhalt);
    IF TRACE THEN WriteString("FKondTkEin.InitEingabeFelder End"); WriteLn; END;
  END InitEingabeFelder;



PROCEDURE LoeschenEingabeFelder();               
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFKondTkEin;
  BEGIN
    IF TRACE THEN WriteString("FKondTkEin.LoeschenEingabeFelder Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondTkEin, meineAddr);
    EntferneZeile(ichSelbst^.GueltigabHdle);
    EntferneZeile(ichSelbst^.StundensatzHdle);
    IF TRACE THEN WriteString("FKondTkEin.LoeschenEingabeFelder End"); WriteLn; END;
  END LoeschenEingabeFelder;



PROCEDURE AusgebenMeldung(inStr:ARRAY OF CHAR);
   VAR 
    MeldText: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FKondTkEin.AusgebenMeldung Begin"); WriteLn; END;
    MeldText := String.Create();
    String.Schreibe(MeldText, inStr);
    MeldungAnzeigen(MeldText); 
    String.Dispose(MeldText);
    IF TRACE THEN WriteString("FKondTkEin.AusgebenMeldung End"); WriteLn; END;
  END AusgebenMeldung;




PROCEDURE StrToCardinal(inStr:ARRAY OF CHAR; VAR outCard:CARDINAL):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToCard(inStr,outCard,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToCardinal;


PROCEDURE StrToInteger(inStr:ARRAY OF CHAR; VAR outInt:INTEGER):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToInt(inStr,outInt,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToInteger;




CONST
  TRACE=FALSE;
  TRACEDATEN=TRUE;
VAR
BEGIN;
END FKondTkEin.
