(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: FKondWkAnz.mod,v $
# $Author: Sopra $
# $Date: 2001/03/11 09:20:50 $
# $Revision: 1.2 $
# Bemerkungen:

IMPLEMENTATION MODULE FKondWkAnz;
Funktion: akuelle Weihnachtsgeldkondition anzeigen

JZ

V 0.6   1.3.01  19:04

*)
(******************************************************************************)

IMPLEMENTATION MODULE FKondWkAnz;

(* System-Importe *)
FROM X_Grafik IMPORT StelleListeDar,EntferneListe;
FROM X_Grafik IMPORT LiesListenelement, AendereListenelement;
FROM X_Grafik IMPORT StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM X_Grafik IMPORT StelleTextDar, EntferneText;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT InitialisiereGrafik, StarteGrafik;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT MeldungAnzeigen, JaNeinAbfrage;
FROM X_Grafik IMPORT StringEingabeFenster, StringEingabeAuslesen;
FROM X_Grafik IMPORT StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT LiesMenueEintrag, EntferneMenue;

FROM SYSTEM IMPORT 	CAST, ADR, ADDRESS, TSIZE;
FROM Storage IMPORT 	ALLOCATE, DEALLOCATE;
FROM InOut IMPORT 	WriteCard, WriteLn, WriteString, WriteInt;
IMPORT WholeConv;
IMPORT WholeStr;
IMPORT ConvTypes;
IMPORT String;  (*  "String" TString *)
IMPORT Strings; (*  "Str"   Strings  enthaelt Operationen fuer ARRAY OF CHAR Datentypen !! *)
IMPORT Stringliste;


(* HiKS-Importe *)
FROM SysReaktFStapel IMPORT 	Push, Pop, Top, TProc;
IMPORT Datum;
IMPORT SysDat;
FROM Konden IMPORT 	TKond, CreateWeihnachtsKondition, DisposeKond,
			SetzeGueltVoninKond, LiesGueltVoninKond,
			SetzeGueltBisinKond, LiesGueltBisinKond,
			SetzeSTaginWKond, LiesSTaginWKond,
			SetzeBemMonatinWKond, LiesBemMonatinWKond,
			HoleGueltigeWKond,
			CreateKonditionsOrdner,
			InsertTKond,
			LoadInKonden, SaveInKonden;



  TYPE 	TFKondWkAnzDS = RECORD
		           WinHdle : ADDRESS;
		           AnlegenKnopfHdle,
			   LoeschenKnopfHdle,
			   AbbrechenKnopfHdle:ADDRESS;  		      
			   GueltigabHdle,
			   GueltigbisHdle,
			   BemmonatHdle,
			   StichtagHdle : ADDRESS
  	      		 END;	
        TPFKondWkAnz = POINTER TO TFKondWkAnzDS;


(* --------------------------------------------------------------- *)

PROCEDURE AktivFAnlegen();
  CONST
    KnopfYPos=INT(180);
    AnlegenKnopfXPos=INT(10);
    LoeschenKnopfXPos=INT(260);
    AbbrechenKnopfXPos=INT(390);
  VAR
    I: CARDINAL;
    AnlegenKnopfText,
    LoeschenKnopfText,
    AbbrechenKnopfText     : String.TString;

    reaktProc: TProc;
    meineAddr: ADDRESS; 
    ichSelbst: TPFKondWkAnz;
  BEGIN
    IF TRACE THEN WriteString("FKondWkAnz.AktivFAnlegen Begin"); WriteLn; END;
    (* Erzeuge den Fensterinhalt *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondWkAnz, meineAddr);

    InitEingabeFelder();

    AbbrechenKnopfText := String.Create();
    String.Schreibe(AbbrechenKnopfText,"Abbrechen");
    ichSelbst^.AbbrechenKnopfHdle:=StelleKnopfDar(AbbrechenKnopfText,
	ichSelbst^.WinHdle, AbbrechenKnopfXPos, KnopfYPos, CAST(PROC,AbbrechenKnopfCallback));
    String.Dispose(AbbrechenKnopfText);

    IF TRACE THEN WriteString("FKondWkAnz.AktivFAnlegen End"); WriteLn; END;
  END AktivFAnlegen;



PROCEDURE AbbrechenKnopfCallback();
  BEGIN
    IF TRACE THEN WriteString("FKondWkAnz.AbbrechenKnopfCallback Begin"); WriteLn; END;
    DisposeFAnlegen();
    IF TRACE THEN WriteString("FKondWkAnz.AbbrechenKnopfCallback End"); WriteLn; END;
  END AbbrechenKnopfCallback;





PROCEDURE LoeschenKnopfCallback();
   VAR 
    MeldHandle: ADDRESS;
    ichSelbst: TPFKondWkAnz;
    reaktProc: TProc;
    meineAddr: ADDRESS;
    MeldText: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FKondWkAnz.LoeschenKnopfCallback Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondWkAnz, meineAddr);
    LoeschenEingabeFelder();
    InitEingabeFelder();
    IF TRACE THEN WriteString("FKondWkAnz.LoeschenKnopfCallback End"); WriteLn; END;
  END LoeschenKnopfCallback;



PROCEDURE CreateFAnlegen();
  CONST
      FXPos=INT(300);
      FYPos=INT(300);
      FHoehe=INT(250);
      FBreite=INT(500);
  VAR FensterUeberschrift: String.TString;
      WinHdle: ADDRESS;
      ichSelbst: TPFKondWkAnz;
      meineAddr: ADDRESS;
  BEGIN
    IF TRACE THEN WriteString("FKondWkAnz.CreateFAnlegen Begin"); WriteLn; END;

    (* Fenstar ADO anlegen; ReaktProcedur- und ADO-Adresse auf den Stapel geben *)
    NEW(ichSelbst);
    meineAddr:= CAST(ADDRESS, ichSelbst);
    Push(ReaktFAnlegen, meineAddr);

    FensterUeberschrift := String.Create();
    String.Schreibe( FensterUeberschrift,"aktuelle Weihnachtsgeldkondition anzeigen");
    ichSelbst^.WinHdle:=NeuesFenster(FensterUeberschrift,FXPos,FYPos,FHoehe,FBreite);
    String.Dispose(FensterUeberschrift);

    AktivFAnlegen();

    IF TRACE THEN WriteString("FKondWkAnz.CreateFAnlegen End"); WriteLn; END;
  END CreateFAnlegen;



PROCEDURE DisposeFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFKondWkAnz;
  BEGIN
    IF TRACE THEN WriteString("FKondWkAnz.DisposeFAnlegen Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondWkAnz, meineAddr);

(*  LoeschenEingabeFelder();
    EntferneKnopf(ichSelbst^.AbbrechenKnopfHdle);  *)

    EntferneFenster(ichSelbst^.WinHdle);

    (* Fenster ADO loeschen; Stapelelement des aktuellen Fensters entfernen und
       ReaktProcedur des uebergeordneten Fensters aufrufen *)
    DISPOSE(ichSelbst);
    Pop();
    Top(reaktProc, meineAddr);
    reaktProc();
    IF TRACE THEN WriteString("FKondWkAnz.DisposeFAnlegen End"); WriteLn; END;
  END DisposeFAnlegen;



PROCEDURE DeaktFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFKondWkAnz;
  BEGIN
    IF TRACE THEN WriteString("FKondWkAnz.DeaktFAnlegen Begin"); WriteLn; END;
    (* Deaktiviere Knpfe *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondWkAnz, meineAddr);
    SetzeKnopf(ichSelbst^.AbbrechenKnopfHdle, FALSE);
    IF TRACE THEN WriteString("FKondWkAnz.DeaktFAnlegen End"); WriteLn; END;
  END DeaktFAnlegen;



PROCEDURE ReaktFAnlegen();                                                           		
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFKondWkAnz;
  BEGIN
    IF TRACE THEN WriteString("FKondWkAnz.ReaktFAnlegen Begin"); WriteLn; END;
    (* Aktiviere alle Fensterinhalte *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondWkAnz, meineAddr);
    SetzeKnopf(ichSelbst^.AbbrechenKnopfHdle, TRUE);
    IF TRACE THEN WriteString("FKondWkAnz.ReaktFAnlegen End"); WriteLn; END;
  END ReaktFAnlegen;



PROCEDURE InitEingabeFelder();               
  CONST
      XPos=INT(40);
      GueltigabYPos=INT(50);
      GueltigabLaen=INT(10);
      GueltigbisYPos=INT(75);
      GueltigbisLaen=INT(10);
      BemmonatYPos=INT(100);
      BemmonatLaen=INT(2);
      StichtagYPos=INT(125);
      StichtagLaen=INT(5);
  VAR
    Text, Inhalt: String.TString;
    ZWDatumString, GueltigabString, GueltigbisString, MeldString, BemmonatString,
     						StichtagString: String.TString;
    ZWDatumStr, TextStr, GueltigabStr, GueltigbisStr, MeldStr, BemmonatStr, StichtagStr: ARRAY[1..200] OF CHAR;
    reaktProc: TProc;
    meineAddr: ADDRESS;
    ichSelbst: TPFKondWkAnz;
    Format: ConvTypes.ConvResults;
    DatenOkay: BOOLEAN;
    BemmonatCard: CARDINAL;
    Bemmonat: Datum.TMonat;
    Stichtag: Datum.TStag;
    WK: TKond;
    ZWDatum: Datum.TDatum;
    Gueltigab, Gueltigbis, Heute: Datum.TDatum;
  BEGIN
    IF TRACE THEN WriteString("FKondWkAnz.InitEingabeFelder Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondWkAnz, meineAddr);

    Text := String.Create();
    Inhalt := String.Create();
    MeldString := String.Create();
    ZWDatumString := String.Create();


(* ( * *)
    String.Schreibe(ZWDatumString,"25.2.2001");
    IF Datum.DatumVonString(ZWDatumString, ZWDatum, MeldString) THEN
	;
    ELSE
      DatenOkay:=FALSE;
      String.Lies(MeldString, MeldStr);
      TextStr:="Dubios: ";
      Strings.Append(MeldStr, TextStr);
      AusgebenMeldung(TextStr);
    END;
    Heute:=Datum.DuplicateDatum(ZWDatum);
(*
    SysDat.SetzeSystemDatumInSysDat(Heute);
*)
(* * ) *)
    Heute:=SysDat.LiesSystemDatumInSysDat();



    IF HoleGueltigeWKond(Heute, WK) THEN
      Gueltigab:=LiesGueltVoninKond(WK);
      GueltigabString:=Datum.DatumAlsString(Gueltigab);
      Gueltigbis:=LiesGueltBisinKond(WK);
      GueltigbisString:=Datum.DatumAlsString(Gueltigbis);
      Bemmonat:=LiesBemMonatinWKond(WK);
      BemmonatString:=Datum.MonatAlsString(Bemmonat);
(*
      BemmonatCard:=Datum.MonatAlsCard(Bemmonat);
      WholeStr.CardToStr(BemmonatCard, BemmonatStr);
      BemmonatString := String.Create();
      String.Schreibe(BemmonatString, BemmonatStr);
*)


      Stichtag:=LiesSTaginWKond(WK);
      StichtagString:=Datum.StagAlsString(Stichtag);

      String.Schreibe(Text,"Gltig ab:  ");
      String.Anhaengen(GueltigabString, Text);
      ichSelbst^.GueltigabHdle:=StelleMeldungDar(Text, FALSE, ichSelbst^.WinHdle, XPos, GueltigabYPos);

      String.Schreibe(Text,"Gltig bis:  ");
      String.Anhaengen(GueltigbisString, Text);
      ichSelbst^.GueltigbisHdle:=StelleMeldungDar(Text, FALSE, ichSelbst^.WinHdle, XPos, GueltigbisYPos);

      String.Schreibe(Text,"Bemessungsmonat:  ");
      String.Anhaengen(BemmonatString, Text);
      ichSelbst^.BemmonatHdle:=StelleMeldungDar(Text, FALSE, ichSelbst^.WinHdle, XPos, BemmonatYPos);

      String.Schreibe(Text,"Stichtag:  ");
      String.Anhaengen(StichtagString, Text);
      ichSelbst^.StichtagHdle:=StelleMeldungDar(Text, FALSE, ichSelbst^.WinHdle, XPos, StichtagYPos);


      DisposeKond(WK);
      String.Dispose(GueltigabString);
      String.Dispose(GueltigbisString);
      String.Dispose(BemmonatString);
      String.Dispose(BemmonatString);
    ELSE
      String.Schreibe(MeldString,"aktuelle WK wurden nicht gefunden !?");
      String.Lies(MeldString, MeldStr);
      AusgebenMeldung(MeldStr);
    END;


    String.Dispose(Text);
    String.Dispose(Inhalt);
    String.Dispose(MeldString);
    String.Dispose(ZWDatumString);
    IF TRACE THEN WriteString("FKondWkAnz.InitEingabeFelder End"); WriteLn; END;
  END InitEingabeFelder;



PROCEDURE LoeschenEingabeFelder();               
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFKondWkAnz;
  BEGIN
    IF TRACE THEN WriteString("FKondWkAnz.LoeschenEingabeFelder Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondWkAnz, meineAddr);
    EntferneZeile(ichSelbst^.GueltigabHdle);
    EntferneZeile(ichSelbst^.GueltigbisHdle);
    EntferneZeile(ichSelbst^.BemmonatHdle);
    EntferneZeile(ichSelbst^.StichtagHdle);
    IF TRACE THEN WriteString("FKondWkAnz.LoeschenEingabeFelder End"); WriteLn; END;
  END LoeschenEingabeFelder;



PROCEDURE AusgebenMeldung(inStr:ARRAY OF CHAR);
   VAR 
    MeldText: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FKondWkAnz.AusgebenMeldung Begin"); WriteLn; END;
    MeldText := String.Create();
    String.Schreibe(MeldText, inStr);
    MeldungAnzeigen(MeldText); 
    String.Dispose(MeldText);
    IF TRACE THEN WriteString("FKondWkAnz.AusgebenMeldung End"); WriteLn; END;
  END AusgebenMeldung;



PROCEDURE StrToCardinal(inStr:ARRAY OF CHAR; VAR outCard:CARDINAL):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToCard(inStr,outCard,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToCardinal;


PROCEDURE StrToInteger(inStr:ARRAY OF CHAR; VAR outInt:INTEGER):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToInt(inStr,outInt,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToInteger;




CONST
  TRACE=FALSE;
VAR
BEGIN;
END FKondWkAnz.
