(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: FKondWkEin.mod,v $
# $Author: Sopra $
# $Date: 2001/03/14 07:58:09 $
# $Revision: 1.5 $
# Bemerkungen:

IMPLEMENTATION MODULE FKondWkEin;
Funktion: Weihnachtsgeldkondition einfuegen

JZ

V 0.6   28.2.01  18:44

*)
(******************************************************************************)


IMPLEMENTATION MODULE FKondWkEin;

(* System-Importe *)
FROM X_Grafik IMPORT StelleListeDar,EntferneListe;
FROM X_Grafik IMPORT LiesListenelement, AendereListenelement;
FROM X_Grafik IMPORT StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM X_Grafik IMPORT StelleTextDar, EntferneText;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT InitialisiereGrafik, StarteGrafik;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT MeldungAnzeigen, JaNeinAbfrage;
FROM X_Grafik IMPORT StringEingabeFenster, StringEingabeAuslesen;
FROM X_Grafik IMPORT StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT LiesMenueEintrag, EntferneMenue;

FROM SYSTEM IMPORT 	CAST, ADR, ADDRESS, TSIZE;
FROM Storage IMPORT 	ALLOCATE, DEALLOCATE;
FROM InOut IMPORT 	ReadString, WriteCard, WriteLn, WriteString, WriteInt;
IMPORT WholeConv;
IMPORT WholeStr;
IMPORT ConvTypes;
IMPORT String;  (*  "String" TString *)
IMPORT Strings; (*  "Str"   Strings  enthaelt Operationen fuer ARRAY OF CHAR Datentypen !! *)
IMPORT Stringliste;


(* HiKS-Importe *)
FROM SysReaktFStapel IMPORT 	Push, Pop, Top, TProc;
IMPORT Datum;
FROM Konden IMPORT 	TKond, CreateWeihnachtsKondition, DisposeKond,
			SetzeGueltVoninKond, LiesGueltVoninKond,
			SetzeGueltBisinKond, LiesGueltBisinKond,
			SetzeSTaginWKond, LiesSTaginWKond,
			SetzeBemMonatinWKond, LiesBemMonatinWKond,
			HoleGueltigeWKond,
			CreateKonditionsOrdner,
			InsertWKond,
			LoadInKonden, SaveInKonden;
		

FROM PSB IMPORT	WKondGeprueftEinf;



  TYPE 	TFKondWkEinDS = RECORD
		           WinHdle : ADDRESS;
		           AnlegenKnopfHdle,
			   LoeschenKnopfHdle,
			   AbbrechenKnopfHdle:ADDRESS;  		      
			   GueltigabHdle,
			   BemmonatHdle,
			   StichtagHdle : ADDRESS
  	      		 END;	
        TPFKondWkEin = POINTER TO TFKondWkEinDS;


(* --------------------------------------------------------------- *)

PROCEDURE AktivFAnlegen();
  CONST
    KnopfYPos=INT(180);
    AnlegenKnopfXPos=INT(50);
    LoeschenKnopfXPos=INT(260);
    AbbrechenKnopfXPos=INT(370);
  VAR
    Text     : String.TString;
    reaktProc: TProc;
    meineAddr: ADDRESS; 
    ichSelbst: TPFKondWkEin;
  BEGIN
    IF TRACE THEN WriteString("FKondWkEin.AktivFAnlegen Begin"); WriteLn; END;

    (* Erzeuge den Fensterinhalt *)

    InitEingabeFelder();

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondWkEin, meineAddr);

    Text := String.Create();
    String.Schreibe(Text,"Weihnachtsgeldkondition anlegen");
    ichSelbst^.AnlegenKnopfHdle:=StelleKnopfDar(Text, ichSelbst^.WinHdle, AnlegenKnopfXPos,
    						 KnopfYPos, CAST(PROC,AnlegenKnopfCallback));

    String.Schreibe(Text,"Abbrechen");
    ichSelbst^.AbbrechenKnopfHdle:=StelleKnopfDar(Text, ichSelbst^.WinHdle, AbbrechenKnopfXPos,
    						 KnopfYPos, CAST(PROC,AbbrechenKnopfCallback));
    String.Dispose(Text);

    IF TRACE THEN WriteString("FKondWkEin.AktivFAnlegen End"); WriteLn; END;
  END AktivFAnlegen;



PROCEDURE AbbrechenKnopfCallback();
  BEGIN
    IF TRACE THEN WriteString("FKondWkEin.AbbrechenKnopfCallback Begin"); WriteLn; END;
    DisposeFAnlegen();
    IF TRACE THEN WriteString("FKondWkEin.AbbrechenKnopfCallback End"); WriteLn; END;
  END AbbrechenKnopfCallback;



PROCEDURE AnlegenKnopfCallback();
  CONST
  VAR
    DatumString, GueltigabString, MeldString, BemmonatString, StichtagString: String.TString;
    DatumStr, GueltigabStr, TextStr, MeldStr, BemmonatStr, StichtagStr: ARRAY[1..200] OF CHAR;
    reaktProc: TProc;
    meineAddr: ADDRESS; 
    ichSelbst: TPFKondWkEin;
    DatenOkay: BOOLEAN;
    WK: TKond;
    Bemmonat: Datum.TMonat;
    Stichtag: Datum.TStag;
    Gueltigab: Datum.TDatum;
  BEGIN
    IF TRACE THEN WriteString("FKondWkEin.AnlegenKnopfCallback Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondWkEin, meineAddr);


    GueltigabString:=String.Create();
    BemmonatString:=String.Create();
    StichtagString:=String.Create();
    MeldString:=String.Create();
    DatumString:=String.Create();


    LiesZeile(ichSelbst^.GueltigabHdle, GueltigabString);
    String.Lies(GueltigabString, GueltigabStr);

    LiesZeile(ichSelbst^.BemmonatHdle, BemmonatString);
    String.Lies(BemmonatString, BemmonatStr);

    LiesZeile(ichSelbst^.StichtagHdle, StichtagString);
    String.Lies(StichtagString, StichtagStr);


    IF TRACEDATEN THEN
      WriteString("WK einfuegen:  Gueltig ab:"); WriteString(GueltigabStr); WriteString(":");
      WriteString("Bemessungsmonat:"); WriteString(BemmonatStr); WriteString(":");
      WriteString("Stichtag:"); WriteString(StichtagStr); WriteString(":"); WriteLn;
    END;


    (*      D a t e n     P r u e f e n       *)
    DatenOkay:=TRUE;

    WK:=CreateWeihnachtsKondition();

    (* Gueltigab prfen und konvertieren *)
    Gueltigab:=NIL;
    IF Datum.DatumVonString(GueltigabString, Gueltigab, MeldString) THEN
	;
    ELSE
      DatenOkay:=FALSE;
      String.Lies(MeldString, MeldStr);
      TextStr:="Gltig ab: ";
      Strings.Append(MeldStr, TextStr);
      AusgebenMeldung(TextStr);
    END;


    (* Bemessungsmonat prfen und konvertieren *)
    Bemmonat:=NIL;
    IF Datum.MonatVonString(BemmonatString, Bemmonat, MeldString) THEN
      IF SetzeBemMonatinWKond(WK,Bemmonat) THEN
        ;
      ELSE
        DatenOkay:=FALSE;
        MeldStr:="Bemessungsmonat konnte nicht gesetzt werden!";
        AusgebenMeldung(MeldStr);
      END;

    ELSE
      DatenOkay:=FALSE;
      String.Lies(MeldString, MeldStr);
      TextStr:="";
      Strings.Append(MeldStr, TextStr);
      AusgebenMeldung(MeldStr);
    END;



    (* Stichtag prfen und konvertieren *)
    Stichtag:=NIL;
    IF Datum.StagVonString(StichtagString, Stichtag, MeldString) THEN
      IF SetzeSTaginWKond(WK,Stichtag) THEN
        ;
      ELSE
        DatenOkay:=FALSE;
        MeldStr:="Meldung zu Stichtag: Stichtag konnte nicht gesetzt werden!";
        AusgebenMeldung(MeldStr);
      END;
    ELSE
      DatenOkay:=FALSE;
      String.Lies(MeldString, MeldStr);
      TextStr:="";
      Strings.Append(MeldStr, TextStr);
      AusgebenMeldung(TextStr);
   END;



    (* Sind die eingegebenen Weihnachtsgeldkonditionsdaten okay, dann wird die WK angelegt *)
    IF DatenOkay THEN
       SetzeGueltVoninKond(WK,Gueltigab);

       IF WKondGeprueftEinf(WK,MeldString) THEN
         AusgebenMeldung("Weihnachtsgeldkondition wurde angelegt");
(*
       IF InsertWKond(WK,MeldString) THEN
         AusgebenMeldung("Weihnachtsgeldkondition wurde angelegt");
*)
       ELSE
         String.Lies(MeldString, MeldStr);
         TextStr:="Meldung zu WK anlegen:";
         Strings.Append(MeldStr, TextStr);
         AusgebenMeldung(TextStr);
       END;
    END;


    DisposeKond(WK);
    IF Gueltigab <> NIL THEN
      Datum.DisposeDatum(Gueltigab);
    END;
    IF Stichtag <> NIL THEN
      Datum.DisposeStag(Stichtag);
    END;
    IF Bemmonat <> NIL THEN
      Datum.DisposeMonat(Bemmonat);
    END;
    String.Dispose(GueltigabString);
    String.Dispose(BemmonatString);
    String.Dispose(StichtagString);
    String.Dispose(MeldString);
    String.Dispose(DatumString);
    IF TRACE THEN WriteString("FKondWkEin.AnlegenKnopfCallback End"); WriteLn; END;
  END AnlegenKnopfCallback;





PROCEDURE CreateFAnlegen();
  CONST
      FXPos=INT(300);
      FYPos=INT(300);
      FHoehe=INT(250);
      FBreite=INT(500);
  VAR FensterUeberschrift: String.TString;
      WinHdle: ADDRESS;
      ichSelbst: TPFKondWkEin;
      meineAddr: ADDRESS;
  BEGIN
    IF TRACE THEN WriteString("FKondWkEin.CreateFAnlegen Begin"); WriteLn; END;

    (* Fenstar ADO anlegen; ReaktProcedur- und ADO-Adresse auf den Stapel geben *)
    NEW (ichSelbst);
    meineAddr:= CAST(ADDRESS, ichSelbst);
    Push(ReaktFAnlegen, meineAddr);

    FensterUeberschrift := String.Create();
    String.Schreibe( FensterUeberschrift,"Weihnachtsgeldkondition anlegen");
    ichSelbst^.WinHdle:=NeuesFenster(FensterUeberschrift,FXPos,FYPos,FHoehe,FBreite);
    String.Dispose(FensterUeberschrift);

    AktivFAnlegen();

    IF TRACE THEN WriteString("FKondWkEin.CreateFAnlegen End"); WriteLn; END;
  END CreateFAnlegen;



PROCEDURE DisposeFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFKondWkEin;
  BEGIN
    IF TRACE THEN WriteString("FKondWkEin.DisposeFAnlegen Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondWkEin, meineAddr);

(*  LoeschenEingabeFelder();
    EntferneKnopf(ichSelbst^.AnlegenKnopfHdle);
    EntferneKnopf(ichSelbst^.AbbrechenKnopfHdle);  *)

    EntferneFenster(ichSelbst^.WinHdle);

    (* Fenster ADO loeschen; Stapelelement des aktuellen Fensters entfernen und
       ReaktProcedur des uebergeordneten Fensters aufrufen *)
    DISPOSE(ichSelbst);
    Pop();
    Top(reaktProc, meineAddr);
    reaktProc();
    IF TRACE THEN WriteString("FKondWkEin.DisposeFAnlegen End"); WriteLn; END;
  END DisposeFAnlegen;



PROCEDURE DeaktFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFKondWkEin;
  BEGIN
    IF TRACE THEN WriteString("FKondWkEin.DeaktFAnlegen Begin"); WriteLn; END;
    (* Deaktiviere Knpfe *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondWkEin, meineAddr);
    SetzeKnopf(ichSelbst^.AnlegenKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.AbbrechenKnopfHdle, FALSE);
    IF TRACE THEN WriteString("FKondWkEin.DeaktFAnlegen End"); WriteLn; END;
  END DeaktFAnlegen;



PROCEDURE ReaktFAnlegen();                                                           		
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFKondWkEin;
  BEGIN
    IF TRACE THEN WriteString("FKondWkEin.ReaktFAnlegen Begin"); WriteLn; END;
    (* Aktiviere alle Fensterinhalte *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondWkEin, meineAddr);
    SetzeKnopf(ichSelbst^.AnlegenKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.AbbrechenKnopfHdle, TRUE);
    IF TRACE THEN WriteString("FKondWkEin.ReaktFAnlegen End"); WriteLn; END;
  END ReaktFAnlegen;



PROCEDURE InitEingabeFelder();               
  CONST
      XPos=INT(40);
      GueltigabYPos=INT(55);
      GueltigabLaen=INT(10);
      BemmonatYPos=INT(85);
      BemmonatLaen=INT(2);
      StichtagYPos=INT(115);
      StichtagLaen=INT(5);
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFKondWkEin;
      Text, Inhalt: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FKondWkEin.InitEingabeFelder Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondWkEin, meineAddr);

    Text := String.Create();
    Inhalt := String.Create();

    String.Schreibe(Text,"Gltig ab (TT.MM.JJJJ):");
    ichSelbst^.GueltigabHdle:=StelleZeileDar(Text, Inhalt, GueltigabLaen,
				ichSelbst^.WinHdle, XPos, GueltigabYPos);
    String.Schreibe(Text,"Bemessungsmonat (MM):");
    ichSelbst^.BemmonatHdle:=StelleZeileDar(Text, Inhalt, BemmonatLaen,
				ichSelbst^.WinHdle, XPos, BemmonatYPos);
    String.Schreibe(Text,"Stichtag (TT.MM):");
    ichSelbst^.StichtagHdle:=StelleZeileDar(Text, Inhalt, StichtagLaen,
				ichSelbst^.WinHdle, XPos, StichtagYPos);

    String.Dispose(Text);
    String.Dispose(Inhalt);
    IF TRACE THEN WriteString("FKondWkEin.InitEingabeFelder End"); WriteLn; END;
  END InitEingabeFelder;



PROCEDURE LoeschenEingabeFelder();               
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFKondWkEin;
  BEGIN
    IF TRACE THEN WriteString("FKondWkEin.LoeschenEingabeFelder Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFKondWkEin, meineAddr);
    EntferneZeile(ichSelbst^.GueltigabHdle);
    EntferneZeile(ichSelbst^.BemmonatHdle);
    EntferneZeile(ichSelbst^.StichtagHdle);
    IF TRACE THEN WriteString("FKondWkEin.LoeschenEingabeFelder End"); WriteLn; END;
  END LoeschenEingabeFelder;



PROCEDURE AusgebenMeldung(inStr:ARRAY OF CHAR);
   VAR 
    ichSelbst: TPFKondWkEin;
    reaktProc: TProc;
    meineAddr: ADDRESS;
    MeldText: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FKondWkEin.AusgebenMeldung Begin"); WriteLn; END;
    MeldText := String.Create();
    String.Schreibe(MeldText, inStr);
    MeldungAnzeigen(MeldText); 
    String.Dispose(MeldText);
    IF TRACE THEN WriteString("FKondWkEin.AusgebenMeldung End"); WriteLn; END;
  END AusgebenMeldung;



PROCEDURE StrToCardinal(inStr:ARRAY OF CHAR; VAR outCard:CARDINAL):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToCard(inStr,outCard,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToCardinal;


PROCEDURE StrToInteger(inStr:ARRAY OF CHAR; VAR outInt:INTEGER):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToInt(inStr,outInt,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToInteger;


PROCEDURE StringAusgeben (inStr : String.TString);
   VAR Test : ARRAY[1..72] OF CHAR;
BEGIN
   WriteString("[");
   String.Lies (inStr, Test);
   WriteString(Test);
   WriteString("]");
   WriteLn;
END StringAusgeben;

PROCEDURE StringEingeben (frage: ARRAY OF CHAR; inoutStr : String.TString);
VAR Wert : ARRAY [0..50] OF CHAR;
BEGIN
   WriteString(frage);
   ReadString(Wert);
   String.Schreibe (inoutStr, Wert);
   WriteLn;
END StringEingeben;



CONST
  TRACE=FALSE;
  TRACEDATEN=TRUE;
VAR
BEGIN;
END FKondWkEin.
