(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: FSelBuKst.mod,v $
# $Author: Sopra $
# $Date: 2001/03/11 16:49:50 $
# $Revision: 1.3 $
# Bemerkungen:

IMPLEMENTATION MODULE FSelBuKst;
Funktion: Selektion einer Kostenstelle zum Buchen

JZ

V 0.6   26.2.01  20:40


*)
(******************************************************************************)

IMPLEMENTATION MODULE FSelBuKst;

(* System-Importe *)
FROM X_Grafik IMPORT StelleListeDar,EntferneListe;
FROM X_Grafik IMPORT LiesListenelement, AendereListenelement;
FROM X_Grafik IMPORT StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM X_Grafik IMPORT StelleTextDar, EntferneText;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT InitialisiereGrafik, StarteGrafik;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT MeldungAnzeigen, JaNeinAbfrage;
FROM X_Grafik IMPORT StringEingabeFenster, StringEingabeAuslesen;
FROM X_Grafik IMPORT StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT LiesMenueEintrag, EntferneMenue;

FROM SYSTEM IMPORT 	CAST, ADR, ADDRESS, TSIZE;
FROM Storage IMPORT 	ALLOCATE, DEALLOCATE;
FROM InOut IMPORT 	WriteCard, WriteLn, WriteString, WriteInt;
IMPORT WholeConv;
IMPORT WholeStr;
IMPORT ConvTypes;
IMPORT String;  (*  "String" TString *)
IMPORT Strings; (*  "Str"   Strings  enthaelt Operationen fuer ARRAY OF CHAR Datentypen !! *)
IMPORT Stringliste;


(* HiKS-Importe *)
FROM SysReaktFStapel IMPORT Push, Pop, Top, TProc;
IMPORT FBuchenKst;
FROM Ksten IMPORT 	TKstID, TKst, CreateKst,
			SetzeKIDinKst, LiesKIDinKst,
 			SetzeEingAminKst, LiesEingAminKst,
 			SetzeGesperrtAminKst, LiesGesperrtAminKst,IstGesperrtAminKst,
 			SetzeLiquidAminKst, LiesLiquidAminKst, IstLiquidiertAminKst,
 			SetzeNameinKst, LiesNameinKst,
 			SetzeJahrinKst,LiesJahrinKst,
 			SetzeKontinginKst, LiesKontinginKst,
 			SetzeAequivinKst, LiesAequivinKst,
			ExistKst,
			KstIDAlsString, StringInKstID, PruefeKstID,
			GibKstenAlsStringlisteInKsten,
			SearchKstZuKID;



  TYPE 	TFSelektionBuKstDS = RECORD
                               WinHdle : ADDRESS;
		               ListenHdle : ADDRESS;
			       AbbrechenKnopfHdle:ADDRESS;  		
  	      		     END;	
        TPFSelektionBuKst = POINTER TO TFSelektionBuKstDS;


(* --------------------------------------------------------------- *)

PROCEDURE AktivFAnlegen();
  CONST
    KnopfYPos=INT(230);
    AbbrechenKnopfXPos=INT(410);
  VAR
    AbbrechenKnopfText     : String.TString;
    reaktProc: TProc;
    meineAddr: ADDRESS; 
    ichSelbst: TPFSelektionBuKst;
  BEGIN
    IF TRACE THEN WriteString("FSelektionBuKst.AktivFAnlegen Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSelektionBuKst, meineAddr);

    (* Erzeuge den Fensterinhalt *)
    StelledarListe();

    AbbrechenKnopfText := String.Create();
    String.Schreibe(AbbrechenKnopfText,"Abbrechen");
    ichSelbst^.AbbrechenKnopfHdle:=StelleKnopfDar(AbbrechenKnopfText,
	ichSelbst^.WinHdle, AbbrechenKnopfXPos, KnopfYPos, CAST(PROC,AbbrechenKnopfCallback));
    String.Dispose(AbbrechenKnopfText);

    IF TRACE THEN WriteString("FSelektionBuKst.AktivFAnlegen End"); WriteLn; END;
  END AktivFAnlegen;




PROCEDURE StelledarListe();
  CONST
    KnopfYPos=INT(230);
    AbbrechenKnopfXPos=INT(410);
  VAR
    TextString, Ueberschrift: String.TString;
    Listenelement: String.TString;
    reaktProc: TProc;
    meineAddr: ADDRESS;
    ichSelbst: TPFSelektionBuKst;
    KstStringListe: Stringliste.TStringliste;
    I:INTEGER;
    TextStr, MeldStr, KstIDStr, NameStr, JahrStr, KontingentStr, AequivalentStr: ARRAY[1..200] OF CHAR;
  BEGIN
    IF TRACE THEN WriteString("FSelektionBuKst.StelledarListe Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSelektionBuKst, meineAddr);


(*
    KstStringListe := Stringliste.Create();
    Listenelement := String.Create();

    String.Schreibe (Listenelement,"    5 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"   45 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"  111 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement," 2222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"32222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"42222 Name     Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"52222 Name der Kosten      2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"00022 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"72222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"82222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);
    String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);

    FOR I:=1 TO 40 DO
      String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
      Stringliste.Append(KstStringListe,Listenelement);
    END;

*)

    KstStringListe:=GibKstenAlsStringlisteInKsten();


    Ueberschrift := String.Create();
    String.Schreibe (Ueberschrift, "Kostenstelle, Auswahl mit linker Maustaste");
    String.Schreibe (Ueberschrift, "KstID     N  a  m  e           Jahr  GesperrtAm");
    ichSelbst^.ListenHdle := StelleListeDar(KstStringListe,Ueberschrift,9,
                             ichSelbst^.WinHdle,50,40,CAST(PROC,ListeCallback));
    String.Dispose(Ueberschrift);


    TextString := String.Create();
    Listenelement:=NIL;
    WHILE NOT (Stringliste.IsEmpty(KstStringListe)) DO
      Stringliste.GoStart(KstStringListe);
      Listenelement:=Stringliste.Current(KstStringListe);
      String.Auslesen(Listenelement,0,5,TextString);
      String.Lies(TextString, TextStr);
(*      WriteString("KstID:"); WriteString(TextStr); WriteString(":"); WriteLn;
*)
      Stringliste.Delete(KstStringListe);
    END;
    Stringliste.Dispose(KstStringListe);

    IF Listenelement <> NIL THEN
      String.Dispose(Listenelement);
    END;
    String.Dispose(TextString);
    IF TRACE THEN WriteString("FSelektionBuKst.StelledarListe End"); WriteLn; END;
  END StelledarListe;




PROCEDURE AbbrechenKnopfCallback();
  VAR
    reaktProc: TProc;
    meineAddr: ADDRESS;
    ichSelbst: TPFSelektionBuKst;
  BEGIN
    IF TRACE THEN WriteString("FSelektionBuKst.AbbrechenKnopfCallback Begin"); WriteLn; END;
    DisposeFAnlegen();
    Top(reaktProc, meineAddr);
    reaktProc();
    IF TRACE THEN WriteString("FSelektionBuKst.AbbrechenKnopfCallback End"); WriteLn; END;
  END AbbrechenKnopfCallback;



PROCEDURE ListeCallback(Nr:INTEGER);
  CONST
  VAR
    MeldString, KstIDString, NameString, JahrString, KontingentString,
						AequivalentString: String.TString;
    MeldStr, KstIDStr, NameStr, JahrStr, KontingentStr, AequivalentStr: ARRAY[1..200] OF CHAR;
    reaktProc: TProc;
    meineAddr: ADDRESS; 
    ichSelbst: TPFSelektionBuKst;
    ElementString: String.TString;
    TextStr: ARRAY [1..100] OF CHAR;
    ElementStr: ARRAY [1..100] OF CHAR;

  BEGIN
    IF TRACE THEN WriteString("FSelektionBuKst.ListeCallback Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSelektionBuKst, meineAddr);

    ElementString := String.Create();
    KstIDString := String.Create();

    LiesListenelement(ichSelbst^.ListenHdle, Nr, ElementString);
    String.Lies(ElementString, ElementStr);
    String.Auslesen(ElementString,0,5,KstIDString);
    String.Lies(KstIDString, MeldStr);
(*
    WriteString("KstID:"); WriteString(MeldStr); WriteString(":"); WriteLn;
*)

    (* aktuelles Fenster entfernen *)
    DisposeFAnlegen();
    (* Neues Fenster erzeugen und KstID der ausgewaehlten Kst uebergeben *)
    FBuchenKst.CreateFAnlegen(KstIDString);

    (* bereinigen *)
    String.Dispose(ElementString);
    String.Dispose(KstIDString);
    IF TRACE THEN WriteString("FSelektionBuKst.ListeCallback End"); WriteLn; END;
  END ListeCallback;




PROCEDURE CreateFAnlegen();
  CONST
      FXPos=INT(300);
      FYPos=INT(300);
      FHoehe=INT(300);
      FBreite=INT(500);
  VAR FensterUeberschrift: String.TString;
      ichSelbst: TPFSelektionBuKst;
      meineAddr: ADDRESS;
  BEGIN
    IF TRACE THEN WriteString("FSelektionBuKst.CreateFAnlegen Begin"); WriteLn; END;

    (* Fenstar ADO anlegen; ReaktProcedur- und ADO-Adresse auf den Stapel geben *)
    NEW(ichSelbst);
    meineAddr:= CAST(ADDRESS, ichSelbst);
    Push(ReaktFAnlegen, meineAddr);

    FensterUeberschrift := String.Create();
    String.Schreibe( FensterUeberschrift,"Selektion der zu buchenden Kostenstelle");
    ichSelbst^.WinHdle:=NeuesFenster(FensterUeberschrift,FXPos,FYPos,FHoehe,FBreite);

    AktivFAnlegen();

    IF TRACE THEN WriteString("FSelektionBuKst.CreateFAnlegen End"); WriteLn; END;
  END CreateFAnlegen;



PROCEDURE DisposeFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFSelektionBuKst;
  BEGIN
    IF TRACE THEN WriteString("FSelektionBuKst.DisposeFAnlegen Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSelektionBuKst, meineAddr);

(*  EntferneListe(ichSelbst^.ListenHdle);
    EntferneKnopf(ichSelbst^.AbbrechenKnopfHdle);  *)

    EntferneFenster(ichSelbst^.WinHdle);

    (* Fenster ADO loeschen; Stapelelement des aktuellen Fensters entfernen  *)
    DISPOSE(ichSelbst);
    Pop();
    IF TRACE THEN WriteString("FSelektionBuKst.DisposeFAnlegen End"); WriteLn; END;
  END DisposeFAnlegen;



PROCEDURE DeaktFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFSelektionBuKst;
  BEGIN
    IF TRACE THEN WriteString("FSelektionBuKst.DeaktFAnlegen Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSelektionBuKst, meineAddr);
    (*Deaktiviere Knpfe, Listboxen,... *)
    SetzeKnopf(ichSelbst^.AbbrechenKnopfHdle, FALSE);
    EntferneListe(ichSelbst^.ListenHdle);
    IF TRACE THEN WriteString("FSelektionBuKst.DeaktFAnlegen End"); WriteLn; END;
  END DeaktFAnlegen;



PROCEDURE ReaktFAnlegen();                                                           		
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFSelektionBuKst;
      Ueberschrift:String.TString;
  BEGIN
    IF TRACE THEN WriteString("FSelektionBuKst.ReaktFAnlegen Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSelektionBuKst, meineAddr);
    (* Aktiviere alle Knpfe, Listbox *)
    StelledarListe();
    SetzeKnopf(ichSelbst^.AbbrechenKnopfHdle, TRUE);
    IF TRACE THEN WriteString("FSelektionBuKst.ReaktFAnlegen End"); WriteLn; END;
  END ReaktFAnlegen;




PROCEDURE AusgebenMeldung(inStr:ARRAY OF CHAR);
   VAR 
    MeldText: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FSelektionBuKst.AusgebenMeldung Begin"); WriteLn; END;
    MeldText := String.Create();
    String.Schreibe(MeldText, inStr);
    MeldungAnzeigen(MeldText); 
    String.Dispose(MeldText);
    IF TRACE THEN WriteString("FSelektionBuKst.AusgebenMeldung End"); WriteLn; END;
  END AusgebenMeldung;



PROCEDURE StrToCardinal(inStr:ARRAY OF CHAR; VAR outCard:CARDINAL):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToCard(inStr,outCard,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToCardinal;


PROCEDURE StrToInteger(inStr:ARRAY OF CHAR; VAR outInt:INTEGER):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToInt(inStr,outInt,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToInteger;




CONST
  TRACE=FALSE;
VAR
BEGIN;
END FSelBuKst.
