(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: FSysVarAnz.mod,v $
# $Author: Sopra $
# $Date: 2001/03/11 11:12:19 $
# $Revision: 1.1 $
# Bemerkungen:

IMPLEMENTATION MODULE FSysVarAnz;
Funktion: Systemvariable anzeigen

JZ

V 0.0   8.3.01  18:54

*)
(******************************************************************************)


IMPLEMENTATION MODULE FSysVarAnz;

(* System-Importe *)
FROM X_Grafik IMPORT StelleListeDar,EntferneListe;
FROM X_Grafik IMPORT LiesListenelement, AendereListenelement;
FROM X_Grafik IMPORT StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM X_Grafik IMPORT StelleTextDar, EntferneText;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT InitialisiereGrafik, StarteGrafik;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT MeldungAnzeigen, JaNeinAbfrage;
FROM X_Grafik IMPORT StringEingabeFenster, StringEingabeAuslesen;
FROM X_Grafik IMPORT StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT LiesMenueEintrag, EntferneMenue;

FROM SYSTEM IMPORT 	CAST, ADR, ADDRESS, TSIZE;
FROM Storage IMPORT 	ALLOCATE, DEALLOCATE;
FROM InOut IMPORT 	WriteCard, WriteLn, WriteString, WriteInt;
IMPORT WholeConv;
IMPORT WholeStr;
IMPORT ConvTypes;
IMPORT String;  (*  "String" TString *)
IMPORT Strings; (*  "Str"   Strings  enthaelt Operationen fuer ARRAY OF CHAR Datentypen !! *)
IMPORT Stringliste;


(* HiKS-Importe *)
FROM SysReaktFStapel IMPORT Push, Pop, Top, TProc;
IMPORT Datum;
IMPORT SysDat;


  TYPE 	TFSysVarAnzDS = RECORD
		           WinHdle : ADDRESS;
			   AbbrechenKnopfHdle:ADDRESS;  		
			   SysDatumHdle,
			   AutoDatumHdle,
			   VersionHdle : ADDRESS
  	      		 END;	
        TPFSysVarAnz = POINTER TO TFSysVarAnzDS;


(* --------------------------------------------------------------- *)

PROCEDURE AktivFAnlegen();
  CONST
    KnopfYPos=INT(180);
    AnlegenKnopfXPos=INT(10);
    LoeschenKnopfXPos=INT(260);
    AbbrechenKnopfXPos=INT(390);
  VAR
    Text     : String.TString;
    reaktProc: TProc;
    meineAddr: ADDRESS; 
    ichSelbst: TPFSysVarAnz;
  BEGIN
    IF TRACE THEN WriteString("FSysVarAnz.AktivFAnlegen Begin"); WriteLn; END;
    (* Erzeuge den Fensterinhalt *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSysVarAnz, meineAddr);

    InitEingabeFelder();

    Text := String.Create();
    String.Schreibe(Text,"Abbrechen");
    ichSelbst^.AbbrechenKnopfHdle:=StelleKnopfDar(Text, ichSelbst^.WinHdle, AbbrechenKnopfXPos,
    							 KnopfYPos, CAST(PROC,AbbrechenKnopfCallback));
    String.Dispose(Text);

    IF TRACE THEN WriteString("FSysVarAnz.AktivFAnlegen End"); WriteLn; END;
  END AktivFAnlegen;



PROCEDURE AbbrechenKnopfCallback();
  BEGIN
    IF TRACE THEN WriteString("FSysVarAnz.AbbrechenKnopfCallback Begin"); WriteLn; END;
    DisposeFAnlegen();
    IF TRACE THEN WriteString("FSysVarAnz.AbbrechenKnopfCallback End"); WriteLn; END;
  END AbbrechenKnopfCallback;




PROCEDURE CreateFAnlegen();
  CONST
      FXPos=INT(300);
      FYPos=INT(300);
      FHoehe=INT(250);
      FBreite=INT(500);
  VAR FensterUeberschrift: String.TString;
      WinHdle: ADDRESS;
      ichSelbst: TPFSysVarAnz;
      meineAddr: ADDRESS;
  BEGIN
    IF TRACE THEN WriteString("FSysVarAnz.CreateFAnlegen Begin"); WriteLn; END;

    (* Fenstar ADO anlegen; ReaktProcedur- und ADO-Adresse auf den Stapel geben *)
    NEW (ichSelbst);
    meineAddr:= CAST(ADDRESS, ichSelbst);
    Push(ReaktFAnlegen, meineAddr);

    FensterUeberschrift := String.Create();
    String.Schreibe( FensterUeberschrift,"System - Variablen");
    ichSelbst^.WinHdle:=NeuesFenster(FensterUeberschrift,FXPos,FYPos,FHoehe,FBreite);
    String.Dispose(FensterUeberschrift);

    AktivFAnlegen();

    IF TRACE THEN WriteString("FSysVarAnz.CreateFAnlegen End"); WriteLn; END;
  END CreateFAnlegen;



PROCEDURE DisposeFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFSysVarAnz;
  BEGIN
    IF TRACE THEN WriteString("FSysVarAnz.DisposeFAnlegen Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSysVarAnz, meineAddr);

(*  LoeschenEingabeFelder();
    EntferneKnopf(ichSelbst^.AbbrechenKnopfHdle);  *)

    EntferneFenster(ichSelbst^.WinHdle);

    (* Fenster ADO loeschen; Stapelelement des aktuellen Fensters entfernen und
       ReaktProcedur des uebergeordneten Fensters aufrufen *)
    DISPOSE(ichSelbst);
    Pop();
    Top(reaktProc, meineAddr);
    reaktProc();
    IF TRACE THEN WriteString("FSysVarAnz.DisposeFAnlegen End"); WriteLn; END;
  END DisposeFAnlegen;



PROCEDURE DeaktFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFSysVarAnz;
  BEGIN
    IF TRACE THEN WriteString("FSysVarAnz.DeaktFAnlegen Begin"); WriteLn; END;
    (*Deaktiviere Knpfe *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSysVarAnz, meineAddr);
    SetzeKnopf(ichSelbst^.AbbrechenKnopfHdle, FALSE);
    IF TRACE THEN WriteString("FSysVarAnz.DeaktFAnlegen End"); WriteLn; END;
  END DeaktFAnlegen;



PROCEDURE ReaktFAnlegen();                                                           		
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFSysVarAnz;
  BEGIN
    IF TRACE THEN WriteString("FSysVarAnz.ReaktFAnlegen Begin"); WriteLn; END;
    (* Aktiviere alle Fensterinhalte *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSysVarAnz, meineAddr);
    SetzeKnopf(ichSelbst^.AbbrechenKnopfHdle, TRUE);
    IF TRACE THEN WriteString("FSysVarAnz.ReaktFAnlegen End"); WriteLn; END;
  END ReaktFAnlegen;



PROCEDURE InitEingabeFelder();               
  CONST
      XPos=INT(40);
      SysDatumYPos=INT(50);
      SysDatumLaen=INT(10);
      AutoDatumYPos=INT(75);
      AutoDatumLaen=INT(10);
      VersionYPos=INT(100);
      VersionLaen=INT(2);
  VAR
    Text, Inhalt: String.TString;
    SysDatumString, AutoDatumString, VersionString, ZWDatumString, GueltigabString,
		    GueltigbisString, MeldString, StundensatzString: String.TString;
    ZWDatumStr, GueltigabStr, GueltigbisStr, TextStr, MeldStr, StundensatzStr: ARRAY[1..200] OF CHAR;
    reaktProc: TProc;
    meineAddr: ADDRESS;
    ichSelbst: TPFSysVarAnz;
    DatenOkay: BOOLEAN;
    Stundensatz: CARDINAL;
    ZWDatum: Datum.TDatum;
    SysDatum, AutoDatum: Datum.TDatum;
    Version: SysDat.TVersion;
  BEGIN
    IF TRACE THEN WriteString("FSysVarAnz.InitEingabeFelder Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSysVarAnz, meineAddr);

    Text := String.Create();
    Inhalt := String.Create();
    MeldString := String.Create();
    ZWDatumString := String.Create();


    SysDatum:=SysDat.LiesSystemDatumInSysDat();
    SysDatumString:=Datum.DatumAlsString(SysDatum);

    AutoDatum:= SysDat.LiesLetztesAutoDatumInSysDat();
    AutoDatumString:=Datum.DatumAlsString(AutoDatum);

    Version := SysDat.LiesBackupVersionInSysDat();
    VersionString:=SysDat.VersionAlsString(Version);


    String.Schreibe(Text,"SystemDatum:  ");
    String.Anhaengen(SysDatumString, Text);
    ichSelbst^.SysDatumHdle:=StelleMeldungDar(Text, FALSE, ichSelbst^.WinHdle, XPos, SysDatumYPos);

    String.Schreibe(Text,"Letztes autom. Betriebsdatum:  ");
    String.Anhaengen(AutoDatumString, Text);
    ichSelbst^.AutoDatumHdle:=StelleMeldungDar(Text, FALSE, ichSelbst^.WinHdle, XPos, AutoDatumYPos);

    String.Schreibe(Text,"Version:  ");
    String.Anhaengen(VersionString, Text);
    ichSelbst^.VersionHdle:=StelleMeldungDar(Text, FALSE, ichSelbst^.WinHdle, XPos, VersionYPos);

    String.Dispose(SysDatumString);
    String.Dispose(AutoDatumString);
    String.Dispose(VersionString);


    String.Dispose(Text);
    String.Dispose(Inhalt);
    String.Dispose(MeldString);
    String.Dispose(ZWDatumString);
    IF TRACE THEN WriteString("FSysVarAnz.InitEingabeFelder End"); WriteLn; END;
  END InitEingabeFelder;



PROCEDURE LoeschenEingabeFelder();               
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFSysVarAnz;
  BEGIN
    IF TRACE THEN WriteString("FSysVarAnz.LoeschenEingabeFelder Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFSysVarAnz, meineAddr);
    EntferneZeile(ichSelbst^.SysDatumHdle);
    IF TRACE THEN WriteString("FSysVarAnz.LoeschenEingabeFelder End"); WriteLn; END;
  END LoeschenEingabeFelder;



PROCEDURE AusgebenMeldung(inStr:ARRAY OF CHAR);
   VAR 
    MeldText: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FSysVarAnz.AusgebenMeldung Begin"); WriteLn; END;
    MeldText := String.Create();
    String.Schreibe(MeldText, inStr);
    MeldungAnzeigen(MeldText); 
    String.Dispose(MeldText);
    IF TRACE THEN WriteString("FSysVarAnz.AusgebenMeldung End"); WriteLn; END;
  END AusgebenMeldung;



PROCEDURE StrToCardinal(inStr:ARRAY OF CHAR; VAR outCard:CARDINAL):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToCard(inStr,outCard,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToCardinal;


PROCEDURE StrToInteger(inStr:ARRAY OF CHAR; VAR outInt:INTEGER):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToInt(inStr,outInt,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToInteger;




CONST
  TRACE=FALSE;
VAR
BEGIN;
END FSysVarAnz.
