IMPLEMENTATION MODULE FAendernVtrHKB;

FROM SYSTEM   IMPORT CAST, ADR, ADDRESS;
FROM X_Grafik IMPORT StelleListeDar,EntferneListe;
FROM X_Grafik IMPORT LiesListenelement, AendereListenelement;
FROM X_Grafik IMPORT StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM X_Grafik IMPORT StelleTextDar, EntferneText;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT InitialisiereGrafik, StarteGrafik;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT MeldungAnzeigen,JaNeinAbfrage;
FROM X_Grafik IMPORT StringEingabeFenster, StringEingabeAuslesen;
FROM X_Grafik IMPORT StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT LiesMenueEintrag, EntferneMenue;
FROM args     IMPORT GetArgs, ArgTable;
FROM InOut    IMPORT WriteString,WriteLn,WriteInt;

IMPORT Strings;
IMPORT String;
IMPORT Stringliste;
IMPORT FLadenSysVw;
IMPORT Vtre;
IMPORT Datum;
IMPORT SysDat;
IMPORT WholeStr;
IMPORT DialogLib;
IMPORT FAendern2VtrHKB;

TYPE TActKind  =  PROCEDURE(ADDRESS,ADDRESS,ADDRESS);
     TActVater = PROCEDURE();
     TCharString = ARRAY[0..255] OF CHAR;

VAR
  FensterHandle		: ADDRESS;
  VaterFenster		: ADDRESS;
  Vater			: ADDRESS;
  EndeKnopfHandle	: ADDRESS;
  VtrIdMeldTitel	: ADDRESS;
  VtrIdMeld		: ADDRESS;
  PersIdMeldTitel       : ADDRESS;
  PersIdMeld		: ADDRESS;
  KstIdMeldTitel	: ADDRESS;
  KstIdMeld		: ADDRESS;
  TestKnopfHandle	: ADDRESS;
  AendernKnopfHandle	: ADDRESS;
  StdZahlTitel		: ADDRESS;
  StdZahlAnzeige  	: ADDRESS;
  TaetigkeitTitel	: ADDRESS;
  TaetigkeitAnzeige     : ADDRESS;
  BegrTitel		: ADDRESS;
  BegrAnzeige           : ADDRESS;
  GueltigBisZeile	: ADDRESS;
  GueltigVonTitel       : ADDRESS;
  GueltigVonAnzeige	: ADDRESS;
  GueltigBisAnzeige     : ADDRESS;
  ErstDatTitel		: ADDRESS;
  HkeListeHdle		: ADDRESS;
  Hinweis1 		: ADDRESS;
  VtrListHdle           : ADDRESS;
  (*Felder fr die Ausgabe des gesuchten Vertrages*)
  ErstDatAnzeige	: ADDRESS;
  VtrStrList		: Stringliste.TStringliste;
  globalVtrId_str  	: String.TString;
  globalPersId_str	: String.TString;
  globalKstId_str 	: String.TString;
  (*sGueltigBis_g       : String.TString; *)
  Vertrag		: Vtre.TVtr;

(*----------------------------------------------------------------------------------------*)

PROCEDURE StC(inStr : String.TString) : TCharString;
(*Umwandlung von TString nach Arrayof Char = TCharString*)
VAR outcharfeld : TCharString;
BEGIN
 String.Lies(inStr,outcharfeld);
 RETURN outcharfeld;
END StC;

(*----------------------------------------------------------------------------------------*)

PROCEDURE InitMaske();
(*Erzeugt die initiale Ein-Ausgabemaske *)
VAR Titel       : String.TString;

BEGIN
  Titel := String.Create();
  String.Schreibe(Titel,"Abbrechen");
  EndeKnopfHandle := StelleKnopfDar(Titel,FensterHandle,210,250,
                                    CAST(PROC,EndeKnopfCallback));
  String.Dispose(Titel);
END InitMaske;

(*----------------------------------------------------------------------------------------*)

PROCEDURE EndeKnopfCallback();
VAR Abfragetext : String.TString;
BEGIN
   DisposeEarly();
END EndeKnopfCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE ShowContentOfVtre();
VAR  StrListe : Stringliste.TStringliste;
     s : String.TString;

BEGIN
   s := String.Create();
   VtrStrList := Vtre.GibVtrAlsStringlisteInVtr();

   String.Schreibe(s," VID      PID      KID      Datum");

   VtrListHdle := StelleListeDar(VtrStrList,s,4,FensterHandle,120,70,
   				 CAST(PROC,VtreListeCallback));
   Stringliste.Dispose(VtrStrList);
   String.Dispose(s);
END ShowContentOfVtre;

(*----------------------------------------------------------------------------------------*)

PROCEDURE VtreListeCallback(element : INTEGER);
VAR Titel       : String.TString;
    Text        : String.TString;
    Abfragetext : String.TString;
    HilfString  : String.TString;
    HeuteString : String.TString;
    Heute   		: Datum.TDatum;

BEGIN
  Text := String.Create();

  LiesListenelement(VtrListHdle,element,Text);
  (*Die selektierten Daten aus der Darstellung zwischenspeichern *)
  ExtractVtrId (Text,globalVtrId_str,0,5);
  ExtractPersId(Text,globalPersId_str,6,5);
  ExtractKstId (Text,globalKstId_str,12,5);

  EntferneListe(VtrListHdle);

  Dispose();

END VtreListeCallback;


(*----------------------------------------------------------------------------*)

PROCEDURE Create(inFunct : ADDRESS);
VAR Titel,s : String.TString;
    Vertrag : Vtre.TVtr;
BEGIN
  Vater := inFunct;
  globalVtrId_str  := String.Create();
  globalPersId_str := String.Create();
  globalKstId_str  := String.Create();

  IF NOT Vtre.FirstVtrUndStorno(Vertrag) THEN
     s := String.Create();
     String.Schreibe(s," Keine Daten im Vertragsordner !! ");
     MeldungAnzeigen(s);
     String.Dispose(s);
     DisposeEarly();
  ELSE
    Vtre.DisposeVtr(Vertrag);
    Titel := String.Create();
    String.Schreibe(Titel,"V e r t r a g   S t o r n i e r e n  |  A e n d e r n ");
    FensterHandle :=  NeuesFenster( Titel,90,250,300,500);
    String.Dispose(Titel);
    InitMaske();
    ShowContentOfVtre();
  END;
END Create;

(*------------------------------------------------------------------------------*)

PROCEDURE Dispose();
BEGIN
  EntferneFenster(FensterHandle);
  FAendern2VtrHKB.Create(CAST(ADDRESS,globalVtrId_str),
			 CAST(ADDRESS,globalPersId_str),
                         CAST(ADDRESS,globalKstId_str),
                         Vater);
END Dispose;
(*------------------------------------------------------------------------------*)

PROCEDURE DisposeEarly();
VAR AktiviereVater : TActVater;
BEGIN
  EntferneFenster(FensterHandle);
  AktiviereVater := CAST(TActVater,Vater);
  AktiviereVater();
END DisposeEarly;
(*------------------------------------------------------------------------------*)

PROCEDURE ExtractVtrId(inQuelle : String.TString; VAR inoutZiel : String.TString;
   								     inStartPos,inAnzahl : CARDINAL);
(* Auslesen von anzahl Zeichen ab start von inQuelle, dannRckgabe via outZiel*)
VAR selString : String.TString;
BEGIN
  selString := String.Create();
  String.Auslesen (inQuelle,inStartPos,inAnzahl,selString);
  WriteString(StC(selString));WriteLn();
  String.Equalize(inoutZiel,selString);
  WriteString(StC(inoutZiel));WriteLn();
  String.Dispose(selString);
END ExtractVtrId;

(*---------------------------------------------------------------------------------*)

PROCEDURE ExtractPersId(inQuelle : String.TString; VAR inoutZiel : String.TString;
   								      inStartPos,inAnzahl : CARDINAL);
(* Auslesen von anzahl Zeichen ab start von inQuelle, dannRckgabe via outZiel*)
VAR selString : String.TString;
BEGIN
  selString := String.Create();
  String.Auslesen (inQuelle,inStartPos,inAnzahl,selString);
  String.Equalize(inoutZiel,selString);
  String.Dispose(selString);
END ExtractPersId;
(*----------------------------------------------------------------------------------*)


PROCEDURE ExtractKstId(inQuelle : String.TString; VAR inoutZiel : String.TString;
   								     inStartPos,inAnzahl : CARDINAL);
(* Auslesen von anzahl Zeichen ab start von inQuelle, dannRckgabe via inoutZiel*)
VAR selString : String.TString;
BEGIN
  selString := String.Create();
  String.Auslesen (inQuelle,inStartPos,inAnzahl,selString);
  String.Equalize(inoutZiel,selString);
  String.Dispose(selString);
END ExtractKstId;
(*----------------------------------------------------------------------------------*)

END FAendernVtrHKB.
