(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile$
# $Author$
# $Date$
# $Revision$
# Bemerkungen:

IMPLEMENTATION MODULE FVtrHKB;

Johannes Magauer

*)
(******************************************************************************)

IMPLEMENTATION MODULE FVtrHKB;

FROM SysReaktFStapel IMPORT Push, Pop, Top, TProc;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT StelleZeileDar, SetzeZeile, LiesZeile, EntferneZeile;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT MeldungAnzeigen;

FROM SYSTEM IMPORT CAST, ADR, ADDRESS, TSIZE;
FROM Storage IMPORT ALLOCATE, DEALLOCATE;
FROM WholeStr IMPORT CardToStr;
FROM InOut IMPORT WriteCard, WriteString, WriteLn;

FROM Datum IMPORT TDatum, DatumVonString, DatumAlsString;
FROM HKB IMPORT BearbeitenNeuVtr;
FROM SysDat IMPORT LiesSystemDatumInSysDat;

IMPORT String;
IMPORT Stringliste;
IMPORT HKe;
IMPORT Ksten;
IMPORT Vtre;
IMPORT FPruefmodulHK;


  TYPE 	TFVtrDS = RECORD
		           WinHdle,
		           OkKnopf,
		           AbbrechenKnopf,
		           HKListe,
		           KstListe,
		           HKIDZ,
		           KSIDZ,
		           StdZ,
		           TaetZ,
		           BegrZ,
		           VonZ,
		           BisZ,
		           DatZ : ADDRESS;
		           SHKID,
		           SKstID: String.TString; 		
		         END;	
       	TPFVtr = POINTER TO TFVtrDS;

  CONST CFLINKS = 80;
  	CFOBEN = 140;
  	CFHOEHE = 400;
  	CFBREITE = 800;
  	CKNOPFOKX = 310;
  	CKNOPFOKY = 300;
  	CKNOPFABBRECHENX = 550;
  	CKNOPFABBRECHENY = 300;
  	CPERSIDL = 5;
  	CPERSIDX = 60;
  	CPERSIDY = 60;
  	CKSTIDL = 5;
  	CKSTIDX = 60;
  	CKSTIDY = 90;
  	CLINKS = 60;
  	CSTD = 4;
  	CTAET = 40;
  	CBEGR = 50;
  	CVON = 10;
  	CBIS = 10;
  	CDAT = 10;
  	CSTDY = 120;
  	CTAETY = 150;
  	CBEGRY = 180;
  	CVONY = 210;
  	CBISY = 240;
  	CDATY = 270;

(*************************************************************************************************)
(********************************** PROZEDURE KnoepfeVtr() ********************************)
(*************************************************************************************************)

PROCEDURE KnoepfeVtr();
  VAR
    hilfsText: String.TString;
    OkHandle, AbbrechenHandle, meineAddr: ADDRESS;
    reaktProc: TProc;
    ichSelbst: TPFVtr;

  BEGIN
    (* Initialisierungen *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFVtr, meineAddr);
    hilfsText := String.Create();
(*************************************************************************************************)
    String.Schreibe(hilfsText,"Vertrag speichern");
    OkHandle := StelleKnopfDar(hilfsText,ichSelbst^.WinHdle,CKNOPFOKX,CKNOPFOKY,
    				    CAST(PROC,AnlegenKnopfCallback));

    String.Schreibe(hilfsText,"Abbrechen");
    AbbrechenHandle := StelleKnopfDar(hilfsText,ichSelbst^.WinHdle,CKNOPFABBRECHENX,
    				      CKNOPFABBRECHENY,CAST(PROC,AbbrechenKnopfCallback));
(*************************************************************************************************)
    String.Dispose(hilfsText);
    WITH ichSelbst^ DO
      OkKnopf:= OkHandle;
      AbbrechenKnopf:= AbbrechenHandle;
    END (*WITH*)
  END KnoepfeVtr;

(*************************************************************************************************)
(******************************* PROCEDURE AbbrechenKnopfCallback() ******************************)
(*************************************************************************************************)

PROCEDURE AbbrechenKnopfCallback();
  BEGIN
    DisposeFVtr();
  END AbbrechenKnopfCallback;

(*************************************************************************************************)
(******************************* PROCEDURE AnlegenKnopfCallback() ********************************)
(*************************************************************************************************)

PROCEDURE AnlegenKnopfCallback();
  VAR
    SStd, STaet, SBegr, SVon, SBis, SDat, SLeer, SText, EMeldung, EMeldung1: String.TString;
    error : BOOLEAN;
    PersID: HKe.TPersID;
    KstID: Ksten.TKstID;
    vtr : Vtre.TVtr;
    von, bis, dat: TDatum;
    stunden : CARDINAL;
    meineAddr: ADDRESS;
    reaktProc: TProc;
    ichSelbst: TPFVtr;

  BEGIN		
    (* Initialisierungen *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFVtr, meineAddr);
    vtr := Vtre.CreateVtr();
    error := FALSE;

    SStd:= String.Create();
    STaet:= String.Create();
    SBegr:= String.Create();
    SVon:= String.Create();
    SBis:= String.Create();
    SDat:= String.Create();
    SLeer:= String.Create();
    SText := String.Create();		(* fr Feldbezeichner *)	
    EMeldung:= String.Create(); 	(* fr Fehlermeldungen beim Attributanlegen in einer HK *)
    EMeldung1:= String.Create();

    String.Schreibe(SLeer,"");  (* fr Feldabfrage *)

    LiesZeile(ichSelbst^.StdZ, SStd);
    LiesZeile(ichSelbst^.TaetZ, STaet);
    LiesZeile(ichSelbst^.BegrZ, SBegr);
    LiesZeile(ichSelbst^.VonZ, SVon);
    LiesZeile(ichSelbst^.BisZ, SBis);
    LiesZeile(ichSelbst^.DatZ, SDat);

    (* Fehlerberprfungen durchfhren *)
    (* Wurde die Eingabelnge berschritten *)
    IF NOT error THEN
        error := PruefeLaengeEingabefelder(ichSelbst);
    END; (* IF *)

    (* eingegebene Stundenzahl prfen, umwandeln und Attribut in Vtr setzen *)
    IF NOT error THEN
        IF FPruefmodulHK.PruefeCardPos(SStd, stunden, EMeldung) THEN
            WriteString("SetzeStdzahlinVtr");
	    WriteLn;
            error:= NOT Vtre.SetzeStdzahlinVtr(vtr,stunden);	
	ELSE
	    String.Schreibe(EMeldung1, "Fehler in Feld 'Stundenzahl:' ");
            String.Anhaengen(EMeldung, EMeldung1);
            MeldungAnzeigen(EMeldung1);
            error := TRUE;
       END; (* IF *)	     	
    END;  (* IF *)

    IF NOT error THEN
        IF DatumVonString(SVon, von, EMeldung) THEN
             WriteString("SetzeErstellDatinVtr");
             WriteLn;
            error:= NOT Vtre.SetzeErstellDatinVtr(vtr,von);
        ELSE
            String.Schreibe(EMeldung1, "Fehler in Feld 'Gueltig Von:' ");
            String.Anhaengen(EMeldung, EMeldung1);
            MeldungAnzeigen(EMeldung1);
            error := TRUE;
        END; (* IF *)
    END;  (* IF *)

    IF NOT error THEN
        IF DatumVonString(SBis, bis, EMeldung) THEN
             WriteString("SetzeGueltigBisinVtr");
             WriteLn;
            Vtre.SetzeGueltigBisinVtr(vtr,bis);
        ELSE
            String.Schreibe(EMeldung1, "Fehler in Feld 'Gueltig Bis:' ");
            String.Anhaengen(EMeldung, EMeldung1);
            MeldungAnzeigen(EMeldung1);
            error := TRUE;
        END; (* IF *)
    END;  (* IF *)

    IF NOT error THEN
        IF DatumVonString(SDat, dat, EMeldung) THEN
             WriteString("SetzeErstellDatinVtr");
             WriteLn;
            error:= NOT Vtre.SetzeErstellDatinVtr(vtr,dat);
        ELSE
            String.Schreibe(EMeldung1, "Fehler in Feld 'Erstellungsdatum:' ");
            String.Anhaengen(EMeldung, EMeldung1);
            MeldungAnzeigen(EMeldung1);
            error := TRUE;
        END; (* IF *)
    END;  (* IF *)

    (* sind die Mussfelder ausgefllt *)
    IF NOT error THEN
        error := Mussfelder(ichSelbst);
    END; (* IF *)

    (* geprfte Felder in Hilfskraft initialisieren *)
    IF NOT error THEN    	
        IF NOT String.IsEqual(STaet, SLeer) THEN
            error := NOT Vtre.SetzeTaetigktinVtr(vtr,STaet);
             WriteString("SetzeTaetigktinVtr");
             WriteLn;
    	END; (* IF *)
    	
    	IF NOT String.IsEqual(SBegr, SLeer) THEN
            error := NOT Vtre.SetzeBegruendinVtr(vtr,SBegr);
             WriteString("SetzeBegruendinVtr");
             WriteLn;
     	END; (* IF *)
     	
     	PersID:= HKe.StringInPersID(ichSelbst^.SHKID);
     	Vtre.SetzePersIDinVtr(vtr, PersID);
     	
     	KstID:= Ksten.StringInKstID(ichSelbst^.SKstID);
     	Vtre.SetzeKstIDinVtr(vtr, KstID);

	IF NOT BearbeitenNeuVtr(vtr, EMeldung) THEN
            MeldungAnzeigen(EMeldung);
            error:= TRUE;
        ELSE
            WriteString("BearbeitenNeuVtr");
            WriteLn;
        END; (* IF *)
    END; (* IF *)


    (* nicht mehr bentigten Speicher vor dem Schlieen des Fensters freigeben *)
    String.Dispose(SStd);
    String.Dispose(STaet);
    String.Dispose(SBegr);
    String.Dispose(SVon);
    String.Dispose(SBis);
    String.Dispose(SDat);
    String.Dispose(SLeer);
    String.Dispose(SText);
    String.Dispose(EMeldung);
    String.Dispose(EMeldung1);


    Vtre.DisposeVtr(vtr);
     WriteString("DisposeVtr");
     WriteLn;
    IF NOT error THEN
      DisposeFVtr();
    END; (* IF *)
  END AnlegenKnopfCallback;

(*************************************************************************************************)

PROCEDURE Mussfelder(inIchSelbst: TPFVtr): BOOLEAN;
(* berprft ob die Mussfelder ausgefllt wurden *)
  VAR
    EMussfeld, EMussfeld1,	(* Fehlermeldung *)
    SStd, SVon, SBis, SDat : String.TString;
    error: BOOLEAN;

  BEGIN		
    (* Initialisierungen *)
    EMussfeld:= String.Create();
    EMussfeld1:= String.Create();
    String.Schreibe(EMussfeld,"Bitte fllen Sie mindestens die Eingabefelder 'Stunden', 'Gueltig Von',");
    String.Schreibe(EMussfeld1," 'Gueltig Bis' und 'Erstellungsdatum' aus!");
    String.Anhaengen(EMussfeld1, EMussfeld);

    SStd:= String.Create();
    SVon:= String.Create();
    SBis:= String.Create();
    SDat:= String.Create();

    LiesZeile(inIchSelbst^.StdZ, SStd);
    LiesZeile(inIchSelbst^.VonZ, SVon);
    LiesZeile(inIchSelbst^.BisZ, SBis);
    LiesZeile(inIchSelbst^.DatZ, SDat);
    error := FALSE;

    (* berprfungsroutine *)
    IF (String.Laenge(SStd) = 0) OR (String.Laenge(SVon) = 0)
			         OR (String.Laenge(SBis) = 0) OR (String.Laenge(SDat) = 0) THEN
        MeldungAnzeigen(EMussfeld);	
        error := TRUE;
    END; (* IF *)

    String.Dispose(EMussfeld);
    String.Dispose(EMussfeld1);
    String.Dispose(SStd);
    String.Dispose(SVon);
    String.Dispose(SBis);
    String.Dispose(SDat);
    RETURN error;
  END Mussfelder;

(*************************************************************************************************)

PROCEDURE PruefeLaengeEingabefelder(inIchSelbst: TPFVtr): BOOLEAN;
(* berprft die Lnge der Eingaben *)
  VAR
    EMeldung, EMeldung1, EMeldung2, EFeld, EZahl,	(* Fehlermeldungen *)
    SStd, STaet, SBegr, SVon, SBis, SDat: String.TString;
    str: ARRAY [0..1] OF CHAR;
    error: BOOLEAN;

  BEGIN		
    (* Initialisierungen *)
    EMeldung:= String.Create();
    EMeldung1:= String.Create();
    EMeldung2:= String.Create();
    EFeld:= String.Create();
    EZahl:= String.Create();

    SStd:= String.Create();
    STaet:= String.Create();
    SBegr:= String.Create();
    SVon:= String.Create();
    SBis:= String.Create();
    SDat:= String.Create();

    String.Schreibe(EMeldung,"In das Eingabefeld '");
    String.Schreibe(EMeldung1,"' drfen Sie hchstens ");
    String.Schreibe(EMeldung2," Zeichen eingeben!");

    LiesZeile(inIchSelbst^.StdZ, SStd);
    LiesZeile(inIchSelbst^.TaetZ, STaet);
    LiesZeile(inIchSelbst^.BegrZ, SBegr);
    LiesZeile(inIchSelbst^.VonZ, SVon);
    LiesZeile(inIchSelbst^.BisZ, SBis);
    LiesZeile(inIchSelbst^.DatZ, SDat);
    error := FALSE;


    IF (NOT error) AND (String.Laenge(SStd) > CSTD) THEN
        String.Schreibe(EFeld,"Stundenzahl");
        CardToStr(CSTD, str);
        error := TRUE;
    END; (* IF *)

    IF (NOT error) AND (String.Laenge(STaet) > CTAET) THEN
        String.Schreibe(EFeld,"Ttigkeit");
        CardToStr(CTAET, str);
        error := TRUE;
    END; (* IF *)

    IF (NOT error) AND (String.Laenge(SBegr) > CBEGR) THEN
        String.Schreibe(EFeld,"Begrndung");
        CardToStr(CBEGR, str);
        error := TRUE;
    END; (* IF *)

    IF (NOT error) AND (String.Laenge(SVon) > CVON) THEN
        String.Schreibe(EFeld,"Gltig Von");
        CardToStr(CVON, str);
        error := TRUE;
    END; (* IF *)

    (* berprfungsroutine Eingabefeld Vorname *)
    IF (NOT error) AND (String.Laenge(SBis) > CBIS) THEN
        String.Schreibe(EFeld,"Gltig Bis");
        CardToStr(CBIS, str);
        error := TRUE;
    END; (* IF *)

    (* berprfungsroutine Eingabefeld Strasse *)
    IF (NOT error) AND (String.Laenge(SDat) > CDAT) THEN
        String.Schreibe(EFeld,"Erstellungsdatum");
        CardToStr(CDAT, str);
        error := TRUE;
    END; (* IF *)

    (* Fehlermeldung ausgeben *)
    IF error THEN
        String.Schreibe(EZahl, str);
        String.Anhaengen(EFeld, EMeldung);
        String.Anhaengen(EMeldung1, EMeldung);
        String.Anhaengen(EZahl, EMeldung);
        String.Anhaengen(EMeldung2, EMeldung);
        MeldungAnzeigen(EMeldung);
    END; (* IF *)

    String.Dispose(EMeldung);
    String.Dispose(EMeldung1);
    String.Dispose(EMeldung2);
    String.Dispose(EFeld);
    String.Dispose(EZahl);

    String.Dispose(SStd);
    String.Dispose(STaet);
    String.Dispose(SBegr);
    String.Dispose(SVon);
    String.Dispose(SBis);
    String.Dispose(SDat);
    RETURN error;
  END PruefeLaengeEingabefelder;

(*************************************************************************************************)
(*********************************** PROCEDURE ZeilenAnlegen() ***********************************)
(*************************************************************************************************)

PROCEDURE ZeilenVtr();
  VAR
    hilfsText, leerText, SDatum : String.TString;
    StdHandle, TaetHandle, BegrHandle, VonHandle, BisHandle, DatHandle, meineAddr: ADDRESS;
    heute : TDatum;
    reaktProc: TProc;
    ichSelbst: TPFVtr;
    yWert: INTEGER;

  BEGIN (* Erzeuge den Fensterinhalt *)
    (* Initialisierungen *)
    leerText := String.Create();
    hilfsText := String.Create();
    SDatum := String.Create();
    String.Schreibe(leerText,"");
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFVtr, meineAddr);

    String.Schreibe(hilfsText,"Stundenzahl:");
    StdHandle := StelleZeileDar(hilfsText,leerText,CSTD,ichSelbst^.WinHdle,CLINKS,CSTDY);

    String.Schreibe(hilfsText,"Taetigkeit:");
    TaetHandle := StelleZeileDar(hilfsText,leerText, CTAET,ichSelbst^.WinHdle,
    				       CLINKS,CTAETY);

    String.Schreibe(hilfsText,"Begruendung:");
    BegrHandle := StelleZeileDar(hilfsText,leerText,CBEGR,ichSelbst^.WinHdle,CLINKS,CBEGRY);

    String.Schreibe(hilfsText,"Gueltig Von:");
    VonHandle := StelleZeileDar(hilfsText,leerText,CVON,ichSelbst^.WinHdle,CLINKS,CVONY);

    String.Schreibe(hilfsText,"Gueltig Bis:");
    BisHandle := StelleZeileDar(hilfsText,leerText,CBIS, ichSelbst^.WinHdle,CLINKS,CBISY);

    heute := LiesSystemDatumInSysDat();
    SDatum := DatumAlsString(heute);
    String.Schreibe(hilfsText,"Erstellungsdatum:");
    DatHandle := StelleZeileDar(hilfsText,SDatum,CDAT, ichSelbst^.WinHdle,CLINKS,CDATY);

    String.Dispose(hilfsText);
    String.Dispose(leerText);
    String.Dispose(SDatum);
    WITH ichSelbst^ DO
      StdZ:= StdHandle;
      TaetZ:= TaetHandle;
      BegrZ:= BegrHandle;
      VonZ:= VonHandle;
      BisZ:= BisHandle;
      DatZ:= DatHandle;
    END; (* WITH *)
END ZeilenVtr;

(*************************************************************************************************)
(************************************* PROCEDURE CreateFVtr() ************************************)
(*************************************************************************************************)

PROCEDURE CreateFVtr(inSHKID : String.TString; inSKstID : String.TString);
  VAR FensterUeberschrift, Titel, SIDHK, SIDKst: String.TString;
      WinHdle: ADDRESS;
      ichSelbst: TPFVtr;
      meineAddr: ADDRESS;
  BEGIN
    (* SHKID:= String.Create();
    SKstID:= String.Create(); *)
    FensterUeberschrift := String.Create();
    Titel := String.Create();

    SIDHK := String.Duplicate(inSHKID);
    SIDKst := String.Duplicate(inSKstID);

    NEW (ichSelbst);
    String.Schreibe( FensterUeberschrift,"V e r t r a g   E r z e u g e n  &  B u c h e n");
    WinHdle:=NeuesFenster(FensterUeberschrift,CFOBEN,CFLINKS,CFHOEHE,CFBREITE);
    meineAddr:= CAST(ADDRESS, ichSelbst);
    Push(ReaktFVtr, meineAddr);

    ichSelbst^.WinHdle:=WinHdle;
    ichSelbst^.SHKID := SIDHK;
    ichSelbst^.SKstID := SIDKst;

    String.Schreibe(Titel,"PersonalID");
    ichSelbst^.HKIDZ:=StelleZeileDar(Titel,SIDHK,CPERSIDL,ichSelbst^.WinHdle,CPERSIDX,CPERSIDY);
    String.Schreibe(Titel,"KostenstellenID");
    ichSelbst^.KSIDZ:=StelleZeileDar(Titel,SIDKst,CKSTIDL,ichSelbst^.WinHdle,CKSTIDX,CKSTIDY);

    String.Dispose(FensterUeberschrift);
    String.Dispose(Titel);
    String.Dispose(SIDHK);
    String.Dispose(SIDKst);

    ZeilenVtr();
    KnoepfeVtr();
  END CreateFVtr;

(*************************************************************************************************)
(************************************* PROCEDURE DisposeFVtr() ***********************************)
(*************************************************************************************************)

PROCEDURE DisposeFVtr();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFVtr;
  BEGIN
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFVtr, meineAddr);

    EntferneFenster(ichSelbst^.WinHdle);
    Pop();
    DISPOSE(ichSelbst);
    Top(reaktProc, meineAddr);
    reaktProc();
  END DisposeFVtr;

(*************************************************************************************************)
(************************************ PROCEDURE DeaktFVtr() **********************************)
(*************************************************************************************************)

PROCEDURE DeaktFVtr();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFVtr;
  BEGIN
    (*Deaktiviere Knpfe, Listboxen,... *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFVtr, meineAddr);
  END DeaktFVtr;

(*************************************************************************************************)
(************************************ PROCEDURE ReaktFVtr() **********************************)
(*************************************************************************************************)

PROCEDURE ReaktFVtr();                                                           		
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFVtr;
  BEGIN
   (* Aktiviere alle Fensterinhalte *)
   Top(reaktProc, meineAddr);
   ichSelbst:= CAST(TPFVtr, meineAddr);

  END ReaktFVtr;

END FVtrHKB.


