(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: FAnlegenHK.mod,v $
# $Author: Sopra $
# $Date: 2001/03/10 09:48:15 $
# $Revision: 1.1.1.1 $
# Bemerkungen:

IMPLEMENTATION MODULE FAnlegenHK; 

Johannes Magauer

*)
(******************************************************************************)

IMPLEMENTATION MODULE FAnlegenHK;

FROM SysReaktFStapel IMPORT Push, Pop, Top, TProc;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT StelleZeileDar, SetzeZeile, LiesZeile, EntferneZeile;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT MeldungAnzeigen;

FROM SYSTEM IMPORT CAST, ADR, ADDRESS, TSIZE;
FROM Storage IMPORT ALLOCATE, DEALLOCATE;
FROM WholeStr IMPORT CardToStr, ConvResults, StrToCard;
FROM InOut IMPORT WriteCard, WriteString, WriteLn;

IMPORT String;
IMPORT Stringliste;



  TYPE 	TFAnlegenDS = RECORD
		        WinHdle,
			PersNrZ,
			LoeschenKnopf,
			AbbrechenKnopf : ADDRESS		
		      END;	
       	TPFAnlegen = POINTER TO TFAnlegenDS;

  CONST CFLINKS = 50;
  	CFOBEN = 50;
  	CFHOEHE = 200;
  	CFBREITE = 400;
  	COBEN = 20;
  	CLINKS = 50;
	CZEILE = 20;  	
        CNR = 5;

(************************************************************************************************************************)
(*********************************************** PROZEDURE AktivFAnlegen() **********************************************)
(************************************************************************************************************************)


PROCEDURE AktivFAnlegen();
  VAR
    hilfsText,
    leerText : String.TString;
    PersNrHandle, AbbrechenHandle, LoeschenHandle, meineAddr: ADDRESS;
    reaktProc: TProc;
    ichSelbst: TPFAnlegen;
    yWert: INTEGER;

  BEGIN (* Erzeuge den Fensterinhalt *)
    (* Initialisierungen *)
    yWert := COBEN;
    leerText := String.Create();
    String.Schreibe(leerText,"");
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFAnlegen, meineAddr);
(************************************************************************************************************************)
(****************************************************** neue Zeile ******************************************************)
(************************************************************************************************************************)
    hilfsText := String.Create();
    String.Schreibe(hilfsText,"Personalnummer: ");
    PersNrHandle := StelleZeileDar(hilfsText,leerText,CNR,ichSelbst^.WinHdle,CLINKS,yWert);
    SetzeZeile(PersNrHandle,TRUE);
    String.Dispose(hilfsText);
(************************************************************************************************************************)
(****************************************************** neue Zeile ******************************************************)
(************************************************************************************************************************)
    yWert := yWert + 2*CZEILE;
    hilfsText := String.Create();
    String.Schreibe(hilfsText,"Eingabe lschen");
    LoeschenHandle := StelleKnopfDar(hilfsText,ichSelbst^.WinHdle,50,yWert,CAST(PROC,LoeschenKnopfCallback));
    SetzeKnopf(LoeschenHandle, TRUE);
    String.Dispose(hilfsText);

    hilfsText := String.Create();
    String.Schreibe(hilfsText,"Abbrechen");
    AbbrechenHandle := StelleKnopfDar(hilfsText,ichSelbst^.WinHdle,250,yWert,CAST(PROC,AbbrechenKnopfCallback));
    SetzeKnopf(AbbrechenHandle, TRUE);
    String.Dispose(hilfsText);

    String.Dispose(leerText);
(************************************************************************************************************************)
(*************************************************** Initialisierung ****************************************************)
(************************************************************************************************************************)
    WITH ichSelbst^ DO
      PersNrZ:= PersNrHandle;
      AbbrechenKnopf:= AbbrechenHandle;
    END (*WITH*)
  END AktivFAnlegen;

(************************************************************************************************************************)
(******************************************* PROCEDURE LoeschenKnopfCallback() ******************************************)
(************************************************************************************************************************)

PROCEDURE LoeschenKnopfCallback();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFAnlegen;
  BEGIN
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFAnlegen, meineAddr);
    EntferneZeile(ichSelbst^.PersNrZ);
    EntferneKnopf(ichSelbst^.LoeschenKnopf);
    EntferneKnopf(ichSelbst^.AbbrechenKnopf);
    AktivFAnlegen();
  END LoeschenKnopfCallback;

(************************************************************************************************************************)
(****************************************** PROCEDURE AbbrechenKnopfCallback() ******************************************)
(************************************************************************************************************************)

PROCEDURE AbbrechenKnopfCallback();
  BEGIN
    (* erzeugte ADT's die nicht mehr gebraucht werden lschen *)
    DisposeFAnlegen();
  END AbbrechenKnopfCallback;

(************************************************************************************************************************)
(********************************************** PROCEDURE CreateFAnlegen() **********************************************)
(************************************************************************************************************************)

PROCEDURE CreateFAnlegen();
  VAR FensterUeberschrift: String.TString;
      WinHdle: ADDRESS;
      ichSelbst: TPFAnlegen;
      meineAddr: ADDRESS;
  BEGIN
    FensterUeberschrift := String.Create();
    String.Schreibe( FensterUeberschrift,"Anlegen einer Hilfskraft");
    WinHdle:=NeuesFenster(FensterUeberschrift,CFOBEN,CFLINKS,CFHOEHE,CFBREITE);
    ALLOCATE (ichSelbst, TSIZE(TFAnlegenDS));
    ichSelbst^.WinHdle:=WinHdle;
    meineAddr:= CAST(ADDRESS, ichSelbst);
    Push(ReaktFAnlegen, meineAddr);
    AktivFAnlegen();
  END CreateFAnlegen;

(************************************************************************************************************************)
(********************************************** PROCEDURE DisposeFAnlegen() *********************************************)
(************************************************************************************************************************)

PROCEDURE DisposeFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFAnlegen;
  BEGIN
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFAnlegen, meineAddr);
    EntferneZeile(ichSelbst^.PersNrZ);
    EntferneKnopf(ichSelbst^.AbbrechenKnopf);
    EntferneFenster(ichSelbst^.WinHdle);
    Pop();
    Top(reaktProc, meineAddr);
    reaktProc();
  END DisposeFAnlegen;

(************************************************************************************************************************)
(*********************************************** PROCEDURE DeaktFAnlegen() **********************************************)
(************************************************************************************************************************)

PROCEDURE DeaktFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFAnlegen;
  BEGIN
    (*Deaktiviere Knpfe, Listboxen,... *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFAnlegen, meineAddr);
    SetzeKnopf(ichSelbst^.AbbrechenKnopf, FALSE);
  END DeaktFAnlegen;

(************************************************************************************************************************)
(*********************************************** PROCEDURE ReaktFAnlegen() **********************************************)
(************************************************************************************************************************)

PROCEDURE ReaktFAnlegen();                                                           		
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFAnlegen;
  BEGIN
   (* Aktiviere alle Fensterinhalte *)
   Top(reaktProc, meineAddr);
   ichSelbst:= CAST(TPFAnlegen, meineAddr);
   SetzeKnopf(ichSelbst^.AbbrechenKnopf, TRUE);
  END ReaktFAnlegen;

END FAnlegenHK.


