(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile$
# $Author$
# $Date$
# $Revision$
# Bemerkungen:

IMPLEMENTATION MODULE FAnlegenHK; 

Johannes Magauer

*)
(******************************************************************************)

IMPLEMENTATION MODULE FAnlegenHK;

FROM SysReaktFStapel IMPORT Push, Pop, Top, TProc;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT StelleZeileDar, SetzeZeile, LiesZeile, EntferneZeile;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT MeldungAnzeigen;

FROM SYSTEM IMPORT CAST, ADR, ADDRESS, TSIZE;
FROM Storage IMPORT ALLOCATE, DEALLOCATE;
FROM WholeStr IMPORT CardToStr, ConvResults, StrToCard;
FROM InOut IMPORT WriteCard, WriteString, WriteLn;

IMPORT String;
IMPORT Stringliste;



  TYPE 	TFAnlegenDS = RECORD
		        WinHdle,
			PersNrZ,
			LoeschenKnopf,
			AbbrechenKnopf : ADDRESS		
		      END;	
       	TPFAnlegen = POINTER TO TFAnlegenDS;

  CONST CFLINKS = 50;
  	CFOBEN = 50;
  	CFHOEHE = 200;
  	CFBREITE = 400;
  	CLINKS = 50;
	CZEILE = 20;  	
	CKNOEPFE = 80;
        CNR = 5;

(************************************************************************************************************************)
(*********************************************** PROZEDURE KnoepfeAnlegen() *********************************************)
(************************************************************************************************************************)


PROCEDURE KnoepfeAnlegen();
  VAR
    hilfsText: String.TString;
    AbbrechenHandle, LoeschenHandle, meineAddr: ADDRESS;
    reaktProc: TProc;
    ichSelbst: TPFAnlegen;

  BEGIN
    (* Initialisierungen *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFAnlegen, meineAddr);

    hilfsText := String.Create();
    String.Schreibe(hilfsText,"Eingabe lschen");
    LoeschenHandle := StelleKnopfDar(hilfsText,ichSelbst^.WinHdle,50,CKNOEPFE,CAST(PROC,LoeschenKnopfCallback));
    SetzeKnopf(LoeschenHandle, TRUE);
    String.Dispose(hilfsText);

    hilfsText := String.Create();
    String.Schreibe(hilfsText,"Abbrechen");
    AbbrechenHandle := StelleKnopfDar(hilfsText,ichSelbst^.WinHdle,250,CKNOEPFE,CAST(PROC,AbbrechenKnopfCallback));
    SetzeKnopf(AbbrechenHandle, TRUE);
    String.Dispose(hilfsText);

    WITH ichSelbst^ DO
      AbbrechenKnopf:= AbbrechenHandle;
      LoeschenKnopf:= LoeschenHandle;
    END (*WITH*)
  END KnoepfeAnlegen;

(************************************************************************************************************************)
(*********************************************** PROCEDURE ZeilenAnlegen() **********************************************)
(************************************************************************************************************************)

PROCEDURE ZeilenAnlegen();
  VAR
    hilfsText,
    leerText : String.TString;
    PersNrHandle, meineAddr: ADDRESS;
    reaktProc: TProc;
    ichSelbst: TPFAnlegen;

  BEGIN (* Erzeuge den Fensterinhalt *)
    (* Initialisierungen *)
    leerText := String.Create();
    String.Schreibe(leerText,"");
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFAnlegen, meineAddr);

    hilfsText := String.Create();
    String.Schreibe(hilfsText,"Personalnummer: ");
    PersNrHandle := StelleZeileDar(hilfsText,leerText,CNR,ichSelbst^.WinHdle,CLINKS,CZEILE);
    SetzeZeile(PersNrHandle,TRUE);
    String.Dispose(hilfsText);
    String.Dispose(leerText);

    WITH ichSelbst^ DO
      PersNrZ:= PersNrHandle;
    END (*WITH*)
  END ZeilenAnlegen;

(************************************************************************************************************************)
(******************************************* PROCEDURE LoeschenKnopfCallback() ******************************************)
(************************************************************************************************************************)

PROCEDURE LoeschenKnopfCallback();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFAnlegen;
  BEGIN
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFAnlegen, meineAddr);
    EntferneZeile(ichSelbst^.PersNrZ);
    ZeilenAnlegen();
  END LoeschenKnopfCallback;

(************************************************************************************************************************)
(****************************************** PROCEDURE AbbrechenKnopfCallback() ******************************************)
(************************************************************************************************************************)

PROCEDURE AbbrechenKnopfCallback();
  BEGIN
    (* erzeugte ADT's die nicht mehr gebraucht werden lschen *)
    DisposeFAnlegen();
  END AbbrechenKnopfCallback;

(************************************************************************************************************************)
(********************************************** PROCEDURE CreateFAnlegen() **********************************************)
(************************************************************************************************************************)

PROCEDURE CreateFAnlegen();
  VAR FensterUeberschrift: String.TString;
      WinHdle: ADDRESS;
      ichSelbst: TPFAnlegen;
      meineAddr: ADDRESS;
  BEGIN
    FensterUeberschrift := String.Create();
    String.Schreibe( FensterUeberschrift,"Anlegen einer Hilfskraft");
    WinHdle:=NeuesFenster(FensterUeberschrift,CFOBEN,CFLINKS,CFHOEHE,CFBREITE);
    ALLOCATE (ichSelbst, TSIZE(TFAnlegenDS));
    ichSelbst^.WinHdle:=WinHdle;
    meineAddr:= CAST(ADDRESS, ichSelbst);
    Push(ReaktFAnlegen, meineAddr);
    ZeilenAnlegen();
    KnoepfeAnlegen();
  END CreateFAnlegen;

(************************************************************************************************************************)
(********************************************** PROCEDURE DisposeFAnlegen() *********************************************)
(************************************************************************************************************************)

PROCEDURE DisposeFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFAnlegen;
  BEGIN
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFAnlegen, meineAddr);
    EntferneZeile(ichSelbst^.PersNrZ);
    EntferneKnopf(ichSelbst^.AbbrechenKnopf);
    EntferneKnopf(ichSelbst^.LoeschenKnopf);
    EntferneFenster(ichSelbst^.WinHdle);
    Pop();
    Top(reaktProc, meineAddr);
    reaktProc();
  END DisposeFAnlegen;

(************************************************************************************************************************)
(*********************************************** PROCEDURE DeaktFAnlegen() **********************************************)
(************************************************************************************************************************)
(*
PROCEDURE DeaktFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFAnlegen;
  BEGIN
    Deaktiviere Knpfe, Listboxen,...
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFAnlegen, meineAddr);
    SetzeKnopf(ichSelbst^.AbbrechenKnopf, FALSE);
    SetzeKnopf(ichSelbst^.LoeschenKnopf, FALSE);
  END DeaktFAnlegen; *)

(************************************************************************************************************************)
(*********************************************** PROCEDURE ReaktFAnlegen() **********************************************)
(************************************************************************************************************************)

PROCEDURE ReaktFAnlegen();                                                           		
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFAnlegen;
  BEGIN
   (* Aktiviere alle Fensterinhalte *)
   Top(reaktProc, meineAddr);
   ichSelbst:= CAST(TPFAnlegen, meineAddr);
   SetzeKnopf(ichSelbst^.AbbrechenKnopf, TRUE);
   SetzeKnopf(ichSelbst^.LoeschenKnopf, TRUE);
  END ReaktFAnlegen;

END FAnlegenHK.


