(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: MAIN.MOD,v $
# $Author: Sopra $
# $Date: 2001/03/10 09:48:23 $
# $Revision: 1.1.1.1 $
# Bemerkungen:

MODULE main;

Johannes Magauer

*)
(******************************************************************************)

MODULE main;

FROM X_Grafik IMPORT InitialisiereGrafik, StarteGrafik;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT StelleZeileDar, SetzeZeile, LiesZeile, EntferneZeile;

FROM SYSTEM IMPORT CAST, ADDRESS, TSIZE;
FROM Storage IMPORT ALLOCATE;
FROM args IMPORT GetArgs, ArgTable;
IMPORT String;

FROM SysReaktFStapel IMPORT Push, Pop, Top, TProc;
FROM FAnlegenHK IMPORT CreateFAnlegen;

(* ACHTUNG : Das Programm entfernt keine erzeugten Strings und
** Stringlisten. Die X-Grafik-Bibliothek kopiert alle Strings, so
** dass diese nach Erzeugung der Fenster geloescht werden koennten. 
** Das Schliessen eines Fensters ueber die Window s-Menue-Leiste wird 
** von der X-Grafik-Bibliothek nicht erkannt und ist verboten. 
*)

  TYPE 	TFMainDS = RECORD
		     WinHdle : ADDRESS;
		     Knopf1 : ADDRESS;
		     Knopf2 : ADDRESS;		     		
		   END;	 (* und deren Elemente *)
       	TPFMain = POINTER TO TFMainDS;

  VAR
     HauptfensterHandle: ADDRESS;
     Args    : ArgTable;
     AnzArgs : CARDINAL;
     ichSelbst: TPFMain; (* Zeiger auf ADT Fenster Main *)
     meineAddr: ADDRESS; (* Addresse dazu *)

(* --------------------------------------------------------------- *)

PROCEDURE AktivFMain();
  VAR
    StartKnopfText,
    EndeKnopfText: String.TString;
    EndeKnopfHandle,
    StartKnopfHandle: ADDRESS;
    reaktProc: TProc;
    meineAddr: ADDRESS;
    ichSelbst: TPFMain;
  BEGIN
    (* Erzeuge den Fensterinhalt *)

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFMain, meineAddr);
    (* Aktuellen Stapeleintrag holen, und Zeiger auf ADT Fenster generieren (Meiner Meinung nach fr Hauptfenster nicht notwendig, da ohnehin
       hier eine globale Variable gesetzt ist; jedoch bei allen anderen ADT's notwendig) *)

    EndeKnopfText := String.Create();
    String.Schreibe(EndeKnopfText,"Ende");
    EndeKnopfHandle := StelleKnopfDar(EndeKnopfText,ichSelbst^.WinHdle,10,50,CAST(PROC,EndeKnopfCallback));

    StartKnopfText := String.Create();
    String.Schreibe(StartKnopfText,"Hilfskraft anlegen");
    StartKnopfHandle := StelleKnopfDar(StartKnopfText,ichSelbst^.WinHdle,100,50,CAST(PROC,StartKnopfCallback));

    WITH ichSelbst^ DO
      Knopf1:= EndeKnopfHandle;
      Knopf2:= StartKnopfHandle;
    END (*WITH*)
  END AktivFMain;

PROCEDURE EndeKnopfCallback();
  BEGIN
    DisposeFMain();
  END EndeKnopfCallback;

PROCEDURE StartKnopfCallback();
  BEGIN
    DeaktFMain();
    CreateFAnlegen();
    (* Neues Fenster erzeugen *)
  END StartKnopfCallback;

PROCEDURE DisposeFMain();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFMain;
  BEGIN
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFMain, meineAddr);
    (* Aktuellen Stapeleintrag holen, und Zeiger auf ADT Fenster generieren (Meiner Meinung nach fr Hauptfenster nicht notwendig, da ohnehin
       hier eine globale Variable gesetzt ist; jedoch bei allen anderen ADT's notwendig) *)
    EntferneKnopf(ichSelbst^.Knopf1);
    EntferneKnopf(ichSelbst^.Knopf2);
    EntferneFenster(ichSelbst^.WinHdle);
    Pop();
    (* Lschen des letzten Stapeleintrages *)
  END DisposeFMain;

PROCEDURE DeaktFMain();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFMain;
  BEGIN
    (*Deaktiviere Knpfe, Listboxen,... *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFMain, meineAddr);
    (* Aktuellen Stapeleintrag holen, und Zeiger auf ADT Fenster generieren (Meiner Meinung nach fr Hauptfenster nicht notwendig, da ohnehin
       hier eine globale Variable gesetzt ist; jedoch bei allen anderen ADT's notwendig) *)
    SetzeKnopf(ichSelbst^.Knopf1, FALSE);
    SetzeKnopf(ichSelbst^.Knopf2, FALSE);
    (* Elemente deaktivieren *)
  END DeaktFMain;

PROCEDURE ReaktFMain();                                                           		
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFMain;
      hilfsText, text: String.TString;
      error: BOOLEAN;
      adresse: ADDRESS;
  BEGIN
    (* Aktiviere alle Fensterinhalte *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFMain, meineAddr);
    (* Aktuellen Stapeleintrag holen, und Zeiger auf ADT Fenster generieren *)

    SetzeKnopf(ichSelbst^.Knopf1, TRUE);
    SetzeKnopf(ichSelbst^.Knopf2, TRUE);
    (* Elemente aktivieren *)
  END ReaktFMain;

BEGIN
  GetArgs (AnzArgs,Args);
  HauptfensterHandle := InitialisiereGrafik(AnzArgs,Args,10,10,150,300);
  (* Addresse des Fensterrahmens bestimmen *)

  ALLOCATE (ichSelbst, TSIZE(TFMainDS));
  (* Speicherplatz fr den "ADT Fenster Main" reservieren *)

  ichSelbst^.WinHdle:= HauptfensterHandle;
  (* Addresszeiger des Fensterrahmens im "ADT Fenster Main" eintragen *)

  meineAddr:= CAST(ADDRESS, ichSelbst);
  (* Zeiger auf die Addresse des "ADT Fenster Main" bestimmen *)

  Push(ReaktFMain, meineAddr);
  (* Reaktivierungsprozedur des "ADT Fenster Main" und dessen Addresszeiger auf Stapel legen *)

  AktivFMain();
  (* Prozedure zum Aufbauen des Fensterinhaltes aufrufen *)

  StarteGrafik();
END main.
