 
(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: SysDat.mod,v $
# $Author: Sopra $
# $Date: 2001/03/10 09:48:10 $
# $Revision: 1.1.1.1 $
# Bemerkungen: Kompilierfhiger Status ist erreicht! hgw 12.1.2001 17:40
*)
(******************************************************************************)
 
IMPLEMENTATION MODULE SysDat; 

(* DatenTeilsystem zum Ablegen der Systemdaten wie Backup-Version und Datum *)
(* letzter Automatischer Betrieb und letztes vom Benutzer gesetztes *)
(* Datum etc. *)

FROM 	Datum IMPORT TDatum;
FROM 	String IMPORT TString;
IMPORT 	SysDatIMPORTE, SysDatADO;

TYPE THandle=SysDatIMPORTE.THandle;
     TVersion=SysDatADO.TVersion;

PROCEDURE CreateVersionInSysDat():TVersion;
(*
vb: --
Gibt ein leeres ADO vom Typ TVersion zurck
nb: ADO existiert
*)
BEGIN
	RETURN SysDatADO.CreateVersion();
END CreateVersionInSysDat;

PROCEDURE DisposeVersionInSysDat(VAR inoutV: TVersion);
(*
vb: ADO inoutV existiert
Lscht ein ADO vom Typ TVersion aus dem Speicher
nb: inoutV existiert nicht mehr
*)  
BEGIN
	SysDatADO.DisposeVersion(inoutV);
END DisposeVersionInSysDat;

PROCEDURE VersionAlsString(inV:TVersion): TString;
(*
vb: --
Erzeugt ein neues ADO vom Typ TString und  beschreibt es mit dem String
aequivalent von inV
nb: --
*)
BEGIN
        RETURN SysDatADO.VersionAlsString(inV);
END VersionAlsString; 

PROCEDURE VersionVonString (inString : TString; VAR outV:TVersion;
                          VAR outMessage:TString) : BOOLEAN;
(*
vb: --
Ldt das ADO outV mit der Version die im Stringaequivalent inString enthalten
war. Gelingt die Konversion nicht wird FALSE und eine Fehlermeldung zurck
gegeben
nb: --
*)  
BEGIN
        RETURN SysDatADO.VersionVonString(inString, outV, outMessage);
END VersionVonString; 

PROCEDURE IsZeroVersionInSysDat(inV:TVersion):BOOLEAN;
(* 
vb: --
Prft ob die bergebene Version = 0 ist
nb: --
*)
BEGIN
	RETURN SysDatADO.IsZeroVersion(inV);
END IsZeroVersionInSysDat;


PROCEDURE LiesBackupVersionInSysDat():TVersion;
(*
vb: --
Gibt ein ADO vom Typ TVersion mit dem aktuellen Inhalt des BackupVersionszhlerszurck  
nb: --
*)
BEGIN
	RETURN SysDatADO.LiesBackupVersion();
END LiesBackupVersionInSysDat;

PROCEDURE SetzeBackupVersionInSysDat(inV:TVersion);
(*
vb: --
Setzt den aktuellen Inhalt des BackupVersionszhlers auf inV. Dient dazu, das   naechste Backup gezielt unter einer bestimmten Version anzulegen
nb: --
*)
BEGIN
        SysDatADO.SetzeBackupVersion(inV);
END SetzeBackupVersionInSysDat; 
 
PROCEDURE LiesBackupDatumInSysDat(inV:TVersion):TDatum;
(*
vb: --
Gibt ein ADO vom Typ TDatum mit dem Datum zur BackupVersion V zurck  
nb: --
*)
BEGIN
	RETURN SysDatADO.LiesBackupDatum(inV);
END LiesBackupDatumInSysDat;

PROCEDURE NeuesBackupInSysDat();
(*
vb: Neues Backup ist angelegt worden
Inkrementiere den Versionszhler und schreibe des aktuelle SystemDatum in die
BackupTabelle
nb: Sei V der Versionszhler und sei Maxbackup die maximale Anzahl vor-
gehaltener Backups. Dann gilt V=(V mod Maxbackups) + 1
*)
BEGIN
	SysDatADO.NeuesBackup();
END NeuesBackupInSysDat;

PROCEDURE LoadInSysDat(inH: THandle; VAR inoutM:TString):BOOLEAN;
(* Wird beim Systemstart zur Restaurierung der BackupTabelle aufgerufen
vb: ADO BackupTable existiert
Lade den Inhalt der Datei HiKS.ini in die Backuptabelle und setze den Versions
zhler, lade das Datum des letzten Autoi-Betriebes. Falls erfolgreich wird true
zurckgegeben. Im Fehlerfall enthlt inoutM eine Fehlernachricht.
nb: Backuptabelle ist mit Versionen und Datum der Backups geladen
*)
BEGIN
	RETURN SysDatADO.Load(inH,inoutM);
END LoadInSysDat;

PROCEDURE SaveInSysDat(inH: THandle; VAR inoutM:TString):BOOLEAN;
(*
vb: ADO BackupTable existiert
Schreibe den Inhalt der BackupTabelle in die Datei HiKS.ini und speichere den
Stand des Versionszhlers und den Inhalt des letzten Automatischen Betriebs.
Falls erfolgreich wird true zurckgegeben. Im Fehlerfall enthlt inoutM eine Fehlernachricht.  
nb: Inhalt von SysDat ist in HiKS.ini
*)
BEGIN
	RETURN SysDatADO.Save(inH,inoutM);
END  SaveInSysDat;

PROCEDURE FirstBackupInSysDat(VAR outV:TVersion; VAR outD:TDatum):BOOLEAN;
(*
vb: Backups existieren e.g. D<>UNDEF
liefert das erste Paar BackupVersion/BackupDatum zurck, also 1/Datum. Falls
D fr Backup 1 UNDEF ist, wird false zurckgegeben
nb: --
*)
BEGIN
	RETURN SysDatADO.FirstBackup(outV,outD);
END  FirstBackupInSysDat;

PROCEDURE NextBackupInSysDat(VAR inoutV:TVersion; VAR inoutD:TDatum):BOOLEAN;
(*
vb: inoutV<MaxBackup and inoutD <> UNDEF
liefert das nchste Paar BackupVersion/BackupDatum zurck, falls FirstBackup
erfolgreich war. Falls es keine BackupVersion mehr gibt wird false zurckgegeben
nb: --
*)
BEGIN
	RETURN SysDatADO.NextBackup(inoutV,inoutD);
END NextBackupInSysDat;

PROCEDURE LiesLetztesAutoDatumInSysDat():TDatum;
(*
vb: --
Gibt ein ADO vom Typ TDatum zurck mit dem Datum an dem der letzte Automatische Betrieb gelaufen ist.
nb: --
*)
BEGIN
	RETURN SysDatADO.LiesLetztesAutoDatum();
END LiesLetztesAutoDatumInSysDat;

PROCEDURE SetzeLetztesAutoDatumInSysDat( inD: TDatum);
(*
vb: --
Setze das ADO LetztesAutoDatum auf den Wert inD
nb: --
*)
BEGIN
	SysDatADO.SetzeLetztesAutoDatum(inD);
END  SetzeLetztesAutoDatumInSysDat;
       	
PROCEDURE LiesSystemDatumInSysDat():TDatum;
(*
vb: --
Gibt ein ADO mit dem Datum zurck das zuletzt vom Benutzer gesetzt worden ist. 
nb: --
*)
BEGIN
	RETURN SysDatADO.LiesSystemDatum();
END LiesSystemDatumInSysDat;

PROCEDURE SetzeSystemDatumInSysDat( inD: TDatum);
(*
vb: --
Setze das Systemdatum auf den Wert inD
nb: --
*)
BEGIN
	SysDatADO.SetzeSystemDatum(inD);
END SetzeSystemDatumInSysDat;

END SysDat.	



