(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: vtre.mod,v $
# $Author: Sopra $
# $Date: 2001/03/13 19:17:50 $
# $Revision: 1.4 $     

IMPLEMENTATION MODULE Vtre   TS-Export-Schnittstelle Vertraege

Erstentwurf: Sigrid Preuss
Implementation: Schoenhammer Herbert

*)
(******************************************************************************)
 
IMPLEMENTATION MODULE Vtre;

(* TS Vertraege *)

FROM Datum  IMPORT  TDatum;
FROM String IMPORT  TString, Create, Schreibe;	
FROM Stringliste IMPORT TStringliste;

FROM VtreIMPORTE IMPORT DisposeHID,
                        DuplicateHID,
                        IsEqualHID,
                        EqualizeHID;

IMPORT Vtr, VtreOrdner;

TYPE TVtr = Vtr.TVtr;



(* Operationen zur Erzeugung von Ausprgungen des Entittstyps Vertrag *)
(*=====================================================================*)

PROCEDURE CreateVtr () : TVtr;
BEGIN
  RETURN Vtr.CreateVtr ()
END CreateVtr;


(* Standard-Operationen auf dem Entittstyp Vertrag                    *)
(*=====================================================================*)

PROCEDURE DisposeVtr (VAR inoutVtr : TVtr);
BEGIN
  Vtr.DisposeVtr (inoutVtr);
END DisposeVtr;

PROCEDURE DuplicateVtr (inQuellVtr : TVtr) : TVtr;
BEGIN
   RETURN Vtr.DuplicateVtr (inQuellVtr)
END DuplicateVtr;

PROCEDURE IsEqualVtr (inVtr1, inVtr2 : TVtr) : BOOLEAN;
BEGIN
   RETURN Vtr.IsEqualVtr (inVtr1, inVtr2)
END IsEqualVtr;

PROCEDURE IsEqualVtrDaten (inVtr1, inVtr2 : TVtr) : BOOLEAN;
BEGIN
   RETURN Vtr.IsEqualVtrDaten (inVtr1, inVtr2)
END IsEqualVtrDaten;

PROCEDURE EqualizeVtr (inoutZielVtr, inQuellVtr : TVtr);
BEGIN
   Vtr.EqualizeVtr (inoutZielVtr, inQuellVtr)
END EqualizeVtr;

PROCEDURE SameVertrag (inVtr1, inVtr2 : TVtr) : BOOLEAN;
BEGIN
   RETURN Vtr.SameVertrag (inVtr1, inVtr2)
END SameVertrag;

PROCEDURE SmallerVertrag (inSmallerVtr, inGreaterVtr : TVtr) : BOOLEAN;
BEGIN
   RETURN Vtr.SmallerVertrag (inSmallerVtr, inGreaterVtr)
END SmallerVertrag;


(* Operationen auf den Attributen des Entittstyps Vertrag             *)
(*=====================================================================*)

(* VertragsID *)
(*============*)

PROCEDURE LiesVtrIDinVtr (inVtr: TVtr) : TVtrID;
BEGIN
   RETURN Vtr.LiesVtrIDinVtr (inVtr)
END LiesVtrIDinVtr;

PROCEDURE DisposeVtrID (VAR inoutVtrID : TVtrID);
BEGIN
   DisposeHID (inoutVtrID)
END DisposeVtrID;

PROCEDURE DuplicateVtrID (inVtrID : TVtrID ) : TVtrID;
BEGIN
   RETURN DuplicateHID (inVtrID)
END DuplicateVtrID;

PROCEDURE IsEqualVtrID (inVtrID1, inVtrID2 : TVtrID ) : BOOLEAN;
BEGIN
  RETURN  IsEqualHID (inVtrID1, inVtrID2)
END IsEqualVtrID;

PROCEDURE EqualizeVtrID (inoutVtrID, inQuellID : TVtrID);
BEGIN
   EqualizeHID (inoutVtrID, inQuellID)
END EqualizeVtrID;


PROCEDURE PruefeVtrID (inString:TString; VAR outMessage:TString):BOOLEAN;
BEGIN
  RETURN Vtr.PruefeVtrID (inString, outMessage);
END PruefeVtrID;

PROCEDURE VtrIDAlsString (inVtrID : TVtrID) :TString;
BEGIN
   RETURN Vtr.VtrIDAlsString (inVtrID)
END VtrIDAlsString;

PROCEDURE StringInVtrID (inString : TString) :TVtrID;
BEGIN
   RETURN Vtr.StringInVtrID (inString)
END StringInVtrID;


(* PersID *)
(*========*)


PROCEDURE SetzePersIDinVtr (inoutVtr : TVtr; inPersID : TPersID);
        (* vb PersID existiert *)
BEGIN
   Vtr.SetzePersIDinVtr (inoutVtr, inPersID)
END SetzePersIDinVtr;

PROCEDURE LiesPersIDinVtr (inVtr : TVtr) : TPersID;
BEGIN
   RETURN Vtr.LiesPersIDinVtr (inVtr)
END LiesPersIDinVtr;


PROCEDURE ExistiertPersIDinVtr (inVtr:TVtr):BOOLEAN;  (* !! Neu !! *)
BEGIN
   RETURN Vtr.ExistiertPersIDinVtr (inVtr)
END ExistiertPersIDinVtr;


(* KstID *)
(*=======*)


PROCEDURE SetzeKstIDinVtr (inoutVtr : TVtr; inKstID : TKstID);
        (* vb KstID existiert *)
BEGIN
   Vtr.SetzeKstIDinVtr (inoutVtr, inKstID)
END SetzeKstIDinVtr;

PROCEDURE LiesKstIDinVtr (inVtr : TVtr ) : TKstID;
BEGIN
   RETURN Vtr.LiesKstIDinVtr (inVtr)
END LiesKstIDinVtr;


(* DatumsAttribute *)
(*=================*)

PROCEDURE SetzeGueltigVoninVtr (inoutVtr : TVtr; inDatum : TDatum);
BEGIN
   Vtr.SetzeGueltigVoninVtr (inoutVtr, inDatum);
END SetzeGueltigVoninVtr;

PROCEDURE LiesGueltigVoninVtr (inVtr: TVtr) : TDatum;
BEGIN
   RETURN Vtr.LiesGueltigVoninVtr (inVtr)
END LiesGueltigVoninVtr;

PROCEDURE SetzeGueltigBisinVtr (inoutVtr: TVtr; inDatum : TDatum);
BEGIN
   Vtr.SetzeGueltigBisinVtr (inoutVtr, inDatum)
END SetzeGueltigBisinVtr;

PROCEDURE LiesGueltigBisinVtr (inVtr : TVtr) : TDatum;
BEGIN
   RETURN Vtr.LiesGueltigBisinVtr (inVtr)
END LiesGueltigBisinVtr;

PROCEDURE SetzeErstellDatinVtr (inoutVtr : TVtr; inErstellDatum : TDatum) : BOOLEAN;
BEGIN
   RETURN Vtr.SetzeErstellDatinVtr (inoutVtr, inErstellDatum)
END SetzeErstellDatinVtr;

PROCEDURE LiesErstellDatinVtr (inVtr : TVtr) : TDatum;
BEGIN
   RETURN Vtr.LiesErstellDatinVtr (inVtr)
END LiesErstellDatinVtr;

PROCEDURE SetzeStornoAminVtr (inoutVtr : TVtr; inStorniertAm : TDatum) : BOOLEAN;
BEGIN
   RETURN Vtr.SetzeStornoAminVtr(inoutVtr, inStorniertAm)
END SetzeStornoAminVtr;

PROCEDURE LiesStornoAminVtr (inVtr : TVtr) : TDatum;
BEGIN
   RETURN Vtr.LiesStornoAminVtr(inVtr)
END LiesStornoAminVtr;

PROCEDURE IstStornoInVtr (inVtr : TVtr) : BOOLEAN;
BEGIN
   RETURN Vtr.IstStornoInVtr (inVtr)
END IstStornoInVtr;

PROCEDURE SetzeStdzahlinVtr (inoutVtr: TVtr;
                               inStdzahl : CARDINAL) : BOOLEAN;
BEGIN
   RETURN Vtr.SetzeStdzahlinVtr (inoutVtr, inStdzahl)
END SetzeStdzahlinVtr;

PROCEDURE LiesStdzahlinVtr (inVtr: TVtr) : CARDINAL;
BEGIN
   RETURN Vtr.LiesStdzahlinVtr (inVtr)
END LiesStdzahlinVtr;


(* Weitere Attribute *)
(*===================*)


PROCEDURE SetzeTaetigktinVtr (inoutVtr: TVtr; inTaetigkt : TString) : BOOLEAN;
BEGIN
   RETURN Vtr.SetzeTaetigktinVtr (inoutVtr, inTaetigkt)
END SetzeTaetigktinVtr;

PROCEDURE LiesTaetigktinVtr (inVtr : TVtr) : TString;
BEGIN
   RETURN Vtr.LiesTaetigktinVtr (inVtr)
END LiesTaetigktinVtr;

PROCEDURE SetzeBegruendinVtr (inoutVtr: TVtr; inBegruend : TString) : BOOLEAN ;
BEGIN
   RETURN Vtr.SetzeBegruendinVtr(inoutVtr, inBegruend)
END SetzeBegruendinVtr;

PROCEDURE LiesBegruendinVtr (inVtr: TVtr) : TString;
BEGIN
   RETURN Vtr.LiesBegruendinVtr (inVtr)
END LiesBegruendinVtr;


(* Pruef-Operatoren auf dem Entitaetstyp Vertrag *)
(*===============================================*)


PROCEDURE IstAbgelaufenVtr(inVtr: TVtr): BOOLEAN;
(* wenn GueltigBis < Heute, dann TRUE, sonst FALSE zurck *)
BEGIN
   RETURN Vtr.IstAbgelaufenVtr (inVtr)
END IstAbgelaufenVtr;

PROCEDURE BeginntNotImLfdJahr(inVtr: TVtr): BOOLEAN;
(* wenn GueltigVon.Jahr > Heute.Jahr, dann TRUE, sonst FALSE zurck *)
BEGIN
   RETURN Vtr.BeginntNotImLfdJahr (inVtr)
END BeginntNotImLfdJahr;

PROCEDURE IstNochNichtLfdVtr(inVtr: TVtr): BOOLEAN;
(* prft, ob Gueltig.Bis > HEUTE, dann TRUE, sonst FALSE  *)
BEGIN
   RETURN Vtr.IstNochNichtLfdVtr (inVtr)
END IstNochNichtLfdVtr;
 
PROCEDURE IstLfdVtr(inVtr: TVtr; inEndeNeu:TDatum): BOOLEAN;
(* prft, ob Gueltig.VON < EndeNeue < Gueltig.Bis dann TRUE, sonst FALSE *)
BEGIN
   RETURN Vtr.IstLfdVtr (inVtr, inEndeNeu)
END IstLfdVtr;
 
PROCEDURE ExistVtr(inVtr: TVtr; VAR outMessage: TString): BOOLEAN;
(* prft, ob zu einem Vertrag die ID bereits existiert/gesetzt wurde,
   wenn ja wird TRUE zurckgegeben,sonst FALSE  *)
VAR exist : BOOLEAN;
BEGIN
   exist := Vtr.ExistiertVtrID (inVtr);
   IF NOT exist
   THEN
      outMessage := Create();
      Schreibe (outMessage, "Vertrag existiert nicht im Ordner");
   END; (* IF *)
   RETURN exist;
END ExistVtr;


(* Ordner-Operationen                                                      *)
(*=========================================================================*)

	
PROCEDURE InsertVtr( inVtr: TVtr; VAR outMessage : TString) : BOOLEAN;
  (* vb: sei V der neu einzufgende Vertrag. Dann muss gelten:
         ADO VertraegeOrdner	existiert and not isfull and 
         inVtr existiert nicht im Vertraegeordner.
         Fuegt einen Vertrag in den VertraegeOrdner ein
         Sei OK der boolesche Rueckgabecode, dann gilt:
     nb: OK <=> inVtr ist in den Vertraegeordner eingefuegt   *)
BEGIN
  RETURN VtreOrdner.InsertVtr (inVtr, outMessage)
END InsertVtr;

PROCEDURE SearchVtr( inVtrID: TVtrID; VAR outVtr : TVtr) : BOOLEAN;
  (* vb: VertraegeOrdner existiert
         Hole den Vertrag zur VertragsID inVtrID
         Sei OK der boolesche Rueckgabecode, dann gilt:
     nb: OK <=> outVtr enthaelt den vertrag mit der VertragsID inVtrID  *)
BEGIN
   RETURN VtreOrdner.SearchVtr (inVtrID, outVtr)
END SearchVtr;


PROCEDURE AendernVtr (inVtr : TVtr; VAR outMessage : TString):BOOLEAN;
 (* Vb.: keine
         Sucht im Ordner den Vertrag mit der uebergebenen inVtr.ID; wird der Vertrag gefunden,
         so werden die Attribute GuelitgBis, StornoAm, Stundenzahl, Taetigkeit und
         Begruendung des Ordnervertrages denen von inVtr angeglichen.
    Nb.: ? *)
BEGIN
   RETURN VtreOrdner.AendernVtr (inVtr, outMessage)
END AendernVtr;


PROCEDURE DeleteVtr (inVtr : TVtr):BOOLEAN;
 (* Vb.: keine
         Sucht im Ordner den Vertrag mit der uebergebenen inVtr.ID; wird der Vertrag gefunden,
         so wird der Vertrag aus dem Ordner geloescht und die inVtrID an die HIDVerwaltung
         zurueckgegeben.
    Nb.: ? *)
BEGIN
   RETURN VtreOrdner.DeleteVtr (inVtr)
END DeleteVtr;


(* Iteratoren ueber nicht stornierte Vertraege *)
(*=============================================*)

PROCEDURE FirstVtr(VAR outVtr : TVtr):BOOLEAN;
  (* vb: VertraegeOrdner existiert
         Holt den ersten nicht stornierten Vertrag
         Sei OK der boolesche Rueckgabecode, dann gilt:
     nb: OK <=> Mindestens ein nicht stornierter Vertrag existiert *)
BEGIN
   RETURN VtreOrdner.FirstVtr (outVtr)
END FirstVtr;


PROCEDURE NextVtr(inoutVtr : TVtr):BOOLEAN;
  (* vb: VertraegeOrdner existiert
         Falls mit FirstVtrHolen ein nicht stornierter Vertrag gefunden wurde,
         dann holt diese Prozedur den naechsten nicht stornierten Vertrag.
         Sei OK der boolesche Rueckgabecode, dann gilt:
         nb: OK <=> Weiterer nicht stornierter Vertrag im Zeitraum existiert *)
BEGIN
   RETURN VtreOrdner.NextVtr (inoutVtr)
END NextVtr;


PROCEDURE FirstVldVtrAbDatum (inDatum : TDatum; VAR outVtr : TVtr):BOOLEAN;
 (* Vb: NOT IsEmpty(inoutVtrOrdner)
        Der erste nicht stornierte Vertrag, dessen GueltigBis >= inDatum
        wird in outVtr zurueckgegeben
        und inoutHKOrdner.pos auf diesen Vertrag positioniert.
    Nb: (outVtr enthaelt den Vertrag *)
BEGIN
   RETURN VtreOrdner.FirstVldVtrAbDatum (inDatum, outVtr)
END FirstVldVtrAbDatum;


PROCEDURE NextVldVtrAbDatum (inDatum : TDatum; inoutVtr : TVtr):BOOLEAN;
 (* Vb: NOT IsEmpty(inoutVtrOrdner)
        Der nchste nicht stornierte Vertrag, dessen GueltigBis >= inDatum
        wird in outVtr zurueckgegeben
        und inoutHKOrdner.pos auf diesen Vertrag positioniert.
    Nb: (outVtr enthaelt den Vertrag *)

BEGIN
   RETURN VtreOrdner.NextVldVtrAbDatum (inDatum, inoutVtr)
END NextVldVtrAbDatum;


PROCEDURE FirstVtrImZeitraum( inGueltigVon, inGueltigBis:TDatum;
                                            VAR outVtr : TVtr) : BOOLEAN;
  (* vb: VertraegeOrdner existiert
         Hole den ersten nicht stornierten Vertrag, dessen GueltigVon-Datum
         im Zeitraum inGueltigVon-inGueltigBis liegt
         Sei OK der boolesche Rueckgabecode, dann gilt:
     nb: OK <=> nicht stornierter Vertrag im Zeitraum existiert *)
BEGIN
   RETURN VtreOrdner.FirstVtrImZeitraum (inGueltigVon, inGueltigBis, outVtr)
END FirstVtrImZeitraum;



PROCEDURE NextVtrImZeitraum( inGueltigVon, inGueltigBis:TDatum;
                                           inoutVtr : TVtr) : BOOLEAN;
  (* vb: VertraegeOrdner existiert
         Falls mit FirstVtrImZeitraumHolen ein nicht stornierter Vertrag,
         dessen GueltigVon-Datum im Zeitraum
         inGueltigVon-inGueltigBis gefunden wurde, dann holt diese Prozedur den
         naechsten Vertrag.
         Sei OK der boolesche Rueckgabecode, dann gilt:
     nb: OK <=> Weiterer nicht stornierter Vertrag im Zeitraum existiert  *)
BEGIN
   RETURN VtreOrdner.NextVtrImZeitraum (inGueltigVon, inGueltigBis, inoutVtr)
END NextVtrImZeitraum;


PROCEDURE FirstValidVtrZuHK (inPersID : TPersID; VAR outVtr : TVtr) : BOOLEAN;
  (* Ersten gueltigter Vertrag (nicht storniert) einer Hilfskraft ausgeben *)
BEGIN
   RETURN VtreOrdner.FirstValidVtrZuHK (inPersID, outVtr)
END FirstValidVtrZuHK;


PROCEDURE NextValidVtrZuHK  (inPersID : TPersID; inoutVtr : TVtr) : BOOLEAN;
  (* Naechsten gueltiger Vertrag (nicht storniert) einer Hilfskraft ausgeben *)
BEGIN
   RETURN VtreOrdner.NextValidVtrZuHK (inPersID, inoutVtr)
END NextValidVtrZuHK;


PROCEDURE FirstVldVtrZuHKinZtraum (inPersID : TPersID; inAnfang,inEnde :TDatum; 
                                   VAR outVtr : TVtr) : BOOLEAN;
BEGIN
   RETURN VtreOrdner.FirstVldVtrZuHKinZtraum (inPersID, inAnfang, inEnde, outVtr)
END FirstVldVtrZuHKinZtraum;


PROCEDURE NextVldVtrZuHKinZtraum  (inPersID : TPersID; inAnfang,inEnde : TDatum; 
                                                     inoutVtr : TVtr) : BOOLEAN;
BEGIN
   RETURN VtreOrdner.NextVldVtrZuHKinZtraum (inPersID, inAnfang, inEnde, inoutVtr)
END NextVldVtrZuHKinZtraum;


PROCEDURE FirstVldVtrZuHKinZtpunkt (inPersID : TPersID; inDatum : TDatum; VAR outVtr : TVtr) : BOOLEAN;
BEGIN
   RETURN VtreOrdner.FirstVldVtrZuHKinZtpunkt (inPersID, inDatum, outVtr)
END FirstVldVtrZuHKinZtpunkt;


PROCEDURE NextVldVtrZuHKinZtpunkt  (inPersID : TPersID; inDatum : TDatum; inoutVtr : TVtr): BOOLEAN;
BEGIN
   RETURN VtreOrdner.NextVldVtrZuHKinZtpunkt (inPersID, inDatum, inoutVtr)
END NextVldVtrZuHKinZtpunkt;


PROCEDURE BerMaxStdZahlDerHK (inVtr: TVtr): INTEGER;
  (* Gabi
        S. 45: ab (*HK nach VKond prfen *)
        bis .. Stunden := Max()... (=Rckgabe)
            END (*FOR*)
        AnzahlMonate wird nicht benoetigt !!!!  *)
BEGIN
   RETURN VtreOrdner.BerMaxStdZahlDerHK (inVtr)
END BerMaxStdZahlDerHK;


PROCEDURE BerMaxBeschZeitDerHK (inHKID : TPersID; VAR outVonDatum, outBisDatum : TDatum): BOOLEAN;
BEGIN
   RETURN VtreOrdner.BerMaxBeschZeitDerHK (inHKID, outVonDatum, outBisDatum)
END BerMaxBeschZeitDerHK;


(* Iterator ueber alle Vertraege (einschl. der stornierten) *)
(*==========================================================*)


PROCEDURE FirstVtrUndStorno(VAR outVtr : TVtr):BOOLEAN;
(*  vb: VertraegeOrdner existiert
        Holt den ersten Vertrag
        Sei OK der boolesche Rueckgabecode, dann gilt:
    nb: OK <=> Mindestens ein Vertrag existiert      *)
BEGIN
   RETURN VtreOrdner.FirstVtrUndStorno (outVtr)
END FirstVtrUndStorno;


PROCEDURE NextVtrUndStorno (inoutVtr : TVtr) : BOOLEAN;
(*  vb: VertraegeOrdner existiert
        Falls mit FirstVtrHolen ein Vertrag gefunden wurde, dann holt diese Prozedur
        den naechsten Vertrag.
        Sei OK der boolesche Rueckgabecode, dann gilt:
    nb: OK <=> Weiterer Vertrag im Zeitraum existiert   *)
BEGIN
   RETURN VtreOrdner.NextVtrUndStorno (inoutVtr)
END NextVtrUndStorno;

PROCEDURE  FirstVtrZuHK (inPersID : TPersID; VAR outVtr : TVtr) : BOOLEAN;
(* Ersten Vertrag einer Hilfskraft ausgeben *)
BEGIN
   RETURN VtreOrdner.FirstVtrZuHK (inPersID, outVtr)
END FirstVtrZuHK;
 
PROCEDURE  NextVtrZuHK  (inPersID : TPersID; inoutVtr : TVtr) : BOOLEAN;
(* Naechsten Vertrag einer Hilfskraft ausgeben *)
BEGIN
   RETURN VtreOrdner.NextVtrZuHK (inPersID, inoutVtr)
END NextVtrZuHK;


PROCEDURE  ExistVtrZuHK (inHKID:TPersID):BOOLEAN;
  (* Prueft, ob zu der HK inHKID jemals ein Vertrag existiert hat. Dabei ist es voellig egal, ob der Vertrag storniert ist usw. Dies Voraussetzung fr Loesche HK *)
BEGIN
   RETURN VtreOrdner.ExistVtrZuHK (inHKID)
END ExistVtrZuHK;
   

PROCEDURE  FirstVtrZuKst (inKstID : TKstID; VAR outVtr : TVtr) : BOOLEAN;
(* Ersten Vertrag einer Kostenstelle ausgeben *)
BEGIN
   RETURN VtreOrdner.FirstVtrZuKst (inKstID, outVtr)
END FirstVtrZuKst;

  
PROCEDURE  NextVtrZuKst  (inKstID : TKstID; inoutVtr : TVtr) : BOOLEAN;
(* Naechsten Vertrag einer Kostenstelle ausgeben *)
BEGIN
   RETURN VtreOrdner.NextVtrZuKst (inKstID, inoutVtr)
END NextVtrZuKst;
   
 
PROCEDURE FirstVtrZuHKinZeitraum (inPersID : TPersID; inAnfang,inEnde :TDatum; VAR outVtr : TVtr) : BOOLEAN;
BEGIN
   RETURN VtreOrdner.FirstVtrZuHKinZeitraum (inPersID, inAnfang, inEnde, outVtr)
END FirstVtrZuHKinZeitraum;
   

PROCEDURE NextVtrZuHKinZeitraum  (inPersID : TPersID; inAnfang,inEnde : TDatum; inoutVtr : TVtr) : BOOLEAN;
BEGIN
   RETURN VtreOrdner.NextVtrZuHKinZeitraum (inPersID, inAnfang, inEnde, inoutVtr)
END NextVtrZuHKinZeitraum;
   
 
PROCEDURE FirstVtrZuKstinZeitraum (inKstID : TKstID; inAnfang,inEnde : TDatum; VAR outVtr : TVtr) : BOOLEAN;
BEGIN
   RETURN VtreOrdner.FirstVtrZuKstinZeitraum (inKstID, inAnfang, inEnde, outVtr)
END FirstVtrZuKstinZeitraum;
   

PROCEDURE NextVtrZuKstinZeitraum  (inKstID : TKstID; inAnfang,inEnde : TDatum; inoutVtr : TVtr) : BOOLEAN;
BEGIN
   RETURN VtreOrdner.NextVtrZuKstinZeitraum (inKstID, inAnfang, inEnde, inoutVtr)
END NextVtrZuKstinZeitraum;

   
PROCEDURE FirstVtrZuHKinZeitpunkt (inPersID : TPersID; inDatum : TDatum; VAR outVtr : TVtr ) : BOOLEAN;
BEGIN
   RETURN VtreOrdner.FirstVtrZuHKinZeitpunkt (inPersID, inDatum, outVtr)
END FirstVtrZuHKinZeitpunkt;
   

PROCEDURE NextVtrZuHKinZeitpunkt (inPersID : TPersID; inDatum : TDatum; inoutVtr : TVtr ) : BOOLEAN;
BEGIN
   RETURN VtreOrdner.NextVtrZuHKinZeitpunkt (inPersID, inDatum, inoutVtr)
END NextVtrZuHKinZeitpunkt;



(* Stringlisten-Operationen *)
(*==========================*)

PROCEDURE GibVtrAlsStringlisteInVtr(): TStringliste;
BEGIN
   RETURN VtreOrdner.GibVtrAlsStringlisteInVtr ()
END GibVtrAlsStringlisteInVtr;
                                                

PROCEDURE GibAllesAlsStringlisteInVtr(): TStringliste;
BEGIN
   RETURN VtreOrdner.GibAllesAlsStringlisteInVtr ()
END GibAllesAlsStringlisteInVtr;


(* Operationen zum Speichern und Laden des VertraegeOrdners *)
(*==========================================================*)

PROCEDURE SaveinVtre (inH : THandle; VAR outMessage : TString) : BOOLEAN;
  (* vb: VertraegeOrdner existiert
         Sichert den VertraegeOrdner auf Datei
         Sei OK der boolesche Rueckgabecode, dann gilt:
     nb: OK <=>  Sicherung korrekt  *)
BEGIN
   RETURN VtreOrdner.SaveinVtre (inH, outMessage)
END SaveinVtre;


PROCEDURE LoadinVtre (inH : THandle; VAR outMessage : TString) : BOOLEAN;
  (* vb: VertraegeOrdner ist mit Save gespeichert worden
         Loescht alle Elemente in einem vorhandenen VertraegeOrdner
         Erstellt den VertraegeOrdner aus der mit Save erstellten Datei
         Sei OK der boolesche Rueckgabecode, dann gilt:
     nb: OK <=>  Der VertraegeOrdner ist korrekt erstellt *)
BEGIN
   RETURN VtreOrdner.LoadinVtre (inH, outMessage)
END LoadinVtre;

	
END Vtre.






