(*
	Autor 			:	Reini
	letzte Aenderung	: 	05.03.2001

*)



IMPLEMENTATION MODULE VtrVerw;

(* -- Importe *)

FROM SYSTEM IMPORT CAST;

FROM HKBIMPORTE IMPORT TVtr, TVtrID,
                       TDatum, TStag, TTag, TMonat,
                       TPersID, THK,
                       TKstID, TKst,
                       TBu, TBuArt,
                       TKond,

                       AnzMonateImJahr, AbgebuGelderDerKst,

                       BCreateBu, BerWGDerHK,

                       DispBu, DispHK, DispKst, DispKond, DispVtr,
                       DupVtr,

                       EinfBu, EinfVtr, ErsteAktKst, EqualizeVtr,
                       EtatDerKst,

                       FirstHK, FirstValVtrZuHK, FirstValVtrZuHKmitZpunkt,

                       GetGueltigeWKond,

                       HKWGBerechtigt,

                       IsEqualKstID, IsEqualVtrDaten,
                       IstGesperrtKst, IstLiquidiertKst, IstVtrAbgelaufen,

                       KBerechneBrutto, KPruefeVKondInZeitr,

                       LGueltigBisInVtr, LGueltigVonInVtr, LHKID,
                       LHKIDinVtr, LKstIDinKst, LStdzahlInVtr,
                       LKstIDinVtr, LSysDatumInSysDat, LSTagInWKond,
                       LVtrIDinVtr,

                       NaechsteAktKst, NextHK, NextValVtrZuHK,
                       NextValVtrZuHKmitZpunkt,

                       SetBetragInBu, SetBuchungsArtInBu,
                       SetKstIDinBu, SetVtrIDinBu, SetStornoAmInVtr,
                       StornoGehaltBu, SucheKstZuKID, SetGueltigBisInVtr,

                       UpdateVtr,

                       VBBerMaxStdzahlDerHK, VBeginntNotImLfdJahr, VExistVtr,

                       WGAnteilDerKst;


FROM Datum IMPORT      DisposeDatum, DisposeStag, DuplicateDatum,

                       LiesTagInStag, LiesMonatInStag,

                       SetzeTagInDatum, SetzeMonatInDatum, SmallerDatum;

IMPORT String;

(* wohl ueberfluessig
IMPORT Vtre;
IMPORT Ksten;
TYPE	THK	= HKe.THK; TString = String.TString; TDatum = Datum.TDatum;
	TKstID	= Ksten.TKstID*)


PROCEDURE BearbeitenNeuVtr ( inVtr : TVtr; VAR outMessage : TString) : BOOLEAN;
(* -- bekommt Vertragsdaten uebergeben, d.h. ohne VtrID!
   -- zuerst werden einfache Bedingungen ueberprueft, falls diese erfuellt sind
   -- wird der Vertrag eingefuegt.
   -- Dies muss geschehen, damit bei spaeterer Restetatsberechnung der
   -- Zeitraum und die Stundenzahl des NeuVtr mitberuecksichtigt werden,
   -- noch keine Buchung erfolgt!
   -- Nun wird getestet, ob Etats von Kostenstellen ueberschritten werden:
   -- * Berechnen des Restetats der direkt betroffenen Kostenstelle
        Etat - bereits abgebuchte Gelder
             - Betrag, der durch NeuVtr entstehen wuerde
             - geschaetzter WG-Anteil (enthaelt auch NeuVtr)
      * Berechnen des Restetats aller Kostenstellen, die einen gueltigen
        Vertrag mit der HK haben, da durch den NeuVtr sich evtl. die Hoehe
        des WG der HK und damit der WG-Anteil, den die einzelnen Kostenstellen
        zu zahlen haben, aendern koennte.
        Etat - bereits abgebuchte Gelder
             - geschaetzter WG-Anteil (enthaelt auch NeuVtr)

   -- Falls der Etat einer betroffenen Kostenstellen ueberschritten wird,
   -- wird der NeuVtr wieder storniert. Hierdurch entstehen zwar
   -- "Vertragsleichen", was aber zumutbar ist, da diese Faelle eher selten
   -- auftreten. "Vertragsleichen" koennten vermieden werden, indem man
   -- ausnahmsweise Vertragsloeschungen zulassen wuerde.
   -- Zum Stornieren des NeuVtr muessen alle gueltigen Vtrs der HK auf
   -- Gleichheit mit den VtrDaten geprueft werden, um die VtrID zu bestimmen,
   -- danach kann NeuVtr storniert werden.

*)
VAR	outKstID	: TKstID;
	outKstZuID	: TKst;
	outKst		: TKst;
	RestEtat	: INTEGER;
	maxStdzahl	: CARDINAL;
	OK		: BOOLEAN;
	result		: BOOLEAN;
	Vtrgefunden	: BOOLEAN;
	outMsg		: TString;
	outMsg2		: TString;
	neuVtrBetrag	: CARDINAL;
	outV1		: TVtr;
	
BEGIN
  outKstID    := LKstIDinVtr ( inVtr );
  OK          := SucheKstZuKID ( outKstID , outKstZuID );
  outMsg      := String.Create();
  Vtrgefunden := FALSE;

  IF IstVtrAbgelaufen ( inVtr ) THEN
      OK := FALSE;
      String.Schreibe (outMsg, "Vertrag ist bereits abgelaufen")
  ELSIF VBeginntNotImLfdJahr ( inVtr ) THEN  	
      OK := FALSE;
      String.Schreibe (outMsg, "Vertrag beginnt nicht im laufenden Jahr")
  ELSIF ( IstGesperrtKst ( outKstZuID ) OR IstLiquidiertKst ( outKstZuID ) ) THEN
      OK := FALSE;
      String.Schreibe (outMsg, "Kostenstelle ist liquidiert oder gesperrt")
  ELSE
  	(* -- einfache Bedingungen erfuellt, Vertrag wird nun eingefuegt
  	   -- danach wird ueberprueft, ob Etats der Ksten ausreichen *)
      IF EinfVtr ( inVtr, outMsg ) THEN
        (* -- falls HK incl. NeuVtr WGBerechtigt ist, muessen alle Etats der
           -- Ksten, welche einen gueltigen Vtr mit HK besitzen, auf
           -- Etatueberschreitung ueberprueft werden, ansonsten nur die Kst
           -- im NeuVtr *)
        IF HKWGBerechtigt ( LHKIDinVtr (inVtr), LSysDatumInSysDat () ) THEN
             (* -- Restetat aller Ksten ueberpruefen, die einen gueltigen Vtr mit
                -- HK haben. Hierfuer werden zunaechst alle nicht liquidierten
                -- Ksten durchlaufen *)
            IF ErsteAktKst ( outKst ) THEN
               REPEAT
                    (* -- Test ob es einen gueltigen Vtr zw. HK und outKst gibt *)
                   IF ExistValVtrZwHKUndKst ( LHKIDinVtr(inVtr), outKst) THEN
                       IF BerRestEtatDerKst ( LKstIDinKst (outKst) ) < 0 THEN
                           OK := FALSE;
                           String.Schreibe (outMsg, "Etatueberschreitung !")
                       END;
                   END;
               UNTIL (NOT NaechsteAktKst ( outKst )) OR (NOT OK);
               DispKst (outKst)
            END; (* IF ErsteAktKst *)

        ELSE
             (* -- nur den Restetat der Kst in NeuVtr ueberpruefen
                -- zuerst den Betrag berechnen, der durch NeuVtr verursacht
                -- werden wuerde *)	
             IF (BerRestEtatDerKst ( outKstID ) -
                 KBerechneBrutto ( LGueltigVonInVtr (inVtr),
                                   LGueltigBisInVtr (inVtr),
                                   LStdzahlInVtr (inVtr) )) < 0 THEN
                 (* -- Etatueberschreitung *)
                 OK := FALSE;
                 String.Schreibe (outMsg, "Etatueberschreitung !")
             END; (* IF *)
        END; (* IF HKWGBerechtigt *)

        (* -- hier ist die Etatueberschreitung bereits geklaert.
           -- Falls Etat OK, muss nun die Vertragskondition getestet werden *)

           IF OK THEN
               (* -- Vertragskondition pruefen *)
               maxStdzahl := CAST (CARDINAL, ABS(VBBerMaxStdzahlDerHK ( inVtr )));
               IF NOT KPruefeVKondInZeitr ( LGueltigVonInVtr (inVtr),
                                           LGueltigBisInVtr (inVtr),
                                           maxStdzahl,
                                           AnzMonateImJahr ( LHKIDinVtr (inVtr),
                                                             LSysDatumInSysDat () ) ) THEN
                    OK := FALSE;
                    String.Schreibe (outMsg, "Vertragskondition nicht erfuellt")
               END;
           END; (* IF OK *)


           (* -- es muss die ID des Vtr bestimmt werden, um entweder diesen
              -- Vtr wieder stornieren zu koennen oder fuer diesen Vtr die
              -- Buchung vornehmen zu koennen. An dieser Stelle ist NeuVtr
              -- noch im Ordner eingefuegt *)

           IF FirstValVtrZuHK ( LHKIDinVtr ( inVtr ) , outV1) THEN
           	REPEAT
                   Vtrgefunden := IsEqualVtrDaten (inVtr, outV1);
                   IF Vtrgefunden THEN
                       EqualizeVtr (inVtr, outV1);  (* -- erforderlich, um
                                                  -- inVtr mit ID zu versehen *)
                   END ;
            	UNTIL (NOT NextValVtrZuHK ( LHKIDinVtr ( inVtr ), outV1)) OR
                         Vtrgefunden;
             	DispVtr (outV1)
           END; (* FirstValVtrZuHK *)

           (* -- VtrID ist bestimmt *)

           IF NOT OK THEN
               (* -- NeuVtr stornieren *)

               result := SetStornoAmInVtr (outV1, LSysDatumInSysDat ());
               result := UpdateVtr (outV1, outMsg2);
               (* -- outMsg2 wird nicht gebraucht *)
               IF NOT result THEN String.Dispose (outMsg2) END;
               EqualizeVtr (inVtr, outV1);  (* -- erforderlich, da
                                                  -- inVtr keine ID enthaelt *)
           ELSE    (* NOT OK *)
           	(* -- NeuVtr buchen *)
           	
           	String.Dispose (outMsg);   (* da nicht benoetigt *)
           	NeuVtrBuchen (inVtr, neuVtrBetrag)
           	
           END; (* NOT OK *)

      END; (* EinfVtr *)

  END; (* IF Bedingungen *)

  RETURN OK

END BearbeitenNeuVtr;

(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)


(* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

PROCEDURE ExistValVtrZwHKUndKst ( inHKID : TPersID; inKst : TKst ): BOOLEAN;
(* -- ermitteln, ob zw. der HK und der Kst ein gueltiger Vtr existiert *)
VAR   VtrZwHKundKst : BOOLEAN;
      outVtr        : TVtr;
BEGIN

    VtrZwHKundKst := FALSE;
    IF FirstValVtrZuHK ( inHKID, outVtr ) THEN
         REPEAT
             IF IsEqualKstID ( LKstIDinKst (inKst), LKstIDinVtr(outVtr) ) THEN
                  VtrZwHKundKst := TRUE END;
         UNTIL (NOT NextValVtrZuHK ( inHKID, outVtr )) OR VtrZwHKundKst;
         DispVtr (outVtr);
    END;

    RETURN VtrZwHKundKst

END ExistValVtrZwHKUndKst;

(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)


(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

PROCEDURE NeuVtrBuchen ( inVtr : TVtr; Betrag : CARDINAL );
(* -- wird nur in Verbindung mit BearbeitenNeuVtr verwendet *)
VAR outBu	: TBu;
    result	: BOOLEAN;
    outMsg	: TString;
BEGIN
	outBu := BCreateBu();
	SetBetragInBu      (outBu, Betrag);
	SetKstIDinBu       (outBu, LKstIDinVtr (inVtr));
	SetVtrIDinBu       (outBu, LVtrIDinVtr (inVtr));
	SetBuchungsArtInBu (outBu, Gehalt);
	result := EinfBu (outBu, outMsg );
	DispBu (outBu);
	IF NOT result THEN String.Dispose (outMsg) END ;
END NeuVtrBuchen;

(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)


(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

PROCEDURE AendernVtr ( inoutVtr : TVtr; inEndeNeu: TDatum;
                       VAR outMsg : TString) : BOOLEAN;
(* -- setzt GueltigBis in inoutVtr auf inEndeNeu, fall inEndeNeu zw.
   -- GueltigVon und GueltigBis *)
VAR  outBu : TBu;

BEGIN

     IF NOT VExistVtr (inoutVtr, outMsg) THEN
          RETURN FALSE
     ELSIF SmallerDatum (inEndeNeu, LGueltigVonInVtr (inoutVtr) ) THEN
          outMsg := String.Create();
          String.Schreibe (outMsg, "neues Ende < Gueltig von");
          RETURN FALSE
     ELSIF SmallerDatum ( LGueltigBisInVtr (inoutVtr), inEndeNeu) THEN
          outMsg := String.Create();
          String.Schreibe (outMsg, "neues Ende > altes Ende");
          RETURN FALSE
     ELSIF NOT StornierenVtr (inoutVtr, outMsg) THEN
          (* -- Fehler beim Stornieren *)
          RETURN FALSE
     ELSE
          (* -- Stornierung war erfolgreich =>
             -- Neuen Vertrag einfuegen und buchen
             -- falls beim Einfuegen eines Vtr eine evtl. vorhandene VtrID
             -- ueberschrieben wird, kann inoutVtr weiter verwendet werden *)
             SetGueltigBisInVtr (inoutVtr, inEndeNeu);
             IF EinfVtr (inoutVtr, outMsg) THEN
                 outBu := BCreateBu ();
                 SetKstIDinBu (outBu, LKstIDinVtr (inoutVtr) );
                 SetVtrIDinBu (outBu, LVtrIDinVtr (inoutVtr) ); (* neue ID! *)
                 SetBetragInBu(outBu,
                               KBerechneBrutto ( LGueltigVonInVtr (inoutVtr),
                                                 inEndeNeu,
                                                 LStdzahlInVtr (inoutVtr) ));
                 SetBuchungsArtInBu (outBu, Gehalt);
                 RETURN TRUE
             ELSE
                 RETURN FALSE
             END; (* IF EinfVtr *)

     END; (* IF *)

END AendernVtr;

(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)


(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

PROCEDURE StornierenVtr (inVtr : TVtr; VAR outMsg : TString) : BOOLEAN;
(* -- ein Vtr kann storniert werden, wenn er existiert, er noch
   -- nicht abgelaufen und die beteiligte Kst weder liquidiert noch
   -- gesperrt ist *)

VAR outKst : TKst;
BEGIN

    IF NOT VExistVtr (inVtr, outMsg) THEN
         RETURN FALSE
    ELSIF IstVtrAbgelaufen (inVtr) THEN
         outMsg := String.Create();
         String.Schreibe (outMsg, "Vertrag abgelaufen");
         RETURN FALSE
    ELSIF NOT SucheKstZuKID ( LKstIDinVtr (inVtr), outKst) THEN
         (* -- falls Kst nicht existiert, warum auch immer *)
         outMsg := String.Create();
         String.Schreibe (outMsg, "Fehler in Kostenstelle");
         RETURN FALSE
    ELSIF ( IstGesperrtKst (outKst) OR IstLiquidiertKst (outKst) ) THEN
         (* -- hier ist outKst schon belegt, da alle drei vorherigen Bed.
            -- FALSE sind *)
         DispKst (outKst);
         outMsg := String.Create();
         String.Schreibe (outMsg, "Kostenstelle liquidiert oder gesperrt");
         RETURN FALSE
    ELSE
         (* -- Vertrag stornieren *)
         DispKst (outKst);
         RETURN StornoGehaltBu ( LHKIDinVtr (inVtr), outMsg)
    END; (* SucheKstZuKID *)

END StornierenVtr;

(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)



(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

PROCEDURE  BerRestEtatDerKst(inKstID : TKstID): INTEGER;
(* -- Restetat := EtatDerKst ( inKstID );
   -- Restetat := Restetat - AbgebuGelderDerKst ( inKstID );

   -- Berechnung des geschaetzten WG-Anteils (probWGAnteil) :
   -- Alg.:
   -- alle gueltigen Vertraege aller HKs durchgehen, die den Stichtag, der am
   -- akt. Datum gueltigen WKond, enthalten.
   -- falls KstID im Vtr = inKstID und HK im Vtr WG-berechtigt ist
   --           probWGAnteil += WGAnteilDerKst (Vtr,STagDatum, WG)

   -- Fuer WG und WG-Anteilberechnung ist ein Datum notwendig,
   -- aus welchem man die gueltigen Konditionen bestimmen muss,
   -- Hierfuer kann das aktuelle Datum verwendet werden
   -- ( LSysDatumInSysDat ())

   -- RETURN Restetat - probWGAnteil
*)

VAR   Restetat		: INTEGER;
      probWGAnteil	: INTEGER;   (* geschaetzter WG-Anteil der Kst *)
      Anteil		: INTEGER;
      WGDerHK		: CARDINAL;
      outDatum		: TDatum;
      STag		: TStag;
      STagDatum		: TDatum;     (* enthaelt den Stichtag der am akt.
                                         Datum gueltigen WKond *)
      outHK		: THK;
      outVtr		: TVtr;
      outWKond		: TKond;
BEGIN
      Restetat     := 0;
      probWGAnteil := 0;
      outDatum     := LSysDatumInSysDat ();
      STagDatum    := DuplicateDatum (outDatum);

      (* -- falls es eine HK und eine gueltige WKond gibt *)

  IF GetGueltigeWKond (outDatum, outWKond) THEN

	STag := LSTagInWKond (outWKond);
        SetzeTagInDatum (STagDatum, LiesTagInStag (STag) );
        SetzeMonatInDatum (STagDatum, LiesMonatInStag (STag) );
        DisposeStag (STag);

      IF FirstHK (outHK) THEN

          REPEAT
	    (* -- alle gueltigen Vertraege, die den Stichtag enthalten
	       -- testen, ob sie die inKstID beinhalten, wenn ja,
	       -- testen, ob die dazugehoerige HK WG-berechtigt ist *)
	
            IF FirstValVtrZuHKmitZpunkt (LHKID (outHK), STagDatum, outVtr) THEN

                  REPEAT
                       IF IsEqualKstID ( inKstID, LKstIDinVtr(outVtr) ) THEN
	                   IF HKWGBerechtigt ( LHKID (outHK), outDatum ) THEN
	                      WGDerHK := BerWGDerHK (outHK, outWKond, outDatum );
	                      Anteil :=  WGAnteilDerKst (outVtr, STagDatum,
                                                         WGDerHK);
                              probWGAnteil := probWGAnteil + Anteil;
                           END; (* HKWGBerechtigt *)
                       END; (* IsEqualKstID *)

                  UNTIL NOT NextValVtrZuHKmitZpunkt ( LHKID (outHK),
                                                      STagDatum, outVtr );
                  DispVtr (outVtr);

            END; (* FirstValVtrZuHKmitZpunkt *)

          UNTIL NOT NextHK(outHK);
          DispHK (outHK)

      END; (* FirstHK *)
      DispKond (outWKond);
      DisposeDatum (STagDatum);
  END; (* GetWKond *)

  DisposeDatum (outDatum);

  Restetat := EtatDerKst ( inKstID ) -
                           AbgebuGelderDerKst ( inKstID ) - probWGAnteil;

  RETURN Restetat

END BerRestEtatDerKst;

(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

END VtrVerw.